package Ajout_Modif_Chambres;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import utils.Define;

public class AM_Chambres_Query {

	private Connection connection = null;
	private Statement query = null;
	
	@SuppressWarnings("unused")
	private String db_link;
	
	public AM_Chambres_Query(String db_link)
	{
		this.db_link = db_link;
		
		try
		{
			// connexion  la BD
			Class.forName("com.mysql.jdbc.Driver");
			String url = "jdbc:mysql://" + db_link + "/" + new Define().get_db_name();
			connection = DriverManager.getConnection(url, new Define().get_user(), new Define().get_pass());
			query = connection.createStatement();
		}
		catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * Supprimer une chambre donne dans la base de donnes
	 * @param name : nom de la chambre  supprimer
	 * @return boolean indique si la suppression a russi ou non
	 */
	public boolean delete_ch(String name)
	{
		boolean returned = true;
		try 
		{
			query.executeUpdate("DELETE FROM chambres WHERE nom_chambre = '" + name.replaceAll("'", "\\\\'") + "'");
		} catch (SQLException e) {
			e.printStackTrace();
			returned = false;
		}
		return returned;
	}
	
	/**
	 * Donne les informations (nom, surfaces, description) d'une chambre donne 
	 * @param name
	 * @return liste contenant ces informations
	 */
	public ArrayList<String> get_info(String name)
	{
		ArrayList<String> info = new ArrayList<String>();
		
		try 
		{
			ResultSet info_rs = query.executeQuery("SELECT * FROM chambres WHERE nom_chambre = '" +
					name.replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'") + "'");
			while( info_rs.next() )
			{
				info.add(info_rs.getString("nom_chambre"));
				info.add(Float.toString(info_rs.getFloat("surface_chambre")));
				info.add(Float.toString(info_rs.getFloat("surface_champ")));
				info.add(info_rs.getString("descriptif"));
			}
		} 
		catch (SQLException e) {
			e.printStackTrace();
		}
		
		return info;
	}
	
	/**
	 * Donne tous les noms des chambres existantes
	 * @return une liste contenant tous ces noms
	 */
	public ArrayList<String> get_chambres_name()
	{
		ArrayList<String> names = new ArrayList<String>();
 
		try 
		{
			ResultSet names_rs = query.executeQuery("SELECT nom_chambre FROM chambres");
			while( names_rs.next() )
				names.add(names_rs.getString("nom_chambre"));	
		} 
		catch (SQLException e) {
			e.printStackTrace();
		}
		
		return names;
	}
	
	
	/**
	 * Ajoute une chambre donne dans la base de donnes
	 * @param info : liste contenant toutes les informations de cette chambre
	 */
	public void new_ch(ArrayList<String> info)
	{
		try {
			query.executeUpdate("INSERT INTO chambres (nom_chambre, surface_chambre, surface_champ, descriptif)"
					+ "VALUES ('" + info.get(0).replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'") + "', " 
					+ Float.parseFloat(info.get(1)) + ", "
					+ Float.parseFloat(info.get(2))	+ ", '" 
					+ info.get(3).replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'") + "')");
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
	}
	
	/**
	 * Met  jour une chambre et ses informations dans la base de donnes
	 * @param info : liste contenant toutes les nouvelles informations de cette chambre
	 */
	public void modif_ch(ArrayList<String> info)
	{
		try {
			
			String requete = "UPDATE chambres "
				+ "set nom_chambre = '" + info.get(0).replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'") + "', " 
				+ "surface_chambre = " + Float.parseFloat(info.get(1)) + ", "
				+ "surface_champ = " + Float.parseFloat(info.get(2)) + ", "
				+ "descriptif = '" + info.get(3).replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'") + "' "
				+ "WHERE nom_chambre = '"
				+ info.get(4).replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'") + "'";

			query.executeUpdate(requete);
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
	}
	
	public void close()
	{
		try 
		{
			query.close();
			connection.close();
		} catch (SQLException e) { e.printStackTrace();	}
	}
}
