package Ajout_Modif_Sites;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import javax.swing.JOptionPane;

import utils.Define;

public class AM_Site_Query {
	
	private Connection connection = null;
	private Statement query = null;
	
	@SuppressWarnings("unused")
	private String db_link;
	
	public AM_Site_Query(String db_link)
	{
		this.db_link = db_link;
		
		try
		{
			// connexion  la base de donnes
			Class.forName("com.mysql.jdbc.Driver");
			String url = "jdbc:mysql://" + db_link + "/" + new Define().get_db_name();
			connection = DriverManager.getConnection(url, new Define().get_user(), new Define().get_pass());
			query = connection.createStatement();
		}
		catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Supprime de la base de donnes une station donne
	 * @param site_name nom de la station 
	 * @param station_name nom du site
	 */
	@SuppressWarnings("static-access")
	public void delete_station(String site_name, String station_name)
	{
		ResultSet rs = null;
		try 
		{
			rs = query.executeQuery("SELECT count(*) FROM echantillons NATURAL JOIN stations WHERE nom_station = '" + station_name + "'");
			rs.next();
			if( rs.getInt(1) == 0)
			{
				rs = query.executeQuery("SELECT count(*) FROM lieux LEFT OUTER JOIN stations on lieux.id_lieu=stations.id_lieu WHERE nom_lieu = '" + site_name + "'");
				rs.next();
				if( rs.getInt(1) > 1)
					query.executeUpdate("DELETE FROM stations WHERE nom_station = '" + station_name.trim()
							+ "' AND id_lieu = (SELECT id_lieu FROM lieux WHERE nom_lieu = '" + site_name.trim() + "')");
				else {
					query.executeUpdate("DELETE FROM stations WHERE nom_station = '" + station_name.trim()
							+ "' AND id_lieu = (SELECT id_lieu FROM lieux WHERE nom_lieu = '" + site_name.trim() + "')");
					query.executeUpdate("DELETE FROM lieux WHERE nom_lieu = '" + site_name + "'");
				}
			}
			else
				new JOptionPane().showMessageDialog(null, "Un chantillon est associ  cette station, vous ne pouvez la supprimer.", "Erreur"
						, JOptionPane.ERROR_MESSAGE);
		} 
		catch (SQLException e) 
		{	e.printStackTrace(); }
	}

	/**
	 * Modifie le nom d'une station donn
	 * @param nom_station : nouveau nom
	 * @param old_name : ancien nom
	 * @param nom_site : nom du site
	 */
	public void modify_station_name(String nom_station, String old_name, String nom_site)
	{
		try 
		{
			query.executeUpdate("UPDATE stations SET nom_station = '" + nom_station.trim() + "'"
					+ " WHERE nom_station = '" + old_name.trim() 
					+ "' AND id_lieu = (SELECT id_lieu FROM lieux WHERE nom_lieu = '" 
					+ nom_site.trim() + "')");
		} 
		catch (SQLException e) 
		{
			e.printStackTrace();
		}
	}

	/**
	 * modifie l'affectation d'une station  un site
	 * @param nom_station nom de la station
	 * @param nom_site nouveau site
	 * @param old_site ancien site
	 */
	public void modify_station_site(String nom_station, String nom_site, String old_site)
	{
		try 
		{
			query.executeUpdate("UPDATE stations SET id_lieu  = (SELECT id_lieu FROM lieux WHERE nom_lieu = '"
					+ nom_site.trim() + "') WHERE nom_station = '" + nom_station.trim() + 
					"' AND id_lieu = (SELECT id_lieu FROM lieux WHERE nom_lieu = '" 
					+ old_site.trim() + "')");
		} 
		catch (SQLException e) 
		{
			e.printStackTrace();
		}
	}

	/**
	 * Modifie le milieu d'une station
	 * @param nom_station nom de la station
	 * @param nom_site nom du site
	 * @param milieu milieu de la station
	 */
	public void modify_station_milieu(String nom_station, String nom_site, String milieu)
	{
		try 
		{
			query.executeUpdate("UPDATE stations SET milieu = '"  + milieu.trim()
					+ "' WHERE nom_station = '" + nom_station.trim() + 
					"' AND id_lieu = (SELECT id_lieu FROM lieux WHERE nom_lieu = '" 
					+ nom_site.trim() + "')");
		} 
		catch (SQLException e) 
		{
			e.printStackTrace();
		}
	}

	/**
	 * Modifie le nom d'un site
	 * @param _new nouveau nom
	 * @param old ancien nom
	 */
	public void modify_site(String _new, String old)
	{
		try 
		{
			query.executeUpdate("UPDATE lieux SET nom_lieu = '" + _new.trim() + "' WHERE nom_lieu = '" 
					+ old.trim() + "'");
		} 
		catch (SQLException e) 
		{
			e.printStackTrace();
		}
	}

	/**
	 * Retourne tous les lieux et leurs ventuelles stations
	 * @return matrice de lieux/stations
	 */
	public String[][] get_data()
	{
		String[][] returned = null;
		ArrayList<Object> data = new ArrayList<Object>();

		try 
		{
			ResultSet rs = query.executeQuery("SELECT nom_lieu, nom_station, milieu FROM lieux LEFT OUTER JOIN stations " +
					"ON lieux.id_lieu=stations.id_lieu ORDER BY nom_lieu, nom_station");

			while( rs.next() )
			{
				data.add(rs.getString("nom_lieu"));
				data.add(rs.getString("nom_station"));
				data.add(rs.getString("milieu"));
			}

			returned = new String[data.size()/3][3];

			for( int i = 0; i < data.size(); i++)
				returned[i/3][i%3] = (String)data.get(i);
		} 
		catch (SQLException e) {
			e.printStackTrace();
		}

		return returned;
	}

	/**
	 * Ferme les connections
	 */
	public void close()
	{
		try 
		{
			query.close();
			connection.close();
		}
		catch(SQLException e)
		{
			e.printStackTrace();
		}
	}
}
