package Ajout_Modif_Sites;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

public class Modify_Frame extends JDialog {

	private static final long serialVersionUID = 1L;
	@SuppressWarnings("unused")
	private Locale locale;
	@SuppressWarnings("unused")
	private String db_link;
	
	private String old_site, old_station;
	
	AM_Site_Query am;
	
	private JButton modif_site = new JButton();
	private JButton modif_station = new JButton();
	
	private JLabel labelSite1 = new JLabel();
	private JLabel labelSite2 = new JLabel();
	private JLabel labelStation = new JLabel();
	private JLabel labelMilieu = new JLabel();
	
	private JTextField site_name = new JTextField();
	private JTextField station_name = new JTextField();
	private JTextField station_site_name = new JTextField();
	private JTextField tf_milieu = new JTextField();
	
	private Modify_Frame self = null;

	public Modify_Frame(JFrame f, String site_name, String station_name, String milieu, 
			Locale locale, String db_link)
	{
		super(f, "Modifications", true);
		this.self = this;
		this.locale = locale;
		this.db_link = db_link;
		
		am = new AM_Site_Query(db_link);
		
		this.old_site = site_name;
		this.old_station = station_name;
		
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		
		this.translate(locale);
		
		this.getContentPane().setLayout(new BorderLayout());

		JPanel site = new JPanel(new FlowLayout());
		
		// pour la traduction des bordures
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);		
		site.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("modifNomSite"), TitledBorder.CENTER, TitledBorder.CENTER));
		site.add(labelSite1);
		site.setBackground(new Color(192, 197, 199));
		
		this.site_name.setPreferredSize(new Dimension(260,20));
		this.site_name.setText(site_name.trim());
		site.add(this.site_name);
		site.add(modif_site);

		this.getContentPane().add(site, BorderLayout.NORTH);

		JPanel stations = new JPanel(new BorderLayout());
		stations.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("modifStation"), TitledBorder.CENTER, TitledBorder.CENTER));
		stations.setBackground(new Color(192, 197, 199));

		JPanel stations_name_pane = new JPanel(new FlowLayout());
		((FlowLayout)stations_name_pane.getLayout()).setAlignment(FlowLayout.LEADING);
		JPanel stations_milieu_pane = new JPanel();
		JPanel stations_site_pane = new JPanel(new FlowLayout());
		((FlowLayout)stations_site_pane.getLayout()).setAlignment(FlowLayout.LEADING);

		stations_name_pane.add(labelStation);
		stations_name_pane.setBackground(new Color(192, 197, 199));
		this.station_name.setPreferredSize(new Dimension(230,20));
		this.station_name.setText(station_name.trim());
		stations_name_pane.add(this.station_name);

		stations.add(stations_name_pane, BorderLayout.NORTH);

		stations_site_pane.add(labelSite2);
		stations_site_pane.setBackground(new Color(192, 197, 199));
		this.station_site_name.setPreferredSize(new Dimension(260,20));
		this.station_site_name.setText(site_name.trim());
		stations_site_pane.add(this.station_site_name);
		this.station_site_name.setEditable(false);

		stations.add(stations_site_pane, BorderLayout.CENTER);

		stations_milieu_pane.setLayout(new BoxLayout(stations_milieu_pane, BoxLayout.LINE_AXIS));
		stations_milieu_pane.add(Box.createHorizontalStrut(5));
		stations_milieu_pane.add(labelMilieu);
		stations_milieu_pane.add(Box.createHorizontalStrut(5));
		stations_milieu_pane.setBackground(new Color(192, 197, 199));
		this.tf_milieu.setMaximumSize(new Dimension(100,20));
		this.tf_milieu.setPreferredSize(new Dimension(100,20));
		this.tf_milieu.setText(milieu.trim());
		stations_milieu_pane.add(this.tf_milieu);
		stations_milieu_pane.add(Box.createHorizontalGlue());
		stations_milieu_pane.add(modif_station);
		stations_milieu_pane.add(Box.createHorizontalStrut(5));

		stations.add(stations_milieu_pane, BorderLayout.SOUTH);

		this.getContentPane().add(stations, BorderLayout.SOUTH);

		this.add_handlers();

		this.pack();
		this.setLocation(150, 150);
		this.setVisible(true);
	}	

	
	
	public void add_handlers()
	{
		// modification du site
		modif_site.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e)
					{
						self.am.modify_site(site_name.getText().trim().replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'"),
								self.old_site.trim().replaceAll("\\\\", "\\\\\\\\").replaceAll("'","\\\\'"));
						self.dispose();
						self.am.close();
					}});
		
		// modification de la station
		modif_station.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e)
					{
						self.am.modify_station_name(station_name.getText().trim().replaceAll("'", "\\\\'")
								, self.old_station.trim().replaceAll("'", "\\\\'"), self.old_site.trim().replaceAll("'", "\\\\'"));
						self.am.modify_station_milieu(station_name.getText().trim().replaceAll("'", "\\\\'"),
								self.old_site.trim().replaceAll("'", "\\\\'"), tf_milieu.getText().trim().replaceAll("'", "\\\\'"));
						self.am.modify_station_site(station_name.getText().trim().replaceAll("'", "\\\\'"),
								station_site_name.getText().trim().replaceAll("'", "\\\\'"), self.old_site.trim().replaceAll("'", "\\\\'"));
						self.dispose();
						self.am.close();
					}});

		// modif d'un site par action sur touche entre
		site_name.addKeyListener( new KeyListener() {

			@Override
			public void keyTyped(KeyEvent e) {
			}

			@Override
			public void keyReleased(KeyEvent e) {
			}

			@Override
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_ENTER )  {
					self.am.modify_site(site_name.getText().trim().replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'"),
							self.old_site.trim().replaceAll("\\\\", "\\\\\\\\").replaceAll("'","\\\\'"));
					modif_site.transferFocus();
				}
			}	
		});

		// modif d'une station et de son milieu par action sur touche entre sur le champ milieu
		tf_milieu.addKeyListener( new KeyListener() {

			@Override
			public void keyTyped(KeyEvent e) {
			}

			@Override
			public void keyReleased(KeyEvent e) {
			}

			@Override
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_ENTER )  {
					self.am.modify_station_name(station_name.getText().trim().replaceAll("'", "\\\\'")
							, self.old_station.trim().replaceAll("'", "\\\\'"), self.old_site.trim().replaceAll("'", "\\\\'"));
					self.am.modify_station_milieu(station_name.getText().trim().replaceAll("'", "\\\\'"),
							self.old_site.trim().replaceAll("'", "\\\\'"), tf_milieu.getText().trim().replaceAll("'", "\\\\'"));
					self.am.modify_station_site(station_name.getText().trim().replaceAll("'", "\\\\'"),
							station_site_name.getText().trim().replaceAll("'", "\\\\'"), self.old_site.trim().replaceAll("'", "\\\\'"));
					self.dispose();
					self.am.close();
				}
			}	
		});

	}
	
	/**
	 * Slection des textes dans la bonne langue des lments de la fentre
	 * @param locale
	 */
	public void translate(Locale locale){
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		// nom de la fentre
		this.setTitle(rb.getString("titreFenModifStation"));
		
		modif_site.setText(rb.getString("modifier"));
		labelSite1.setText(rb.getString("champNomSite"));
		labelSite2.setText(rb.getString("champNomSite"));
		modif_station.setText(rb.getString("modifier"));
		labelStation.setText(rb.getString("champNomStation"));
		labelMilieu.setText(rb.getString("champMilieu"));

		
		//ragencement de la position des items de la fentre
		this.pack();
	}

}