package C_M_Perso;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import utils.Define;

public class Consultation_Perso_Query {
	private Connection connection = null;
	private Statement query = null;
	
	@SuppressWarnings("unused")
	private String db_link;
	
	public Consultation_Perso_Query(String db_link)
	{
		this.db_link = db_link;
		
		try
		{
			// connexion  la base de donnes
			Class.forName("com.mysql.jdbc.Driver");
			String url = "jdbc:mysql://" + db_link + "/" + new Define().get_db_name();
			connection = DriverManager.getConnection(url, new Define().get_user(), new Define().get_pass());
			query = connection.createStatement();
		}
		catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * Remplit la table avec toutes les donnes des taxons de la base
	 * @param table JTable  remplir
	 */
	public void fill_table( JTable table )
	{
		Object[] data = new Object[10];/*#*/
		
		try 
		{
			ResultSet rs = query.executeQuery("SELECT code_taxon, nom_taxon, nom_auteur, " +
					"indiv_defaut, biovolcel, biovolind, embranchement, createur, " + 
					 	"(SELECT nom_forme FROM formes WHERE id_forme = liste_taxa_cpt.id_forme_cel) AS cel, " + 
					 	"(SELECT nom_forme FROM formes WHERE id_forme = liste_taxa_cpt.id_forme_ind) AS ind" +
					" FROM liste_taxa_cpt ORDER BY nom_taxon");
			
			while( rs.next() )
			{
				data[0] = rs.getString("code_taxon");
				data[1] = rs.getString("nom_taxon");
				data[2] = rs.getString("nom_auteur");
				data[3] = rs.getString("indiv_defaut");
				data[4] = rs.getString("biovolcel");
				data[5] = rs.getString("biovolind");
				data[6] = rs.getString("embranchement");
				data[7] = rs.getString("createur");
				data[8] = rs.getString("cel");
				data[9] = rs.getString("ind");
				
				((DefaultTableModel)table.getModel()).addRow(data);
			}
			
		} 
		catch (SQLException e) { e.printStackTrace(); }
	}
}
