package C_M_Perso;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

import Comptage.Choisir_Forme;

public class Modification_Frame extends JFrame {

	private static final long serialVersionUID = 1L;
	private Locale locale;
	@SuppressWarnings("unused")
	private String db_link;
	
	private JPanel code_nom = new JPanel( new FlowLayout() );
	private JPanel auteur = new JPanel();
	private JPanel embranchement = new JPanel();
	private JPanel autres = new JPanel( new FlowLayout() );
	private JPanel formes = new JPanel( new FlowLayout() );

	
	private JLabel labelCode = new JLabel();
	private JLabel labelNom = new JLabel();
	private JLabel labelIndDef = new JLabel();
	private JLabel labelBioVolCel = new JLabel();
	private JLabel labelBioVolInd = new JLabel();
	private JLabel labelCreateur = new JLabel();
	private JLabel labelFormeCel = new JLabel();
	private JLabel labelFormeInd = new JLabel();
	 
	
	private JComboBox<String> auteur_cb = new JComboBox<String>();
	private JComboBox<String> jcb_embranchements = new JComboBox<String>();
	private JComboBox<String> code_cb = new JComboBox<String>();
	private JComboBox<String> nom_cb = new JComboBox<String>();
	private Modification_Query cpt_query;
	private JComboBox<String> type_cb = null;
	private JTextField biovolcel_tf = new JTextField();
	private JTextField biovolind_tf = new JTextField();
	private JTextField createur_tf = new JTextField();
	private JButton validate = new JButton();
	private JTextField forme_cel = new JTextField();
	private JTextField forme_ind = new JTextField();
	private JButton modif_forme_cel = new JButton();
	private JButton modif_forme_ind = new JButton();
	private JButton delete = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/close.png")));
	private Modification_Frame self = null;
	@SuppressWarnings("unused")
	private boolean throwable = true;
	private String code;

	public Modification_Frame(Locale locale, String db_link)
	{
		super();
		this.setBackground(new Color(192, 197, 199));
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.PAGE_AXIS));
		this.getContentPane().setBackground(new Color(192, 197, 199));
		self = this;
		this.locale = locale;
		this.db_link = db_link;
		
		cpt_query = new Modification_Query(db_link);

		this.add_buttons();
		
		this.translate(locale);
		
		this.add_handlers();

		this.pack();
		this.setLocation(100, 100);
		this.setResizable(false);
		this.setVisible(true);
	}
	
	public Modification_Frame(Locale locale, String db_link, String code)
	{
		super();
		this.setBackground(new Color(192, 197, 199));
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.PAGE_AXIS));
		this.getContentPane().setBackground(new Color(192, 197, 199));
		self = this;
		this.locale = locale;
		this.db_link = db_link;
		
		cpt_query = new Modification_Query(db_link);

		this.add_buttons();
		
		this.translate(locale);
		
		this.add_handlers();

		this.pack();
		this.setLocation(100, 100);
		this.setResizable(false);
		this.setVisible(true);
		code_cb.requestFocus();
		show_infos(code);
	}

	/**
	 * Rempli la fentre de modification avec les informations d'un taxon personnel donn 
	 * @param code
	 */
	private void show_infos( String code )
	{
		throwable = false;
		String[] data = cpt_query.get_all_from_liste(code.replaceAll("'", "\\\\'"));
		if( data != null )
		{
			((JTextField)code_cb.getEditor().getEditorComponent()).setText(data[0]);
			((JTextField)nom_cb.getEditor().getEditorComponent()).setText(data[1]);
			((JTextField)auteur_cb.getEditor().getEditorComponent()).setText(data[2]);

			type_cb.setSelectedItem(data[3]);
			biovolcel_tf.setText(data[4]);
			biovolind_tf.setText(data[5]);
			
			((JTextField)jcb_embranchements.getEditor().getEditorComponent()).setText(data[6]);
			
			createur_tf.setText(data[7]);
			forme_cel.setText(data[8]);
			forme_ind.setText(data[9]);
			self.code = data[0];
		}
		throwable = true;
	}

	private void add_handlers() 
	{
		
		// ncessaire pour les traductions des botes de dialogue...
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		
		((JTextField)code_cb.getEditor().getEditorComponent()).addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						String code = ((JTextField)e.getSource()).getText();
						show_infos(code);
					}});
	
		// gestion de l'auto-slection du code d'un taxon personnel lorsque l'on commence  taper
			// dans le champ code
		code_cb.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent arg0) 
					{
						throwable = false;
						if( arg0.getKeyCode() != KeyEvent.VK_DOWN
								&& arg0.getKeyCode() != KeyEvent.VK_UP)
						{
							String typed = ((JTextField)arg0.getSource()).getText();
							code_cb.removeAllItems();
							code_cb.addItem(typed);
							String[] data = cpt_query.get_codes_like(typed.replaceAll("'", "\\\\'"));
							if( data != null )
								for( String s : data )
									code_cb.addItem(s);

							if( arg0.getKeyChar() != KeyEvent.VK_ENTER )
							{
								code_cb.hidePopup();
								code_cb.showPopup();
							}
						}
						throwable = true;
					}
					public void keyTyped(KeyEvent arg0) {}
				});

		((JTextField)nom_cb.getEditor().getEditorComponent()).addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						String nom = ((JTextField)e.getSource()).getText();
						show_infos(nom);
					}});
		
		// gestion de l'auto-slection du nom du taxon
		nom_cb.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent arg0) 
					{
						throwable = false;
						if( arg0.getKeyCode() != KeyEvent.VK_DOWN
								&& arg0.getKeyCode() != KeyEvent.VK_UP)
						{
							String typed = ((JTextField)arg0.getSource()).getText();
							nom_cb.removeAllItems();
							nom_cb.addItem(typed);
							String[] data = cpt_query.get_noms_like(typed.replaceAll("'", "\\\\'"));
							if( data != null )
								for( String s : data )
									nom_cb.addItem(s);

							if( arg0.getKeyChar() != KeyEvent.VK_ENTER )
							{
								nom_cb.hidePopup();
								nom_cb.showPopup();
							}
						}
						throwable = true;
					}
					public void keyTyped(KeyEvent arg0) {}
				});

		// gestion de l'auto selection du nom de l'auteur
		auteur_cb.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent arg0) {
						String debut = ((JTextField)arg0.getSource()).getText();
						if( debut.length() > 3 && arg0.getKeyCode() != KeyEvent.VK_DOWN
								&& arg0.getKeyCode() != KeyEvent.VK_UP)
						{
							String[] auteurs = cpt_query.get_auteurs_like(debut.replaceAll("'", "\\\\'"));
							if( auteurs != null )
							{
								auteur_cb.removeAllItems();
								auteur_cb.addItem(debut);
								for( String s : auteurs )
									auteur_cb.addItem(s);
								auteur_cb.hidePopup();
								auteur_cb.showPopup();
							}
						}
					}
					public void keyTyped(KeyEvent arg0) {}
				});
		
		// gestion de l'auto-selection de l'embranchement
		jcb_embranchements.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {
					}

					public void keyReleased(KeyEvent arg0) {
						String debut = ((JTextField) arg0.getSource())
								.getText().trim();
						if (arg0.getKeyCode() != KeyEvent.VK_BACK_SPACE
								&& arg0.getKeyCode() != KeyEvent.VK_ENTER
								&& arg0.getKeyCode() != KeyEvent.VK_DOWN
								&& arg0.getKeyCode() != KeyEvent.VK_UP) 
						{
							
							String[] embrs_correspondants = cpt_query.get_embranchement_designes(debut);
							
							if (embrs_correspondants != null) {
								jcb_embranchements.removeAllItems();
								jcb_embranchements.addItem(debut);
								for (String s : embrs_correspondants)
									jcb_embranchements.addItem(s);
								
								jcb_embranchements.hidePopup();
								jcb_embranchements.showPopup();
							}
						}
					}

					public void keyTyped(KeyEvent arg0) {
					}
				});
		
		// validation des informations du taxon personnel
		validate.addActionListener(

				new ActionListener() {
					boolean nom_ok = false, biovolcel_ok = true, biovolind_ok = true, createur_ok = false, type_ok = false;
					@SuppressWarnings("static-access")
					public void actionPerformed( ActionEvent e ) {
						if( ! ((JTextField)nom_cb.getEditor().getEditorComponent()).getText().trim().isEmpty() )
							nom_ok = true;
						else
						{
							new JOptionPane().showMessageDialog(self, rb.getString("mssgNomVide"), rb.getString("titreBoxNomVide"),
									JOptionPane.ERROR_MESSAGE);
							
							nom_ok = false;
						}

						try
						{
							if( ! biovolcel_tf.getText().trim().isEmpty() )
							{
								Float.parseFloat(biovolcel_tf.getText());
								biovolcel_ok = true;
							}
							else
								biovolcel_ok = true;
							if( ! biovolind_tf.getText().trim().isEmpty() )
							{
								Float.parseFloat(biovolind_tf.getText());
								biovolind_ok = true;
							}
							else
								biovolind_ok = true;
						}

						catch(NumberFormatException nfe)
						{
							biovolind_ok = false;
							biovolcel_ok = false;
							new JOptionPane().showMessageDialog(self, rb.getString("mssgBioVolFormat"), rb.getString("titreBoxBioVolFormat"),
									JOptionPane.ERROR_MESSAGE);
						}

						if( createur_tf.getText().trim().isEmpty() )
						{
							new JOptionPane().showMessageDialog(self, rb.getString("mssgCreateurVide"), rb.getString("titreBoxCreateurVide"),
									JOptionPane.ERROR_MESSAGE);
							createur_ok = false;
						}
						else
							createur_ok = true;

						if( type_cb.getSelectedIndex() == 0 )
						{
							new JOptionPane().showMessageDialog(self, rb.getString("mssgTypeVide"), rb.getString("titreBoxTypeVide"),
									JOptionPane.ERROR_MESSAGE);
							type_ok = false;
						}
						else
							type_ok = true;

						// si toutes les informations sont valides, alors le taxon peut tre mis  jour
						if( nom_ok && biovolcel_ok && biovolind_ok && createur_ok && type_ok)
						{
							String nom_auteur = ((JTextField)auteur_cb.getEditor().getEditorComponent()).getText();
							String embr = ((JTextField)jcb_embranchements.getEditor().getEditorComponent()).getText();
							
							float biocel = ((biovolcel_tf.getText().isEmpty()) ? 0 : Float.parseFloat(biovolcel_tf.getText()));
							float bioind = ((biovolind_tf.getText().isEmpty()) ? 0 : Float.parseFloat(biovolind_tf.getText()));
							if( nom_auteur.trim().isEmpty() )
								nom_auteur = rb.getString("ARemplir");
							
							// mise  jour du taxon dans la BD
							cpt_query.update_taxon_cpt(self.code, ((JTextField)nom_cb.getEditor().getEditorComponent()).getText().trim(), 
									nom_auteur, (String)type_cb.getSelectedItem(), biocel, bioind, embr, createur_tf.getText().trim(), forme_cel.getText(), forme_ind.getText());
							
							// bote de dialogue : confirmation de la modification
							new JOptionPane().showMessageDialog(self, rb.getString("mssgModifOK"), rb.getString("titreBoxModifOK"),
									JOptionPane.INFORMATION_MESSAGE);
						}
					}});

		modif_forme_cel.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Choisir_Forme(null, self, 0, false, locale);
					}});

		modif_forme_ind.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Choisir_Forme(null, self, 1, false, locale);
					}});

		// suppression d'un taxon personnel
		delete.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) 
					{
						code_cb.requestFocus();
						if(code_cb.getSelectedItem() != null && code_cb.getSelectedItem() != ""){
							// boite de dialogue pour confirmation de suppression
							int reponse = JOptionPane.showConfirmDialog(
									self, rb.getString("mssgConfirmSuppress"),
									rb.getString("titreBoxConfirmSuppress"), 
									JOptionPane.YES_NO_OPTION);

							// si suppression confirme
							if(reponse == 0){
								String selected = code_cb.getSelectedItem().toString();
								// le taxon peut tre supprim s'il n'est pas utilis ailleurs
								if(!cpt_query.isUsed(selected)){
									cpt_query.delTax(selected);
									code_cb.removeItem(selected);
									code_cb.repaint();
									code_cb.removeAllItems();
									nom_cb.removeAllItems();
									auteur_cb.removeAllItems();
									jcb_embranchements.removeAllItems();
									type_cb.removeAllItems();
								}
								else 
									// boite de dialogue : le taxon ne peut pas tre supprim
									JOptionPane.showMessageDialog(self, rb.getString("mssgProblemSuppress"),
																rb.getString("titreBoxProblemSuppress"),
																JOptionPane.ERROR_MESSAGE);

							}
						}
					}});
	}

	public void changerForme(String new_forme, int type){
		if(type == 0)
			forme_cel.setText(new_forme);
		else
			forme_ind.setText(new_forme);
	}

	private void add_buttons()
	{
		
		JPanel code = new JPanel();
		code.setBackground(new Color(192, 197, 199));
		code.setLayout( new BoxLayout(code, BoxLayout.PAGE_AXIS));
		code.add(Box.createVerticalStrut(5));
		code.add(labelCode);
		code.add(Box.createVerticalStrut(5));
		code_cb.setEditable(true);
		code_cb.setPreferredSize(new Dimension(80,20));
		code.add(code_cb);

		JPanel nom = new JPanel();
		nom.setBackground(new Color(192, 197, 199));
		nom.setLayout( new BoxLayout(nom, BoxLayout.PAGE_AXIS));
		nom.add(Box.createVerticalStrut(5));
		nom.add(labelNom);
		nom.add(Box.createVerticalStrut(5));
		nom_cb.setPreferredSize(new Dimension(200, 20));
		nom_cb.setEditable(true);
		nom.add(nom_cb);

		JPanel type = new JPanel();
		type.setBackground(new Color(192, 197, 199));
		type.setLayout( new BoxLayout(type, BoxLayout.PAGE_AXIS));
		type.add(Box.createVerticalStrut(5));
		type.add(labelIndDef);
		type.add(Box.createVerticalStrut(5));
		type_cb = new JComboBox<String>( new String[] {"", "Cel.", "Fil.", "Col."} );
		type.add(type_cb);

		
		code_nom.setBackground(new Color(192, 197, 199));

		code_nom.add(code);
		code_nom.add(nom);
		code_nom.add(type);

		auteur.setBackground(new Color(192, 197, 199));
		auteur.setLayout( new BoxLayout(auteur, BoxLayout.PAGE_AXIS));

		auteur.add(Box.createVerticalStrut(5));
		auteur_cb.setEditable(true);
		auteur_cb.setPreferredSize(new Dimension(150, 20));
		auteur.add(Box.createVerticalStrut(5));
		auteur.add(auteur_cb);
		
		jcb_embranchements.setEnabled(true);
		jcb_embranchements.setEditable(true);
		jcb_embranchements.setPreferredSize(new Dimension(200, 20));
		
		embranchement.setBackground(new Color(192, 197, 199));
		embranchement.add(jcb_embranchements);
		
		
		JPanel biovolcel = new JPanel();
		biovolcel.setBackground(new Color(192, 197, 199));
		biovolcel.setLayout( new BoxLayout(biovolcel, BoxLayout.PAGE_AXIS));
		biovolcel.add(Box.createVerticalStrut(5));
		biovolcel.add(labelBioVolCel);
		biovolcel.add(Box.createVerticalStrut(5));
		biovolcel_tf.setPreferredSize(new Dimension(50,20));
		biovolcel.add(biovolcel_tf);

		JPanel biovolind = new JPanel();
		biovolind.setBackground(new Color(192, 197, 199));
		biovolind.setLayout( new BoxLayout(biovolind, BoxLayout.PAGE_AXIS));
		biovolind.add(Box.createVerticalStrut(5));
		biovolind.add(labelBioVolInd);
		biovolind.add(Box.createVerticalStrut(5));
		biovolind_tf.setPreferredSize(new Dimension(50, 20));
		biovolind.add(biovolind_tf);

		JPanel createur = new JPanel();
		createur.setBackground(new Color(192, 197, 199));
		createur.setLayout( new BoxLayout(createur, BoxLayout.PAGE_AXIS));
		createur.add(Box.createVerticalStrut(5));
		createur.add(labelCreateur);
		createur.add(Box.createVerticalStrut(5));
		createur_tf.setPreferredSize(new Dimension(200, 20));
		createur.add(createur_tf);

		
		formes.setBackground(new Color(192, 197, 199));

		JPanel cel = new JPanel();
		cel.setBackground(new Color(192, 197, 199));
		cel.setLayout( new BoxLayout(cel, BoxLayout.PAGE_AXIS));
		cel.add(Box.createVerticalStrut(5));
		cel.add(labelFormeCel, BorderLayout.CENTER);
		cel.add(Box.createVerticalStrut(5));
		forme_cel.setPreferredSize(new Dimension(200, 20));
		cel.add(forme_cel);
		cel.add(Box.createVerticalStrut(5));
		cel.add(Box.createHorizontalStrut(77));
		cel.add(modif_forme_cel);

		JPanel ind = new JPanel();
		ind.setBackground(new Color(192, 197, 199));
		ind.setLayout( new BoxLayout(ind, BoxLayout.PAGE_AXIS));
		ind.add(Box.createVerticalStrut(5));
		ind.add(labelFormeInd, BorderLayout.CENTER);
		ind.add(Box.createVerticalStrut(5));
		forme_ind.setPreferredSize(new Dimension(200, 20));
		ind.add(forme_ind);
		ind.add(Box.createVerticalStrut(5));
		ind.add(Box.createHorizontalStrut(72));
		ind.add(modif_forme_ind);

		formes.add(cel, BorderLayout.NORTH);
		formes.add(ind, BorderLayout.SOUTH);

		autres.setBackground(new Color(192, 197, 199));

		autres.add(biovolcel);
		autres.add(biovolind);
		autres.add(createur);

		JPanel buttons = new JPanel( new FlowLayout() );
		buttons.setBackground(new Color(192, 197, 199));
		buttons.add(Box.createHorizontalStrut(315));
		validate.setPreferredSize(new Dimension(80,20));
		validate.setAlignmentX(new Float(0.5));
		buttons.add(validate);
		delete.setPreferredSize(new Dimension(20,20));
		buttons.add(delete);

		this.getContentPane().add(buttons);
		this.getContentPane().add(code_nom);
		this.getContentPane().add(auteur);
		this.getContentPane().add(embranchement);
		this.getContentPane().add(autres);
		this.getContentPane().add(formes);
	}
	
	/**
	 * traduction des textes dans la bonne langue
	 * @param locale
	 */
	public void translate(Locale locale){
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		// nom de la fentre
		this.setTitle(rb.getString("titreFenModifTaxons"));	
		
		validate.setText(rb.getString("modifier"));
		
		code_nom.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("denomination"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		auteur.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("auteur"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		embranchement.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("embranchement"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		
		autres.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("autresInfos"), TitledBorder.CENTER, TitledBorder.RIGHT));
		
		
		formes.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("formes"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		 
		 labelCode.setText(rb.getString("champCode"));
		 labelNom.setText(rb.getString("champNom"));
		 labelIndDef.setText(rb.getString("champIndivDef"));
		 labelBioVolCel.setText(rb.getString("champBiovolCel"));
		 labelBioVolInd.setText(rb.getString("champBiovolInd"));
		 labelCreateur.setText(rb.getString("champCreateur"));
		 labelFormeCel.setText(rb.getString("champFormeCel"));
		 labelFormeInd.setText(rb.getString("champFormeIndiv"));
		
		 modif_forme_cel.setText(rb.getString("changer"));
		 modif_forme_ind.setText(rb.getString("changer"));
		
		//ragencement de la position des items de la fentre
		this.pack();
		
	}
	
	
}
