package C_R_Valides;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

/* import C_R_Valides.Consultation_Frame.startHandsTableModel;
*/
import utils.Define;

public class Consultation_Query {
	private Connection connection = null;
	private Statement query = null;
	
	@SuppressWarnings("unused")
	private String db_link;
	
	public Consultation_Query(String db_link)
	{
		this.db_link = db_link;
		
		try
		{
			// connexion  la base de donnes
			Class.forName("com.mysql.jdbc.Driver");
			String url = "jdbc:mysql://" + db_link + "/" + new Define().get_db_name();
			System.out.println(url);
			connection = DriverManager.getConnection(url, new Define().get_user(), new Define().get_pass());
			query = connection.createStatement();
		}
		catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * Remplit la table avec toutes les donnes des taxons de la base
	 * @param table JTable  remplir
	 */

	public void fill_table( JTable table)
	{
		Object[] data = new Object[26];

		try 
		{
			ResultSet rs = query.executeQuery("SELECT code_sandre, code_taxon, nom_taxon, nom_auteur, indiv_defaut, "
					+ "biovolcel, biovolind, code_taxon_ref, "
					+ "(SELECT nom_forme FROM formes WHERE id_forme = id_forme_cel) AS cel, "
					+ "(SELECT nom_forme FROM formes WHERE id_forme = id_forme_ind) AS ind , "
					+ "cote_specifique, coef_stenoecie , trophie, slad_s, slad_v, "
					+ "regne, sous_regne, embranchement, classe, ordre, sous_ordre, famille, "
					+ "groupe_algual, code_omnidia, date_maj, valide "
					+ "FROM liste_taxa "
					+ "NATURAL JOIN synonymes "
					+ "NATURAL JOIN auteurs "
					+ "NATURAL JOIN taxinomie "
					+ "ORDER BY nom_taxon");
			
			while( rs.next() )
			{
				// rcupration des donnes
				
				data[0] = rs.getString("code_sandre");
				data[1] = rs.getString("code_taxon");
				data[2] = rs.getString("nom_taxon");
				data[3] = rs.getString("nom_auteur");
				data[4] = rs.getString("indiv_defaut");
				data[5] = rs.getString("biovolcel");
				data[6] = rs.getString("biovolind");
				data[7] = rs.getString("code_taxon_ref");
				data[8] = rs.getString("cel");
				data[9] = rs.getString("ind");
				data[10] = rs.getString("cote_specifique");
				data[11] = rs.getString("coef_stenoecie");
				data[12] = rs.getString("trophie");
				data[13] = rs.getString("slad_s");
				data[14] = rs.getString("slad_v");
				data[15] = rs.getString("regne");
				data[16] = rs.getString("sous_regne");
				data[17] = rs.getString("embranchement");
				data[18] = rs.getString("classe");
				data[19] = rs.getString("ordre");
				data[20] = rs.getString("sous_ordre");
				data[21] = rs.getString("famille");
				data[22] = rs.getString("groupe_algual");
				data[23] = rs.getString("code_omnidia");
				data[24] = rs.getString("date_maj");
				int valid  = rs.getInt("valide");
				if(valid==1){
					data[25] = "true";
				}
				else{
					data[25] = "false";
				}
				
				((DefaultTableModel)table.getModel()).addRow(data);
			}
			
		} 
		catch (SQLException e) { e.printStackTrace(); }
	}
	
	
	public String get_last_date()
	{
		String returned = null;
		
		try
		{
			ResultSet rs = query.executeQuery("SELECT date_maj "
					+ "FROM liste_taxa "
					+ "ORDER BY date_maj DESC LIMIT 1");
			rs.next();
			returned = rs.getString(1);
		}
		catch( SQLException e) { e.printStackTrace(); }
		
		return returned;
	}
	
}
