package C_R_Valides;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.File;
import java.io.IOException;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableModel;

public class Recherche_Frame extends JFrame {

	private static final long serialVersionUID = 1L;
	private Locale locale;
	@SuppressWarnings("unused")
	private String db_link;
	private String code_choisi;
	
	JMenu file_menu = new JMenu();
	JMenu apropos = new JMenu("?");
	JMenu version = new JMenu();
	
	JPanel recherche = new JPanel(new FlowLayout());
	JPanel infos = new JPanel(new BorderLayout());
	
	JLabel labelMAJ = new JLabel();
	JLabel labelCodeSandre = new JLabel();
	JLabel labelNom = new JLabel();
	JLabel labelAuteur = new JLabel();
	JLabel labelCodeTaxon = new JLabel();
	JLabel labelCodeRef = new JLabel();
	JLabel labelCodeOmnidia = new JLabel();
	JLabel labelGrpAlgal = new JLabel();

	JLabel labelCodesSyn = new JLabel();
	JLabel labelFormeCel = new JLabel();
	JLabel labelFormeInd = new JLabel();

	@SuppressWarnings("serial")
	JLabel labelTypeInd = new JLabel() 	{ public int getHorizontalAlignment() { return JLabel.CENTER; } };
	@SuppressWarnings("serial")
	JLabel labelCoefSteno = new JLabel(){ public int getHorizontalAlignment() { return JLabel.CENTER; } };

	@SuppressWarnings("serial")
	JLabel labelSladS = new JLabel()	{ public int getHorizontalAlignment() { return JLabel.CENTER; } };
	@SuppressWarnings("serial")
	JLabel labelBioVolCel = new JLabel(){ public int getHorizontalAlignment() { return JLabel.CENTER; } };
	@SuppressWarnings("serial")
	JLabel labelCoteSpec = new JLabel()	{ public int getHorizontalAlignment() { return JLabel.CENTER; } };
	@SuppressWarnings("serial")
	JLabel labelSladV = new JLabel()	{ public int getHorizontalAlignment() { return JLabel.CENTER; } };
	@SuppressWarnings("serial")
	JLabel labelBiovolInd = new JLabel(){ public int getHorizontalAlignment() { return JLabel.CENTER; } };
	@SuppressWarnings("serial")
	JLabel labelTrophie = new JLabel()	{ public int getHorizontalAlignment() { return JLabel.CENTER; } };
	
	private JComboBox<String> code_nom = new JComboBox<String>();
	private JButton previous = new JButton("<");
	private JButton next = new JButton(">");
	private JTextField date = new JTextField();
	private JCheckBox isValide = new JCheckBox();
	private JTextField nom = new JTextField();
	private JTextField code = new JTextField();
	private JTextField sandre = new JTextField();
	private JTextField omnidia = new JTextField();
	private JTextField auteur = new JTextField();
	private JTextField code_ref = new JTextField();
	private JTextField grp_algal = new JTextField();
	private JTable regne = null;
	private Recherche_Frame self = null;
	private JList<String> ref = new JList<String>();
	private JTextField indiv = new JTextField();
	private JTextField biovolcel = new JTextField();
	private JTextField biovolind = new JTextField();
	private JTextField coef = new JTextField();
	private JTextField cote = new JTextField();
	private JTextField trophie = new JTextField();
	private JTextField slads = new JTextField();
	private JTextField sladv = new JTextField();
	private JTextField forme_ind = new JTextField();
	private JTextField forme_cel = new JTextField();
	private DefaultListModel<String> model = new DefaultListModel<String>();
	private Recherche_Query rq;
	@SuppressWarnings("unused")
	private Boolean throwable = true;
	private JMenuItem close_menu_item = new JMenuItem();
	private JMenuItem biblio = new JMenuItem();
	private JMenuItem date_version = new JMenuItem();
	private Consultation_Query c_query;

	public Recherche_Frame(Locale locale, String db_link) 
	{
		super();
		self = this;
		this.locale = locale;
		this.db_link = db_link;
		
		rq = new Recherche_Query(db_link);
		c_query = new Consultation_Query(db_link);
		
		this.setLayout(new BorderLayout());
		this.setBackground(new Color(192, 197, 199));
		this.getContentPane().setBackground(new Color(192, 197, 199));
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		this.add_panels(locale);
		this.add_listeners();
		this.add_menu();
		
		this.translate(locale);

		this.pack();
		this.setResizable(false);
		this.setLocation(200, 200);
		this.setSize(new Dimension(this.getWidth() + 100, this.getHeight()));
		this.setVisible(true);
		
	}

	//constructeur pour afficher toutes les infos d'un taxon valide slectionn
	public Recherche_Frame(Locale locale, String db_link, String code) {
		super();
		self = this;
		this.locale = locale;
		this.db_link = db_link;
		this.code_choisi = code;
		
		rq = new Recherche_Query(db_link);
		c_query = new Consultation_Query(db_link);
		
		this.setLayout(new BorderLayout());
		this.setBackground(new Color(192, 197, 199));
		this.getContentPane().setBackground(new Color(192, 197, 199));
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		this.add_panels(locale);
		this.add_listeners();
		this.add_menu();
		
		this.translate(locale);

		this.pack();
		this.setResizable(false);
		this.setLocation(200, 200);
		this.setSize(new Dimension(this.getWidth() + 100, this.getHeight()));
		this.setVisible(true);
		
		show_infos(code_choisi, true);
	}

	private void add_menu()
	{

		JMenuBar menu_bar = new JMenuBar();
		file_menu.add(close_menu_item);
		menu_bar.add(file_menu);
		menu_bar.add(apropos);
		date_version.setText(c_query.get_last_date());
		version.add(date_version);
		apropos.add(version);
		apropos.add(biblio);
		this.setJMenuBar(menu_bar);
	}

	/**
	 * Rempli les champs d'informations avec les informations d'un taxon donn
	 * @param code : code d'un taxon
	 * @param isCode
	 */
	private void show_infos( String code, boolean isCode )
	{
		throwable = false;
		// rcupration des informations du taxon
		String[] data = rq.get_all_from_liste(code.replaceAll("'", "\\\\'"), isCode);
		
		if( data != null )
		{
			sandre.setText( ( (data[0] == null) ? "" : data[0] ) );
			this.code.setText(data[1]);
			nom.setText(data[2]);
			nom.setFont(nom.getFont().deriveFont(Font.ITALIC));
			int id_auteur = Integer.parseInt(data[3]);
			int id_taxinomie = Integer.parseInt(data[4]);
			indiv.setText(data[5]);
			biovolcel.setText( ( (data[6].compareTo("0.0") == 0) ? "" : data[6] ) );
			biovolind.setText( ( (data[7].compareTo("0.0") == 0) ? "" : data[7] ) );
			grp_algal.setText( ( (data[8].compareTo("0") == 0) ? "" : data[8] ) );
			omnidia.setText( ( (data[9] == null) ? "" : data[9] ) );
			date.setText(data[10]);
			coef.setText(( (data[11].compareTo("0.0") == 0) ? "" : data[11] ));
			cote.setText(( (data[12].compareTo("0.0") == 0) ? "" : data[12] ));
			trophie.setText(( (data[13].compareTo("0.0") == 0) ? "" : data[13] ));
			slads.setText(( (data[14].compareTo("0.0") == 0) ? "" : data[14] ));
			sladv.setText(( (data[15].compareTo("0") == 0) ? "" : data[15] ));
			isValide.setSelected( ( (data[16].compareTo("0") == 0) ? false : true ));
			forme_cel.setText(((data[17].compareTo("0") == 0) ? "" : data[17] ) );
			forme_ind.setText(((data[18].compareTo("0") == 0) ? "" : data[18] ) );

			auteur.setText(rq.get_auteur(id_auteur));
			if(regne.getRowCount() > 0)
				((DefaultTableModel)regne.getModel()).removeRow(0);

			String[] da = rq.get_taxinomie(id_taxinomie);

			((DefaultTableModel)regne.getModel()).addRow(da);
			((DefaultTableModel)regne.getModel()).fireTableDataChanged();
			code_ref.setText(rq.get_ref(data[1]));
			String[] d = rq.get_parents(data[1]);
			model.clear();
			for( String s : d )
				model.addElement(s);

			code_nom.removeAllItems();
			if( isCode )
				code_nom.addItem(code.toUpperCase());
			else
				code_nom.addItem(code);
		}
		throwable = true;
	}

	private void add_listeners()
	{
		// traduction des boites de dialogue
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		close_menu_item.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						self.dispose();
					}});

		((JTextField)code_nom.getEditor().getEditorComponent()).addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						String text = ((JTextField)e.getSource()).getText();
						show_infos(text, (((text.length() == 6) ? true : false )));
					}});
		
		// gestion de l'auto-slection du code d'un taxon lorsque l'on commence  taper son code
		code_nom.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					
					public void keyReleased(KeyEvent e){
						throwable = false;
						
						if( e.getKeyCode() != KeyEvent.VK_DOWN 
								&& e.getKeyCode()!= KeyEvent.VK_UP)
						{
							String typed = ((JTextField)e.getSource()).getText();
							code_nom.removeAllItems();
							code_nom.addItem(typed);
							String[] data = rq.get_noms_codes_like(typed.replaceAll("'", "\\\\'"));
							if( data != null )
								for( String s : data )
									code_nom.addItem(s);

							if( e.getKeyChar() != KeyEvent.VK_ENTER )
							{
								code_nom.hidePopup();
								code_nom.showPopup();
							}
						}
						throwable = true;
					}
					public void keyTyped(KeyEvent arg0) {}
				});

		next.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						String text = (String)code_nom.getSelectedItem();
						if( text != null )
							if( text.length() > 5 )
							{
								String code = rq.get_next( text );
								if( code.compareTo("") != 0 )
									show_infos(code, (((text.length() == 6) ? true : false )));
							}
					}});

		previous.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						String text = (String)code_nom.getSelectedItem();
						if( text != null )
							if( text.length() > 5 )
							{
								String code = rq.get_previous( text );
								if( code.compareTo("") != 0 )
									show_infos(code, (((text.length() == 6) ? true : false )));
							}
					}});

		biblio.addActionListener(
				new ActionListener() {
					@SuppressWarnings("static-access")
					public void actionPerformed(ActionEvent e) {

						File bibli = new File("Docs/biblio.pdf");

						if(!bibli.exists())
							bibli = new File("biblio.pdf");

						System.out.println(bibli.getAbsolutePath());

						if(Desktop.isDesktopSupported()) 
						{
							if(Desktop.getDesktop().isSupported(java.awt.Desktop.Action.OPEN))
							{
								try { java.awt.Desktop.getDesktop().open(bibli);} 
								catch (IOException ex) { ex.printStackTrace(); }
							} 
							else 
								new JOptionPane().showMessageDialog(self, rb.getString("mssgFonctionNonSupportee"), 
										rb.getString("titreBoxFonctionNonSupp"), JOptionPane.ERROR_MESSAGE);
						}
						else
							new JOptionPane().showMessageDialog(self, rb.getString("mssgFonctionNonSupportee"), 
									rb.getString("titreBoxFonctionNonSupp"), JOptionPane.ERROR_MESSAGE);
					}});
	}

	@SuppressWarnings("serial")
	private void add_panels(Locale locale)
	{
		
		// uniquement necessaire pour la traduction des colonnes de la table
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		
		
		recherche.setBackground(new Color(192, 197, 199));
	
		code_nom.setPreferredSize(new Dimension(300, 20));
		code_nom.setEditable(true);
		
		recherche.add(code_nom);
		recherche.add(previous);
		recherche.add(next);
		
		recherche.add(labelMAJ);
		date.setPreferredSize(new Dimension(75, 20));
		date.setEditable(false);
		recherche.add(date);
		isValide.setEnabled(false);
		isValide.setBackground(new Color(192, 197, 199));
		recherche.add(isValide);

		infos.setBackground(new Color(192, 197, 199));
		JPanel up = new JPanel(new FlowLayout());
		up.setBackground(new Color(192, 197, 199));
		sandre.setEditable(false);
		sandre.setPreferredSize(new Dimension(50,20));
		up.add(labelCodeSandre);
		up.add(sandre);
		nom.setPreferredSize(new Dimension(250,20));
		nom.setEditable(false);
		up.add(labelNom);
		up.add(nom);
		up.add(labelAuteur);
		auteur.setPreferredSize(new Dimension(250,20));
		auteur.setEditable(false);
		up.add(auteur);

		infos.add(up, BorderLayout.NORTH);

		JPanel left = new JPanel(new FlowLayout());
		left.setBackground(new Color(192, 197, 199));
		code.setEditable(false);
		code.setPreferredSize(new Dimension(75, 20));
		left.add(labelCodeTaxon);
		left.add(code);
		left.add(labelCodeRef);
		code_ref.setPreferredSize(new Dimension(60,20));
		code_ref.setEditable(false);
		left.add(code_ref);
		omnidia.setEditable(false);
		omnidia.setPreferredSize(new Dimension(50,20));
		left.add(labelCodeOmnidia);
		left.add(omnidia);
		left.add(labelGrpAlgal);
		grp_algal.setPreferredSize(new Dimension(50,20));
		grp_algal.setEditable(false);
		left.add(grp_algal);

		// traduction des colonnes de la table
		String[] col = { rb.getString("colRegne"), rb.getString("colSousRegne"), 
						rb.getString("colEmbranchement"), rb.getString("colClasse"), 
						rb.getString("colOrdre"), rb.getString("colSousOrdre"), 
						rb.getString("colFamille") };


		String[][] row = null;
		regne = new JTable(new DefaultTableModel(row, col)) { public boolean isCellEditable(int row, int col) { return false; };};
		regne.getTableHeader().setReorderingAllowed(false);
		regne.getTableHeader().setResizingAllowed(false);
		regne.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		
		int nbColumns = 7;
		for(int i=0; i<nbColumns; i++){
			regne.getColumnModel().getColumn(i).setPreferredWidth(150);
		}

		
		JPanel btm = new JPanel(new FlowLayout());
		btm.setBackground(new Color(192, 197, 199));
		btm.add(labelFormeCel);
		btm.add(forme_cel);
		forme_cel.setPreferredSize(new Dimension(170,20));
		btm.add(Box.createHorizontalStrut(5));
		btm.add(Box.createHorizontalStrut(5));
		btm.add(labelFormeInd);
		btm.add(forme_ind);
		forme_ind.setPreferredSize(new Dimension(170,20));
		btm.add(Box.createHorizontalStrut(5));

		JScrollPane center = new JScrollPane(regne, JScrollPane.VERTICAL_SCROLLBAR_NEVER, 
													JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		center.setBackground(new Color(192, 197, 199));
		center.setPreferredSize(new Dimension(500, 55));

		JPanel syn = new JPanel();
		syn.setLayout(new BoxLayout(syn, BoxLayout.PAGE_AXIS));
		syn.setBackground(new Color(192, 197, 199));
		JScrollPane list = new JScrollPane(ref);
		list.setPreferredSize(new Dimension(30, 50));
		syn.add(labelCodesSyn);
		ref.setModel(model);
		syn.add(list);
		left.add(syn);

		JPanel l = new JPanel(new BorderLayout());
		l.setBackground(new Color(192, 197, 199));
		l.add(left, BorderLayout.NORTH);
		l.add(btm, BorderLayout.CENTER);
		l.add(center, BorderLayout.SOUTH);

		infos.add(l, BorderLayout.CENTER);

		JPanel autres = new JPanel( new GridLayout(3,6));
		autres.setBackground(new Color(192, 197, 199));
		autres.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
				new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)));
		autres.add(labelTypeInd);
		indiv.setEditable(false);
		autres.add(indiv);
		autres.add(labelBioVolCel);
		biovolcel.setEditable(false);
		autres.add(biovolcel);
		autres.add(labelBiovolInd);
		biovolind.setEditable(false);
		autres.add(biovolind);
		autres.add(labelCoefSteno);
		coef.setEditable(false);
		autres.add(coef);
		autres.add(labelCoteSpec);
		cote.setEditable(false);
		autres.add(cote);
		autres.add(labelTrophie);
		trophie.setEditable(false);
		autres.add(trophie);
		autres.add(labelSladS);
		slads.setEditable(false);
		autres.add(slads);
		autres.add(labelSladV);
		sladv.setEditable(false);
		autres.add(sladv);

		this.add(recherche, BorderLayout.NORTH);
		this.add(infos, BorderLayout.CENTER);
		this.add(autres, BorderLayout.SOUTH);
	}
	
	
	/**
	 * Traduction dans la bonne langue des textes
	 * @param locale
	 */
	public void translate(Locale locale){
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		// nom de la fentre
		this.setTitle(rb.getString("titreFenRechercheTaxons"));	

		file_menu.setText(rb.getString("fichier"));
		close_menu_item.setText(rb.getString("fermer"));
		biblio.setText(rb.getString("bibliographie"));
		
		version.setText(rb.getString("versionDu"));
		
		isValide.setText(rb.getString("valide"));
		
		recherche.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("sectionCodeNom"), TitledBorder.LEADING, TitledBorder.CENTER));
		
		infos.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("infos"), TitledBorder.CENTER, TitledBorder.CENTER));
		

		labelMAJ.setText(rb.getString("champMAJ"));
		labelCodeSandre.setText(rb.getString("champCodeSandre"));
		labelNom.setText(rb.getString("champNom"));
		labelAuteur.setText(rb.getString("champAuteur"));
		labelCodeTaxon.setText(rb.getString("champCodeTaxon"));
		labelCodeRef.setText(rb.getString("champCodeRef"));
		labelCodeOmnidia.setText(rb.getString("champCodeOMNIDIA"));
		labelGrpAlgal.setText(rb.getString("champGrpAlgal"));
		
		labelCodesSyn.setText(rb.getString("champCodeSyn"));
		labelFormeCel.setText(rb.getString("champFormeCel"));
		labelFormeInd.setText(rb.getString("champFormeIndiv"));
		labelTypeInd.setText(rb.getString("champTypeIndiv"));
		labelCoefSteno.setText(rb.getString("champCoefSteno"));
		
		labelSladS.setText(rb.getString("champSladS"));
		labelBioVolCel.setText(rb.getString("champBiovolCel"));
		labelCoteSpec.setText(rb.getString("champCoteSpec"));
		labelSladV.setText(rb.getString("champSladV"));
		labelBiovolInd.setText(rb.getString("champBiovolInd"));
		labelTrophie.setText(rb.getString("champTrophie"));
		
		//ragencement de la position des items de la fentre
		this.pack();
	}
	

}
