package C_R_Valides;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import utils.Define;

public class Recherche_Query {
	private Connection connection = null;
	private Statement query = null;
	
	@SuppressWarnings("unused")
	private String db_link;

	public Recherche_Query(String db_link)
	{
		this.db_link = db_link;
		
		try
		{
			// connexion  la BD
			Class.forName("com.mysql.jdbc.Driver");
			String url = "jdbc:mysql://" + db_link + "/" + new Define().get_db_name();
			connection = DriverManager.getConnection(url, new Define().get_user(), new Define().get_pass());
			query = connection.createStatement();
		}
		catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	
	/**
	 * 
	 * @param code d'un taxon
	 * @return le code de rfrence d'un taxon donn
	 */
	public String get_ref( String code )
	{
		String returned = null;
		try
		{
			ResultSet rs = query.executeQuery("SELECT code_taxon_ref "
					+ "FROM synonymes "
					+ "WHERE code_taxon = '" + code + "'");
			rs.next();
			returned = rs.getString(1);
			if( returned.compareTo(code) == 0 )
				returned = "";
		}
		catch(SQLException e) { e.printStackTrace(); }

		return returned;
	}

	/**
	 * 
	 * @param code d'un taxon
	 * @return code d'un taxon prcdant un autre taxon donn
	 */
	public String get_previous(String code)
	{
		String returned = null;
		ResultSet rs = null;
		try
		{
			if( code.length() == 6)
				rs = query.executeQuery("SELECT code_taxon "
						+ "FROM liste_taxa "
						+ "WHERE code_taxon < '" + code + "' "
								+ "ORDER BY code_taxon DESC LIMIT 1");
			else
				if( code.length() > 6)
					rs = query.executeQuery("SELECT nom_taxon "
							+ "FROM liste_taxa "
							+ "WHERE nom_taxon < '" + code + "' "
									+ "ORDER BY nom_taxon DESC LIMIT 1");

			if( rs.next() )
				returned = rs.getString(1);
			else
				returned = "";
		}
		catch(SQLException e) { e.printStackTrace(); }

		return returned;
	}
	
	
	/**
	 * 
	 * @param code d'un taxon
	 * @return code du taxon suivant dans la base de donnes
	 */
	public String get_next( String code)
	{
		String returned = null;
		ResultSet rs = null;
		try
		{
			if( code.length() == 6 )
				rs = query.executeQuery("SELECT code_taxon "
						+ "FROM liste_taxa "
						+ "WHERE code_taxon > '" + code + "' "
						+ "ORDER BY code_taxon LIMIT 1");
			else
				if( code.length() > 6 )
					rs = query.executeQuery("SELECT nom_taxon "
							+ "FROM liste_taxa "
							+ "WHERE nom_taxon > '" + code + "' "
							+ "ORDER BY nom_taxon LIMIT 1");

			if( rs.next() )
				returned = rs.getString(1);
			else
				returned = "";
		}
		catch(SQLException e) { e.printStackTrace(); }

		return returned;
	}

	
	/**
	 * 
	 * @param code
	 * @return un tableau contenant les codes des taxons parents d'un taxon donn
	 */
	public String[] get_parents( String code )
	{
		String[] returned = null;
		ArrayList<String> tmp = new ArrayList<String>();
		try
		{
			ResultSet rs = query.executeQuery("SELECT code_taxon "
					+ "FROM synonymes "
					+ "WHERE code_taxon_ref = '" + code + "'");

			while(rs.next())
				if(rs.getString(1).compareTo(code) != 0)
					tmp.add(rs.getString(1));

			if( tmp.size() > 0)
			{
				returned = new String[tmp.size()];
				for( int i = 0; i < tmp.size(); i++ )
					returned[i] = tmp.get(i);
			}	
			else
			{
				returned = new String[1];
				returned[0] = "";
			}
		}
		catch(SQLException e) { e.printStackTrace(); }

		return returned;
	}
	
	
	/**
	 * 
	 * @param id d'une taxinomie
	 * @return un tableau contenant toute la taxinomie
	 */
	public String[] get_taxinomie(int id)
	{
		String[] returned = new String[7];
		try
		{
			ResultSet rs = query.executeQuery("SELECT * "
					+ "FROM taxinomie "
					+ "WHERE id_taxinomie = " + id);
			rs.next();
			for( int i = 0; i < 7; i++ )
			{
				returned[i] = rs.getString(i+2);
				if( returned[i] == null)
					returned[i] = "";
			}
		}
		catch(SQLException e) { e.printStackTrace(); }

		return returned;
	}
	
	
	/**
	 * 
	 * @param id d'un auteur
	 * @return nom d'un auteur donn
	 */
	public String get_auteur( int id )
	{
		String returned = null;
		try
		{
			ResultSet rs = query.executeQuery("SELECT nom_auteur "
					+ "FROM auteurs "
					+ "WHERE id_auteur = " + id);
			rs.next();
			returned = rs.getString(1);	
		}
		catch(SQLException e) { e.printStackTrace(); }

		return returned;
	}
	
	
	/**
	 * 
	 * @param code d'un taxon
	 * @param isCode
	 * @return un tableau contenant toutes les informations d'un taxon donn
	 */
	public String[] get_all_from_liste( String code, Boolean isCode )
	{
		String[] returned = new String[19];
		ResultSet rs = null;
		try
		{
			if( isCode )
				rs = query.executeQuery("SELECT code_sandre, code_taxon, nom_taxon, id_auteur, id_taxinomie, indiv_defaut, " +
						" biovolcel, biovolind, groupe_algual, code_omnidia, date_maj, coef_stenoecie," +
						" cote_specifique, trophie, slad_s, slad_v, valide, id_forme_cel, id_forme_ind "
						+ "FROM liste_taxa "
						+ "WHERE code_taxon = '" + code +"'");
			else
				rs = query.executeQuery("SELECT * "
						+ "FROM liste_taxa "
						+ "WHERE nom_taxon = '" + code +"'");
			
			// rcupration des donnes
			if( rs.next() )
			{
				returned[0] = rs.getString("code_sandre");
				returned[1] = rs.getString("code_taxon");
				returned[2] = rs.getString("nom_taxon");
				returned[3] = Integer.toString(rs.getInt("id_auteur"));
				returned[4] = Integer.toString(rs.getInt("id_taxinomie"));
				returned[5] = rs.getString("indiv_defaut");
				returned[6] = Float.toString(rs.getFloat("biovolcel"));
				returned[7] = Float.toString(rs.getFloat("biovolind"));
				returned[8] = Integer.toString(rs.getInt("groupe_algual"));
				returned[9] = rs.getString("code_omnidia");
				returned[10] = rs.getString("date_maj");
				returned[11] = Float.toString(rs.getFloat("coef_stenoecie"));
				returned[12] = Float.toString(rs.getFloat("cote_specifique"));
				returned[13] = Float.toString(rs.getFloat("trophie"));
				returned[14] = Float.toString(rs.getFloat("slad_s"));
				returned[15] = Integer.toString(rs.getInt("slad_v"));
				returned[16] = Integer.toString(rs.getInt("valide"));	
				returned[17] = Integer.toString(rs.getInt("id_forme_cel"));	
				returned[18] = Integer.toString(rs.getInt("id_forme_ind"));	
			}
			else
				return null;
		}
		catch(SQLException e) { e.printStackTrace(); }

		// si la forme cellulaire est renseigne
		if(  Integer.parseInt(returned[17]) != 0){
			try
			{
				rs = query.executeQuery("SELECT nom_forme AS forme_cel "
						+ "FROM formes "
						+ "WHERE id_forme = '" + returned[17]+"'");
				rs.next();
				returned[17] = rs.getString("forme_cel");	
			}
			catch(SQLException e) { e.printStackTrace(); }
		}
		
		
		// si la forme individuelle est renseigne
		if(  Integer.parseInt(returned[18]) != 0 ){
			try
			{
				rs = query.executeQuery("SELECT nom_forme AS forme_ind "
						+ "FROM formes "
						+ "WHERE id_forme = '" + returned[18]+"'");
				rs.next();
				returned[18] = rs.getString("forme_ind");	
			}
			catch(SQLException e) { e.printStackTrace(); }
		}
		return returned;
	}
	
	
	/**
	 * 
	 * @param debut : String
	 * @return un tableau contenant tous les codes des taxons valids dont le code ou le nom 
	 * commence par la chane de caractres debut 
	 */
	public String[] get_noms_codes_like(String debut)
	{
		String[] returned = null;
		ArrayList<String> tmp = new ArrayList<String>();
		try
		{
			ResultSet rs = query.executeQuery("SELECT code_taxon "
					+ "FROM liste_taxa "
					+ "WHERE code_taxon LIKE '" + debut + "%' "
					+ "UNION ALL "
					+ "SELECT nom_taxon "
					+ "FROM liste_taxa "
					+ "WHERE nom_taxon LIKE '" + debut + "%' "
					+ "ORDER BY code_taxon");

			while(rs.next())
				tmp.add(rs.getString(1));

			if( tmp.size() > 0)
			{
				returned = new String[tmp.size()];
				for( int i = 0; i < tmp.size(); i++ )
					returned[i] = tmp.get(i);
			}
		}
		catch(SQLException e) { e.printStackTrace(); }

		return returned;
	}

}
