package Calcul_Biovolume;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.text.MaskFormatter;

import Comptage.Ajout_Site;

public class Calcul_Biovolume_Frame extends JFrame{

	private static final long serialVersionUID = 1L;
	private Locale locale;
	private String db_link;

	private Calcul_Biovolume_Frame self = null;

	private JMenu menu_fichier = new JMenu();
	private JMenuItem save_close = new JMenuItem();
	private JMenuItem no_save_close = new JMenuItem();
	private JMenuItem open = new JMenuItem();

	private JLabel banniere = new JLabel();

	private JPanel infosTaxon_pane = null; 
	private JPanel tmp_pane = null; 
	private JPanel table_pane = null; 
	private JScrollPane __scrollPane = null;

	private JButton modif_forme = new JButton();
	private JButton validation = new JButton();
	private JButton modification = new JButton();
	private JButton ajouter_ligne = new JButton(" + ");
	private JButton calculer = new JButton();

	private  Calcul_Biovolume_Query calcul_biovol_query;
	private Calcul_Biovolume_Table __table = null;

	private int opti_width;
	private int id_calcul = 0;
	private String typeTaxon = null;

	private JLabel labelCode = new JLabel();
	private JLabel labelNom = new JLabel();
	private JLabel labelAuteur = new JLabel();
	private JLabel labelTaxinomiste = new JLabel();
	private JLabel labelObjMes = new JLabel();
	private JLabel labelForme = new JLabel();
	private JLabel labelFormule = new JLabel();
	private JLabel labelBiovolCel = new JLabel();
	private JLabel labelBiovolInd = new JLabel();
	private JLabel labelCom = new JLabel();

	JLabel labelRens = new JLabel();

	private JLabel labelSite = new JLabel();
	private JLabel labelStation = new JLabel();
	private JLabel labelMilieu = new JLabel();
	private JLabel labelDate = new JLabel();
	private JLabel labelRefEch = new JLabel();
	private JLabel labelBiovolMoy = new JLabel();
	private JLabel labelBiovolMin = new JLabel();
	private JLabel labelBiovolMax = new JLabel();
	private JLabel labelNbCellMoy = new JLabel();

	private JTextField commentaire = new JTextField("");
	private JTextField auteur = new JTextField();
	private JTextField forme = new JTextField();
	private JTextField formule = new JTextField();
	private JTextField milieu = new JTextField();
	private JTextField taximoniste = new JTextField();
	private JTextField biovolcel_outil = new JTextField();
	private JTextField biovolind_outil = new JTextField();
	private JFormattedTextField date = null;
	private JTextField ref_ech = new JTextField();

	private DecimalFormat df = (DecimalFormat)DecimalFormat.getNumberInstance();

	private boolean calculEnCours = false;

	private JTextField biovol_moy = new JTextField();
	private JTextField biovol_min = new JTextField();
	private JTextField biovol_max = new JTextField();
	private JTextField nb_cellule_moy = new JTextField();

	private JComboBox<String> station = new JComboBox<String>();
	private JComboBox<String> code = new JComboBox<String>();
	private JComboBox<String> objet_mesure = null;
	private JComboBox<String> lieu = null;
	private JComboBox<String> nom = new JComboBox<String>();

	private ImageIcon _image = new ImageIcon(getClass().getClassLoader().getResource("images/no_img.png"));
	private JLabel ImgLabel = new JLabel(_image);	
	private int frameHeight, frameWidth;
	private boolean isCol = false;
	private boolean throwable = true;
	private static String tmp_code = null;
	private String[] biovols = null;	
	private static int nb_forme= 0;

	private boolean enModif = false;
	private boolean enModification = false;
	private boolean chgtForme = false;

	public Calcul_Biovolume_Frame(Locale locale, String db_link)
	{
		super();
		self = this;
		this.locale = locale;
		this.db_link = db_link;

		calcul_biovol_query = new Calcul_Biovolume_Query(db_link);

		this.getContentPane().setLayout(new BorderLayout());
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		Toolkit.getDefaultToolkit().setDynamicLayout(true);

		add_menu();
		add_fields();
		this.translate(locale);
		add_handlers();
		draw_frame();
		this.setResizable(true);

		frameWidth = this.getWidth();
		frameHeight = this.getHeight()-300;

		df.applyPattern("0.0");

		DecimalFormatSymbols symbols = new DecimalFormatSymbols();
		symbols.setDecimalSeparator('.');
		df.setDecimalFormatSymbols(symbols);

		self.setMinimumSize(new Dimension( this.getWidth(), this.getHeight()-300));
	}

	// boolen pour ne pas autoriser la fermeture de l'application si l'cran calcul biovol
	// est ouvert avec un calcul 
	public boolean get_closableCalc()
	{
		return (( self != null && (self.get_id_calcul() != 0 || self.new_calc() )) ? false : true);
	}

	private void add_menu()
	{
		JMenuBar menubar = new JMenuBar();
		menu_fichier.add(open);
		menu_fichier.add(save_close);
		menu_fichier.add(no_save_close);
		save_close.setEnabled(false);
		menubar.add(menu_fichier);
		this.setJMenuBar(menubar);

		modification.setEnabled(false);
	}

	private void add_handlers()
	{
		// ncessaire pour la traduction des botes de dialogues
		//	this.locale = locale;
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		this.addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent evt)
			{
				if(self.getHeight() < frameHeight){
					self.setSize(frameWidth, frameHeight);		  
				}
				self.setSize(self.opti_width, self.getHeight());
			}});

		this.addWindowListener(
				new WindowAdapter() {
					public void windowClosing(WindowEvent arg0) {
						if(calculEnCours){
							if(enModif){
								int reponse = JOptionPane.showConfirmDialog(
										self, rb.getString("mssgAnnulationCalcul"),
										rb.getString("titreBoxAnnulationCalcul"), 
										JOptionPane.YES_NO_OPTION);

								if(reponse == 0){
									closeCalcul();
								}
							}
							else{
								int reponse = JOptionPane.showConfirmDialog(
										self, rb.getString("mssgQuitCalcul"),
										rb.getString("titreBoxQuitCalcul"), 
										JOptionPane.YES_NO_OPTION);

								if(reponse == 0){
									calcul_biovol_query.delCalcul(id_calcul);
									closeCalcul();
								}
							}	
						}
						else{
							closeCalcul();
						}
					}});

		__table.addKeyListener(
				new KeyAdapter() {
					public void keyPressed(KeyEvent ke) {
						if ((ke.getModifiers()==KeyEvent.CTRL_MASK) && (ke.getKeyCode()==KeyEvent.VK_B)){
							self.__table.addEmptyLine();
							if(self.__table.getRowCount() > 1)
								calculBiovolRow(self.__table.getRowCount()-2);
						}
					}
				});

		station.addItemListener(
				new ItemListener() {
					String selected;
					String milieu;
					String newStation;
					boolean launched = false;
					@SuppressWarnings("unchecked")
					public void itemStateChanged(ItemEvent e) {
						if( throwable )
						{
							throwable = false;
							self.milieu.setText("");
							selected = (String)((JComboBox<String>)e.getSource()).getSelectedItem();
							if( selected.compareTo(rb.getString("nouvelle")) != 0 )
							{
								milieu = calcul_biovol_query.get_milieu(((String)self.lieu.getSelectedItem()),
										((String)self.station.getSelectedItem()));
								self.milieu.setText(milieu);
							}
							else
							{
								if( ! launched )
								{
									Ajout_Site AjSite = new Ajout_Site(self, true, ((String)self.lieu.getSelectedItem()), locale, db_link);
									station.removeAllItems();
									for( String s : calcul_biovol_query.get_stations( (String)self.lieu.getSelectedItem() ))
										station.addItem(s);
									station.addItem(rb.getString("nouvelle"));
									launched = true;
									newStation = AjSite.obtRepSta();
									station.setSelectedItem(newStation);
									milieu = calcul_biovol_query.get_milieu(((String)self.lieu.getSelectedItem()),
											((String)self.station.getSelectedItem()));
									self.milieu.setText(milieu);

								}
								else
									launched = false;
							}
							throwable = true;
						}	
					}});

		lieu.addItemListener(
				new ItemListener() {
					String selected;
					String[] stations;
					String milieu;
					String newSite;

					boolean launched = false;
					@SuppressWarnings("unchecked")
					public void itemStateChanged(ItemEvent e) {
						if( throwable )
						{
							throwable = false;
							self.station.removeAllItems();
							self.milieu.setText("");
						//	self.date.setText(null);
							selected = (String)((JComboBox<String>)e.getSource()).getSelectedItem();
							if( selected.compareTo(rb.getString("nouveau")) != 0 )
							{
								stations = calcul_biovol_query.get_stations(selected);
								if( stations != null )
								{
									for( String s : stations )
										self.station.addItem(s);
									milieu = calcul_biovol_query.get_milieu(((String)self.lieu.getSelectedItem()),
											((String)self.station.getSelectedItem()));
									self.milieu.setText(milieu);
								}
								else
									self.station.addItem("");
								self.station.addItem(rb.getString("nouvelle"));
							}
							else		// si site nouveau slectionn
							{
								if( launched == false)
								{
									Ajout_Site AjSite = new Ajout_Site(self, false, "", locale, db_link);
									lieu.removeAllItems();
									for( String s : calcul_biovol_query.get_sites("") )
										lieu.addItem(s);
									lieu.addItem(rb.getString("nouveau"));
									launched = true;
									newSite = AjSite.obtRep();
									lieu.setSelectedItem(newSite);
									stations = calcul_biovol_query.get_stations(newSite);

								}
								else
									launched = false;
							}
							throwable = true;
						}
					}});

		lieu.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					String user_input;
					String[] sites;
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent e) {
						if( e.getKeyCode() != KeyEvent.VK_BACK_SPACE
								&& e.getKeyCode() != KeyEvent.VK_UP
								&& e.getKeyCode() != KeyEvent.VK_DOWN) {
							user_input = ((JTextField)e.getSource()).getText().trim();
							sites = calcul_biovol_query.get_sites( user_input.replaceAll("'", "\\\\'") );
							throwable = false;
							if( sites != null ) {
								self.lieu.removeAllItems();
								self.station.removeAllItems();
								self.milieu.setText("");
								//self.date.setText(null);
								if( sites.length > 1 ) {
									self.lieu.addItem(user_input);
									for( String s : sites)
										self.lieu.addItem(s);
									self.lieu.hidePopup();
									self.lieu.showPopup();
								}
								else {
									throwable = true;
									self.lieu.addItem(sites[0]);
								}
								self.lieu.addItem(rb.getString("nouveau"));
							}
							else {
								throwable = false;
								self.lieu.removeAllItems();
								self.station.removeAllItems();
								self.milieu.setText("");
								self.date.setText(null);
								self.lieu.addItem(user_input);
								self.lieu.addItem("");
								self.lieu.addItem(rb.getString("nouveau"));
							}
						} 
						else {
							throwable = false;
							self.station.removeAllItems();
							self.milieu.setText("");
							self.date.setText(null);
						}
						throwable = true;
					}
					public void keyTyped(KeyEvent e) {}
				});

		modif_forme.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {
						if(enModification == true){
						chgtForme = true;
						}
						else{
							chgtForme = false;
						}
						if(calcul_biovol_query.getNbLines(id_calcul) > 0) {
							calcul_biovol_query.vide_rows(id_calcul);

							System.out.println("cas1"+chgtForme);
							new Modification_Forme_Frame(self, locale, db_link);
						} 
						else {
							System.out.println("cas2"+chgtForme);
						new Modification_Forme_Frame(self, locale, db_link);
						}
					}});

		validation.addActionListener(
				new ActionListener()  {

					String Sdate;
					boolean dateFormat_valid=true;

					private static final String DATE_PATTERN = "yyyy-MM-dd";

					public void actionPerformed(ActionEvent e) {
						date.setBackground(Color.WHITE);
						forme.setBackground(Color.WHITE);
						formule.setBackground(Color.WHITE);
						taximoniste.setBackground(Color.WHITE);
						if (nb_forme < 1) {
							forme.setBackground(Color.RED);
							formule.setBackground(Color.RED);
							JOptionPane.showMessageDialog(self,
									rb.getString("mssgChampNonRens"),
									rb.getString("titreBoxChampNonRens"),
									JOptionPane.ERROR_MESSAGE);
						}
						else {
							if (taximoniste.getText().compareTo("")==0
									||taximoniste.getText() == null) {
								taximoniste.setBackground(Color.RED);
								JOptionPane.showMessageDialog(self,
										rb.getString("mssgChampTaxiNonRens"),
										rb.getString("titreBoxChampTaxiNonRens"),
										JOptionPane.ERROR_MESSAGE);
							}
							else {
								if (lieu.getSelectedItem()!="") {
									if(!date.getText().matches("([1-2]([0-9]{3}))-((0[1-9])|(1[0-2]))-(([0-2][1-9])|10|20|(3[0-1]))")
											) {
										System.out.println(date.getText());
										JOptionPane.showMessageDialog(self,
												rb.getString("mssgMauvaiseDate"),
												rb.getString("titreBoxMauvaiseDate"),
												JOptionPane.ERROR_MESSAGE);
										date.setBackground(Color.RED);
									}
									else {
										Sdate=date.getText();
										SimpleDateFormat sdf = new SimpleDateFormat();
										sdf.applyPattern(DATE_PATTERN);
										try {
											sdf.setLenient(false); //on accepte pas une date irrelle du genre 30 fv ou 31 avril
											Date d = sdf.parse(Sdate);
											System.out.println(Sdate);
											System.out.println(d);

										}
										catch(ParseException pe) {
											dateFormat_valid = false;
										}
										if (dateFormat_valid==false) {
											date.setBackground(Color.RED);
											dateFormat_valid=true;

										}
										else {
											date.setBackground(Color.WHITE);
											dateFormat_valid=true;

											//Ajout d'une colonne nb_cellule si on choisit Col. ou Fil.
											if(objet_mesure.getSelectedItem() == objet_mesure.getItemAt(2) 
													|| objet_mesure.getSelectedItem() == objet_mesure.getItemAt(3)) {
												if(enModification==true) {
													if(chgtForme==true) {
														updateCalc();
														disableAll();
														__table.refresh(nb_forme, id_calcul, true);
														chgtForme=false;
														isCol = true;
													}
													else {
													updateCalc();
													disableAll();
													isCol = true;
													}
												}
												else {
													addCalcul();
													disableAll();
													__table.refresh(nb_forme, id_calcul, true);
													isCol = true;
												}
											}
											else {
												if(enModification==true) {
													if(chgtForme == true) {
														updateCalc();
														disableAll();
														__table.refresh(nb_forme, id_calcul, false);
														chgtForme=false;
														isCol = false;
													}
													else {
													updateCalc();
													disableAll();
													isCol = false;
													}
												}
												else {
													addCalcul();
													disableAll();
													__table.refresh(nb_forme, id_calcul,  false);
													isCol = false;
												}
											}
										}
									}
								}
								else {
									System.out.println(enModification);

									if (date.getText().compareTo("    -  -  ") != 0) {
										nom.setBackground(Color.RED);
										date.setBackground(Color.RED);
									}
									else {
										//Ajout d'une colonne nb_cellule si on choisit Col. ou Fil.
										if(objet_mesure.getSelectedItem() == objet_mesure.getItemAt(2) 
												|| objet_mesure.getSelectedItem() == objet_mesure.getItemAt(3)) {
											if(enModification==true) {
												if(chgtForme ==true) {
													updateCalc();
													disableAll();
													__table.refresh(nb_forme, id_calcul, true);
													chgtForme=false;
													isCol = true;
												}
												else {
												updateCalc();
												disableAll();
												isCol = true;
												}
											}
											else {
												addCalcul();
												disableAll();
												__table.refresh(nb_forme, id_calcul, true);
												isCol = true;
											}
										}
										else {
											if(enModification==true) {
												if(chgtForme ==true) {
													updateCalc();
													disableAll();
													__table.refresh(nb_forme, id_calcul, false);
													chgtForme = false;
													isCol = false;
												}
												else {
												updateCalc();
												disableAll();
												isCol = false;
												}
											}
											else {
												addCalcul();
												disableAll();
												__table.refresh(nb_forme, id_calcul,  false);
												isCol = false;
											}
										}
									}
								}	
							}
						}					
					}});

		modification.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e){
				new JOptionPane();
				if (JOptionPane.showConfirmDialog(self,
						rb.getString("mssgConfirmModifInfos"),
						rb.getString("titreBoxConfirmModifInfos"), 
						JOptionPane.YES_NO_OPTION,
						JOptionPane.WARNING_MESSAGE) == JOptionPane.YES_OPTION) {

					//	passage en modification d'un calcul
					enModification=true;
					// dblocage de tous les champs dans le cartouche
					reactiveAll();
				}
			}
		});

		open.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {	
						new Ouvrir_Calcul(self, false, false, locale, db_link);
					}});

		no_save_close.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {	
						if(calculEnCours){
							if(enModif){
								int reponse = JOptionPane.showConfirmDialog(
										self, rb.getString("mssgAnnulationCalcul"),
										rb.getString("titreBoxAnnulationCalcul"), 
										JOptionPane.YES_NO_OPTION);

								if(reponse == 0){
									closeCalcul();
								}
							}
							else{
								int reponse = JOptionPane.showConfirmDialog(
										self, (rb.getString("mssgQuitCalcul")),
										(rb.getString("titreBoxQuitCalcul")), 
										JOptionPane.YES_NO_OPTION);

								if(reponse == 0){
									calcul_biovol_query.delCalcul(id_calcul);
									closeCalcul();
								}
							}	
						}
						else{
							closeCalcul();
						}
					}});

		save_close.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {	
						boolean emptyDim = false;
						for(int i = 0; i<self.__table.getRowCount() ; i++){
							calculBiovolRow(i);
							if( self.__table.dimEmpty(i) )
								emptyDim = true;
						}

						if(!emptyDim && self.__table.getRowCount() > 0){
							self.biovols = self.__table.calculBiovols(isCol);

							biovol_moy.setText(self.biovols[0]);
							biovol_max.setText(self.biovols[1]);
							biovol_min.setText(self.biovols[2]);
							nb_cellule_moy.setText(self.biovols[3]);

							if(enModif){
								System.out.println("en modif");
								if(enModification== true){
									if(calcul_biovol_query.getNbLines(id_calcul) > 0) {
										__table.updateLines(id_calcul);
										enModification = false;
									}
									else{
									__table.addLines(id_calcul);
									enModification = false;
									}
								}
								else {
								__table.updateLines(id_calcul);
								}
							}
							else{
								System.out.println("pas en modif");
								__table.addLines(id_calcul);
							}

							calcul_biovol_query.updateCalcul(id_calcul, 
									Float.parseFloat(biovol_moy.getText()), 
									Float.parseFloat(biovol_min.getText()), 
									Float.parseFloat(biovol_max.getText()), 
									nb_cellule_moy.getText(), commentaire.getText(), 
									isCol);
							//met  "" la date si la date ="    -  -  "
							calcul_biovol_query.set_dateNull(id_calcul);

							closeCalcul();

						}
						else{
							if(self.__table.getRowCount() == 0){
								int reponse = JOptionPane.showConfirmDialog(
										self, rb.getString("mssgComptageVide"),
										rb.getString("titreBoxComptageVide"), 
										JOptionPane.YES_NO_OPTION);
								if(reponse == 0){
									if(enModif){
										System.out.println("en modif");
										__table.updateLines(id_calcul);
									}
									else{
										System.out.println("pas en modif");
										__table.addLines(id_calcul);
									}

									float f = 0;

									calcul_biovol_query.updateCalcul(id_calcul, f, f, f, "0", 
											commentaire.getText(), isCol);

									//met  "" la date si la date ="    -  -  "
									calcul_biovol_query.set_dateNull(id_calcul);

									closeCalcul();
								}

							}
							else if(self.__table.getRowCount() > 0 && emptyDim){

								JOptionPane.showMessageDialog(self,
										rb.getString("mssgCasesVides"),
										rb.getString("titreBoxCasesVides"),
										JOptionPane.ERROR_MESSAGE);

							}
							else{
								//met  "" la date si la date ="    -  -  "
								calcul_biovol_query.set_dateNull(id_calcul);

								closeCalcul();
							}	
						}
					}});

		ajouter_ligne.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {
						self.__table.addEmptyLine();
						// s'il y a au moins une ligne prcdente  calculer
						if(self.__table.getRowCount() > 1)
							calculBiovolRow(self.__table.getRowCount()-2);
					}});

		calculer.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {
						System.out.println(self.__table.getRowCount());
						boolean emptyDim = false;
						for(int i = 0; i<self.__table.model.getRowCount(); i++){
							calculBiovolRow(i);
							if( self.__table.dimEmpty(i) )
								emptyDim = true;
						}


						if(emptyDim){
							JOptionPane.showMessageDialog(self,
									rb.getString("mssgDimManquantes"),
									rb.getString("titreBoxDimManquantes"),
									JOptionPane.WARNING_MESSAGE);
						}

						self.biovols = self.__table.calculBiovols(isCol);

						biovol_moy.setText(self.biovols[0]);
						biovol_max.setText(self.biovols[1]);
						biovol_min.setText(self.biovols[2]);
						nb_cellule_moy.setText(self.biovols[3]);
					}});

		((JTextField) code.getEditor().getEditorComponent())
		.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (throwable) {
					throwable = false;
					((JTextField) e.getSource())
					.setText(((JTextField) e.getSource())
							.getText().trim().toUpperCase());
					nom.removeAllItems();
					nom.addItem(calcul_biovol_query
							.get_nom_taxon(((JTextField) e.getSource())
									.getText().trim()));
					nom.setSelectedIndex(0);
					throwable = true;
				}
			}
		});

		code.addItemListener(
				new ItemListener() {
					public void itemStateChanged(ItemEvent arg0) {
						if( arg0.getStateChange() == ItemEvent.SELECTED && throwable )
						{
							throwable = false;

							tmp_code = (String)arg0.getItem();
							nom.removeAllItems();
							nom.addItem(calcul_biovol_query.get_nom_taxon((String)arg0.getItem()));
							auteur.setText(calcul_biovol_query.get_auteur((String)arg0.getItem()));

							boolean perso = ( ((String)arg0.getItem()).startsWith("NEW"));

							biovolcel_outil.setText(calcul_biovol_query.get_biovolcel((String)arg0.getItem(), perso));
							biovolind_outil.setText(calcul_biovol_query.get_biovolind((String)arg0.getItem(), perso));
							objet_mesure.setSelectedItem(objet_mesure.getItemAt(0));
							forme.setText(null);
							formule.setText(null);
							nb_forme = 0;
							modif_forme.setEnabled(false);
							changeImg_bis(nb_forme);
							nom.setSelectedIndex(0);
							auteur.setToolTipText(auteur.getText());
							biovolcel_outil.setToolTipText(biovolcel_outil.getText());
							biovolind_outil.setToolTipText(biovolind_outil.getText());

							throwable = true;
						}
					}

				});

		code.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent arg0) {
						String debut = ((JTextField)arg0.getSource()).getText().trim();
						if( arg0.getKeyCode() != KeyEvent.VK_BACK_SPACE 
								&& debut.length() > 1 
								&& arg0.getKeyCode() != KeyEvent.VK_UP
								&& arg0.getKeyCode() != KeyEvent.VK_DOWN
								&& arg0.getKeyCode() != KeyEvent.VK_ENTER )
						{
							throwable = false;
							((JTextField)nom.getEditor().getEditorComponent()).setText("");
							nom.removeAllItems();
							String[] codes = calcul_biovol_query.get_codes_taxon(debut);
							self.code.removeAllItems();
							self.code.addItem(debut);
							if( codes != null )
							{
								for( String s : codes )
									self.code.addItem(s);
								self.code.hidePopup();
								self.code.showPopup();
							}
							throwable = true;
						}
					}
					public void keyTyped(KeyEvent arg0) {}		
				});

		objet_mesure.addItemListener(
				new ItemListener() {
					public void itemStateChanged(ItemEvent arg0) {
						if( arg0.getStateChange() == ItemEvent.SELECTED && tmp_code != null) {
							if(enModification == true){
								if(calcul_biovol_query.getNbLines(id_calcul) > 0) {
									calcul_biovol_query.vide_rows(id_calcul);
								}
								chgtForme = true;
								}
								else{
									chgtForme = false;
								}
							
							if (arg0.getItem() == "Cel."){
								formule.setText(calcul_biovol_query.get_formule(tmp_code, -1, false));
								forme.setText(calcul_biovol_query.get_forme(tmp_code, -1, false));
								setNbForme((calcul_biovol_query.get_idForme(tmp_code,false)));
								modif_forme.setEnabled(true);
							}

							else {
								if(arg0.getItem() == "Col." || arg0.getItem() == "Fil."){
									formule.setText(calcul_biovol_query.get_formule(tmp_code, -1, true));
									forme.setText(calcul_biovol_query.get_forme(tmp_code, -1, true));
									setNbForme((calcul_biovol_query.get_idForme(tmp_code, true)));
									modif_forme.setEnabled(true);
								}

								else{
									modif_forme.setEnabled(false);
									formule.setText("");
									forme.setText("");
									nb_forme = 0;
								}
							}
							changeImg_bis(nb_forme);
							typeTaxon = (String) arg0.getItem();
						}
					}

				});

		nom.getEditor().getEditorComponent().addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent arg0) {
			}

			public void keyReleased(KeyEvent arg0) {
				String debut = ((JTextField) arg0.getSource()).getText();
				if (arg0.getKeyCode() != KeyEvent.VK_BACK_SPACE
						&& arg0.getKeyCode() != KeyEvent.VK_ENTER
						&& arg0.getKeyCode() != KeyEvent.VK_UP
						&& arg0.getKeyCode() != KeyEvent.VK_DOWN
						&& debut.length() > 2) {
					throwable = false;
					((JTextField) code.getEditor().getEditorComponent())
					.setText("");
					code.removeAllItems();
					String[] nom = calcul_biovol_query.get_noms_taxon_like(debut);
					self.nom.removeAllItems();
					self.nom.addItem(debut);
					if (nom != null) {
						for (String s : nom)
							self.nom.addItem(s);
						self.nom.hidePopup();
						self.nom.showPopup();
					}
					throwable = true;
				}
			}

			public void keyTyped(KeyEvent arg0) {
			}
		});

		((JTextField) nom.getEditor().getEditorComponent())
		.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (throwable) {
					throwable = false;
					code.removeAllItems();
					code.addItem(calcul_biovol_query
							.get_code_taxon_nom(((JTextField) e
									.getSource()).getText()));
					code.setSelectedIndex(0);
					throwable = true;
				}
			}
		});

		nom.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if (arg0.getStateChange() == ItemEvent.SELECTED && throwable) {
					throwable = false;
					code.removeAllItems();
					code.addItem(calcul_biovol_query.get_code_taxon_nom((String) arg0
							.getItem()));
					code.setSelectedIndex(0);
					throwable = false;

					tmp_code = calcul_biovol_query.get_code_taxon_nom((String) arg0
							.getItem());

					auteur.setText(calcul_biovol_query.get_auteur(tmp_code));

					boolean perso = ( ((String)arg0.getItem()).startsWith("NEW"));

					biovolcel_outil.setText(calcul_biovol_query.get_biovolcel(tmp_code, perso));
					biovolind_outil.setText(calcul_biovol_query.get_biovolind(tmp_code, perso));
					objet_mesure.setSelectedItem(objet_mesure.getItemAt(0));
					forme.setText(null);
					formule.setText(null);
					nb_forme = 0;
					modif_forme.setEnabled(false);
					changeImg_bis(nb_forme);

					auteur.setToolTipText(auteur.getText());
					biovolcel_outil.setToolTipText(biovolcel_outil.getText());
					biovolind_outil.setToolTipText(biovolind_outil.getText());

					throwable = true;
					throwable = true;
				}
			}

		});

	}

	public void calculBiovolRow(int row){
		int tmp_row = row;
		float biovol = 0, d, d1, d2, d3, d4, h, h1, h2, h3, h4, l, w, nb_epine; //l1, l2, a, b

		if(!self.__table.dimEmpty(tmp_row)){

			switch(nb_forme){
			case 1: //sphere
				d = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				biovol = (float) ((Math.PI/6) * (Math.pow(d, 3)));
				break;

			case 2: //cymbel V = 2 / 3 * (pi) * w^2 * l * (2 * sin-1 ( h/2w))/360
				l = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				w = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 4));
				biovol = (float) ( ((2*Math.PI)/3) * ((Math.pow(w, 2)) * l * ( (2*(Math.asin(h/(w*2)) ))/360) ));
				break;

			case 3: //cylinder
				d = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				biovol = (float) ((Math.PI/4) * (Math.pow(d, 2)) * h);
				break;

			case 4: //oval cylinder
				d1 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				d2 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 4));
				biovol = (float) ((Math.PI/4) * d1 * d2 * h);
				break;

			case 5: //rot ellips
				d = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				biovol = (float) ((Math.PI/6) * (Math.pow(d, 2)) * h);
				break;

			case 6: //flat ellips
				d1 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				d2 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 4));
				biovol = (float) ((Math.PI/6) * d1 * d2 * h);
				break;

			case 7: //ceratium form 
				d = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				d1 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 4));
				d2 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 6));
				d3 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 8));
				d4 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 10));
				h1 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 5));
				h2 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 7));
				h3 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 9));
				h4 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 11));
				biovol = (float) ( ((Math.PI/6)*(Math.pow(d, 2)*h)) + ((Math.PI/12)*(Math.pow(d1, 2))*h1) 
						+ ((Math.PI/12)*(Math.pow(d2, 2))*h2)
						+ ((Math.PI/12)*(Math.pow(d3, 2))*h3)
						+ ((Math.PI/12)*(Math.pow(d4, 2))*h4));
				break;


				//	V = 2 * ( (pi) / 12 * h1 * ( d1^2 + d1d2 + d2^2 ) ) + nb * (  (pi) / 12 * d * h )
			case 8: //straurastrum form
				d2 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 5));
				d = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				d1 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 4));
				h1 = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 6));
				nb_epine = Integer.parseInt((String) self.__table.getValueAt(tmp_row, 7));
				biovol = (float) ( 2 * ((Math.PI/12) * h1 * ((Math.pow(d1, 2)) + (d1*d2) + (Math.pow(d2, 2)))) 
						+ nb_epine * ((Math.PI/12) * (Math.pow(d, 2) * h )));
				break;

			case 9: //double cone
				d = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				biovol = (float) ((Math.PI/12) * (Math.pow(d, 2)) * h);
				break;

			case 10: //parall
				l = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				w = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 4));
				biovol = (float) (l * w * h);
				break;

			case 11: //prism parall
				l = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				w = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 4));
				biovol = (float) (l * w * (h/2));
				break;

			case 12: //prism triang
				l = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				w = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 4));
				biovol = (float) (l * w * (h/2));
				break;

			case 13: //cone with half sphere
				d = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 2));
				h = Float.parseFloat((String) self.__table.getValueAt(tmp_row, 3));
				biovol = (float) ((Math.PI/12) * (Math.pow(d, 2)) * h);
				break;

			default:
				break;
			}
			self.__table.setValueAt(df.format(biovol), tmp_row, 1);
		}
	}

	public void closeCalcul(){
		self.__table.setNb(0);
		nb_forme = 0;
		changeImg("no_img");
		id_calcul = 0;
		validation.setEnabled(false);
		self.dispose();
	}

	public int get_id_calcul() {
		return id_calcul;
	}

	/**
	 * Indique si un tout nouveau calcul de biovolume est en train d'tre cr
	 * @return boolean 
	 */
	public boolean new_calc(){
		System.out.println("Boolen retourn : " + validation.isEnabled());
		return validation.isEnabled();
	}


	/**
	 * Rempli les champs de textes de la fentre avec les donnes d'un calcul existant donn
	 * @param id_calcul
	 */
	public void ouvrirCalcul(int id_calcul){
		String[] datas = calcul_biovol_query.get_all_up_for_open(id_calcul);

		this.id_calcul = id_calcul;

		enModif = true;

		code.setSelectedItem(datas[0]);
		if(datas[1] != null && datas[1] != "")
			date.setText(datas[1]);
		ref_ech.setText(datas[2]);
		taximoniste.setText(datas[3]);
		commentaire.setText(datas[4]);

		if(datas[15].compareTo("has_station") == 0){
			lieu.setSelectedItem(datas[12]);
			station.setSelectedItem(datas[13]);
		}

		biovol_moy.setText(datas[5]);
		biovol_max.setText(datas[6]);
		biovol_min.setText(datas[7]);
		nb_cellule_moy.setText(datas[11]);
		objet_mesure.setSelectedItem(datas[9]);
		nb_forme = Integer.parseInt(datas[8]);
		changeImg_bis(nb_forme);

		if(objet_mesure.getSelectedItem() == objet_mesure.getItemAt(2) || objet_mesure.getSelectedItem() == objet_mesure.getItemAt(3)){
			disableAll();
			__table.refresh(nb_forme, id_calcul, true);
			isCol = true;
		}
		else{
			disableAll();
			__table.refresh(nb_forme, id_calcul,  false);
			isCol = false;
		}

		__table.showLines(id_calcul);
	}


	/**
	 * Ajoute un nouveau calcul dans la BD
	 */
	public void addCalcul(){
		if(lieu.getSelectedItem() == null || lieu.getSelectedItem()=="" || station.getSelectedItem() == null)
			id_calcul = calcul_biovol_query.add_calcul(code.getSelectedItem().toString(), 
					taximoniste.getText(), typeTaxon, nb_forme, null, null, date.getText(), 
					ref_ech.getText());

		else 
			id_calcul = calcul_biovol_query.add_calcul(code.getSelectedItem().toString(), 
					taximoniste.getText(), typeTaxon, nb_forme, 
					lieu.getSelectedItem().toString(), station.getSelectedItem().toString(), 
					date.getText(), ref_ech.getText());
	}

	/**
	 * Met  jour un calcul dans la BD
	 */
	public void updateCalc(){
		if(lieu.getSelectedItem() == null || lieu.getSelectedItem()=="" || station.getSelectedItem() == null)
			id_calcul = calcul_biovol_query.updateCalc(id_calcul, code.getSelectedItem().toString(), 
					taximoniste.getText(), objet_mesure.getSelectedItem().toString(), nb_forme,
					commentaire.getText(), null, null, null, null);

		else 
			id_calcul = calcul_biovol_query.updateCalc(id_calcul, code.getSelectedItem().toString(), 
					taximoniste.getText(), objet_mesure.getSelectedItem().toString(), nb_forme,
					commentaire.getText(), lieu.getSelectedItem().toString(),
					station.getSelectedItem().toString(), date.getText(), ref_ech.getText());
	}

	/**
	 * Dsactive les boutons et champs aprs validation
	 */
	public void disableAll(){
		milieu.setEditable(false);
		taximoniste.setEditable(false);
		date.setEditable(false);
		ref_ech.setEditable(false);
		station.setEnabled(false);
		code.setEnabled(false);
		objet_mesure.setEnabled(false);
		lieu.setEnabled(false);
		nom.setEnabled(false);

		calculer.setEnabled(true);
		ajouter_ligne.setEnabled(true);

		open.setEnabled(false);

		validation.setEnabled(false);
		modification.setEnabled(true);
		modif_forme.setEnabled(false);
		save_close.setEnabled(true);

		calculEnCours = true;
	}

	public void reactiveAll(){

		milieu.setEditable(true);
		taximoniste.setEditable(true);
		date.setEditable(true);
		ref_ech.setEditable(true);
		station.setEnabled(true);
		objet_mesure.setEnabled(true);
		lieu.setEnabled(true);

		calculer.setEnabled(false);
		ajouter_ligne.setEnabled(false);

		open.setEnabled(false);

		validation.setEnabled(true);
		modification.setEnabled(false);
		modif_forme.setEnabled(true);
		save_close.setEnabled(false);

		calculEnCours = true;
		enModification = true;
	}
	
	/**retourne l'tat du changement de forme
	 * 
	 * @return changement
	 */
	public boolean changementForme(){
		boolean changement=false;
		if(chgtForme == true){
			changement = true;
		}
		else{
			changement = false;
		}
			return changement;
	}

	public void changeImg_bis(int id_forme){
		switch (id_forme){
		case 1: changeImg("sphere");
		break;
		case 2: changeImg("cymbel");
		break;
		case 3: changeImg("cylinder");
		break;
		case 4: changeImg("oval_cylinder");
		break;
		case 5: changeImg("rot_ellips");
		break;
		case 6: changeImg("flat_ellips");
		break;
		case 7: changeImg("ceratium_form");
		break;
		case 8: changeImg("straurastrum_form");
		break;
		case 9: changeImg("dble_cone");
		break;
		case 10: changeImg("parall");
		break;
		case 11: changeImg("prism_parall");
		break;
		case 12: changeImg("prism_triang");
		break;
		case 13: changeImg("cone_half_sphere");
		break;
		default: changeImg("no_img");
		break;		
		}
	}

	public void changeImg(String new_img){
		_image = new ImageIcon(getClass().getClassLoader().getResource("images/"+new_img+".png"));
		ImgLabel.setIcon(_image);

		forme.setText(calcul_biovol_query.get_forme(tmp_code, nb_forme, false));
		formule.setText(calcul_biovol_query.get_formule(tmp_code, nb_forme, false));

		formule.setToolTipText(formule.getText());
		forme.setToolTipText(forme.getText());
	}

	public static void setNbForme(int new_int){
		nb_forme = new_int;
	}

	private void add_fields()
	{
		// ncessaire pour la traduction de l'item "Nouveau" (pour le site)
		//	this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		//Ajout de la bannire
		JPanel banniere_pane = new JPanel(new FlowLayout());
		((FlowLayout)banniere_pane.getLayout()).setAlignment(FlowLayout.LEFT);
		banniere_pane.setBackground(new Color(192, 197, 199));
		banniere = new JLabel("", 
				new ImageIcon(getClass().getClassLoader().getResource("images/bannierev2.png")), JLabel.TRAILING);
		banniere.setFont(new Font(banniere.getFont().getName(), banniere.getFont().getStyle(), 15));
		banniere_pane.add(banniere);

		infosTaxon_pane = new JPanel(new BorderLayout());

		JPanel first_column = new JPanel(new BorderLayout());
		JPanel second_column = new JPanel(new BorderLayout());

		tmp_pane = new JPanel(new BorderLayout());

		JPanel north_pane = new JPanel(new FlowLayout());
		JPanel center_pane = new JPanel(new FlowLayout());
		JPanel south_pane = new JPanel(new FlowLayout());

		infosTaxon_pane.setBackground(new Color(192, 197, 199));
		tmp_pane.setBackground(new Color(192, 197, 199));
		north_pane.setBackground(new Color(192, 197, 199));
		center_pane.setBackground(new Color(192, 197, 199));
		south_pane.setBackground(new Color(192, 197, 199));

		first_column.setBackground(new Color(192, 197, 199));
		second_column.setBackground(new Color(192, 197, 199));


		((FlowLayout)center_pane.getLayout()).setAlignment(FlowLayout.LEADING);
		((FlowLayout)south_pane.getLayout()).setAlignment(FlowLayout.LEADING);
		((FlowLayout)north_pane.getLayout()).setAlignment(FlowLayout.LEADING);

		tmp_pane.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();

		c.insets = new Insets(5, 10, 0, 5);

		//Ajout du panneau nord
		north_pane.add(labelCode);
		code.setPreferredSize(new Dimension(82,20));
		code.setEditable(true);
		north_pane.add(code);
		north_pane.add(labelNom);
		nom.setPreferredSize(new Dimension(260, 20));
		nom.setEditable(true);
		north_pane.add(nom);
		north_pane.add(labelAuteur);
		auteur.setPreferredSize(new Dimension(220, 20));
		auteur.setEditable(false);
		north_pane.add(auteur);
		north_pane.add(labelTaxinomiste);
		taximoniste.setPreferredSize(new Dimension(142, 20));
		taximoniste.setEditable(true);
		north_pane.add(taximoniste);


		//Ajout du panneau central
		center_pane.add(labelObjMes);
		objet_mesure = new JComboBox<String>();
		objet_mesure.addItem("    ");
		objet_mesure.addItem("Cel.");
		objet_mesure.addItem("Col.");
		objet_mesure.addItem("Fil.");
		objet_mesure.setPreferredSize(new Dimension(75,20));
		center_pane.add(objet_mesure);
		center_pane.add(labelForme); // affiche la forme aprs avoir choisi l'objet mesur
		forme.setPreferredSize(new Dimension(180, 20));
		forme.setEditable(false);
		center_pane.add(forme);
		center_pane.add(labelFormule); 
		formule.setPreferredSize(new Dimension(351, 20));
		formule.setEditable(false);
		center_pane.add(formule);
		center_pane.add(modif_forme);
		modif_forme.setEnabled(false);

		//Ajout du panneau sud
		south_pane.add(labelBiovolCel);
		biovolcel_outil.setPreferredSize(new Dimension(90, 20));
		biovolcel_outil.setEditable(false);
		south_pane.add(biovolcel_outil);
		south_pane.add(labelBiovolInd);
		biovolind_outil.setPreferredSize(new Dimension(90, 20));
		biovolind_outil.setEditable(false);
		south_pane.add(biovolind_outil);
		south_pane.add(labelCom);
		commentaire.setPreferredSize(new Dimension(436,20));
		south_pane.add(commentaire);

		first_column.add(north_pane, BorderLayout.NORTH);
		first_column.add(center_pane, BorderLayout.CENTER);
		first_column.add(south_pane, BorderLayout.SOUTH);

		second_column.add(ImgLabel, BorderLayout.CENTER);

		tmp_pane.add(first_column, c);
		tmp_pane.add(second_column, c);
		infosTaxon_pane.add(tmp_pane, BorderLayout.NORTH);

		__table = null;

		JPanel rens_pane = new JPanel(new FlowLayout());

		JPanel label_pane = new JPanel(new FlowLayout());

		rens_pane.setBackground(new Color(192, 197, 199));
		((FlowLayout)rens_pane.getLayout()).setAlignment(FlowLayout.LEADING);

		label_pane.setBackground(new Color(192, 197, 199));
		((FlowLayout)label_pane.getLayout()).setAlignment(FlowLayout.LEADING);

		label_pane.add(Box.createHorizontalStrut(6));

		labelRens.setFont(new Font("sansserif", Font.BOLD, 12));

		label_pane.add(labelRens);
		label_pane.add(Box.createHorizontalStrut(750));
		label_pane.add(validation);

		rens_pane.add(Box.createHorizontalStrut(6));
		rens_pane.add(labelSite);
		lieu = new JComboBox<String>(calcul_biovol_query.get_sites(""));
		lieu.setPreferredSize(new Dimension(230, 20));
		lieu.setEditable(true);

		if( ((String)lieu.getItemAt(0)).compareTo("") != 0 )
			lieu.insertItemAt("", 0);

		lieu.setSelectedIndex(0);
		lieu.addItem(rb.getString("nouveau"));
		rens_pane.add(lieu);
		rens_pane.add(labelStation);
		station.setPreferredSize(new Dimension(211, 20));
		rens_pane.add(station);
		rens_pane.add(labelMilieu);
		milieu.setPreferredSize(new Dimension(75, 20));
		milieu.setEditable(false);
		rens_pane.add(milieu);
		rens_pane.add(labelDate);
		try {
			MaskFormatter formatDate = new MaskFormatter("####-##-##");
			date = new JFormattedTextField(formatDate);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		date.setToolTipText("aaaa-mm-jj");
		date.setPreferredSize(new Dimension(75, 20));
		rens_pane.add(this.date);
		rens_pane.add(labelRefEch);
		ref_ech.setPreferredSize(new Dimension(75, 20));
		rens_pane.add(this.ref_ech);
		rens_pane.add(Box.createHorizontalStrut(5));
		rens_pane.add(modification);

		infosTaxon_pane.add(label_pane, BorderLayout.CENTER);
		infosTaxon_pane.add(rens_pane, BorderLayout.SOUTH);

		// Ajout du paneau contenant la JTable ainsi que les biovolumes moy, min et max
		table_pane = new JPanel(new BorderLayout());
		JPanel infos_calcul_pane = new JPanel(new FlowLayout());
		infos_calcul_pane.setBackground(new Color(192, 197, 199));
		((FlowLayout)infos_calcul_pane.getLayout()).setAlignment(FlowLayout.LEADING);

		infos_calcul_pane.add(labelBiovolMoy);
		biovol_moy.setPreferredSize(new Dimension(115, 20));
		biovol_moy.setEditable(false);
		infos_calcul_pane.add(biovol_moy);
		infos_calcul_pane.add(Box.createHorizontalStrut(10));
		infos_calcul_pane.add(labelBiovolMin);
		biovol_min.setPreferredSize(new Dimension(115, 20));
		biovol_min.setEditable(false);
		infos_calcul_pane.add(biovol_min);
		infos_calcul_pane.add(Box.createHorizontalStrut(10));
		infos_calcul_pane.add(labelBiovolMax);
		biovol_max.setPreferredSize(new Dimension(115, 20));
		biovol_max.setEditable(false);
		infos_calcul_pane.add(biovol_max);
		infos_calcul_pane.add(Box.createHorizontalStrut(10));
		infos_calcul_pane.add(labelNbCellMoy);
		nb_cellule_moy.setPreferredSize(new Dimension(75, 20));
		nb_cellule_moy.setEditable(false);
		infos_calcul_pane.add(nb_cellule_moy);
		infos_calcul_pane.add(Box.createHorizontalStrut(67));
		infos_calcul_pane.add(Box.createHorizontalStrut(10));
		infos_calcul_pane.add(calculer);

		table_pane.add(infos_calcul_pane, BorderLayout.NORTH);

		__table = new Calcul_Biovolume_Table(self, nb_forme, db_link);
		__scrollPane = new JScrollPane(__table, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

		table_pane.setBackground(new Color(192, 197, 199));

		table_pane.add(__scrollPane, BorderLayout.CENTER);

		this.getContentPane().setBackground(new Color(192, 197, 199));
		JPanel test = new JPanel(new BorderLayout());
		test.add(banniere_pane, BorderLayout.NORTH);
		test.add(infosTaxon_pane, BorderLayout.SOUTH);

		this.getContentPane().add(test, BorderLayout.NORTH);
		this.getContentPane().add(table_pane, BorderLayout.CENTER);	

		calculer.setEnabled(false);
		ajouter_ligne.setEnabled(false);
	}

	private void draw_frame()
	{
		this.setLocation(100, 50);
		this.pack();
		this.setVisible(true);
		opti_width = this.getWidth();
	}

	/**
	 * Traduction dans la bonne langue de tous les textes de la fentre
	 * @param locale
	 */
	public void translate(Locale locale){
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		// nom de la fentre
		this.setTitle(rb.getString("titreFenCalculDeBioVol"));		

		menu_fichier.setText(rb.getString("fichier"));
		open.setText(rb.getString("ouvrir"));
		save_close.setText(rb.getString("sauveEtQuit"));
		no_save_close.setText(rb.getString("quitSansSauv"));

		banniere.setText(rb.getString("titreCalculDeBiovol"));

		infosTaxon_pane.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("infoSurLeTaxon"), TitledBorder.CENTER, TitledBorder.CENTER));

		labelCode.setText(rb.getString("champCode"));
		labelNom.setText(rb.getString("champNom"));
		labelAuteur.setText(rb.getString("champAuteur"));
		labelTaxinomiste.setText(rb.getString("champTaxinomiste"));
		labelObjMes.setText(rb.getString("champObjetMesure"));
		labelForme.setText(rb.getString("champForme"));
		labelFormule.setText(rb.getString("champFormule"));

		modif_forme.setText(rb.getString("changerForme"));

		labelBiovolCel.setText(rb.getString("champBiovolCel"));
		labelBiovolInd.setText(rb.getString("champBiovolInd"));
		labelCom.setText(rb.getString("champCommentaires"));

		labelRens.setText(rb.getString("rensFacult"));

		labelSite.setText(rb.getString("champSite"));
		labelStation.setText(rb.getString("champStation"));
		labelMilieu.setText(rb.getString("champMilieu"));
		labelDate.setText(rb.getString("champDate"));
		labelRefEch.setText(rb.getString("champRefEch"));

		validation.setText(rb.getString("validerInfos"));
		modification.setText(rb.getString("modifierInfos"));

		table_pane.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("calculBioVol"), TitledBorder.CENTER, TitledBorder.CENTER));


		labelBiovolMoy.setText(rb.getString("champBiovolMoy"));
		labelBiovolMin.setText(rb.getString("champBiovolMin"));
		labelBiovolMax.setText(rb.getString("champBiovolMax"));
		labelNbCellMoy.setText(rb.getString("champNbCelMoy"));

		calculer.setText(rb.getString("calculer"));


		//ragencement de la position des items de la fentre
		this.pack();
	}

}