package Calcul_Biovolume;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Arrays;
import java.util.Vector;

import javax.swing.AbstractCellEditor;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;

public class Calcul_Biovolume_Table extends JTable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@SuppressWarnings("unused")
	private String db_link;

	private Calcul_Biovolume_Query calcul_biovol_query;
	private Calcul_Biovolume_Table self = null;
	private Calcul_Biovolume_Frame frame;

	private Vector<String> __columns_sphere = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "d", "", ""));
	private Vector<String> __columns_cymbel = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "l", "h", "w", "", ""));
	private Vector<String> __columns_cylinder = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "d", "h", "", ""));
	private Vector<String> __columns_oval_cylinder = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "d1", "d2", "h", "", ""));

	private Vector<String> __columns_rot_ellips = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "d", "h", "", ""));
	private Vector<String> __columns_flat_ellips = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "d1", "d2", "h", "", ""));
	private Vector<String> __columns_ceratium_form = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "d", "h", "d1", "h1", "d2", "h2", "d3", "h3", "d4", "h4", "", ""));
	private Vector<String> __columns_straurastrum_form = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "d", "h", "d1", "d2", "h1", "nb_epine", "", ""));

	private Vector<String> __columns_dble_cone = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "d", "h", "", ""));
	private Vector<String> __columns_parall = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "l", "h", "w", "", ""));
	private Vector<String> __columns_prism_parall = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "l", "h", "w", "", ""));
	private Vector<String> __columns_prism_triang = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "l", "h", "w", "", ""));
	private Vector<String> __columns_cone_half_sphere = new Vector<String>(Arrays.asList("#", "Biovol.(m)", "d", "h", "", ""));

	private Vector<String> __columns_empty = new Vector<String>(); //vecteur columns vide

	private Vector<String>  __columns = new Vector<String>(); //vecteur columns final

	public int id_calcul = 0;

	int nb = 1;
	int id_line = 1;
	public DefaultTableModel model;
	@SuppressWarnings("unused")
	private boolean isCol=false;

	public Calcul_Biovolume_Table(final Calcul_Biovolume_Frame parent, int forme, String db_link)
	{
		frame = parent;

		this.db_link = db_link;

		calcul_biovol_query = new Calcul_Biovolume_Query(db_link);

		self = this; 

		__columns = __columns_empty;

		model = new DefaultTableModel(null, __columns) {
			private static final long serialVersionUID = 1L;
			@SuppressWarnings({ "rawtypes", "unchecked" })
			public Class getColumnClass(int c) {
				return getValueAt(0, c).getClass();
			}
			public boolean isCellEditable(int row, int col) { if(col == 0 || col == 1){return false;} return true; }
		};

		this.setModel(model);
	}

	public void nextCell(){
		selectNextCell();
	}


	public void addEmptyLine(){ 
		// si calcul en modification de forme on recommence en ligne 1 les N de ligne
		boolean chgt = false;
		chgt = frame.changementForme();
		if(chgt == true){
			nb=1;
			id_line=1;
		}

		Object[] row = { id_line, "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
		row[__columns.size()-1] = "+";
		row[__columns.size()-2] = new ImageIcon(getClass().getClassLoader().getResource("images/close.png"));
		model.addRow(row);
		model.fireTableRowsInserted(0,0);

		nb++;
		id_line++;

		selectNextCell();
		if(self.getRowCount() > 1)
			frame.calculBiovolRow(self.getRowCount()-2);
	}

	@SuppressWarnings("rawtypes")
	public void addLines(int id_calcul){
		Vector data = this.model.getDataVector();
		calcul_biovol_query.add_lines(id_calcul, data, __columns, nb);
	}

	@SuppressWarnings("rawtypes")
	public void updateLines(int id_calcul){
		Vector data = this.model.getDataVector();
		calcul_biovol_query.update_lines(id_calcul, data, __columns, nb);
	}

	public void showLines(int id_calcul){
		int nbLines = calcul_biovol_query.getNbLines(id_calcul);

		if(nbLines>0){
			for (int i=model.getRowCount()-1 ; i>=0 ; --i) 
				model.removeRow(i);

			for (int i = 0; i < nbLines; i++)
			{
				addEmptyLine();
				for(int j = 0; j < __columns.size()-1; j++){
					if(calcul_biovol_query.getLineDatas(id_calcul, nbLines, __columns)[i][j] != null)
						model.setValueAt((calcul_biovol_query.getLineDatas(id_calcul, nbLines, __columns)[i][j]).toString(), i, j);
				}
			}

			nb = model.getRowCount()+1;
			id_line = Integer.parseInt(model.getValueAt(model.getRowCount()-1, 0).toString()) + 1;
		}
	}

	public void configColumns (){
		if(__columns != __columns_empty){
			new ButtonColumn(this, __columns.size()-1);  
			new ButtonColumn(this, __columns.size()-2);  
			this.getTableHeader().setReorderingAllowed(false);
			this.setAutoResizeMode(AUTO_RESIZE_OFF);
			this.getTableHeader().setResizingAllowed(true);
			this.getColumnModel().getColumn(0).setPreferredWidth(30);
			this.getColumnModel().getColumn(0).setCellEditor(null);
			this.getColumnModel().getColumn(1).setPreferredWidth(110);
			this.getColumnModel().getColumn(__columns.size()-2).setPreferredWidth(20);
			this.getColumnModel().getColumn(__columns.size()-1).setPreferredWidth(45);
			for(int i = 0; i <= __columns.size() -3 ; i++){
				self.getColumnModel().getColumn(i).setCellRenderer(new NbCellRenderer());
				if(i >= 2)
					this.getColumnModel().getColumn(i).setPreferredWidth(80);
			}
		}
	}
	//affichage bulle d'info pour (+) nouvelle ligne : raccourci et pour "nb_epine" : nombre de bras 
	public String getToolTipText(MouseEvent e) {
		java.awt.Point p = e.getPoint();
		int rowIndex = rowAtPoint(p);
		int colIndex = columnAtPoint(p);
		int colIndEp = __columns.size()-3;
		String ep = getColumnName(colIndEp);

		if(colIndex == __columns.size()-1 && rowIndex == this.getRowCount()-1)
			return "Raccourci : Ctrl + b";
		else
			if(colIndex ==__columns.size()-3 && rowIndex == this.getRowCount()-1
			&& ep == "nb_epine") 
				return "ou nombre de bras";
			else
				return null;
	}

	public String[] calculBiovols(boolean isCol){	
		float moy = 0, max = 0, min = 0, som = 0, nb = 0, tmp_float = 0, nb_cel = 0, som_cel = 0;
		String tmp_string;
		boolean empty = true;

		DecimalFormat df = (DecimalFormat)DecimalFormat.getNumberInstance();
		df.applyPattern("0.0");

		tmp_string = ((String)getValueAt(0,1));
		tmp_float = Float.parseFloat(tmp_string);
		min = tmp_float;

		DecimalFormatSymbols symbols = new DecimalFormatSymbols();
		symbols.setDecimalSeparator('.');
		df.setDecimalFormatSymbols(symbols);

		for (int i = 0; i < self.getRowCount(); i++){
			if ( !((String)getValueAt(i,1)).isEmpty() ){
				tmp_string = ((String)getValueAt(i,1));
				tmp_float = Float.parseFloat(tmp_string);

				if (tmp_float > max)
					max = tmp_float;
				if (tmp_float < min)
					min = tmp_float;			

				som += tmp_float;
				nb++;
				empty = false;
			}
			if(isCol && !((String)getValueAt(i,__columns.size()-3)).isEmpty()){
				som_cel++;
				nb_cel += Integer.parseInt(((String)getValueAt(i,__columns.size()-3)));
			}
		}

		if(empty){
			String[] biovols_empty = {"N/A", "N/A", "N/A", "N/A"};
			return biovols_empty;
		}

		else{
			if(isCol){
				moy = som / nb;
				nb_cel = nb_cel / som_cel;
				if(som_cel == 0)
					nb_cel = 0;
				String[] biovols = {df.format(moy), df.format(max), df.format(min), df.format(nb_cel)};
				return biovols;
			}
			else{
				moy = som / nb;
				String[] biovols = {df.format(moy), df.format(max), df.format(min), "N/A"};
				return biovols;
			}
		}
	}

	public void selectNextCell(){
		model.fireTableRowsInserted(0, self.getRowCount());
		self.editCellAt(nb-2, 2);
		self.getSelectionModel().setSelectionInterval(nb-2, nb-2);
		self.getColumnModel().getSelectionModel().setSelectionInterval(2, 2);
	}


	public void refresh (int forme, int id_calcul, boolean isCol){
		this.isCol = isCol;
		this.id_calcul = id_calcul;
		__columns = chooseColumns(forme, isCol);

		model = new DefaultTableModel(null, __columns) {
			private static final long serialVersionUID = 1L;
			@SuppressWarnings({ "rawtypes", "unchecked" })
			public Class getColumnClass(int c) {
				return getValueAt(0, c).getClass();
			}
			public boolean isCellEditable(int row, int col) { if(col == 0 || col == 1){return false;} return true; }
		};

		self.setModel(model);
		configColumns();
		addEmptyLine();
		this.setCellSelectionEnabled(true);
	}

	//false si la table ne contient aucune colone "nb_cellule"
	public boolean noColCel(Vector<String> tmp){
		boolean hasColCel = false;
		for(int i = 0; i < tmp.size(); i++){
			if (tmp.get(i) == "nb_cellule")
				hasColCel = true;
		}
		return hasColCel;
	}

	public Vector<String> get_columns(){
		return __columns;
	}

	public void setNb(int new_nb){
		this.nb = new_nb;
	}

	public int getNb(){
		return this.nb;
	}

	//test si l'user a bien entr toutes les dimensions pour une ligne donne 
	public boolean dimEmpty(int row){
		System.out.println(row);
		boolean empty = false;
		for (int i = 2 ; i < __columns.size()-2 ; i++ ){
			if ( ((String)getValueAt(row,i)).isEmpty() && getColumnName(i) != "nb_cellule")
				empty = true;
		}
		return empty;
	}

	public Vector<String> chooseColumns(int forme, boolean isCol){
		Vector<String> tmp = null;
		switch (forme){
		case 1: tmp = __columns_sphere;
		break;
		case 2: tmp = __columns_cymbel;
		break;
		case 3: tmp = __columns_cylinder;
		break;
		case 4: tmp = __columns_oval_cylinder;
		break;
		case 5: tmp = __columns_rot_ellips;
		break;
		case 6: tmp = __columns_flat_ellips;
		break;
		case 7: tmp = __columns_ceratium_form;
		break;
		case 8: tmp = __columns_straurastrum_form;
		break;
		case 9: tmp = __columns_dble_cone;
		break;
		case 10: tmp = __columns_parall;
		break;
		case 11: tmp = __columns_prism_parall;
		break;
		case 12: tmp = __columns_prism_triang;
		break;
		case 13: tmp = __columns_cone_half_sphere;
		break;
		default: tmp = __columns_empty;
		break;
		}	

		if(isCol && !noColCel(tmp)){
			tmp.add(tmp.size()-2, "nb_cellule");
		}

		else{
			if (!isCol)
				tmp.remove("nb_cellule");
		}

		return tmp;
	}

	class ButtonColumn extends AbstractCellEditor implements TableCellRenderer, TableCellEditor, ActionListener
	{
		private static final long serialVersionUID = 1L;
		Calcul_Biovolume_Table table;
		JButton renderButton;
		JButton editButton;
		String text;

		public ButtonColumn(Calcul_Biovolume_Table table, int column)
		{
			super();
			this.table = table;
			renderButton = new JButton(new ImageIcon("images/close.png" )); 

			editButton = new JButton(new ImageIcon("images/close.png" )); 
			editButton.setFocusPainted( false );
			editButton.addActionListener( this );

			TableColumnModel columnModel = table.getColumnModel();
			columnModel.getColumn(column).setCellRenderer( this );
			columnModel.getColumn(column).setCellEditor( this );
		}

		public Component getTableCellRendererComponent(
				JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
		{
			if(column == table.getColumnCount()-2 || column == table.getColumnCount()-1 && row == table.getRowCount()-1){
				if (hasFocus)
				{
					renderButton.setForeground(table.getForeground());
					renderButton.setBackground(UIManager.getColor("Button.background"));
				}
				else if (isSelected)
				{
					renderButton.setForeground(table.getSelectionForeground());
					renderButton.setBackground(table.getSelectionBackground());
				}
				else
				{
					renderButton.setForeground(table.getForeground());
					renderButton.setBackground(UIManager.getColor("Button.background"));
				}

				if( value instanceof ImageIcon )
					renderButton.setIcon((ImageIcon) value);
				else
					renderButton.setText( (value == null) ? "" : value.toString() );

				return renderButton;
			}
			else {
				return null;
			}

		}

		public Component getTableCellEditorComponent(
				final JTable table, Object value, boolean isSelected, final int row, int column)
		{
			if( value instanceof ImageIcon )
				editButton.setIcon((ImageIcon)value);
			else
			{
				text = (value == null) ? "" : value.toString();
				editButton.setText( text );	
			}

			return editButton;
		}

		public void actionPerformed(ActionEvent e)
		{
			if(table.getSelectedColumn() == table.getColumnCount()-2 && table.getRowCount() !=0){
				this.stopCellEditing();
				((DefaultTableModel)table.getModel()).removeRow(table.getSelectedRow());
				nb--;
			}
			else if(table.getSelectedColumn() == table.getColumnCount()-1){
				table.addEmptyLine();
			}	
		}

		public Object getCellEditorValue()
		{
			return text;
		}
	}

	class NbCellRenderer extends DefaultTableCellRenderer {
		private static final long serialVersionUID = 1L;

		public Component getTableCellRendererComponent (JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
			Component c = super.getTableCellRendererComponent (table,  value, isSelected, hasFocus, row, column);
			if(column == 0)
				c.setBackground(new Color(192, 197, 199));
			if(column == 1){
				c.setFont( c.getFont().deriveFont(Font.BOLD) );
				c.setBackground(new Color(230, 230, 230));
			}		    	  
			return c;
		}
	}
}




