package Calcul_Biovolume;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

public class Modification_Forme_Frame extends JDialog{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Locale locale;
	@SuppressWarnings("unused")
	private String db_link;
	private Modification_Forme_Frame self = null;
	private JMenuBar menu_bar = new JMenuBar();
	private JMenu file_menu = new JMenu();
	private JMenuItem close_menu_item = new JMenuItem();
	private JPanel main_pane = null;
	private Calcul_Biovolume_Frame tmp;
	
	private JButton sphere = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/sphere.png" ))); 
	private JButton cymbel = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/cymbel.png" ))); 
	private JButton cylinder = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/cylinder.png" ))); 
	private JButton oval_cylinder = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/oval_cylinder.png" ))); 
	private JButton rot_ellips = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/rot_ellips.png" ))); 
	private JButton flat_ellips = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/flat_ellips.png" ))); 
	private JButton ceratium_form = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/ceratium_form.png" ))); ;
	private JButton straurastrum_form = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/straurastrum_form.png" )));
	private JButton dble_cone = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/dble_cone.png" ))); 
	private JButton parall = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/parall.png" ))); 
	private JButton prism_parall = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/prism_parall.png" )));
	private JButton prism_triang = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/prism_triang.png" ))); 
	private JButton cone_half_sphere = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/cone_half_sphere.png" ))); 
	
	
	public Modification_Forme_Frame(Calcul_Biovolume_Frame mainFrame, Locale locale, String db_link)
	{
		super(mainFrame, "");
		self = this;
		this.locale = locale;
		this.db_link = db_link;
	
		tmp = mainFrame;
		
		this.setBackground(new Color(192, 197, 199));
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.PAGE_AXIS));
		this.getContentPane().setBackground(new Color(192, 197, 199));
		
		this.add_menu();
		this.add_buttons();
		this.translate(locale);
		this.add_handlers();
		this.draw_frame();
	}
	
	private void add_menu()
	{
		file_menu.add(close_menu_item);
		menu_bar.add(file_menu);
		this.setJMenuBar(menu_bar);
	}

	private void add_handlers()
	{
		close_menu_item.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						self.dispose();
					}});
		
		sphere.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(1);
							tmp.changeImg("sphere");
							self.dispose();
						}});
		
		cymbel.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(2);
							tmp.changeImg("cymbel");
							self.dispose();
						}});
		
		cylinder.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(3);
							tmp.changeImg("cylinder");
							self.dispose();
						}});
		
		oval_cylinder.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(4);
							tmp.changeImg("oval_cylinder");
							self.dispose();
						}});
		
		rot_ellips.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(5);
							tmp.changeImg("rot_ellips");
							self.dispose();
						}});
		
		flat_ellips.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(6);
							tmp.changeImg("flat_ellips");
							self.dispose();
						}});
		
		ceratium_form.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(7);
							tmp.changeImg("ceratium_form");
							self.dispose();
						}});
		
		straurastrum_form.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(8);
							tmp.changeImg("straurastrum_form");
							self.dispose();
						}});
		
		dble_cone.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(9);
							tmp.changeImg("dble_cone");
							self.dispose();
						}});
		
		parall.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(10);
							tmp.changeImg("parall");
							self.dispose();
						}});
		
		prism_parall.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(11);
							tmp.changeImg("prism_parall");
							self.dispose();
						}});
		
		prism_triang.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(12);
							tmp.changeImg("prism_triang");
							self.dispose();
						}});
		
		cone_half_sphere.addActionListener(
				   new ActionListener()  {
						public void actionPerformed(ActionEvent e) {
							Calcul_Biovolume_Frame.setNbForme(13);
							tmp.changeImg("cone_half_sphere");
							self.dispose();
						}});
	}

	private void add_buttons()
	{
		// pour la traduction des noms de forme
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		main_pane = new JPanel(new BorderLayout());
		main_pane.setBackground(new Color(192, 197, 199));
		main_pane.setLayout(new GridLayout(4,4, 5, 5));

		main_pane.add(sphere);
		main_pane.add(cymbel);
		main_pane.add(cylinder);
		main_pane.add(oval_cylinder);
		
		main_pane.add(rot_ellips);
		main_pane.add(flat_ellips);
		main_pane.add(ceratium_form);
		main_pane.add(straurastrum_form);
		
		main_pane.add(dble_cone);
		main_pane.add(parall);
		main_pane.add(prism_parall);
		main_pane.add(prism_triang);

		main_pane.add(cone_half_sphere);

		sphere.setToolTipText("Sphere");
		cymbel.setToolTipText("Cymbelloid");
		cylinder.setToolTipText("Cylinder");
		oval_cylinder.setToolTipText("Oval Cylinder");
		
		rot_ellips.setToolTipText("Rotational Ellipsoid");
		flat_ellips.setToolTipText("Flattened Ellipsoid");
		ceratium_form.setToolTipText(rb.getString("formeRelaCeratium"));
		straurastrum_form.setToolTipText(rb.getString("formeRelaStraurastrum"));
		
		dble_cone.setToolTipText("Double Cone");
		parall.setToolTipText("Parallelepiped");
		prism_parall.setToolTipText("Prism on paralellogram base");
		prism_triang.setToolTipText("Prism on triangulare base");

		cone_half_sphere.setToolTipText("Cone with Half Sphere");
		
		this.getContentPane().setBackground(new Color(192, 197, 199));
		JPanel test = new JPanel(new BorderLayout());
		test.add(main_pane, BorderLayout.CENTER);

		this.getContentPane().add(test, BorderLayout.NORTH);
	}

	private void draw_frame()
	{
		this.setResizable(false);
		this.setLocation(200,200);
		this.pack();
		this.setVisible(true);
	}
	
	public void translate(Locale locale){
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		// nom de la fentre
		this.setTitle(rb.getString("titreFenModifForme"));
		
		file_menu.setText(rb.getString("fichier"));
		close_menu_item.setText(rb.getString("fermer"));
		
		
		main_pane.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("choisirNouvelleForme"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		//ragencement de la position des items de la fentre
		this.pack();
	}
	
}