package Calcul_Biovolume;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.print.PrinterException;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.RowSorter;
import javax.swing.SortOrder;
import javax.swing.JTable.PrintMode;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;

import Import_Export.Import_Exporter;

public class Ouvrir_Calcul extends JDialog{

	private static final long serialVersionUID = 1L;
	private Locale locale;
	private String db_link;
	private Calcul_Biovolume_Frame mainFrame;
	private Calcul_Biovolume_Query calcul_biovol_query;
	private Ouvrir_Calcul self = null;
	private JMenuBar menu_bar = new JMenuBar();
	private JMenu file_menu = new JMenu();
	private JMenuItem close_menu_item = new JMenuItem();
	private JMenuItem imprimer = new JMenuItem();
	private JTable liste;
	private JButton ouvrir_calcul = new JButton();
	private JButton delete = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/close.png")));
	private JTextField code_filter = new JTextField();
	private JTextField nom_filter = new JTextField();

	private JLabel recherche_lbl = new JLabel();
	private JLabel labelSelectMulti = new JLabel();
	
	private int id_calcul;
	boolean isLibre = false;
	private int[] ids = null;
	private boolean inExport = false;

	public static String img = "half_sphere.png";

	public Ouvrir_Calcul(Calcul_Biovolume_Frame mainFrame, boolean export, boolean isLibre, 
			Locale locale, String db_link)
	{
		super(mainFrame, "");
		this.isLibre = isLibre;
		
		if( export )
		{
			this.setTitle("Exporter un calcul de biovolume");
			ouvrir_calcul.setText("Export");
		}
		else
			this.setTitle("Ouvrir un calcul");

		if(mainFrame != null)
			this.mainFrame = mainFrame;

		self = this;
		this.locale = locale;
		this.db_link = db_link;
		
		calcul_biovol_query = new Calcul_Biovolume_Query(db_link);
		
		inExport = export;
		this.setBackground(new Color(192, 197, 199));
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.PAGE_AXIS));
		this.getContentPane().setBackground(new Color(192, 197, 199));

		this.translate(locale, export);
		
		//traduction des colonnes de la table...
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		String[] columnNames = {rb.getString("colCodeTaxon"), rb.getString("colNom"), 
								rb.getString("colType"), rb.getString("biovolMoy"), rb.getString("colDateEch"), 
								rb.getString("colTaxinomiste"), "#"};
		
		this.add_menu();
		this.add_buttons(columnNames);
		this.add_handlers(columnNames);
		this.draw_frame();

		this.setResizable(false);
		self.setMinimumSize(new Dimension(670, 200));
	}

	// boolen pour ne pas autoriser la fermeture de l'application si l'cran calcul biovol
	// est ouvert avec un calcul 
	public boolean get_closableCalc()
	{
		return (( mainFrame != null && (mainFrame.get_id_calcul() != 0 || mainFrame.new_calc() )) ? false : true);
	}
	
	private void add_menu()
	{
		file_menu.add(imprimer);
		file_menu.add(close_menu_item);
		menu_bar.add(file_menu);
		this.setJMenuBar(menu_bar);
	}

	private void add_handlers(final String[] columnNames)
	{		
		
		// pour les traductions des botes de dialogue
	//	this.locale = locale;
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		close_menu_item.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						self.dispose();
					}});
		
//TODO finaliser impression
		imprimer.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						MessageFormat header = new MessageFormat(rb.getString("listeCalculsPerso"));
						MessageFormat footer = new MessageFormat(new SimpleDateFormat("dd/MM/yyyy").format(new java.util.Date()) + "                                " +
								rb.getString("phytobsVer") + "                        " +
								"                    {0}");
						try {
							if (liste.print(PrintMode.FIT_WIDTH, header, footer) )
								self.dispose();
						} catch (PrinterException e1) {e1.printStackTrace();}
					}});
		
		ouvrir_calcul.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						openCalcul();
					}});

		liste.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				if (e.getClickCount() == 2) {
					openCalcul();
				}
			}
		});

		delete.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) 
					{
						if( self.liste.getSelectedRow() != -1 )
						{
							int reponse = JOptionPane.showConfirmDialog(
									self, rb.getString("mssgSuppressCalcul"),
									rb.getString("titreBoxSuppressCalcul"), 
									JOptionPane.YES_NO_OPTION);

							if(reponse == 0){
								calcul_biovol_query.delCalcul(Integer.parseInt(liste.getValueAt(liste.getSelectedRow(), 6).toString()));
	
								((DefaultTableModel)liste.getModel()).setDataVector(calcul_biovol_query.get_data(), columnNames);
								setTableFormat();
								methodeTri();
							}
						}
						else {
							JOptionPane.showMessageDialog(self,
									rb.getString("mssgErrOuvertureCalcul"),
									rb.getString("titreBoxErrOuvCalcul"),
									JOptionPane.ERROR_MESSAGE);
						}
					}});
		
		//recherche par code 6 lettres	
		code_filter.addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent arg0) {
						String text = ((JTextField)arg0.getSource()).getText();
						if( ! text.isEmpty() )
						{
							nom_filter.setText("");
							// tri par la colonne code taxon
							List<RowSorter.SortKey> keys = new ArrayList<RowSorter.SortKey>();
							keys.add(new RowSorter.SortKey(0, SortOrder.ASCENDING));
							liste.getRowSorter().setSortKeys(keys);
							
							for( int i = 0; i < liste.getRowCount(); i++ )
								if( ((String)liste.getValueAt(i, 0)).toUpperCase().startsWith(text.toUpperCase()))
								{
									self.liste.scrollRectToVisible(self.liste.getCellRect(i+5, 0, true));
									self.liste.getSelectionModel().setSelectionInterval(i, i);
									break;
								}
						}
					}
					public void keyTyped(KeyEvent arg0) {}	
				});

		//recherche par nom de taxon	
		nom_filter.addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent arg0) {
						String text = ((JTextField)arg0.getSource()).getText();
						if( ! text.isEmpty() )
						{
							code_filter.setText("");
							// tri par la colonne nom taxon
							List<RowSorter.SortKey> keys = new ArrayList<RowSorter.SortKey>();
							keys.add(new RowSorter.SortKey(1, SortOrder.ASCENDING));
							liste.getRowSorter().setSortKeys(keys);
							
							for( int i = 0; i < liste.getRowCount(); i++ )
								if( ((String)liste.getValueAt(i, 1)).toUpperCase().startsWith(text.toUpperCase()))
								{
									self.liste.scrollRectToVisible(self.liste.getCellRect(i+5, 1, true));
									self.liste.getSelectionModel().setSelectionInterval(i, i);
									break;
								}
						}
					}
					public void keyTyped(KeyEvent arg0) {}	
				});

	}

	private void openCalcul(){
		
		// pour les traductions des botes de dialogue
	//	this.locale = locale;
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		if(!inExport){
			if(liste.getSelectedRow() != -1){
				if(mainFrame == null)
					mainFrame = new Calcul_Biovolume_Frame(locale, db_link);
				id_calcul = Integer.parseInt(liste.getValueAt(liste.getSelectedRow(), 6).toString());
				mainFrame.ouvrirCalcul(id_calcul);
				self.dispose();
			}
			else{
				
				JOptionPane.showMessageDialog(self,
						rb.getString("mssgErrOuvertureCalcul"),
						rb.getString("titreBoxErrOuvCalcul"),
						JOptionPane.ERROR_MESSAGE);
			}      	
		}
		else{
			if(liste.getSelectedRowCount() > 0){
				int nb = self.liste.getSelectedRowCount();
				ids = new int[nb];
				int index = 0;

				for( int i : self.liste.getSelectedRows() )
				{
					ids[index] = Integer.parseInt(self.liste.getValueAt(i, 6).toString());
					index++;
				}
				if(isLibre)
					new Import_Exporter(locale, db_link).export_libre_calcul(ids);
				else
					new Import_Exporter(locale, db_link).export_dce_calcul(ids);
				self.dispose();
			}
			else{
				JOptionPane.showMessageDialog(self,
						rb.getString("mssgSelectLignes"),
						rb.getString("titreBoxSelectLignes"),
						JOptionPane.ERROR_MESSAGE);
			} 
		}
	}


	private void add_buttons(String[]columnNames)
	{	
		// ajout des champs de recherche par code et par nom puis ajout de la table (liste) avec les taxons
		JPanel all = new JPanel();
		JPanel table_pane = new JPanel(new BorderLayout());
		
		all.setLayout(new BoxLayout(all, BoxLayout.PAGE_AXIS));
		all.setBackground(new Color(192, 197, 199));
		
		JPanel label = new JPanel();
		((FlowLayout)label.getLayout()).setAlignment(FlowLayout.LEFT);
		label.setBackground(new Color(192, 197, 199));
		recherche_lbl.setHorizontalAlignment(0); 
		label.add(recherche_lbl);
//TODO espace sous champs de recherche avant le tableau
		JPanel liste_pane = new JPanel();
		liste_pane.setBackground(new Color(192, 197, 199));
		liste_pane.setLayout(new BoxLayout(liste_pane, BoxLayout.LINE_AXIS));
		liste_pane.setAlignmentX(Component.LEFT_ALIGNMENT);
		code_filter.setMaximumSize(new Dimension(70,20));
		code_filter.setPreferredSize(new Dimension(70,20));
		nom_filter.setMaximumSize(new Dimension(225,20));
		nom_filter.setPreferredSize(new Dimension(225,20));

		liste_pane.add(Box.createHorizontalStrut(2));
		liste_pane.add(code_filter);
		liste_pane.add(Box.createHorizontalStrut(3));
		liste_pane.add(nom_filter);
		
		all.add(label);
		all.add(liste_pane);
		all.add(Box.createVerticalStrut(5));
		all.add(table_pane);
		
		DefaultTableModel model = new DefaultTableModel(){

			private static final long serialVersionUID = 1L;

			public boolean isCellEditable(int rowIndex, int columnIndex) {
				return false;
			}
		};
		liste = new JTable(model);

		((DefaultTableModel)this.liste.getModel()).setDataVector(calcul_biovol_query.get_data(), columnNames);


		liste.setAutoCreateRowSorter(true);

		liste.getTableHeader().setReorderingAllowed(false);
		liste.getTableHeader().setResizingAllowed(true);
		
		// appel de la mthode pour dfinir la taille prfre de la table liste
		setTableFormat();
		
		// appel de la mthode pour dfinir la possibilit de tri
		methodeTri();
		
		// tri par la colonne nom taxon
		List<RowSorter.SortKey> keys = new ArrayList<RowSorter.SortKey>();
		keys.add(new RowSorter.SortKey(1, SortOrder.ASCENDING));
		liste.getRowSorter().setSortKeys(keys);

		if(inExport){
			//ajout du texte spcifique  l'export de calculs
			liste_pane.add(labelSelectMulti);
			ouvrir_calcul.setPreferredSize(new Dimension(75,20));
			liste_pane.add(ouvrir_calcul);

		}
		else{
			//ajout boutons spcifique ouverture d'un calcul
			ouvrir_calcul.setPreferredSize(new Dimension(69,20));
			delete.setPreferredSize(new Dimension(20,20));
			liste_pane.add(Box.createHorizontalStrut(270));
			liste_pane.add(ouvrir_calcul);
			liste_pane.add(Box.createHorizontalStrut(3));
			liste_pane.add(delete);
		}

		this.add(label, BorderLayout.NORTH);
		table_pane.add(liste_pane, BorderLayout.NORTH);
		


		JScrollPane __scrollPane = new JScrollPane(liste, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

		table_pane.setBackground(new Color(192, 197, 199));
		table_pane.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						"", TitledBorder.CENTER, TitledBorder.CENTER));

		table_pane.add(__scrollPane, BorderLayout.CENTER);
		this.getContentPane().add(table_pane, BorderLayout.CENTER);	
	}

	// mthode pour dfinir la taille prfre de la Jtable liste de calculs
	private void setTableFormat(){
		liste.getColumnModel().getColumn(0).setPreferredWidth(70);
		liste.getColumnModel().getColumn(1).setPreferredWidth(225);
		liste.getColumnModel().getColumn(2).setPreferredWidth(40);
		liste.getColumnModel().getColumn(3).setPreferredWidth(75);
		liste.getColumnModel().getColumn(4).setPreferredWidth(75);
		liste.getColumnModel().getColumn(5).setPreferredWidth(120);
		liste.getColumnModel().getColumn(6).setPreferredWidth(40);
	}
	
	// cration de la fonction de tri sur les champs autres que string
	private void methodeTri(){
		TableRowSorter<TableModel> sorter = new TableRowSorter<TableModel>(liste.getModel());   
		liste.setRowSorter(sorter);
		sorter.setComparator(3, new FloatComparator());
		sorter.setComparator(6, new IntComparator());
	}


	private void draw_frame()
	{
		this.setResizable(false);
		this.setLocation(200,200);
		this.pack();
		this.setVisible(true);
	}

	public void setImg(String new_img){
		img = new_img;
	}

	public static String getImg() {
		return img;
	}


	// Cration de la comparaison des champs de la table qui sont des entiers
	// pour permmettre le tri correct sur ces champs
	public class IntComparator implements Comparator<String> {

		@Override
		public int compare(String arg0, String arg1) {
			if(Integer.parseInt(arg0) < Integer.parseInt(arg1)) return -1;
			if(Integer.parseInt(arg0) > Integer.parseInt(arg1)) return 1;
			return 0;
		}
	}

	// Cration de la comparaison des champs de la table qui sont des flottants
	// pour permmettre le tri correct sur ces champs
	public class FloatComparator implements Comparator<String> {

		@Override
		public int compare(String o1, String o2) {
			if(Float.parseFloat(o1) < Float.parseFloat(o2)) return -1;
			if(Float.parseFloat(o1) > Float.parseFloat(o2)) return 1;
			return 0;
		}
	}
	
	public void translate(Locale locale, boolean export){
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		// nom de la fentre
		if( export ) {
			this.setTitle(rb.getString("titreFenOuvCalculExport"));
			ouvrir_calcul.setText(rb.getString("export"));
		}
		else
			this.setTitle(rb.getString("titreFenOuvertureCalcul"));

		
		file_menu.setText(rb.getString("fichier"));
		imprimer.setText(rb.getString("imprimer"));
		close_menu_item.setText(rb.getString("fermer"));
		ouvrir_calcul.setText(rb.getString("ouvrir"));
		recherche_lbl.setText(rb.getString("saisieCodeOuNomPerso"));
		
		labelSelectMulti.setText(rb.getString("selectInterMultCalcAExport"));
		
		
		//ragencement de la position des items de la fentre
		this.pack();
	}
	
	
}