package Comptage;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

public class Ajout_Site extends JDialog {

	private static final long serialVersionUID = 1L;
	private Locale locale;
	@SuppressWarnings("unused")
	private String db_link;
	
	Comptage_Query am;
	private JPanel site = new JPanel(new FlowLayout());
	
	
	private JLabel labelNomSite = new JLabel();
	
	JPanel stations = new JPanel(new BorderLayout());

	private JLabel labelNomStation = new JLabel();
	private JLabel labelMilieu = new JLabel();
	
	
	private JButton ajout_site = new JButton();
	private JButton ajout_station = new JButton();
	private JTextField site_name = new JTextField();
	private JTextField station_name = new JTextField();
	private JTextField station_site_name = new JTextField();
	private JTextField tf_milieu = new JTextField();
	private Ajout_Site self = null;
	public String rep="";
	public String repSta="";
	
	/**
	 * Fenetre d'ajout d'un site
	 * @param f JFrame parent
	 * @param half true = ajout d'une station uniquement
	 * @param site_n nom du site
	 */
	public Ajout_Site(JFrame f, boolean half, String site_n, Locale locale, String db_link)
	{
		super(f, "", true);
		this.self = this;
		this.locale = locale;
		this.db_link = db_link;
		
		am = new Comptage_Query(db_link);
		
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.getContentPane().setLayout(new BorderLayout());

		
		site.add(labelNomSite);
		site.setBackground(new Color(192, 197, 199));
		this.site_name.setPreferredSize(new Dimension(100,20));
		site.add(this.site_name);
		site.add(ajout_site);

		if( half )
		{
			ajout_site.setEnabled(false);
			site_name.setEditable(false);
			station_site_name.setText(site_n);
		}
		else
		{
			station_name.setEditable(false);
			tf_milieu.setEditable(false);
			ajout_station.setEnabled(false);
		}

		this.getContentPane().add(site, BorderLayout.NORTH);

		stations.setBackground(new Color(192, 197, 199));

		JPanel stations_name_pane = new JPanel(new FlowLayout());
		((FlowLayout)stations_name_pane.getLayout()).setAlignment(FlowLayout.LEADING);
		JPanel stations_milieu_pane = new JPanel(new FlowLayout());
		((FlowLayout)stations_milieu_pane.getLayout()).setAlignment(FlowLayout.LEADING);
		JPanel stations_site_pane = new JPanel(new FlowLayout());
		((FlowLayout)stations_site_pane.getLayout()).setAlignment(FlowLayout.LEADING);

		stations_name_pane.add(labelNomStation);
		stations_name_pane.setBackground(new Color(192, 197, 199));
		this.station_name.setPreferredSize(new Dimension(100,20));
		stations_name_pane.add(this.station_name);

		stations.add(stations_name_pane, BorderLayout.NORTH);

		stations_site_pane.add(labelNomSite);
		stations_site_pane.setBackground(new Color(192, 197, 199));
		this.station_site_name.setPreferredSize(new Dimension(100,20));
		this.station_site_name.setEditable(false);
		stations_site_pane.add(this.station_site_name);

		stations.add(stations_site_pane, BorderLayout.CENTER);

		stations_milieu_pane.add(labelMilieu);
		stations_milieu_pane.setBackground(new Color(192, 197, 199));
		this.tf_milieu.setPreferredSize(new Dimension(100,20));
		stations_milieu_pane.add(this.tf_milieu);
		((FlowLayout)stations_milieu_pane.getLayout()).setHgap(20);
		stations_milieu_pane.add(ajout_station);

		stations.add(stations_milieu_pane, BorderLayout.SOUTH);

		this.getContentPane().add(stations, BorderLayout.SOUTH);

		this.translate(locale);
		this.add_handlers();

		this.pack();
		this.setLocation(150, 150);
		this.setVisible(true);

	}	

	public void add_handlers()
	{
		
		// ncessaire pour la traduction des botes de dialogues
	//	this.locale = locale;
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		
		ajout_site.addActionListener(
				new ActionListener() {
					@SuppressWarnings("static-access")
					public void actionPerformed(ActionEvent e)
					{
						if( self.am.add_site(self.site_name.getText().trim()) == false )
							new JOptionPane().showMessageDialog(self, rb.getString("mssgErreurAjoutSite"), rb.getString("titreBoxErreurAjoutSite"), JOptionPane.ERROR_MESSAGE);
						else
							new JOptionPane().showMessageDialog(self, rb.getString("mssgSuccesAjoutSite"), rb.getString("titreBoxSuccesAjoutSite"), JOptionPane.INFORMATION_MESSAGE);
						self.station_site_name.setText(self.site_name.getText());
						self.station_name.setText("");
						self.station_name.setEditable(true);
						self.tf_milieu.setText("");
						self.tf_milieu.setEditable(true);
						self.ajout_station.setEnabled(true);
						self.ajout_site.transferFocus();
					}
				});


		//Ajout d'un site par action sur touche entre
		site_name.addKeyListener( new KeyListener() {

			@Override
			public void keyTyped(KeyEvent e) {
			}

			@Override
			public void keyReleased(KeyEvent e) {
			}

			@Override
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_ENTER )  {
					// permet de lancer l'action du bouton ajout_site (click) sans rcrire les lignes de codes
					ajout_site.doClick();
				}
			}	
		});


		ajout_station.addActionListener(
				new ActionListener() {
					@SuppressWarnings("static-access")
					public void actionPerformed(ActionEvent e)
					{
						if( self.am.add_station(self.station_site_name.getText().trim(),
								self.station_name.getText().trim(), self.tf_milieu.getText().trim()) == false)
							new JOptionPane().showMessageDialog(self, rb.getString("mssgErreurAjoutStation"),
									rb.getString("titreBoxErrAjoutStation"), JOptionPane.ERROR_MESSAGE);
						else {
							if (!station_site_name.getText().isEmpty() ){
								rep = site_name.getText();
								repSta = self.station_name.getText();
								self.dispose();
							}	
						}
					}
				});

		//Ajout d'une station et de son milieu par action sur touche entre
		tf_milieu.addKeyListener( new KeyListener() {

			@Override
			public void keyTyped(KeyEvent e) {
			}

			@Override
			public void keyReleased(KeyEvent e) {
			}

			@Override
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_ENTER )  {
					ajout_station.doClick(); // permet de lancer l'action du bouton ajout_station et de son milieu (click) sans rcrire les lignes de codes

				}
			}	
		});

		//Reprise de la nouvelle valeur site pour affichage dans le Comptage 
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent arg0) {

				if (!station_site_name.getText().isEmpty() ){
					rep = site_name.getText();
					repSta = self.station_name.getText();
					self.dispose();
				}	
			}
		});

	}

	public String obtRep(){
		return this.rep;
	}
	public String obtRepSta(){
		return this.repSta;
	}
	
	
	/**
	 * Traduction des textes de la fentre dans la bonne langue
	 * @param locale
	 */
	public void translate(Locale locale){
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		// nom de la fentre
		this.setTitle(rb.getString("titreFenAjoutNouvSite"));
		
		site.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("ajoutDuSite"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		
		labelNomSite.setText(rb.getString("champNomSite"));
		ajout_site.setText(rb.getString("ajouter"));
		
		stations.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
						rb.getString("ajoutStation"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		labelNomStation.setText(rb.getString("champNomStation"));
		labelMilieu.setText(rb.getString("champMilieu"));
		
		ajout_station.setText(rb.getString("ajouter"));
		
		
		//ragencement de la position des items de la fentre
		this.pack();
	}
	

}