package Comptage;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.text.MaskFormatter;

import C_M_Perso.Consultation_Perso_Frame;
import C_R_Valides.Consultation_Frame;
import C_R_Valides.Recherche_Frame;
import Calcul_Biovolume.Calcul_Biovolume_Frame;
import Calcul_Biovolume.Ouvrir_Calcul;
import Menus.Gestion_IPLAC_Frame;

import com.itextpdf.text.BaseColor;
import com.itextpdf.text.Chunk;
import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.Font;
import com.itextpdf.text.Header;
import com.itextpdf.text.Image;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfWriter;

import Ajout_Modif_Chambres.AM_Chambres_Frame;
import Ajout_Modif_Sites.AM_Site_Frame;


public class Comptage_Frame extends JFrame {

	private static final long serialVersionUID = 1L;
	private Locale locale;
	private String db_link;
	private Comptage_Frame self = null;

	private Comptage_Frame cf2 = null;
	private Calcul_Biovolume_Frame cbf = null;
	private Ouvrir_Calcul oc = null;

	//cration du menu fichier
	private JMenuItem open = new JMenuItem();
	private JMenuItem consult_cpt = new JMenuItem();	
	private JMenuItem save_close = new JMenuItem();
	private JMenuItem no_save_close = new JMenuItem();
	private JMenuItem exportPDF = new JMenuItem();

	//cration du menu menu
	private JMenu menu = new JMenu();
	private JMenu taxons = new JMenu();
	private JMenuItem iplac = new JMenuItem();

	private JMenuItem newCalc = new JMenuItem();
	private JMenuItem openCalc = new JMenuItem();
	private JMenuItem synStation = new JMenuItem();
	private JMenuItem synTaxon = new JMenuItem();
	private JMenuItem consultTax = new JMenuItem();
	private JMenuItem recherchTax = new JMenuItem();
	private JMenuItem consultTaxP = new JMenuItem();
	private JMenuItem notice = new JMenuItem();

	JLabel banniere = new JLabel("", new ImageIcon(getClass().getClassLoader().getResource(
			"images/bannierev2.png")), JLabel.TRAILING);

	//cration des chemins des dossiers
	private String pathDocs = new String("Docs");
	
	private JMenuBar menubar = new JMenuBar();
	private JMenu menu_fichier = new JMenu();
	private JMenu menu_calcul = new JMenu();
	private JMenu menu_synthese = new JMenu();
	private JMenu menu_aide = new JMenu("?");
	private JMenu menu_config = new JMenu();
	private JMenuItem am_chambres = new JMenuItem();
	private JMenuItem am_sites = new JMenuItem();

	private JLabel labelSite = new JLabel();
	private JLabel labelStation = new JLabel();
	private JLabel labelMilieu = new JLabel();
	private JLabel labelDatePrel = new JLabel();
	private JLabel labelRefEch = new JLabel();
	private JLabel labelTaxinomiste = new JLabel();
	private JLabel labelVolSed = new JLabel();
	private JLabel labelFactDilu = new JLabel();
	private JLabel labelChambre = new JLabel();
	private JLabel labelNbChamps = new JLabel();
	private JLabel labelIndivTotal = new JLabel();
	private JLabel labelCommentaire = new JLabel();
	private JLabel labelObj = new JLabel();

	private JLabel labelCode = new JLabel();
	private JLabel labelNom = new JLabel();

	private JFormattedTextField date;
	private JTextField id_ech = new JTextField();
	private JComboBox<String> lieu = null;
	private JComboBox<String> station = new JComboBox<String>();
	public JTextField oper = new JTextField();
	private JComboBox<String> chambre = null;
	private JTextField milieu = new JTextField();
	private JTextField vol_sed = new JTextField();
	private JTextField dill = new JTextField();
	private JTextField nb_chp = new JTextField();
	private JButton nb_chp_plus = new JButton("+");
	private JButton nb_chp_moins = new JButton("-");
	private JTextField nb_tot = new JTextField();
	private JButton nb_tot_plus = new JButton("+");
	private JButton nb_tot_moins = new JButton("-");

	private Comptage_Table __table = null;
	private Comptage_Query cpt_query;
	private boolean throwable = true;

	private JButton validation = new JButton();
	private JButton modification = new JButton();

	private JComboBox<String> codes = new JComboBox<String>();
	private JComboBox<String> noms = new JComboBox<String>();
	private JButton add = new JButton();
	private int id_cpt = 0;
	private JCheckBox cpt_cel = new JCheckBox();
	private JCheckBox cpt_ind = new JCheckBox();

	private JButton create = new JButton();
	private JTextField commentaire = new JTextField();
	public static JTextField nb_obj_tot = new JTextField();
	private JPanel cartouche_pane = null;
	private int opti_width;
	private String idLabel = "";

	private boolean modifInfos = false;
	private boolean ocOuvert = false;

	public Comptage_Frame(Locale locale, String db_link) {
		super();
		self = this;
		this.locale = locale;
		this.db_link = db_link;

		cpt_query = new Comptage_Query(db_link);

		this.getContentPane().setLayout(new BorderLayout());
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		Toolkit.getDefaultToolkit().setDynamicLayout(true);

		this.translate(locale);
		add_menu();
		add_fields();
		add_handlers();
		draw_frame();

		self.setMinimumSize(new Dimension(opti_width, 400));

	}

	// boolen pour ne pas autoriser la fermeture de l'application si l'cran comptage est ouvert avec un comptage 
	public boolean get_closable()
	{
		return ((cf2 != null && cf2.get_id_cpt() != 0) ? false : true);
	}

	// boolen pour ne pas autoriser la fermeture de l'application si l'cran calcul biovol
	// est ouvert avec un calcul nouveau ou r-ouvert
	public boolean get_closableCalc()
	{
		return (( cbf != null && (cbf.get_id_calcul() != 0 || cbf.new_calc())
				|| (ocOuvert ==true && ! oc.get_closableCalc())) ? false : true);
	}

	private void add_menu() {


		menu.add(iplac);
		menubar.add(menu);

		menu_fichier.add(open);
		menu_fichier.add(consult_cpt);
		menu_fichier.add(exportPDF);
		menu_fichier.add(save_close);
		menu_fichier.add(no_save_close);
		menubar.add(menu_fichier);

		menu_calcul.add(newCalc);
		menu_calcul.add(openCalc);
		menubar.add(menu_calcul);

		menu_synthese.add(synTaxon);
		menu_synthese.add(synStation);
		menubar.add(menu_synthese);

		taxons.add(consultTax);
		taxons.add(recherchTax);
		taxons.add(consultTaxP);
		menubar.add(taxons);

		menu_config.add(am_chambres);
		menu_config.add(am_sites);
		menubar.add(menu_config);

		menu_aide.add(notice);
		menubar.add(menu_aide);


		modification.setEnabled(false);

		this.setJMenuBar(menubar);
	}

	public int get_id_cpt() {
		return id_cpt;
	}

	private void add_handlers() {

		// pour les traductions boites de dialogues entre autres
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		this.addWindowListener(new WindowAdapter() {
			@SuppressWarnings("static-access")
			public void windowClosing(WindowEvent arg0) {
				if (id_cpt != 0)
					new JOptionPane()
					.showMessageDialog(
							self,
							rb.getString("mssgComptageOuvert"),
							rb.getString("titreBoxComptageOuvert"), JOptionPane.WARNING_MESSAGE);
				else
					self.dispose();
			}
		});

		this.addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent evt) {
				self.setSize(self.opti_width, self.getHeight());
			}
		});

		//ouverture de la page de calcul d'IPLAC
		iplac.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {
						new Gestion_IPLAC_Frame(locale, db_link, "3", "01/05", "31/10", true, false);
					}});

		//ouverture de la page de gestion des taxons
		taxons.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {
						new Consultation_Frame(locale, db_link);
					}});

		//Sauvegarde et fermeture du comptage
		save_close.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				// si les informations n'ont pas t valides
				if(validation.isEnabled()){
					// bote de dialogue indiquant qu'on ne peut pas quitter sans avoir valid
					//	 les informations du cartouche
					JOptionPane.showMessageDialog(
							self, rb.getString("mssgEssaiQuitterSansValider"),
							rb.getString("titreBoxEssaiQuitSansValid"), 
							JOptionPane.WARNING_MESSAGE);
				}
				else if (id_cpt != 0) {
					float mult = cpt_query.get_multi(id_cpt);
					for (int i = 0; i < __table.getRowCount(); i++){
						// on regarde si le taxon est personnel (la table  mettre  jour ne sera pas la mme selon a)
						boolean perso = ((__table.getValueAt(i, 1).toString()).startsWith("NEW")) ||  
								(__table.getValueAt(i, 12).equals(true));
						// mise  jour du biovol de la ligne
						cpt_query.set_biovol( id_cpt, 
								(Integer)__table.getValueAt(i, 0), 
								(Float)__table.getValueAt(i, 9), 
								mult, perso);

						//mise  jour du type d'objet compt de la ligne						
						cpt_query.change_type(id_cpt,(Integer) __table
								.getValueAt(i, 0), (String) __table
								.getValueAt(i, 4), (String) __table
								.getValueAt(i, 1),(Boolean) __table
								.getValueAt(i, 12) );/*#*/


						if( ((String)__table.getValueAt(i, 5)).compareTo("Cf.") == 0 )
							cpt_query.change_cf(id_cpt, (Integer)__table.getValueAt(i, 0), true);
						else 
							cpt_query.change_cf(id_cpt, (Integer)__table.getValueAt(i, 0), false);
					}

					nb_chp.setText(Integer.toString(Integer.parseInt(nb_chp
							.getText())));
					cpt_query.change_nb_chp(id_cpt, Integer.parseInt(nb_chp
							.getText()));
					nb_tot.setText(Integer.toString(Integer.parseInt(nb_tot
							.getText())));
					cpt_query.change_nb_tot(id_cpt, Integer.parseInt(nb_tot
							.getText()));
					cpt_query.set_commentaire(id_cpt, commentaire.getText()
							.trim());				

					// affichage d'un message lorsqu'il manque un biovol unitaire sur une ligne

					int reponse=3;
					for (int i = 0; i < __table.getRowCount(); i++){					
						if ((Float) __table.getValueAt(i,9)==0) 
						{
							reponse=javax.swing.JOptionPane.showConfirmDialog(self, 
									rb.getString("mssgManqueBiovolUnit"),
									rb.getString("titreBoxManqueBiovolUnit"),
									JOptionPane.YES_NO_OPTION );

							if (reponse==JOptionPane.NO_OPTION){
								self.pack();
								break;
							}
							else
								id_cpt = 0;
							nb_obj_tot.setText("");
							self.dispose();
							//ouverture d'une nouvelle fentre de comptage
							cf2 = new Comptage_Frame(locale, db_link);
							break;
						}
					}
					if (reponse==3){
						id_cpt = 0;
						nb_obj_tot.setText("");
						self.dispose();
						//ouverture d'une nouvelle fentre de comptage
						cf2 = new Comptage_Frame(locale, db_link);
					}
				}
				else
					self.dispose();
			}
		});

		//fermeture du comptage sans enregistrer	
		no_save_close.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (id_cpt != 0) {
					int reponse = JOptionPane.showConfirmDialog(
							self, rb.getString("mssgQuitSansSauv"),
							rb.getString("titreBoxQuitSansSauv"), 
							JOptionPane.YES_NO_OPTION);

					if(reponse == 0){
						id_cpt = 0;
						nb_obj_tot.setText("");
						self.dispose();	
						//ouverture d'une nouvelle fentre de comptage
						cf2 = new Comptage_Frame(locale, db_link);	
					} else;
				} else
					self.dispose(); 
			}
		});


		// export PDF du comptage ouvert
		exportPDF.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				// si un comptage est ouvert
				if(id_cpt != 0){
					// choix du rpertoire
					JFileChooser fc = new JFileChooser();
					fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					fc.setMultiSelectionEnabled(false);

					File f = null;
					if( fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION ){
						f = new File(fc.getSelectedFile().getAbsolutePath() 
								+ File.separator + rb.getString("comptage") + id_cpt + ".pdf");
					}
					
					
					// alerte si fichier pdf dj ouvert
					boolean accesLibre = false;					
					Document document = new Document(PageSize.A4);
					
					try{
						PdfWriter.getInstance(document, new FileOutputStream(f));
					accesLibre = true;
				} catch (FileNotFoundException notF) {
					accesLibre = false;
					new JOptionPane();
					JOptionPane.showMessageDialog(self, 
							rb.getString("mssgPdfOuvert"),
							rb.getString("titreBoxPdfOuvert"), JOptionPane.WARNING_MESSAGE);
			} catch (DocumentException e1) {
					e1.printStackTrace();
				};
				
				if(accesLibre){
					
					
					// export pdf
					try{
						PdfWriter.getInstance(document, new FileOutputStream(f));
						// ouverture du fichier pdf
						document.open();
						// creation du contenu du fichier
						Font bigFont = new Font(Font.FontFamily.HELVETICA, 22, Font.BOLD, BaseColor.BLUE);
						Font mediumFont = new Font(Font.FontFamily.HELVETICA, 16, Font.BOLD, BaseColor.BLACK);
						Font normalBoldFont = new Font(Font.FontFamily.HELVETICA, 12, Font.BOLD, BaseColor.BLACK);
						Font normalItalicFont = new Font(Font.FontFamily.HELVETICA, 10, Font.ITALIC, BaseColor.BLACK);
						Font normalFont = new Font(Font.FontFamily.HELVETICA, 12, Font.NORMAL, BaseColor.BLACK);
						Font tinyFont = new Font(Font.FontFamily.HELVETICA, 10, Font.NORMAL, BaseColor.BLACK);
						Font tiny2Font = new Font(Font.FontFamily.HELVETICA, 5, Font.NORMAL, BaseColor.BLACK);

						// entte
						Paragraph entete = new Paragraph(lieu.getItemAt(0) + " - " + station.getItemAt(0) + " - " + 
								date.getText());
						entete.setAlignment(Header.ALIGN_RIGHT);
						document.add(entete);

						// logo IRSTEA : images/Logo_Irstea_red.png
						Image imgLogo = Image.getInstance(getClass().getClassLoader().getResource("images/logo_irstea.jpg"));
						imgLogo.setAlignment(Element.ALIGN_LEFT);
						imgLogo.scaleAbsolute(100f, 100f);
						imgLogo.setSpacingAfter(-20f);
						document.add(imgLogo);

						// titre de la fiche
						Paragraph title  = new Paragraph(rb.getString("titreFichePDFCpt") + id_cpt + "\n\n", bigFont);
						title.setAlignment(Element.ALIGN_CENTER);
						document.add(title);

						Paragraph titreDG = new Paragraph(rb.getString("donnesGenerales"), mediumFont);
						titreDG.setAlignment(Element.ALIGN_LEFT);
						document.add(titreDG);
						// ajout d'un petit saut de ligne avant le tableau
						Paragraph petitSautDeLigne = new Paragraph("\n", tiny2Font);
						document.add(petitSautDeLigne);

						// tableau contenant le tableau des donnes gnrales
						PdfPTable tableauDG = new PdfPTable(4);
						tableauDG.setWidthPercentage(100);
						//choix de la largeur de chaque colonne
						tableauDG.setWidths(new float[]{22f, 28f, 20f, 28f});

						// ajout du site dans le tableau
						PdfPCell champSite = new PdfPCell(new Paragraph(rb.getString("champSite"), normalBoldFont));
						tableauDG.addCell(champSite);
						PdfPCell valeurSite = new PdfPCell(new Paragraph((String) lieu.getSelectedItem(), normalFont));
						tableauDG.addCell(valeurSite);

						// ajout de la station dans le tableau
						PdfPCell champStation = new PdfPCell(new Paragraph(rb.getString("champStation"), normalBoldFont));
						tableauDG.addCell(champStation);
						PdfPCell valeurStation = new PdfPCell(new Paragraph((String) station.getSelectedItem(), normalFont));
						tableauDG.addCell(valeurStation);

						// ajout du milieu dans le tableau
						PdfPCell champMilieu = new PdfPCell(new Paragraph(rb.getString("champMilieu"), normalBoldFont));
						tableauDG.addCell(champMilieu);
						PdfPCell valeurMilieu = new PdfPCell(new Paragraph(milieu.getText(), normalFont));
						tableauDG.addCell(valeurMilieu);


						// ajout de la date de prlevement dans le tableau
						PdfPCell champDatePrel = new PdfPCell(new Paragraph(rb.getString("champDatePrel"), normalBoldFont));
						tableauDG.addCell(champDatePrel);
						PdfPCell valeurDatePrel = new PdfPCell(new Paragraph(date.getText(), normalFont));
						tableauDG.addCell(valeurDatePrel);

						// ajout de la rfrence de l'chantillon dans le tableau
						PdfPCell champRefEch = new PdfPCell(new Paragraph(rb.getString("champRefEch"), normalBoldFont));
						tableauDG.addCell(champRefEch);
						PdfPCell valeurRefEch = new PdfPCell(new Paragraph(id_ech.getText(), normalFont));
						tableauDG.addCell(valeurRefEch);

						// ajout du taxinomiste dans le tableau
						PdfPCell champTaxi = new PdfPCell(new Paragraph(rb.getString("champTaxinomiste"), normalBoldFont));
						tableauDG.addCell(champTaxi);
						PdfPCell valeurTaxi = new PdfPCell(new Paragraph(oper.getText(), normalFont));
						tableauDG.addCell(valeurTaxi);

						// ajout du volume sdiment dans le tableau
						PdfPCell champVolSed = new PdfPCell(new Paragraph(rb.getString("champVolSed"), normalBoldFont));
						tableauDG.addCell(champVolSed);
						PdfPCell valeurVolSed = new PdfPCell(new Paragraph(vol_sed.getText() + " ml", normalFont));
						tableauDG.addCell(valeurVolSed);

						// ajout du facteur diluvien dans le tableau
						PdfPCell champFactDilu = new PdfPCell(new Paragraph(rb.getString("champFactDilu"), normalBoldFont));
						tableauDG.addCell(champFactDilu);
						PdfPCell valeurFactDilu = new PdfPCell(new Paragraph(dill.getText(), normalFont));
						tableauDG.addCell(valeurFactDilu);

						// ajout d dans le tableau
						PdfPCell champChambre = new PdfPCell(new Paragraph(rb.getString("champChambre"), normalBoldFont));
						tableauDG.addCell(champChambre);
						PdfPCell valeurChambre = new PdfPCell(new Paragraph((String) chambre.getSelectedItem(), normalFont));
						tableauDG.addCell(valeurChambre);


						// ajout du nombre de champs dans le tableau
						PdfPCell champNbChamps = new PdfPCell(new Paragraph(rb.getString("champNbChamps"), normalBoldFont));
						tableauDG.addCell(champNbChamps);
						PdfPCell valeurNbChamps = new PdfPCell(new Paragraph(nb_chp.getText(), normalFont));
						tableauDG.addCell(valeurNbChamps);

						// ajout du nombre d'individus total dans le tableau
						PdfPCell champNbIndivTotal = new PdfPCell(new Paragraph(rb.getString("champNbIndivTotal"), normalBoldFont));
						tableauDG.addCell(champNbIndivTotal);
						PdfPCell valeurNbIndivTotal = new PdfPCell(new Paragraph(nb_tot.getText(), normalFont));
						tableauDG.addCell(valeurNbIndivTotal);

						// ajout d'une case vide (car sinon la ligne ne se cre pas... )
						PdfPCell champVide = new PdfPCell(new Paragraph(" "));
						tableauDG.addCell(champVide);
						PdfPCell valeurVide = new PdfPCell(new Paragraph(" "));
						tableauDG.addCell(valeurVide);


						document.add(tableauDG);

						// ajout du commentaire du comptage sous le tableau
						Paragraph commentairePara = new Paragraph();
						Chunk champCommCh = new Chunk(rb.getString("champCommentaire"), normalBoldFont);
						commentairePara.add(champCommCh);
						Chunk commentaireCh = new Chunk(' ' + commentaire.getText() + "\n\n", normalFont);
						commentairePara.add(commentaireCh);
						document.add(commentairePara);


						////////////////////////////
						// Partie des taxons compts
						Paragraph taxonsComptes = new Paragraph(rb.getString("taxonsCpt"), mediumFont);
						taxonsComptes.setAlignment(Element.ALIGN_LEFT);
						document.add(taxonsComptes);

						// ajout du petit saut de ligne avant le tableau
						document.add(petitSautDeLigne);

						// cette partie sera sous la forme d'un tableau reprsentant le comptage (9 colonnes)
						PdfPTable tableauCpt = new PdfPTable(9);
						tableauCpt.setWidthPercentage(100);
						// choix de la largeur de chaque colonne
						tableauCpt.setWidths(new float[]{23f,16f, 10f, 54f, 55f, 24f, 25f, 22f, 16f});

						// ajout des titres des colonnes
						PdfPCell c1 = new PdfPCell(new Paragraph(rb.getString("colCodeTaxon"), normalBoldFont));
						tableauCpt.addCell(c1);

						PdfPCell c2 = new PdfPCell(new Paragraph(rb.getString("colTypeObj"), normalBoldFont));
						tableauCpt.addCell(c2);

						PdfPCell c3 = new PdfPCell(new Paragraph(rb.getString("colCf"), normalBoldFont));
						tableauCpt.addCell(c3);

						PdfPCell c4 = new PdfPCell(new Paragraph(rb.getString("colNomTaxon"), normalBoldFont));
						tableauCpt.addCell(c4);

						PdfPCell c5 = new PdfPCell(new Paragraph(rb.getString("colAuteur"), normalBoldFont));
						tableauCpt.addCell(c5);

						PdfPCell c6 = new PdfPCell(new Paragraph(rb.getString("colCodeRef"), normalBoldFont));
						tableauCpt.addCell(c6);

						PdfPCell c7 = new PdfPCell(new Paragraph(rb.getString("colBiovolParObj"), normalBoldFont));
						tableauCpt.addCell(c7);

						PdfPCell c8 = new PdfPCell(new Paragraph(rb.getString("col1NbMoyCell_ind"), normalBoldFont));
						tableauCpt.addCell(c8);

						PdfPCell c9 = new PdfPCell(new Paragraph(rb.getString("colNbCpt"), normalBoldFont));
						tableauCpt.addCell(c9);

						// rcupration des comptages pour ajout dans le tableau						
						// : rcupration des taxons compts pour ce comptage prcis
						Object[][] listeTaxonsCpt = cpt_query.get_all_taxon(id_cpt);

						// ncessaire  l'insertion de l'entte sur chaque page...
						int cpt = 0;
						int maxNbLignesCptPage1 = 17;
						int maxNbLignesCptPages = 30;
						boolean premierePage = true;

						// date du jour pour pied de page
						Date aujourdhui = new Date();
						DateFormat shortDateFormat = DateFormat.getDateTimeInstance(
								DateFormat.SHORT, DateFormat.SHORT, locale);

						//TODO n version  actualiser dans langue lors de changement de version
						Paragraph pdp = new Paragraph(rb.getString("phytobsVer")
								+ " - " + rb.getString("dateImpress") + 
								shortDateFormat.format(aujourdhui));
						
						for(Object[] data : listeTaxonsCpt){

							tableauCpt.addCell(new Paragraph(data[1].toString(), tinyFont));
							tableauCpt.addCell(new Paragraph(data[2].toString(), tinyFont));
							tableauCpt.addCell(new Paragraph(data[3].toString(), tinyFont));
							tableauCpt.addCell(new Paragraph(data[4].toString(), normalItalicFont));
							tableauCpt.addCell(new Paragraph(data[5].toString(), tinyFont));
							tableauCpt.addCell(new Paragraph(data[6].toString(), tinyFont));

							// les trois valeurs suivantes doivent tre alignes  droite

							// biovolume
							String strCellBioVol;
							// les biovolumes valant 0.0 ne sont pas affichs
							if(!data[7].toString().equals("0.0"))
								strCellBioVol = data[7].toString();
							else strCellBioVol = "";

							PdfPCell pc1 = new PdfPCell(new Paragraph(strCellBioVol, tinyFont));
							pc1.setHorizontalAlignment(Element.ALIGN_RIGHT);
							tableauCpt.addCell(pc1);

							// nb moy cell/ind
							String valNbMoyCell_Ind;
							if (data[8] != null)
								valNbMoyCell_Ind = data[8].toString();
							else
								valNbMoyCell_Ind = "";


							PdfPCell pc2 = new PdfPCell(new Paragraph(valNbMoyCell_Ind, tinyFont));/*#*/
							pc2.setHorizontalAlignment(Element.ALIGN_RIGHT);
							tableauCpt.addCell(pc2);

							// nombre compt
							PdfPCell pc3 = new PdfPCell(new Paragraph(data[9].toString(), tinyFont));/*#*/
							pc3.setHorizontalAlignment(Element.ALIGN_RIGHT);
							tableauCpt.addCell(pc3);

							cpt++;
							
							// astuce pour insrer l'entte sur chaque page
							if ( (cpt > maxNbLignesCptPage1 && premierePage) ||
									(cpt > maxNbLignesCptPages && !premierePage) ) {

								// ajout d'une partie du tableau
								document.add(tableauCpt);
								// ajout du pied de page
								pdp.setAlignment(Element.ALIGN_RIGHT);
								document.add(pdp);
								
								// vidage du tableau
								tableauCpt.flushContent();

								cpt = 0;

								if (premierePage)
									premierePage = false;

								// nouvelle page
								document.newPage();
								// ajout de l'entte
								document.add(entete);
								document.add(petitSautDeLigne);
							}
						}

						document.add(tableauCpt);

						// ajout du pied de page
						pdp.setAlignment(Element.ALIGN_RIGHT);
						document.add(pdp);

					}catch (DocumentException de){
						de.printStackTrace();
					}catch (IOException ioe){
						ioe.printStackTrace();
					}

					// Message de russite d'export :
					JOptionPane.showMessageDialog(
							self, rb.getString("mssgSuccesExportPDF") + 
							fc.getSelectedFile().getAbsolutePath() 
							+ File.separator + rb.getString("comptage") + id_cpt + ".pdf",
							rb.getString("titreBoxSuccesExportPDF"), 
							JOptionPane.INFORMATION_MESSAGE);
					document.close();
				}
				}

				// s'il n'y a pas de calculs ouverts  exporter :
				else {
					JOptionPane.showMessageDialog(
							self, rb.getString("mssgRienAExporter"),
							rb.getString("titreBoxRienAExporter"), 
							JOptionPane.ERROR_MESSAGE);
				}
			}
		});


		nb_tot_plus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					nb_tot.setText(Integer.toString(Integer.parseInt(nb_tot
							.getText()) + 1));
					cpt_query.change_nb_tot(id_cpt, Integer.parseInt(nb_tot
							.getText()));
				} catch (NumberFormatException ex) {
					JOptionPane
					.showMessageDialog(
							self,
							rb.getString("mssgNbTotalNonEntier"),
							rb.getString("titreBoxNbTotalNonEntier"), JOptionPane.ERROR_MESSAGE);
					nb_tot.setText("0");
				}
			}
		});

		nb_tot_moins.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (nb_tot.getText().compareTo("0") != 0) {
					try {
						nb_tot.setText(Integer.toString(Integer.parseInt(nb_tot
								.getText()) - 1));
						cpt_query.change_nb_tot(id_cpt, Integer.parseInt(nb_tot
								.getText()));
					} catch (NumberFormatException ex) {
						JOptionPane
						.showMessageDialog(
								self,
								rb.getString("mssgNbTotalNonEntier"),
								rb.getString("titreBoxNbTotalNonEntier"), JOptionPane.ERROR_MESSAGE);
						nb_tot.setText("0");
					}
				}
			}
		});

		nb_tot.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (nb_tot.getText().compareTo("0") != 0) {
					try {
						nb_tot.setText(Integer.toString(Integer.parseInt(nb_tot
								.getText())));
						cpt_query.change_nb_tot(id_cpt, Integer.parseInt(nb_tot
								.getText()));
					} catch (NumberFormatException ex) {
						JOptionPane
						.showMessageDialog(
								self,
								rb.getString("mssgNbTotalNonEntier"),
								rb.getString("titreBoxNbTotalNonEntier"), JOptionPane.ERROR_MESSAGE);
						nb_tot.setText("0");
					}
				}
			}
		});

		//Prise en compte du nbre total de taxons lorsque saisie directe dans le champs
		nb_tot.addKeyListener(new KeyListener() {

			@Override
			public void keyTyped(KeyEvent arg0) {
			}

			@Override
			public void keyReleased(KeyEvent e) {
				if (nb_tot.getText().compareTo("0") != 0) {
					try {
						nb_tot.setText(Integer.toString(Integer.parseInt(nb_tot
								.getText())));
						cpt_query.change_nb_tot(id_cpt, Integer.parseInt(nb_tot
								.getText()));
					} catch (NumberFormatException ex) {
						JOptionPane
						.showMessageDialog(
								self,
								rb.getString("mssgNbTotalNonEntier"),
								rb.getString("titreBoxNbTotalNonEntier"), JOptionPane.ERROR_MESSAGE);
						nb_tot.setText("0");
					}
				}
			}

			@Override
			public void keyPressed(KeyEvent arg0) {	
			}
		});

		nb_chp_plus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					nb_chp.setText(Integer.toString(Integer.parseInt(nb_chp
							.getText()) + 1));
					cpt_query.change_nb_chp(id_cpt, Integer.parseInt(nb_chp
							.getText()));
				} catch (NumberFormatException ex) {
					JOptionPane
					.showMessageDialog(
							self,
							rb.getString("mssgNbChampsNonEntier"),
							rb.getString("titreBoxNbChampsNonEntier"), JOptionPane.ERROR_MESSAGE);
					nb_chp.setText("0");
				}
			}
		});

		nb_chp_moins.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (nb_chp.getText().compareTo("0") != 0) {
					try {
						nb_chp.setText(Integer.toString(Integer.parseInt(nb_chp
								.getText()) - 1));
						cpt_query.change_nb_chp(id_cpt, Integer.parseInt(nb_chp
								.getText()));
					} catch (NumberFormatException ex) {
						JOptionPane
						.showMessageDialog(
								self,
								rb.getString("mssgNbChampsNonEntier"),
								rb.getString("titreBoxNbChampsNonEntier"), JOptionPane.ERROR_MESSAGE);
						nb_chp.setText("0");
					}
				}
			}
		});

		nb_chp.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (nb_chp.getText().compareTo("0") != 0) {
					try {
						nb_chp.setText(Integer.toString(Integer.parseInt(nb_chp
								.getText())));
						cpt_query.change_nb_chp(id_cpt, Integer.parseInt(nb_chp
								.getText()));
					} catch (NumberFormatException ex) {
						JOptionPane
						.showMessageDialog(
								self,
								rb.getString("mssgNbChampsNonEntier"),
								rb.getString("titreBoxNbChampsNonEntier"), JOptionPane.ERROR_MESSAGE);
						nb_chp.setText("0");
					}
				}
			}
		});

		//Prise en compte nbre de champs lorsque saisie directe dans le champs
		nb_chp.addKeyListener(new KeyListener() {
			public void keyTyped(KeyEvent arg0) {
			}

			@Override
			public void keyPressed(KeyEvent arg0) {
			}

			@Override
			public void keyReleased(KeyEvent e) {
				if (nb_chp.getText().compareTo("0") != 0) {
					try {
						nb_chp.setText(Integer.toString(Integer.parseInt(nb_chp
								.getText())));
						cpt_query.change_nb_chp(id_cpt, Integer.parseInt(nb_chp
								.getText()));
					} catch (NumberFormatException ex) {
						JOptionPane
						.showMessageDialog(
								self,
								rb.getString("mssgNbChampsNonEntier"),
								rb.getString("titreBoxNbChampsNonEntier"), JOptionPane.ERROR_MESSAGE);
						nb_chp.setText("0");
					}
				}
			}
		});

		// ouverture de la fenetre pour ajouter un site/station et ajout d'une station...
		station.addItemListener(new ItemListener() {
			String selected;
			String milieu;
			boolean launched = false;
			String newStation;


			@SuppressWarnings("unchecked")
			public void itemStateChanged(ItemEvent e) {
				if (throwable) {
					throwable = false;
					self.milieu.setText("");
					selected = (String) ((JComboBox<String>) e.getSource())
							.getSelectedItem();
					if (selected.compareTo(rb.getString("nouvelle")) != 0) {
						milieu = cpt_query.get_milieu(((String) self.lieu
								.getSelectedItem()), ((String) self.station
										.getSelectedItem()));
						self.milieu.setText(milieu);
					} else {
						if (!launched) {
							Ajout_Site AjSite = new Ajout_Site(self, true, ((String) self.lieu
									.getSelectedItem()), locale, db_link);
							station.removeAllItems();
							for (String s : cpt_query
									.get_stations((String) self.lieu
											.getSelectedItem()))
								station.addItem(s);
							station.addItem(rb.getString("nouvelle"));
							newStation = AjSite.obtRepSta();
							station.setSelectedItem(newStation);
							milieu = cpt_query.get_milieu(((String) self.lieu
									.getSelectedItem()), ((String) self.station
											.getSelectedItem()));
							self.milieu.setText(milieu);

							launched = true;
						} else
							launched = false;
					}
					throwable = true;
				}
			}
		});

		// ouverture de la fenetre pour ajouter un site
		lieu.addItemListener(new ItemListener() {
			String selected;
			String[] stations;
			String milieu;
			boolean launched = false;
			String newSite;

			@SuppressWarnings("unchecked")
			public void itemStateChanged(ItemEvent e) {
				if (throwable) {
					throwable = false;
					self.station.removeAllItems();
					self.milieu.setText("");
					selected = (String) ((JComboBox<String>) e.getSource())
							.getSelectedItem();
					if (selected.compareTo(rb.getString("nouveau")) != 0) {
						stations = cpt_query.get_stations(selected);
						if (stations != null) {
							for (String s : stations)
								self.station.addItem(s);
							milieu = cpt_query.get_milieu(((String) self.lieu
									.getSelectedItem()), ((String) self.station
											.getSelectedItem()));
							self.milieu.setText(milieu);
						} else
							self.station.addItem("");
						self.station.addItem(rb.getString("nouvelle"));
					} else {
						if (launched == false) {		
							//action si le choix "nouveau" est slectionn
							Ajout_Site AjSite = new Ajout_Site(self, false, "", locale, db_link);
							lieu.removeAllItems();
							for (String s : cpt_query.get_sites(""))
								lieu.addItem(s);
							lieu.addItem(rb.getString("nouveau"));
							launched = true;
							newSite = AjSite.obtRep();		
							//affichage du nom du nouveau site
							lieu.setSelectedItem(newSite);	
							// dans le champ lieu
							stations = cpt_query.get_stations(newSite);
							self.station.addItem(rb.getString("nouvelle"));
						} else
							launched = false;
					}
					throwable = true;
				}
			}
		});

		lieu.getEditor().getEditorComponent().addKeyListener(new KeyListener() {
			String user_input;
			String[] sites;

			public void keyPressed(KeyEvent arg0) {
			}

			public void keyReleased(KeyEvent e) {
				if (e.getKeyCode() != KeyEvent.VK_DOWN
						&& e.getKeyCode() != KeyEvent.VK_BACK_SPACE
						&& e.getKeyCode() != KeyEvent.VK_UP) {
					user_input = ((JTextField) e.getSource()).getText().trim();
					sites = cpt_query.get_sites(user_input.replaceAll("'",
							"\\\\'"));
					throwable = false;
					if (sites != null) {
						self.lieu.removeAllItems();
						self.station.removeAllItems();
						self.milieu.setText("");
						if (sites.length > 1) {
							self.lieu.addItem(user_input);
							for (String s : sites)
								self.lieu.addItem(s);
							self.lieu.hidePopup();
							self.lieu.showPopup();
						} else {
							throwable = true;
							self.lieu.addItem(sites[0]);
						}
						self.lieu.addItem(rb.getString("nouveau"));

					} else {
						throwable = false;
						self.lieu.removeAllItems();
						self.station.removeAllItems();
						self.milieu.setText("");
						self.lieu.addItem(user_input);
						self.lieu.addItem("");
						self.lieu.addItem(rb.getString("nouveau"));
					}
				} else {
					throwable = false;
					self.station.removeAllItems();
					self.milieu.setText("");
				}
				throwable = true;
			}

			public void keyTyped(KeyEvent e) {
			}
		});

		validation.addActionListener(new ActionListener() {

			boolean date_ok = false, site_ok = false, station_ok = false,
					oper_ok = false, volsed_ok = false, dill_ok = false,
					ch_ok = false, dateFormat_valid=true;
			String site, stations, ch;
			Float vol, dillu;
			String Sdate;
			private static final String DATE_PATTERN = "yyyy-MM-dd";
			public void actionPerformed(ActionEvent e) {
				site = (String) lieu.getSelectedItem();
				stations = (String) station.getSelectedItem();
				ch = (String) chambre.getSelectedItem();
				if (date.getText().matches("([1-2]([0-9]{3}))-((0[1-9])|(1[0-2]))-(([0-2][1-9])|10|20|(3[0-1]))")) {
					//format de date contraint entre l'an 1000 et 2999; 01 et 12; 01 et 31
					Sdate=date.getText();
					SimpleDateFormat sdf = new SimpleDateFormat();
					sdf.applyPattern(DATE_PATTERN);
					try
					{
						sdf.setLenient(false); //on accepte pas une date irrelle du genre 30 fv ou 31 avril
						Date d = sdf.parse(Sdate);
						System.out.println(d);

					}
					catch(ParseException pe)
					{
						dateFormat_valid = false;
					}
					if (dateFormat_valid==false)
					{
						date.setBackground(Color.RED);
						dateFormat_valid=true;
						date_ok = false;
					} else {
						date.setBackground(Color.WHITE);
						dateFormat_valid=true;
						date_ok = true;
					}

				} else {
					date.setBackground(Color.RED);
					dateFormat_valid=true;
					date_ok = false;
				}

				if (site.compareTo(rb.getString("nouveau")) != 0 && !site.isEmpty()) {
					site_ok = true;
					lieu.getEditor().getEditorComponent().setBackground(
							Color.WHITE);
				} else {
					lieu.getEditor().getEditorComponent().setBackground(
							Color.RED);
					site_ok = false;
				}

				if (ch != null && !ch.trim().isEmpty()) {
					ch_ok = true;
					chambre.setBackground(Color.WHITE);
				} else {
					chambre.setBackground(Color.RED);
					ch_ok = false;
				}

				if (stations != null && stations.compareTo(rb.getString("nouvelle")) != 0
						&& !stations.isEmpty()) {
					station_ok = true;
					station.setBackground(Color.WHITE);
				} else {
					station.setBackground(Color.RED);
					station_ok = false;
				}

				if (!oper.getText().trim().isEmpty()) {
					oper.setBackground(Color.WHITE);
					oper_ok = true;
				} else {
					oper.setBackground(Color.RED);
					oper_ok = false;
				}

				try {
					vol = Float.parseFloat(vol_sed.getText().trim());
					volsed_ok = true;
					vol_sed.setBackground(Color.WHITE);
				} catch (NumberFormatException nfe) {
					volsed_ok = false;
					vol_sed.setBackground(Color.RED);
				}

				try {
					dillu = Float.parseFloat(dill.getText().trim());
					dill_ok = true;
					dill.setBackground(Color.WHITE);
				} catch (NumberFormatException nfe) {
					dill_ok = false;
					dill.setBackground(Color.RED);
				}

				if (date_ok && site_ok && station_ok && oper_ok && volsed_ok
						&& dill_ok && ch_ok) {
					// si le comptage est tout nouveau : ajout
					if(!modifInfos){
						id_cpt = cpt_query.add_cpt(
								((String) lieu.getSelectedItem()).trim(),
								((String) station.getSelectedItem()).trim(), date
								.getText(), id_ech.getText().trim(), oper
								.getText().trim(), vol, dillu,
								((String) chambre.getSelectedItem()).trim());
					}
					// si le comptage existe dj : modification
					else if (id_cpt!= 0){
						cpt_query.set_cpt( id_cpt,
								((String) lieu.getSelectedItem()).trim(),
								((String) station.getSelectedItem()).trim(), date
								.getText(), id_ech.getText().trim(), oper
								.getText().trim(), vol, dillu,
								((String) chambre.getSelectedItem()).trim());
					}

					// affichage du numro du nouveau comptage 			
					get_id_cpt();
					idLabel = rb.getString("infosCptNum") + id_cpt;
					cartouche_pane.setBorder(BorderFactory.createTitledBorder(
							BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
									new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
							idLabel, TitledBorder.CENTER, TitledBorder.CENTER));

					// blocage des champs aprs validation effectue
					if (id_cpt != 0) {
						nb_chp.setEditable(true);
						nb_chp_plus.setEnabled(true);
						nb_chp_moins.setEnabled(true);
						nb_tot.setEditable(true);
						nb_tot_plus.setEnabled(true);
						nb_tot_moins.setEnabled(true);

						validation.setEnabled(false);
						modification.setEnabled(true);

						date.setEditable(false);
						add.setEnabled(true);
						lieu.setEnabled(false);
						station.setEnabled(false);
						chambre.setEnabled(false);
						vol_sed.setEditable(false);
						dill.setEditable(false);
						oper.setEditable(false);
						id_ech.setEditable(false);
						create.setEnabled(true);
						codes.setEditable(true);
						noms.setEditable(true);
					}
				}
			}
		} );

		modification.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e){

				new JOptionPane();
				if (JOptionPane.showConfirmDialog(self,
						rb.getString("mssgConfirmModifInfos"),
						rb.getString("titreBoxConfirmModifInfos"), 
						JOptionPane.YES_NO_OPTION,
						JOptionPane.WARNING_MESSAGE) == JOptionPane.YES_OPTION){

					// ractivation du bouton validation
					validation.setEnabled(true);
					modification.setEnabled(false);
					modifInfos = true;

					// dblocage de tous les champs dans le cartouche
					lieu.setEnabled(true);
					station.setEnabled(true);
					date.setEditable(true);
					id_ech.setEditable(true);
					oper.setEditable(true);
					vol_sed.setEditable(true);
					dill.setEditable(true);

					chambre.setEnabled(true);

				}
			}
		});


		((JTextField) noms.getEditor().getEditorComponent())
		.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (throwable) {
					throwable = false;
					codes.removeAllItems();
					codes.addItem(cpt_query
							.get_code_taxon_nom(((JTextField) e
									.getSource()).getText()));
					codes.setSelectedIndex(0);
					throwable = true;
				}
			}
		});

		noms.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if (arg0.getStateChange() == ItemEvent.SELECTED && throwable) {
					throwable = false;
					codes.removeAllItems();
					codes.addItem(cpt_query.get_code_taxon_nom((String) arg0
							.getItem()));
					codes.setSelectedIndex(0);
					throwable = true;
				}
			}

		});

		noms.getEditor().getEditorComponent().addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent arg0) {
			}

			public void keyReleased(KeyEvent arg0) {
				String debut = ((JTextField) arg0.getSource()).getText();
				if (arg0.getKeyCode() != KeyEvent.VK_BACK_SPACE
						&& arg0.getKeyCode() != KeyEvent.VK_ENTER
						&& arg0.getKeyCode() != KeyEvent.VK_DOWN 
						&& arg0.getKeyCode() != KeyEvent.VK_UP
						&& debut.length() > 2) {

					// inactivation de la possibilit de modifs des champs noms et codes par java
					throwable = false; 

					((JTextField) codes.getEditor().getEditorComponent())
					.setText("");
					codes.removeAllItems();
					String[] noms = cpt_query.get_noms_taxon_like(debut);
					self.noms.removeAllItems();
					self.noms.addItem(debut);
					if (noms != null) {
						// boucle for pour tous les items s du champs noms
						for (String s : noms)
							self.noms.addItem(s);
						self.noms.hidePopup();
						self.noms.showPopup();
					}
					throwable = true;
				}
			}

			public void keyTyped(KeyEvent arg0) {
			}
		});

		// Ajout d'une ligne de relev suppl par touche entre 
		// 	sur le champ noms lorsque code et nom sont remplis
		noms.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyTyped(KeyEvent arg0) {
					}

					@Override
					public void keyPressed(KeyEvent e) {
						if ((e.getKeyCode() == KeyEvent.VK_ENTER) && !((JTextField) codes.getEditor().getEditorComponent())
								.getText().isEmpty()&& !((JTextField) noms.getEditor().getEditorComponent())
								.getText().isEmpty()) {

							int ligne = __table.addRow(
									(String) codes.getSelectedItem(), id_cpt, 
									cpt_ind.isSelected());

							if (cpt_cel.isSelected()) {
								if (ligne != 0) {
									__table.setValueAt("Cel.",
											__table.getRowCount() - 1, 4);
									float biovol = cpt_query.change_type(id_cpt, ligne,
											"Cel.", (String) __table.getValueAt(__table
													.getRowCount() - 1, 1), false);
									__table.setValueAt(biovol,
											__table.getRowCount() - 1, 9);
								}
							}
							noms.removeAllItems();
						}
					}

					@Override
					public void keyReleased(KeyEvent e) {
					}
				});


		((JTextField) codes.getEditor().getEditorComponent())
		.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (throwable) {
					throwable = false;
					((JTextField) e.getSource())
					.setText(((JTextField) e.getSource())
							.getText().trim().toUpperCase());
					noms.removeAllItems();
					noms.addItem(cpt_query
							.get_nom_taxon(((JTextField) e.getSource())
									.getText().trim()));
					noms.setSelectedIndex(0);
					throwable = true;
				}
			}
		});

		codes.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if (arg0.getStateChange() == ItemEvent.SELECTED && throwable) {
					throwable = false;
					noms.removeAllItems();
					noms.addItem(cpt_query.get_nom_taxon((String) arg0
							.getItem()));
					noms.setSelectedIndex(0);
					throwable = true;
				}
			}

		});

		codes.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {
					}

					public void keyReleased(KeyEvent arg0) {
						String debut = ((JTextField) arg0.getSource())
								.getText().trim();
						if (arg0.getKeyCode() != KeyEvent.VK_BACK_SPACE
								&& arg0.getKeyCode() != KeyEvent.VK_ENTER
								&& arg0.getKeyCode() != KeyEvent.VK_DOWN
								&& arg0.getKeyCode() != KeyEvent.VK_UP
								&& debut.length() > 1) {
							throwable = false;
							((JTextField) noms.getEditor().getEditorComponent())
							.setText("");
							noms.removeAllItems();
							String[] codes = cpt_query.get_codes_taxon(debut);
							self.codes.removeAllItems();
							self.codes.addItem(debut);
							if (codes != null) {
								for (String s : codes)
									self.codes.addItem(s);
								self.codes.hidePopup();
								self.codes.showPopup();
							}
							throwable = true;
						}
					}

					public void keyTyped(KeyEvent arg0) {
					}
				});


		// Ajout d'une ligne de relev suppl par touche entre sur le champ codes 
		//	lorsque code et nom sont remplis
		codes.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyTyped(KeyEvent arg0) {
					}

					@Override
					public void keyPressed(KeyEvent e) {
						if ((e.getKeyCode() == KeyEvent.VK_ENTER) && !((JTextField) codes.getEditor().getEditorComponent())
								.getText().isEmpty()&& !((JTextField) noms.getEditor().getEditorComponent())
								.getText().isEmpty()) {

							int ligne = __table.addRow(
									(String) codes.getSelectedItem(), id_cpt, 
									cpt_ind.isSelected());

							if (cpt_cel.isSelected()) {
								if (ligne != 0) {
									__table.setValueAt("Cel.",
											__table.getRowCount() - 1, 4);
									float biovol = cpt_query.change_type(id_cpt, ligne,
											"Cel.", (String) __table.getValueAt(__table
													.getRowCount() - 1, 1), false);
									__table.setValueAt(biovol,
											__table.getRowCount() - 1, 9);
								}
							}
							codes.removeAllItems();
						}
					}

					@Override
					public void keyReleased(KeyEvent e) {
					}
				});

		//checkbox comptage en cellule bloquant le comptage en ind en simultane
		cpt_cel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (cpt_ind.isSelected()) {
					cpt_cel.setSelected(true);;
					cpt_ind.setSelected(false);
				}			
			}
		});

		//checkbox comptage en individu bloquant le comptage en cel en simultane
		cpt_ind.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (cpt_cel.isSelected()) {
					cpt_ind.setSelected(true);;
					cpt_cel.setSelected(false);
				}			
			}
		});

		add.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (!((JTextField) codes.getEditor().getEditorComponent())
						.getText().isEmpty()
						&& !((JTextField) noms.getEditor().getEditorComponent())
						.getText().isEmpty()) {

					int ligne = __table.addRow(
							(String) codes.getSelectedItem(), id_cpt, 
							cpt_ind.isSelected());

					if (cpt_cel.isSelected()) {
						if (ligne != 0) {
							__table.setValueAt("Cel.",
									__table.getRowCount() - 1, 4);
							float biovol = cpt_query.change_type(id_cpt, ligne,
									"Cel.", (String) __table.getValueAt(__table
											.getRowCount() - 1, 1), false);
							__table.setValueAt(biovol,
									__table.getRowCount() - 1, 9);
						}
					}
				}
			}
		});

		open.addActionListener(new ActionListener() {
			@SuppressWarnings("static-access")
			public void actionPerformed(ActionEvent e) {
				id_cpt = new Ouvrir_Cpt(self, false, locale, db_link).get_cpt();
				//rcupration de la date du cpt et comparaison avec la date limite (aujourdhui-2j)
				if(id_cpt!=0){
					Date dateCpt = cpt_query.get_dateCpt(id_cpt);
					GregorianCalendar aujourdhui = new GregorianCalendar();
					aujourdhui.add(Calendar.DATE, -2);
					Date dateLimite = aujourdhui.getTime();

					if (dateCpt.compareTo(dateLimite)==-1) {
						if (new JOptionPane().showConfirmDialog(self,
								rb.getString("mssgConfirmOuvCptValid"),
								rb.getString("titreBoxConfirmOuvCptValid"), JOptionPane.YES_NO_OPTION,
								JOptionPane.WARNING_MESSAGE) == JOptionPane.YES_OPTION) {
							if (id_cpt != 0) {
								open.setEnabled(false);
								nb_chp.setEditable(true);
								nb_chp_plus.setEnabled(true);
								nb_chp_moins.setEnabled(true);
								nb_tot.setEditable(true);
								nb_tot_plus.setEnabled(true);
								nb_tot_moins.setEnabled(true);
								validation.setEnabled(false);
								modification.setEnabled(true);
								add.setEnabled(true);
								lieu.setEnabled(false);
								station.setEnabled(false);
								chambre.setEnabled(false);
								vol_sed.setEditable(false);
								dill.setEditable(false);
								oper.setEditable(false);
								date.setEditable(false);
								id_ech.setEditable(false);
								create.setEnabled(true);
								codes.setEditable(true);
								noms.setEditable(true);

								String[] data = cpt_query
										.get_all_up_for_open(id_cpt);
								throwable = false;
								lieu.removeAllItems();
								lieu.addItem(data[0]);
								station.removeAllItems();
								station.addItem(data[1]);
								milieu.setText(data[2]);
								date.setText(data[3]);
								id_ech.setText(data[4]);
								oper.setText(data[5]);
								vol_sed.setText(data[6]);
								dill.setText(data[7]);
								chambre.removeAllItems();
								chambre.addItem(data[8]);
								nb_chp.setText(data[9]);
								nb_tot.setText(data[10]);
								commentaire.setText(data[11]);
								__table.refresh(id_cpt);
								//affichage du nb total d'obj compts
								String nb_obj = (Integer.toString(__table.calculNbObjTot()));
								self.nb_obj_tot.setText(nb_obj);
								idLabel = rb.getString("infosCptNum") + id_cpt;

								cartouche_pane.setBorder(BorderFactory.createTitledBorder(BorderFactory
										.createEtchedBorder(EtchedBorder.LOWERED, new Color(0xa0, 0xca,
												0x56), new Color(0x3d, 0x61, 0x89)),
										idLabel, TitledBorder.CENTER,
										TitledBorder.CENTER));
							}
						} else
							self.id_cpt = 0;
					} 
					else {
						if (id_cpt != 0) {
							open.setEnabled(false);
							nb_chp.setEditable(true);
							nb_chp_plus.setEnabled(true);
							nb_chp_moins.setEnabled(true);
							nb_tot.setEditable(true);
							nb_tot_plus.setEnabled(true);
							nb_tot_moins.setEnabled(true);
							validation.setEnabled(false);
							modification.setEnabled(true);
							add.setEnabled(true);
							lieu.setEnabled(false);
							station.setEnabled(false);
							chambre.setEnabled(false);
							vol_sed.setEditable(false);
							dill.setEditable(false);
							oper.setEditable(false);
							date.setEditable(false);
							id_ech.setEditable(false);
							create.setEnabled(true);
							codes.setEditable(true);
							noms.setEditable(true);

							String[] data = cpt_query
									.get_all_up_for_open(id_cpt);
							throwable = false;
							lieu.removeAllItems();
							lieu.addItem(data[0]);
							station.removeAllItems();
							station.addItem(data[1]);
							milieu.setText(data[2]);
							date.setText(data[3]);
							id_ech.setText(data[4]);
							oper.setText(data[5]);
							vol_sed.setText(data[6]);
							dill.setText(data[7]);
							chambre.removeAllItems();
							chambre.addItem(data[8]);
							nb_chp.setText(data[9]);
							nb_tot.setText(data[10]);
							commentaire.setText(data[11]);
							__table.refresh(id_cpt);

							idLabel = rb.getString("infosCptNum") + id_cpt;

							cartouche_pane.setBorder(BorderFactory.createTitledBorder(BorderFactory
									.createEtchedBorder(EtchedBorder.LOWERED, new Color(0xa0, 0xca,
											0x56), new Color(0x3d, 0x61, 0x89)),
									idLabel, TitledBorder.CENTER,
									TitledBorder.CENTER));
						}
						else
							self.id_cpt = 0;
					}

				}
			}
		});

		//consultation d'un comptage
		consult_cpt.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						Consultation_Comptage consult = new Consultation_Comptage(locale, db_link);
						consult.open();
					}});

		//cration d'un nouveau taxon
		create.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String newcode = new Creer_Taxon(self, oper.getText().trim(), locale, db_link)
						.set_visible().get_code();

				if (newcode != null) {
					int ligne = __table.addRow(newcode, id_cpt, 
							cpt_ind.isSelected());

					if (ligne != 0)
						if (cpt_cel.isSelected()) {
							float biovol = cpt_query.change_type(id_cpt, ligne,
									"Cel.", newcode, false);
							__table.setValueAt("Cel.",
									__table.getRowCount() - 1, 4);
							__table.setValueAt(biovol,
									__table.getRowCount() - 1, 9);
						}
				}
			}
		});

		// ouverture de la fenetre nouveau calcul de biovolume
		newCalc.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				cbf = new Calcul_Biovolume_Frame(locale, db_link);				
			}
		});

		// ouverture de la fenetre d'un calcul de biovolume existant
		openCalc.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				oc = new Ouvrir_Calcul(null, false, false, locale, db_link);
				ocOuvert = true;
			}
		});

		// ouverture de la fenetre de la synthse pour une station
		synStation.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				new Synthese(locale, db_link);			
			}
		});

		// ouverture de la fenetre de la synthse pour un taxon
		synTaxon.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				new SyntheseTax(locale, db_link);				
			}
		});

		// ouverture de la fenetre de consultation de la liste taxinomique
		consultTax.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				new Consultation_Frame(locale, db_link);				
			}
		});

		// ouverture de la fenetre de recherche d'un taxon de la liste taxinomique
		recherchTax.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				new Recherche_Frame(locale, db_link);				
			}
		});

		// ouverture de la fenetre de consultation des taxons perso
		consultTaxP.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				new Consultation_Perso_Frame(locale, db_link);				
			}
		});

		//ouverture modification des chambres
		am_chambres.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Thread() {
							public void run() {
								new AM_Chambres_Frame(locale, db_link);
							}}.start();						
					}});

		//ouverture des site et stations
		am_sites.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Thread() {
							public void run() {
								new AM_Site_Frame(locale, db_link);
							}}.start();						
					}});
		// ouverture de la notice
		notice.addActionListener(new ActionListener() {

			@SuppressWarnings("static-access")
			@Override
			public void actionPerformed(ActionEvent arg0) {

				File pdf = new File(pathDocs + File.separator + "notice.pdf");
				if(!pdf.exists())
					pdf = new File(pathDocs + File.separator + "notice.pdf");

				if(Desktop.isDesktopSupported()) 
				{
					if(Desktop.getDesktop().isSupported(java.awt.Desktop.Action.OPEN))
					{
						try { java.awt.Desktop.getDesktop().open(pdf);} 
						catch (IOException ex) { ex.printStackTrace(); }
					} 
					else 
						new JOptionPane().showMessageDialog(self, rb.getString("mssgErrOuvNoticePDF"), 
								rb.getString("titreBoxErrOuvNoticePDF"), JOptionPane.ERROR_MESSAGE);
				}
				else
					new JOptionPane().showMessageDialog(self, rb.getString("mssgErrOuvNoticePDF"), 
							rb.getString("titreBoxErrOuvNoticePDF"), JOptionPane.ERROR_MESSAGE);
			}});

	}

	private void add_fields() {

		// pour la traduction de "nouveau comptage"
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		/* Ajout de la bannire */
		JPanel banniere_pane = new JPanel(new FlowLayout());
		((FlowLayout) banniere_pane.getLayout()).setAlignment(FlowLayout.LEFT);
		banniere_pane.setBackground(new Color(192, 197, 199));

		banniere_pane.add(banniere);

		cartouche_pane = new JPanel(new BorderLayout());
		JPanel north_pane = new JPanel(new FlowLayout());
		JPanel center_pane = new JPanel(new FlowLayout());
		JPanel south_pane = new JPanel();

		cartouche_pane.setBackground(new Color(192, 197, 199));
		north_pane.setBackground(new Color(192, 197, 199));
		center_pane.setBackground(new Color(192, 197, 199));
		south_pane.setBackground(new Color(192, 197, 199));
		((FlowLayout) south_pane.getLayout()).setAlignment(FlowLayout.LEADING);
		center_pane.setLayout(new BoxLayout(center_pane, BoxLayout.LINE_AXIS));


		/* Ajout du panneau nord */
		north_pane.add(labelSite);
		lieu = new JComboBox<String>(cpt_query.get_sites(""));
		lieu.setPreferredSize(new Dimension(250, 20));
		lieu.setEditable(true);

		if (((String) lieu.getItemAt(0)).compareTo("") != 0)
			lieu.insertItemAt("", 0);

		lieu.setSelectedIndex(0);
		lieu.addItem(rb.getString("nouveau"));
		north_pane.add(lieu);
		north_pane.add(labelStation);
		station.setPreferredSize(new Dimension(177, 20));
		north_pane.add(station);
		north_pane.add(labelMilieu);
		milieu.setPreferredSize(new Dimension(75, 20));
		milieu.setEditable(false);
		north_pane.add(milieu);
		north_pane.add(labelDatePrel);
		try {
			MaskFormatter formatDate = new MaskFormatter("####-##-##");
			date = new JFormattedTextField(formatDate);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		date.setPreferredSize(new Dimension(75, 20));
		date.setToolTipText("aaaa-mm-jj");

		north_pane.add(this.date);
		north_pane.add(labelRefEch);
		id_ech.setPreferredSize(new Dimension(75, 20));
		north_pane.add(this.id_ech);
		north_pane.add(labelTaxinomiste);
		oper.setPreferredSize(new Dimension(100, 20));
		north_pane.add(oper);

		/* Ajout du panneau central */
		center_pane.add(Box.createHorizontalStrut(5));
		center_pane.add(labelVolSed);
		center_pane.add(Box.createHorizontalStrut(5));
		vol_sed.setMaximumSize(new Dimension(50, 20));
		vol_sed.setPreferredSize(new Dimension(50, 20));
		center_pane.add(vol_sed);
		center_pane.add(Box.createHorizontalStrut(5));
		center_pane.add(labelFactDilu);
		center_pane.add(Box.createHorizontalStrut(5));
		dill.setText("1");
		dill.setMaximumSize(new Dimension(50, 20));
		dill.setPreferredSize(new Dimension(50, 20));
		center_pane.add(dill);
		center_pane.add(Box.createHorizontalStrut(5));
		center_pane.add(labelChambre);
		center_pane.add(Box.createHorizontalStrut(5));
		chambre = new JComboBox<String>(cpt_query.get_chambres());
		chambre.insertItemAt("", 0);
		chambre.setSelectedIndex(0);
		chambre.setMaximumSize(new Dimension(300, 20));
		chambre.setPreferredSize(new Dimension(300, 20));
		center_pane.add(chambre);
		center_pane.add(Box.createHorizontalGlue());
		center_pane.add(modification);
		center_pane.add(validation);

		/* Ajout du panneau sud */
		south_pane.add(labelNbChamps);
		nb_chp_moins.setEnabled(false);
		nb_chp_plus.setEnabled(false);
		south_pane.add(nb_chp_moins);
		south_pane.add(nb_chp_plus);
		nb_chp.setPreferredSize(new Dimension(50, 20));
		nb_chp.setEditable(false);
		nb_chp.setText("1");
		south_pane.add(nb_chp);
		south_pane.add(labelIndivTotal);
		nb_tot_moins.setEnabled(false);
		south_pane.add(nb_tot_moins);
		nb_tot_plus.setEnabled(false);
		south_pane.add(nb_tot_plus);
		nb_tot.setEditable(false);
		nb_tot.setText("0");
		nb_tot.setPreferredSize(new Dimension(50, 20));
		south_pane.add(nb_tot);
		south_pane.add(labelCommentaire);
		commentaire.setPreferredSize(new Dimension(555, 20));
		south_pane.add(commentaire);

		cartouche_pane.add(north_pane, BorderLayout.NORTH);
		cartouche_pane.add(center_pane, BorderLayout.CENTER);
		cartouche_pane.add(south_pane, BorderLayout.SOUTH);


		cartouche_pane.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEtchedBorder(EtchedBorder.LOWERED, new Color(0xa0, 0xca,
						0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("infosNouveauCpt"), TitledBorder.CENTER,
				TitledBorder.CENTER));

		__table = new Comptage_Table(this, locale, db_link);

		JPanel table_pane = new JPanel(new BorderLayout());
		JPanel add_pane = new JPanel();
		add_pane.setLayout(new BoxLayout(add_pane, BoxLayout.PAGE_AXIS));

		JPanel add_pane1 = new JPanel();
		add_pane1.setLayout(new BoxLayout(add_pane1, BoxLayout.LINE_AXIS));

		JPanel add_pane2 = new JPanel();
		add_pane2.setLayout(new BoxLayout(add_pane2, BoxLayout.LINE_AXIS));

		add_pane1.add(labelCode);
		add_pane1.add(Box.createHorizontalStrut(2));
		codes.setPreferredSize(new Dimension(75, 20));
		codes.setMaximumSize(new Dimension(75, 20));
		codes.setMinimumSize(new Dimension(75, 20));
		codes.setEditable(false);
		add_pane1.add(codes);
		add_pane1.add(Box.createHorizontalStrut(5));
		add_pane1.add(labelNom);
		noms.setPreferredSize(new Dimension(400, 20));
		noms.setMaximumSize(new Dimension(400, 20));
		noms.setMinimumSize(new Dimension(400, 20));
		noms.setEditable(false);
		add_pane1.add(Box.createHorizontalStrut(2));
		add_pane1.add(noms);
		add.setPreferredSize(new Dimension(80, 10));
		add.setEnabled(false);
		add_pane1.add(Box.createHorizontalStrut(5));
		add_pane1.add(add);
		cpt_cel.setBackground(new Color(192, 197, 199));
		add_pane1.add(Box.createHorizontalStrut(5));
		add_pane1.add(cpt_cel);
		cpt_ind.setBackground(new Color(192, 197, 199));

		add_pane1.setBackground(new Color(192, 197, 199));
		create.setPreferredSize(new Dimension(100, 10));
		create.setEnabled(false);
		add_pane1.add(Box.createHorizontalStrut(5));
		add_pane1.add(create);
		add_pane1.add(Box.createHorizontalStrut(240));
		add_pane.add(add_pane1);

		add_pane2.setBackground(new Color(192, 197, 199));
		add_pane2.add(Box.createHorizontalStrut(610));
		add_pane2.add(cpt_ind);
		add_pane2.add(Box.createHorizontalStrut(225));
		nb_obj_tot.setPreferredSize(new Dimension(73, 20));
		nb_obj_tot.setMaximumSize(new Dimension(73, 20));
		nb_obj_tot.setMinimumSize(new Dimension(73, 20));
		nb_obj_tot.setEditable(false);
		add_pane2.add(nb_obj_tot);
		add_pane2.add(labelObj);
		add_pane.add(add_pane2);

		add_pane.setBackground(new Color(192, 197, 199));
		table_pane.add(add_pane, BorderLayout.NORTH);

		JScrollPane __scrollPane = new JScrollPane(__table,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

		table_pane.setBackground(new Color(192, 197, 199));
		table_pane.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEtchedBorder(EtchedBorder.LOWERED, new Color(0xa0, 0xca,
						0x56), new Color(0x3d, 0x61, 0x89)), rb.getString("taxonsComptes"),
				TitledBorder.CENTER, TitledBorder.CENTER));

		table_pane.add(__scrollPane, BorderLayout.CENTER);

		this.getContentPane().setBackground(new Color(192, 197, 199));
		JPanel test = new JPanel(new BorderLayout());
		test.add(banniere_pane, BorderLayout.NORTH);
		test.add(cartouche_pane, BorderLayout.SOUTH);

		this.getContentPane().add(test, BorderLayout.NORTH);
		this.getContentPane().add(table_pane, BorderLayout.CENTER);
	}

	private void draw_frame() {
		this.setLocation(100, 50);
		this.pack();
		this.setVisible(true);
		opti_width = this.getWidth();
	}

	public void translate(Locale locale){

		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		// nom de la fentre
		this.setTitle(rb.getString("titreFenSaisieComptages"));

		menu.setText(rb.getString("menu"));
		taxons.setText(rb.getString("taxon"));
		iplac.setText(rb.getString("calculIPLAC"));

		menu_fichier.setText(rb.getString("fichier"));
		open.setText(rb.getString("ouvrirModif"));
		consult_cpt.setText(rb.getString("consultComptage"));
		exportPDF.setText(rb.getString("exportPDF"));
		save_close.setText(rb.getString("sauveEtQuit"));
		no_save_close.setText(rb.getString("quitterSansMAJ"));
		menu_calcul.setText(rb.getString("calculDeBioVol"));
		newCalc.setText(rb.getString("nouveauCalcul"));
		openCalc.setText(rb.getString("ouvrirCalcul"));
		menu_synthese.setText(rb.getString("syntheses"));
		synTaxon.setText(rb.getString("syntheseTaxon"));
		synStation.setText(rb.getString("syntheseStation"));
		consultTax.setText(rb.getString("taxonsValides"));
		recherchTax.setText(rb.getString("rechercheTaxon"));
		consultTaxP.setText(rb.getString("taxonsPersonnels"));
		menu_config.setText(rb.getString("configuration"));
		am_chambres.setText(rb.getString("chambre"));
		am_sites.setText(rb.getString("site"));
		notice.setText(rb.getString("notice"));

		banniere.setText(rb.getString("titreComptage"));



		labelSite.setText(rb.getString("champSite"));
		labelStation.setText(rb.getString("champStation"));
		labelMilieu.setText(rb.getString("champMilieu"));
		labelDatePrel.setText(rb.getString("champDatePrel"));
		labelRefEch.setText(rb.getString("champRefEch"));
		labelTaxinomiste.setText(rb.getString("champTaxinomiste"));
		labelVolSed.setText(rb.getString("champVolSed"));
		labelFactDilu.setText(rb.getString("champFactDilu"));
		labelChambre.setText(rb.getString("champChambre"));

		validation.setText(rb.getString("validerInfos"));
		modification.setText(rb.getString("modifierInfos"));

		labelNbChamps.setText(rb.getString("champNbChamps"));
		labelIndivTotal.setText(rb.getString("champNbIndivTotal"));
		labelCommentaire.setText(rb.getString("champCommentaire"));


		labelCode.setText(rb.getString("champCode"));
		labelNom.setText(rb.getString("champNom"));

		add.setText(rb.getString("ajouter"));
		cpt_cel.setText(rb.getString("comptageEnCell"));
		cpt_ind.setText(rb.getString("comptageEnInd"));
		create.setText(rb.getString("creerTaxon"));
		labelObj.setText(rb.getString("objTot"));

		//ragencement de la position des items de la fentre
		this.pack();
	}


}
