package Comptage;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.AbstractCellEditor;
import javax.swing.DefaultCellEditor;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;

public class Comptage_Table extends JTable
{
	private static final long serialVersionUID = 1L;
	private Comptage_Query cpt_query;
	private Comptage_Table self = null;
	private int id_cpt;
	private Locale locale;
	@SuppressWarnings("unused")
	private String db_link;

	@SuppressWarnings("serial")
	public Comptage_Table(final Comptage_Frame parent, final Locale locale, String db_link)
	{
		self = this;
		this.locale = locale;
		this.db_link = db_link;
		final String db_link_f = db_link;

		cpt_query = new Comptage_Query(db_link);

		Object[][] default_row = {};

		// traduction des colonnes de la table
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		String[] __columns = { "#", rb.getString("colCodeTaxon"), 
				"-", "+", 
				rb.getString("colTypeObj1"), rb.getString("colCf"), 
				rb.getString("colNomTaxon"), rb.getString("colAuteur"), 
				rb.getString("colCodeRef"), rb.getString("colBiovolParObj"), 
				rb.getString("colNbMoyCell_ind"),
				rb.getString("colNbCompte"), rb.getString("colVp"),"" };



		DefaultTableModel model = new DefaultTableModel(default_row, __columns) { 
			private boolean editable = true;
			@SuppressWarnings("static-access")
			public void setValueAt(Object aValue, int row, int column){
				// si la colonne est celle du nombre moyen de cellules/individu
				if(column == 10 && self.isColumnSelected(10) && editable){
					super.setValueAt(aValue, row, column);
					cpt_query.change_nb_moy_cell_ind(id_cpt, (Integer)self.getValueAt(row, 0), 
							(Integer)aValue);
				}

				// si la colonne est celle du nombre compt
				if( column == 11){
					super.setValueAt(aValue, row, column);
					cpt_query.change_nb_cpt(id_cpt, (Integer)self.getValueAt(row, 0), (Integer)aValue);	
					//met  jour le nbre total d'objets compts
					String nb_obj = (Integer.toString(self.calculNbObjTot()));
					Comptage_Frame.nb_obj_tot.setText(nb_obj);
				}
				else{
					// si la colonne est celle du biovolume
					if( column == 9 && self.isColumnSelected(9) && editable){
						if( cpt_query.already_created((String)self.getValueAt(row, 1)) )
							new JOptionPane().showMessageDialog(null, 
									rb.getString("mssgTaxonDejaCree"), 
									rb.getString("titreBoxTaxonDejaCree"),
									JOptionPane.ERROR_MESSAGE);
						else{
							if( new JOptionPane().showConfirmDialog(null, 
									rb.getString("mssgBiovolModifie"), 
									rb.getString("titreBoxBiovolModifie"),
									JOptionPane.YES_NO_OPTION, 
									JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION ){

								String newcode = new Creer_Taxon(null, parent.oper.getText().trim(), 
										locale, db_link_f).pre_remplir((String)self.getValueAt(row, 1),
												(String)self.getValueAt(row, 6),(String)self.getValueAt(row, 4),
												(String)self.getValueAt(row, 7), 
												((Float)aValue).toString()).set_visible().get_code();
								if( newcode != null ){
									editable = false;
									self.setValueAt(aValue, row, column);
									self.setValueAt(true, row, 12);
									cpt_query.change_isUser(true, id_cpt, (Integer)self.getValueAt(row, 0));
									editable = true;
								}
							}
						}
					}
					else{
						// si la colonne est celle des valeurs personnelles
						if( column == 12 ){	
							if( ! ((String)self.getValueAt(row, 1)).matches("NEW\\d{3}") ){
								if( cpt_query.already_created((String)self.getValueAt(row, 1)) ){
									super.setValueAt(aValue, row, column);
									String biovol = cpt_query.get_biovol((String)self.getValueAt(row, 1), 
											(String)self.getValueAt(row, 4), (Boolean)aValue);
									self.setValueAt(Float.parseFloat(biovol), row, 9);
									cpt_query.change_isUser((Boolean)aValue, id_cpt, (Integer)self.getValueAt(row, 0));
								}
								else{
									if( new JOptionPane().showConfirmDialog(null, rb.getString("mssgPasDeValeurPerso"), 
											rb.getString("titreBoxPasDeValeurPerso"), JOptionPane.YES_NO_OPTION,
											JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION ){
										String biovol = new Creer_Taxon(null, parent.oper.getText().trim(), 
												locale, db_link_f).pre_remplir(
														(String)self.getValueAt(row, 1), (String)self.getValueAt(row, 6),
														(String)self.getValueAt(row, 4), (String)self.getValueAt(row, 7),
														((Float)self.getValueAt(row, 9)).toString()).set_visible().get_code();
										if( biovol != null ){
											self.setValueAt(true, row, 12);
											cpt_query.change_isUser(true, id_cpt, (Integer)self.getValueAt(row, 0));
										}
									}
								}
							}
							else{
								new JOptionPane().showMessageDialog(null, 
										rb.getString("mssgTaxonDejaCree"),
										rb.getString("titreBoxTaxonDejaCree"), 
										JOptionPane.ERROR_MESSAGE);
							}	
						}
						else
							super.setValueAt(aValue, row, column);
					}
				}
			}};


			// permet de masquer les cases o le nb moy cell/ind est invalide (<=0)
			// 	et les cases o le biovolume vaut 0
			TableCellRenderer doubleRenderer = new DefaultTableCellRenderer() {		
				@Override
				public Component getTableCellRendererComponent(JTable table,
						Object value, boolean isSelected, boolean hasFocus,
						int row, int column) {
					if( value instanceof Integer){
						// les cases de la colonne o nb moy cell/ind est invalide sont masques
						if((Integer)value <= 0 && column == 10){
							return super.getTableCellRendererComponent(table, "",
									isSelected, hasFocus, row, column);
						}

					}
					if(value instanceof Float){
						// les cases de la colonne biovolume valant 0 ne sont pas affiches :
						if ((Float)value == 0.0f && column == 9){
							return super.getTableCellRendererComponent(table, "", 
									isSelected, hasFocus, row, column);
						}
					}


					// alignement  droite
					this.setHorizontalAlignment(SwingConstants.RIGHT);

					return super.getTableCellRendererComponent(table, value,
							isSelected, hasFocus, row, column);
				}
			};

			this.setModel(model);

			new ButtonColumn(this, 2);
			new ButtonColumn(this, 3);
			new ButtonColumn(this, 13);   

			this.getTableHeader().setReorderingAllowed(false);
			this.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			//TODO pb du tri des colonnes
			this.setAutoCreateRowSorter(true);

			this.getTableHeader().setResizingAllowed(false);

			this.getColumnModel().getColumn(10).setCellRenderer(doubleRenderer);
			this.getColumnModel().getColumn(9).setCellRenderer(doubleRenderer);


			// ajustement de la taille des colonnes
			this.getColumnModel().getColumn(0).setPreferredWidth(30);
			this.getColumnModel().getColumn(1).setPreferredWidth(75);
			this.getColumnModel().getColumn(2).setPreferredWidth(55);
			this.getColumnModel().getColumn(3).setPreferredWidth(55);
			this.getColumnModel().getColumn(4).setPreferredWidth(40);
			this.getColumnModel().getColumn(5).setPreferredWidth(30);
			this.getColumnModel().getColumn(6).setPreferredWidth(260);
			this.getColumnModel().getColumn(7).setPreferredWidth(220);
			this.getColumnModel().getColumn(8).setPreferredWidth(75);
			this.getColumnModel().getColumn(9).setPreferredWidth(85);
			this.getColumnModel().getColumn(10).setPreferredWidth(70);
			this.getColumnModel().getColumn(11).setPreferredWidth(70);
			this.getColumnModel().getColumn(12).setPreferredWidth(20);
			this.getColumnModel().getColumn(13).setPreferredWidth(20);

			// ajustement de la hauteur de l'entte de la table
			int hauteur_entete = 35;
			this.getTableHeader().setPreferredSize(new Dimension(this.getTableHeader().getWidth(), hauteur_entete));

			this.setRowHeight(this.getRowHeight() + 5);

			// ajout des choix de types d'individu
			JComboBox<String> type = new JComboBox<String>(new String[]{"Cel.", "Fil.", "Col."});
			// modification du biovol en fonction du type slectionn
			type.addItemListener(new ItemListener() {

				public void itemStateChanged(ItemEvent arg0) {	
					if( arg0.getStateChange() == ItemEvent.SELECTED && self.getSelectedRow() != -1){

						self.changeSelection(self.getSelectedRow(),6, false, false);

						float biovol = cpt_query.change_type(id_cpt, (Integer)self.getValueAt(self.getSelectedRow(), 0),
								(String)arg0.getItem(), (String)self.getValueAt(self.getSelectedRow(), 1),
								(Boolean)self.getValueAt(self.getSelectedRow(), 12)  );
						self.setValueAt(biovol, self.getSelectedRow(), 9);
						self.clearSelection();
					}
				}});



			this.getColumnModel().getColumn(4).setCellEditor(new DefaultCellEditor(type));

			JComboBox<String> cf = new JComboBox<String>(new String[]{"", "Cf."});
			cf.addItemListener(new ItemListener() {
						public void itemStateChanged(ItemEvent arg0) {	
							if( arg0.getStateChange() == ItemEvent.SELECTED && self.getSelectedRow() != -1){
								boolean cf = ((((String)arg0.getItem()).compareTo("Cf.") == 0) ? true : false);
								cpt_query.change_cf(id_cpt, (Integer)self.getValueAt(self.getSelectedRow(), 0), cf);
							}
						}});
			this.getColumnModel().getColumn(5).setCellEditor(new DefaultCellEditor(cf));	
			this.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			this.getSelectionModel().setSelectionInterval(0, 0);
	}

	/**
	 * Rafraichit la table avec les donnes d'un comptage
	 * @param id_cpt id du comptage  afficher
	 */
	public void refresh(int id_cpt)
	{
		this.id_cpt = id_cpt;
		for( int i = this.getRowCount() - 1; i > -1; i-- )
			((DefaultTableModel)this.getModel()).removeRow(i);
		Object[][] d = cpt_query.get_all_taxon(id_cpt);

		for( Object[] data : d){
			Object[] row = { data[0], data[1], "-", "+", data[2], data[3], data[4],
					data[5], data[6], data[7], data[8], data[9], data[10], 
					new ImageIcon(getClass().getClassLoader().getResource("images/close.png"))};

			((DefaultTableModel)this.getModel()).addRow(row);
		}
		((DefaultTableModel)this.getModel()).fireTableDataChanged();
	}

	/**
	 * Ajoute une ligne dans la table et dans la base de donnes
	 * @param code code du taxon  ajouter
	 * @param id_cpt id du comptage auquel ajouter
	 */
	@SuppressWarnings("static-access")
	public int addRow(String code, int id_cpt, boolean cptInInd){
		// traduction de botes de dialogue
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		this.id_cpt = id_cpt;
		int n_l = 0; 
		boolean exists = false;

		for( int i = 0; i < this.getRowCount(); i++ ){
			if( ((String)this.getValueAt(i, 1)).compareTo(code.toUpperCase()) == 0)
				exists = true;
		}

		if( ! exists ){
			if( this.getRowCount() == 0 )
				n_l = 1;
			else
				n_l = (Integer)this.getValueAt(this.getRowCount() - 1 , 0) + 1;

			Integer nbMoyCell_Ind = null;

			// si la case comptage en individu a t coche :
			if (cptInInd){
				// on regarde le type de l'individu pour savoir si on met 1 au nombre moyen de cell/ind
				String typeIndDef = cpt_query.get_indiv_def(code);

				// Si le type d'individu par dfaut est cellule
				if (typeIndDef.equals("Cel.")){
					nbMoyCell_Ind = 1;					
				}
			}

			Object[] row = { n_l, code, "-", "+", cpt_query.get_indiv_def(code), "", 
					cpt_query.get_nom_taxon(code),
					cpt_query.get_auteur(code), cpt_query.get_actuel(code), 
					Float.parseFloat(cpt_query.get_biovol(code, "", false)), 
					nbMoyCell_Ind, 0, false, 
					new ImageIcon(getClass().getClassLoader().getResource("images/close.png")) 	};

			((DefaultTableModel)this.getModel()).addRow(row);
			((DefaultTableModel)this.getModel()).fireTableDataChanged();

			cpt_query.add_line(id_cpt, (Integer)this.getValueAt(this.getRowCount()-1, 0), code, 
					(String)this.getValueAt(this.getRowCount()-1, 4));

			// si on connait le nombre moyen de cellules par individus
			if(nbMoyCell_Ind != null){
				// criture dans la BD du nb moy cell/ind si l'individu est de type cell
				cpt_query.change_nb_moy_cell_ind(id_cpt, n_l, nbMoyCell_Ind);	
			}


		}
		else
			new JOptionPane().showMessageDialog(null, rb.getString("mssgTaxonDejaDansListe"), 
					rb.getString("titreBoxTaxonDejaDansListe"), 
					JOptionPane.ERROR_MESSAGE);


		return n_l;
	}

	/**
	 * Fait la somme des nb d'objet compts
	 */
	public int calculNbObjTot(){

		int tmp_nb;
		int nb_obj_tot=0;
		for (int i = 0; i < self.getRowCount(); i++){
			if ( ((int)getValueAt(i,11))!= 0 ){
				tmp_nb = ((int)getValueAt(i,11));
				nb_obj_tot = nb_obj_tot + tmp_nb;
			}
		}
		return  nb_obj_tot;
	}


	public boolean isCellEditable(int row, int col){
		if( col == 1 || col == 6 || col == 7 || col == 8 )
			return false;
		return true;
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public Class getColumnClass(int column){
		if (column == 10)
			return java.lang.Integer.class;
		else 
			return getValueAt(0, column).getClass();
	}

	class ButtonColumn extends AbstractCellEditor implements TableCellRenderer, 
	TableCellEditor, ActionListener {

		private static final long serialVersionUID = 1L;
		JTable table;
		JButton renderButton;
		JButton editButton;
		String text;

		public ButtonColumn(JTable table, int column){
			super();
			this.table = table;
			renderButton = new JButton();

			editButton = new JButton();
			editButton.setFocusPainted( false );
			editButton.addActionListener( this );

			TableColumnModel columnModel = table.getColumnModel();
			columnModel.getColumn(column).setCellRenderer( this );
			columnModel.getColumn(column).setCellEditor( this );
		}

		public Component getTableCellRendererComponent(
				JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column){
			if (hasFocus){
				renderButton.setForeground(table.getForeground());
				renderButton.setBackground(UIManager.getColor("Button.background"));
			}
			else if (isSelected){
				renderButton.setForeground(table.getSelectionForeground());
				renderButton.setBackground(table.getSelectionBackground());
			}
			else{
				renderButton.setForeground(table.getForeground());
				renderButton.setBackground(UIManager.getColor("Button.background"));
			}

			if( value instanceof ImageIcon )
				renderButton.setIcon((ImageIcon) value);
			else
				renderButton.setText( (value == null) ? "" : value.toString() );

			return renderButton;
		}

		public Component getTableCellEditorComponent(
				final JTable table, Object value, boolean isSelected, final int row, int column){
			if( value instanceof ImageIcon )
				editButton.setIcon((ImageIcon)value);
			else{
				text = (value == null) ? "" : value.toString();
				editButton.setText( text );	
			}

			return editButton;
		}

		public void actionPerformed(ActionEvent e){
			if( text == null || text.isEmpty()){
				this.stopCellEditing();
				cpt_query.remove_row(id_cpt, (Integer)table.getValueAt(table.getSelectedRow(), 0));
				((DefaultTableModel)table.getModel()).removeRow(table.getSelectedRow());
				// met  jour le champ nb total d'objets compts
				String nb_obj = (Integer.toString(self.calculNbObjTot()));
				Comptage_Frame.nb_obj_tot.setText(nb_obj);
			}

			else{
				// les clics sur les boutons + et - agissent sur la colonne 11 : nombre d'objets compts
				if( text.compareTo("+") == 0 ){
					int nb = (Integer)table.getValueAt(table.getSelectedRow(), 11) + 1;
					table.setValueAt(nb, table.getSelectedRow(), 11);
					// met  jour le champ nb total d'objets compts
					String nb_obj = (Integer.toString(self.calculNbObjTot()));
					Comptage_Frame.nb_obj_tot.setText(nb_obj);
				}

				else 
					if( text.compareTo("-") == 0 )
						if( ((Integer)table.getValueAt(table.getSelectedRow(), 11)) != 0  ){
							int nb = (Integer)table.getValueAt(table.getSelectedRow(), 11) - 1;
							table.setValueAt(nb, table.getSelectedRow(), 11);
							// met  jour le champ nb total d'objets compts
							String nb_obj = (Integer.toString(self.calculNbObjTot()));
							Comptage_Frame.nb_obj_tot.setText(nb_obj);
						}
			}
		}

		public Object getCellEditorValue(){
			return text;
		}
	}
}