package Comptage;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.util.Date;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableModel;

import com.itextpdf.text.BaseColor;
import com.itextpdf.text.Chunk;
import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.Font;
import com.itextpdf.text.Header;
import com.itextpdf.text.Image;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfWriter;

public class Consultation_Comptage extends JFrame {

	private static final long serialVersionUID = 1L;
	private Locale locale;
	private String db_link;
	private Consultation_Comptage self = null;

	JMenuBar menubar = new JMenuBar();
	JMenu menu_fichier = new JMenu();
	private JMenuItem open = new JMenuItem();
	private JMenuItem exportPDF = new JMenuItem();
	private JMenuItem save_close = new JMenuItem();


	private JLabel labelSite = new JLabel();
	private JLabel labelStation = new JLabel();
	private JLabel labelMilieu = new JLabel();
	private JLabel labelDatePrel = new JLabel();
	private JLabel labelRefEch = new JLabel();
	private JLabel labelTaxinomiste = new JLabel();
	private JLabel labelVolSed = new JLabel();
	private JLabel labelFactDilu = new JLabel();
	private JLabel labelChambre = new JLabel();
	private JLabel labelNbChamps = new JLabel();
	private JLabel labelNbIndTotal = new JLabel();
	private JLabel labelCommentaire = new JLabel();

	private JLabel labelChoixNivTaxinomique= new JLabel();

	private JTextField date = new JTextField();
	private JTextField id_ech = new JTextField();
	private JTextField lieu = new JTextField();
	private JTextField station = new JTextField();
	private JTextField oper = new JTextField();
	private JTextField chambre = new JTextField();
	private JTextField milieu = new JTextField();
	private JTextField vol_sed = new JTextField();
	private JTextField dilu = new JTextField();
	private JTextField nb_chp = new JTextField();
	private JTextField nb_tot = new JTextField();
	private String idLabel;
	private Consultation_Table __table = null;

	private JComboBox<String> taxi_lvl;

	private Comptage_Query cpt_query;
	private int id_cpt = 0;
	private JTextField commentaire = new JTextField();
	private JPanel cartouche_pane = null;
	private int opti_width;

	public Consultation_Comptage(Locale locale, String db_link)
	{
		super();
		self = this;
		this.locale = locale;
		this.db_link = db_link;

		cpt_query = new Comptage_Query(db_link);

		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		this.translate(locale);
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		taxi_lvl = new JComboBox<String>( new String[]{ "", rb.getString("colRegne"), 
				rb.getString("colSousRegne"), rb.getString("colEmbranchement"),
				rb.getString("colClasse"), rb.getString("colOrdre"), 
				rb.getString("colSousOrdre"), rb.getString("colFamille")} );


		this.getContentPane().setLayout(new BorderLayout());

		add_menu();
		add_handlers();
		add_fields();
		draw_frame();

		self.setMinimumSize(new Dimension( opti_width, 400));
	}

	private void refresh_table()
	{		

		for( int i = __table.getRowCount() - 1; i > -1; i-- )
			((DefaultTableModel)__table.getModel()).removeRow(i);

		// rcupration du fichier de ressources
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		// rcupration du niveau taxinomique choisi
		String lvl = (String)taxi_lvl.getSelectedItem();

		// conversion en franais de ce niveau taxinomique
		if (lvl.equals(rb.getString("colRegne")) )
			lvl = "Rgne";
		else if (lvl.equals(rb.getString("colSousRegne")) )
			lvl = "Sous rgne";
		else if (lvl.equals(rb.getString("colEmbranchement")) )
			lvl = "Embranchement";
		else if (lvl.equals(rb.getString("colClasse")))
			lvl = "Classe";
		else if (lvl.equals(rb.getString("colOrdre")))
			lvl = "Ordre";
		else if (lvl.equals(rb.getString("colSousOrdre")))
			lvl = "Sous ordre";
		else if (lvl.equals(rb.getString("colFamille")))
			lvl = "Famille";

		// appel de la fonction de requte avec le mot franais
		Object[][] d = cpt_query.get_all_for_consult(id_cpt, lvl);

		for( Object[] data : d)
		{
			Object[] row = { data[0], data[1], data[2], data[3], "<html><i>" + (String)data[4] + "</i></html>",
					data[5], data[6], data[7], data[8], data[9], data[10] };

			((DefaultTableModel)__table.getModel()).addRow(row);
		}

		if(d.length > 0)
			((DefaultTableModel)__table.getModel()).fireTableDataChanged();
	}

	private void refresh_taxi( String lvl )
	{
		if( lvl.isEmpty() ) 
		{
			for( int i = 0; i < __table.getRowCount(); i++ )
				__table.setValueAt("", i, 7);	
		}
		else
		{

			ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

			// traduction des niveaux taxinomiques pour la requte
			// Les requtes sont faites en fonction du  mot franais...
			if (lvl.equals(rb.getString("colRegne")) )
				lvl = "Rgne";
			else if (lvl.equals(rb.getString("colSousRegne")) )
				lvl = "Sous rgne";
			else if (lvl.equals(rb.getString("colEmbranchement")) )
				lvl = "Embranchement";
			else if (lvl.equals(rb.getString("colClasse")))
				lvl = "Classe";
			else if (lvl.equals(rb.getString("colOrdre")))
				lvl = "Ordre";
			else if (lvl.equals(rb.getString("colSousOrdre")))
				lvl = "Sous ordre";
			else if (lvl.equals(rb.getString("colFamille")))
				lvl = "Famille";


			String[] data = cpt_query.refresh_taxinomie(id_cpt, lvl);
			for( int i = 0; i < data.length; i++ )
				__table.setValueAt(data[i], __table.convertRowIndexToView(i), 7);
		}
	}

	void setId(int new_id){
		id_cpt = new_id;
		if( id_cpt != 0 )
		{
			String[] data = cpt_query.get_all_up_for_open(id_cpt);
			lieu.setText(data[0]);
			station.setText(data[1]);
			milieu.setText(data[2]);
			date.setText(data[3]);
			id_ech.setText(data[4]);
			oper.setText(data[5]);
			vol_sed.setText(data[6]);
			dilu.setText(data[7]);
			chambre.setText(data[8]);
			nb_chp.setText(data[9]);
			nb_tot.setText(data[10]);
			commentaire.setText(data[11]);

			refresh_table();
		}
	}

	private void add_menu()
	{
		this.addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent evt)
			{
				self.setSize(self.opti_width, self.getHeight());
			}});

		taxi_lvl.addItemListener(
				new ItemListener() {
					public void itemStateChanged(ItemEvent arg0) {
						if( arg0.getStateChange() == ItemEvent.SELECTED )
							refresh_taxi((String)arg0.getItem());
					}});

		open.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						open();
					}});

		save_close.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						self.dispose();
					}});

		menu_fichier.add(open);
		menu_fichier.add(exportPDF);
		menu_fichier.add(save_close);

		menubar.add(menu_fichier);
		this.setJMenuBar(menubar);
	}

	public void open(){
		id_cpt = new Ouvrir_Cpt(self, false, locale, db_link).get_cpt();
		if( id_cpt != 0 )
		{
			String[] data = cpt_query.get_all_up_for_open(id_cpt);
			lieu.setText(data[0]);
			station.setText(data[1]);
			milieu.setText(data[2]);
			date.setText(data[3]);
			id_ech.setText(data[4]);
			oper.setText(data[5]);
			vol_sed.setText(data[6]);
			dilu.setText(data[7]);
			chambre.setText(data[8]);
			nb_chp.setText(data[9]);
			nb_tot.setText(data[10]);
			commentaire.setText(data[11]);


			// pour la traduction de "informations sur le comptage n..."
			ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
			idLabel = rb.getString("infosCptNum")+id_cpt;

			cartouche_pane.setBorder(BorderFactory.createTitledBorder(
					BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
							new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
					idLabel, TitledBorder.CENTER, TitledBorder.CENTER));

			refresh_table();
		}
	}

	private void add_handlers() {

		// pour les traductions boites de dialogues entre autres
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		// export PDF du comptage avec les rsultats
		exportPDF.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				// si un comptage est ouvert
				if(id_cpt != 0){
					// choix du rpertoire
					JFileChooser fc = new JFileChooser();
					fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					fc.setMultiSelectionEnabled(false);

					File f = null;
					if( fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION ){
						f = new File(fc.getSelectedFile().getAbsolutePath() 
								+ File.separator + rb.getString("resultComptage") + id_cpt + ".pdf");
					}

					// alerte si fichier pdf dj ouvert
					boolean accesLibre = false;					
					Document document = new Document(PageSize.A4);

					try{
						PdfWriter.getInstance(document, new FileOutputStream(f));
						accesLibre = true;
					} catch (FileNotFoundException notF) {
						accesLibre = false;
						new JOptionPane();
						JOptionPane.showMessageDialog(self, 
								rb.getString("mssgPdfOuvert"),
								rb.getString("titreBoxPdfOuvert"), JOptionPane.WARNING_MESSAGE);
					} catch (DocumentException e1) {
						e1.printStackTrace();
					};

					if(accesLibre){

						// export pdf
						try{
							PdfWriter.getInstance(document, new FileOutputStream(f));
							// ouverture du fichier pdf
							document.open();
							// creation des polices du fichier
							Font bigFont = new Font(Font.FontFamily.HELVETICA, 20, Font.BOLD, BaseColor.BLUE);
							Font mediumFont = new Font(Font.FontFamily.HELVETICA, 14, Font.BOLD, BaseColor.BLACK);
							Font normalBoldFont = new Font(Font.FontFamily.HELVETICA, 9, Font.BOLD, BaseColor.BLACK);
							Font normalFont = new Font(Font.FontFamily.HELVETICA, 9, Font.NORMAL, BaseColor.BLACK);
							Font tinyFont = new Font(Font.FontFamily.HELVETICA, 7, Font.NORMAL, BaseColor.BLACK);
							Font tinyItalicFont = new Font(Font.FontFamily.HELVETICA, 7, Font.ITALIC, BaseColor.BLACK);
							Font tiny2Font = new Font(Font.FontFamily.HELVETICA, 5, Font.NORMAL, BaseColor.BLACK);

							// entte
							Paragraph entete = new Paragraph(lieu.getText() + " - " + station.getText() + " - " + 
									date.getText());
							entete.setAlignment(Header.ALIGN_RIGHT);
							document.add(entete);

							// logo IRSTEA : images/Logo_Irstea_red.png
							Image imgLogo = Image.getInstance(getClass().getClassLoader().getResource("images/logo_irstea.jpg"));
							imgLogo.setAlignment(Element.ALIGN_LEFT);
							imgLogo.scaleAbsolute(100f, 100f);
							imgLogo.setSpacingAfter(-20f);
							document.add(imgLogo);

							// titre de la fiche
							Paragraph title  = new Paragraph(rb.getString("titreFicheResultPDFCpt") + id_cpt + "\n\n", bigFont);
							title.setAlignment(Element.ALIGN_CENTER);
							document.add(title);

							Paragraph titreDG = new Paragraph(rb.getString("donnesGenerales"), mediumFont);
							titreDG.setAlignment(Element.ALIGN_LEFT);
							document.add(titreDG);
							// ajout d'un petit saut de ligne avant le tableau
							Paragraph petitSautDeLigne = new Paragraph("\n", tiny2Font);
							document.add(petitSautDeLigne);

							// tableau contenant le tableau des donnes gnrales
							PdfPTable tableauDG = new PdfPTable(4);
							tableauDG.setWidthPercentage(100);
							//choix de la largeur de chaque colonne
							tableauDG.setWidths(new float[]{22f, 28f, 20f, 28f});

							// ajout du site dans le tableau
							PdfPCell champSite = new PdfPCell(new Paragraph(rb.getString("champSite"), normalBoldFont));
							tableauDG.addCell(champSite);
							PdfPCell valeurSite = new PdfPCell(new Paragraph((String) lieu.getText(), normalFont));
							tableauDG.addCell(valeurSite);

							// ajout de la station dans le tableau
							PdfPCell champStation = new PdfPCell(new Paragraph(rb.getString("champStation"), normalBoldFont));
							tableauDG.addCell(champStation);
							PdfPCell valeurStation = new PdfPCell(new Paragraph((String) station.getText(), normalFont));
							tableauDG.addCell(valeurStation);

							// ajout du milieu dans le tableau
							PdfPCell champMilieu = new PdfPCell(new Paragraph(rb.getString("champMilieu"), normalBoldFont));
							tableauDG.addCell(champMilieu);
							PdfPCell valeurMilieu = new PdfPCell(new Paragraph(milieu.getText(), normalFont));
							tableauDG.addCell(valeurMilieu);


							// ajout de la date de prlevement dans le tableau
							PdfPCell champDatePrel = new PdfPCell(new Paragraph(rb.getString("champDatePrel"), normalBoldFont));
							tableauDG.addCell(champDatePrel);
							PdfPCell valeurDatePrel = new PdfPCell(new Paragraph(date.getText(), normalFont));
							tableauDG.addCell(valeurDatePrel);

							// ajout de la rfrence de l'chantillon dans le tableau
							PdfPCell champRefEch = new PdfPCell(new Paragraph(rb.getString("champRefEch"), normalBoldFont));
							tableauDG.addCell(champRefEch);
							PdfPCell valeurRefEch = new PdfPCell(new Paragraph(id_ech.getText(), normalFont));
							tableauDG.addCell(valeurRefEch);

							// ajout du taxinomiste dans le tableau
							PdfPCell champTaxi = new PdfPCell(new Paragraph(rb.getString("champTaxinomiste"), normalBoldFont));
							tableauDG.addCell(champTaxi);
							PdfPCell valeurTaxi = new PdfPCell(new Paragraph(oper.getText(), normalFont));
							tableauDG.addCell(valeurTaxi);

							// ajout du volume sdiment dans le tableau
							PdfPCell champVolSed = new PdfPCell(new Paragraph(rb.getString("champVolSed"), normalBoldFont));
							tableauDG.addCell(champVolSed);
							PdfPCell valeurVolSed = new PdfPCell(new Paragraph(vol_sed.getText() + " ml", normalFont));
							tableauDG.addCell(valeurVolSed);

							// ajout du facteur de dilution dans le tableau
							PdfPCell champFactDilu = new PdfPCell(new Paragraph(rb.getString("champFactDilu"), normalBoldFont));
							tableauDG.addCell(champFactDilu);
							PdfPCell valeurFactDilu = new PdfPCell(new Paragraph(dilu.getText(), normalFont));
							tableauDG.addCell(valeurFactDilu);

							// ajout d dans le tableau
							PdfPCell champChambre = new PdfPCell(new Paragraph(rb.getString("champChambre"), normalBoldFont));
							tableauDG.addCell(champChambre);
							PdfPCell valeurChambre = new PdfPCell(new Paragraph((String) chambre.getText(), normalFont));
							tableauDG.addCell(valeurChambre);


							// ajout du nombre de champs dans le tableau
							PdfPCell champNbChamps = new PdfPCell(new Paragraph(rb.getString("champNbChamps"), normalBoldFont));
							tableauDG.addCell(champNbChamps);
							PdfPCell valeurNbChamps = new PdfPCell(new Paragraph(nb_chp.getText(), normalFont));
							tableauDG.addCell(valeurNbChamps);

							// ajout du nombre d'individus total dans le tableau
							PdfPCell champNbIndivTotal = new PdfPCell(new Paragraph(rb.getString("champNbIndivTotal"), normalBoldFont));
							tableauDG.addCell(champNbIndivTotal);
							PdfPCell valeurNbIndivTotal = new PdfPCell(new Paragraph(nb_tot.getText(), normalFont));
							tableauDG.addCell(valeurNbIndivTotal);

							// ajout d'une case vide (car sinon la ligne ne se cre pas... )
							PdfPCell champVide = new PdfPCell(new Paragraph(" "));
							tableauDG.addCell(champVide);
							PdfPCell valeurVide = new PdfPCell(new Paragraph(" "));
							tableauDG.addCell(valeurVide);


							document.add(tableauDG);

							// ajout du commentaire du comptage sous le tableau
							Paragraph commentairePara = new Paragraph();
							Chunk champCommCh = new Chunk(rb.getString("champCommentaire"), normalBoldFont);
							commentairePara.add(champCommCh);
							Chunk commentaireCh = new Chunk(' ' + commentaire.getText() + "\n\n", normalFont);
							commentairePara.add(commentaireCh);
							document.add(commentairePara);


							////////////////////////////
							// Partie des taxons dnombrs
							Paragraph taxonsDenomb = new Paragraph(rb.getString("taxonsDenombre"), mediumFont);
							taxonsDenomb.setAlignment(Element.ALIGN_LEFT);
							document.add(taxonsDenomb);

							// ajout du petit saut de ligne avant le tableau
							document.add(petitSautDeLigne);

							// cette partie sera sous la forme d'un tableau reprsentant le comptage (11 colonnes)
							PdfPTable tableauCpt = new PdfPTable(11);
							tableauCpt.setWidthPercentage(100);
							// choix de la largeur de chaque colonne
							tableauCpt.setWidths(new float[]{24f, 25f, 18f, 12f, 60f, 48f, 25f, 62f, 27f, 23f, 26f});

							// ajout des titres des colonnes
							PdfPCell c1 = new PdfPCell(new Paragraph(rb.getString("colCodeSandre"), normalBoldFont));
							tableauCpt.addCell(c1);

							PdfPCell c2 = new PdfPCell(new Paragraph(rb.getString("colCodeTaxon"), normalBoldFont));
							tableauCpt.addCell(c2);

							PdfPCell c3 = new PdfPCell(new Paragraph(rb.getString("colTypeObj"), normalBoldFont));
							tableauCpt.addCell(c3);

							PdfPCell c4 = new PdfPCell(new Paragraph(rb.getString("colCf"), normalBoldFont));
							tableauCpt.addCell(c4);

							PdfPCell c5 = new PdfPCell(new Paragraph(rb.getString("colNomTaxon"), normalBoldFont));
							tableauCpt.addCell(c5);

							PdfPCell c6 = new PdfPCell(new Paragraph(rb.getString("colAuteur"), normalBoldFont));
							tableauCpt.addCell(c6);

							PdfPCell c7 = new PdfPCell(new Paragraph(rb.getString("colCodeRef"), normalBoldFont));
							tableauCpt.addCell(c7);

							PdfPCell c8 = new PdfPCell(new Paragraph(rb.getString("colNiveauTaxinomique"), normalBoldFont));
							tableauCpt.addCell(c8);

							PdfPCell c9 = new PdfPCell(new Paragraph(rb.getString("colNbCel_ml"), normalBoldFont));
							tableauCpt.addCell(c9);

							PdfPCell c10 = new PdfPCell(new Paragraph(rb.getString("colNbInd_ml"), normalBoldFont));
							tableauCpt.addCell(c10);

							PdfPCell c11 = new PdfPCell(new Paragraph(rb.getString("colBiovol_mm3_L"), normalBoldFont));
							tableauCpt.addCell(c11);

							// rcupration du comptage pour ajout dans le tableau						

							// avant a, rcupration du niveau taxinomique choisi
							String lvl = (String)taxi_lvl.getSelectedItem();

							// conversion en franais de ce niveau taxinomique
							if (lvl.equals(rb.getString("colRegne")) )
								lvl = "Rgne";
							else if (lvl.equals(rb.getString("colSousRegne")) )
								lvl = "Sous rgne";
							else if (lvl.equals(rb.getString("colEmbranchement")) )
								lvl = "Embranchement";
							else if (lvl.equals(rb.getString("colClasse")))
								lvl = "Classe";
							else if (lvl.equals(rb.getString("colOrdre")))
								lvl = "Ordre";
							else if (lvl.equals(rb.getString("colSousOrdre")))
								lvl = "Sous ordre";
							else if (lvl.equals(rb.getString("colFamille")))
								lvl = "Famille";

							// rcupration des taxons compts pour ce comptage prcis avec le niveau taxo
							Object[][] listeTaxonsCpt = cpt_query.get_all_for_consult(id_cpt, lvl);

							// ncessaire  l'insertion de l'entte sur chaque page...
							int cpt = 0;
							int maxNbLignesCptPage1 = 25;
							int maxNbLignesCptPages = 50;
							boolean premierePage = true;

							// date du jour pour pied de page
							Date aujourdhui = new Date();
							DateFormat shortDateFormat = DateFormat.getDateTimeInstance(
									DateFormat.SHORT, DateFormat.SHORT, locale);

							//TODO n version  actualiser dans langue lors de changement de version
							Paragraph pdp = new Paragraph(rb.getString("phytobsVer")
									+ " - " + rb.getString("dateImpress") + 
									shortDateFormat.format(aujourdhui));


							for(Object[] data : listeTaxonsCpt){
								
								// affichage de "" en code sandre pour les taxons new
								String codeSandre;
								if (data[0].toString().equals("2147483647")){
									codeSandre="";
								}else
									codeSandre= data[0].toString();
								
								tableauCpt.addCell(new Paragraph(codeSandre, tinyFont));
								
								tableauCpt.addCell(new Paragraph(data[1].toString(), tinyFont));
								tableauCpt.addCell(new Paragraph(data[2].toString(), tinyFont));
								tableauCpt.addCell(new Paragraph(data[3].toString(), tinyFont));							
								tableauCpt.addCell(new Paragraph(data[4].toString(), tinyItalicFont));
								tableauCpt.addCell(new Paragraph(data[5].toString(), tinyFont));
								tableauCpt.addCell(new Paragraph(data[6].toString(), tinyFont));
								tableauCpt.addCell(new Paragraph(data[7].toString(), tinyFont));

								// format du biovolume : 5 chiffres aprs la virgule
								// format des abondance : 2 chiffres aprs la virgule
								DecimalFormat formatterAb = new DecimalFormat( "#0.00");
								DecimalFormat formatterBv = new DecimalFormat( "#0.00000");

								// nombre cell/ml
								String valNbCell_ml;
								if (!data[8].toString().equals("-1.0") && !data[8].toString().equals("0.0")){
									valNbCell_ml = data[8].toString();
									valNbCell_ml = formatterAb.format((Float.valueOf(valNbCell_ml)));
								}
								else
									valNbCell_ml = "";

								// valeur aligne  droite
								PdfPCell pc1 = new PdfPCell(new Paragraph(valNbCell_ml, tinyFont));/*#*/
								pc1.setHorizontalAlignment(Element.ALIGN_RIGHT);
								tableauCpt.addCell(pc1);

								// nombre ind/ml
								String valNbInd_ml;
								if (!data[9].toString().equals("-1.0") && !data[9].toString().equals("0.0")){
									valNbInd_ml = data[9].toString();
									valNbInd_ml = formatterAb.format((Float.valueOf(valNbInd_ml)));
								}
								else
									valNbInd_ml = "";

								// valeur aligne  droite
								PdfPCell pc2 = new PdfPCell(new Paragraph(valNbInd_ml, tinyFont));/*#*/
								pc2.setHorizontalAlignment(Element.ALIGN_RIGHT);
								tableauCpt.addCell(pc2);

								// biovolume mm3/l
								String valBioVol;
								// les biovolumes valant 0.0 ne sont pas affichs
								if(!data[10].toString().equals("0.0")){
									valBioVol = data[10].toString();
									valBioVol = formatterBv.format((Float.valueOf(valBioVol)));
								}
								else valBioVol = "";

								// valeur aligne  droite
								PdfPCell pc3 = new PdfPCell(new Paragraph(valBioVol, tinyFont));
								pc3.setHorizontalAlignment(Element.ALIGN_RIGHT);
								tableauCpt.addCell(pc3);

								cpt++;

								// astuce pour insrer l'entte sur chaque page
								if ( (cpt > maxNbLignesCptPage1 && premierePage) ||
										(cpt > maxNbLignesCptPages && !premierePage) ) {

									// ajout d'une partie du tableau
									document.add(tableauCpt);
									// ajout du pied de page
									pdp.setAlignment(Element.ALIGN_RIGHT);
									document.add(pdp);
									// vidage du tableau
									tableauCpt.flushContent();

									cpt = 0;

									if (premierePage)
										premierePage = false;

									// nouvelle page
									document.newPage();
									// ajout de l'entte
									document.add(entete);
									document.add(petitSautDeLigne);
								}
							}

							document.add(tableauCpt);

							// ajout du pied de page
							pdp.setAlignment(Element.ALIGN_RIGHT);
							document.add(pdp);

						}catch (DocumentException de){
							de.printStackTrace();
						}catch (IOException ioe){
							ioe.printStackTrace();
						}

						// Message de russite d'export :
						JOptionPane.showMessageDialog(
								self, rb.getString("mssgSuccesExportPDF") + 
								fc.getSelectedFile().getAbsolutePath() 
								+ File.separator + rb.getString("resultComptage") + id_cpt + ".pdf",
								rb.getString("titreBoxSuccesExportPDF"), 
								JOptionPane.INFORMATION_MESSAGE);
						document.close();
					}
				}
				// s'il n'y a pas de comptage ouvert en consultation  exporter :
				else {
					JOptionPane.showMessageDialog(
							self, rb.getString("mssgRienAExporter"),
							rb.getString("titreBoxRienAExporter"), 
							JOptionPane.ERROR_MESSAGE);
				}
			}
		});


	}

	private void add_fields()
	{
		// pour la traduction du titre de la bannire
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		/*Ajout de la bannire */
		JPanel banniere_pane = new JPanel(new FlowLayout());
		((FlowLayout)banniere_pane.getLayout()).setAlignment(FlowLayout.LEFT);
		banniere_pane.setBackground(new Color(192, 197, 199));
		JLabel banniere = new JLabel(rb.getString("consultationCpt"), 
				new ImageIcon(getClass().getClassLoader().getResource("images/bannierev2.png")), JLabel.TRAILING);
		//banniere.setFont(new Font(banniere.getFont().getName(), banniere.getFont().getStyle(), 15));
		banniere_pane.add(banniere);

		cartouche_pane  = new JPanel(new BorderLayout());
		JPanel north_pane = new JPanel(new FlowLayout());
		JPanel center_pane = new JPanel(new FlowLayout());
		JPanel south_pane = new JPanel();

		cartouche_pane.setBackground(new Color(192, 197, 199));
		north_pane.setBackground(new Color(192, 197, 199));
		center_pane.setBackground(new Color(192, 197, 199));
		south_pane.setBackground(new Color(192, 197, 199));
		((FlowLayout)south_pane.getLayout()).setAlignment(FlowLayout.LEADING);
		center_pane.setLayout(new BoxLayout(center_pane, BoxLayout.LINE_AXIS));

		/*Ajout du panneau nord*/
		north_pane.add(labelSite);
		lieu.setPreferredSize(new Dimension(250, 20));
		lieu.setEditable(false);
		north_pane.add(lieu);
		north_pane.add(labelStation);
		station.setPreferredSize(new Dimension(177, 20));
		station.setEditable(false);
		north_pane.add(station);
		north_pane.add(labelMilieu);
		milieu.setPreferredSize(new Dimension(75, 20));
		milieu.setEditable(false);
		north_pane.add(milieu);
		north_pane.add(labelDatePrel);
		date.setPreferredSize(new Dimension(75, 20));
		date.setEditable(false);
		north_pane.add(this.date);
		north_pane.add(labelRefEch);
		id_ech.setPreferredSize(new Dimension(75, 20));
		id_ech.setEditable(false);
		north_pane.add(this.id_ech);
		north_pane.add(labelTaxinomiste);
		oper.setPreferredSize(new Dimension(100,20));
		oper.setEditable(false);
		north_pane.add(oper);


		/*Ajout du panneau central*/
		center_pane.add(Box.createHorizontalStrut(5));
		center_pane.add(labelVolSed);
		center_pane.add(Box.createHorizontalStrut(5));
		vol_sed.setMaximumSize(new Dimension(50,20));
		vol_sed.setPreferredSize(new Dimension(50,20));
		vol_sed.setEditable(false);
		center_pane.add(vol_sed);
		center_pane.add(Box.createHorizontalStrut(5));
		center_pane.add(labelFactDilu);
		center_pane.add(Box.createHorizontalStrut(5));
		dilu.setEditable(false);
		dilu.setMaximumSize(new Dimension(50,20));
		dilu.setPreferredSize(new Dimension(50,20));
		center_pane.add(dilu);
		center_pane.add(Box.createHorizontalStrut(5));
		center_pane.add(labelChambre);
		center_pane.add(Box.createHorizontalStrut(5));
		chambre.setEditable(false);
		chambre.setMaximumSize(new Dimension(300,20));
		chambre.setPreferredSize(new Dimension(300,20));
		center_pane.add(chambre);
		center_pane.add(Box.createHorizontalGlue());

		/*Ajout du panneau sud*/
		south_pane.add(labelNbChamps);
		nb_chp.setPreferredSize(new Dimension(50,20));
		nb_chp.setEditable(false);
		south_pane.add(nb_chp);
		south_pane.add(labelNbIndTotal);
		nb_tot.setEditable(false);
		nb_tot.setPreferredSize(new Dimension(50,20));
		south_pane.add(nb_tot);
		south_pane.add(labelCommentaire);
		commentaire.setPreferredSize(new Dimension(730, 20));
		commentaire.setEditable(false);
		south_pane.add(commentaire);

		cartouche_pane.add(north_pane, BorderLayout.NORTH);
		cartouche_pane.add(center_pane, BorderLayout.CENTER);
		cartouche_pane.add(south_pane, BorderLayout.SOUTH);

		cartouche_pane.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				idLabel, TitledBorder.CENTER, TitledBorder.CENTER));

		__table = new Consultation_Table(locale); 

		JPanel table_pane = new JPanel(new BorderLayout());
		JPanel taxi = new JPanel(); taxi.setLayout(new BoxLayout(taxi, BoxLayout.LINE_AXIS));
		taxi.add(Box.createHorizontalStrut(551));
		taxi.add(labelChoixNivTaxinomique);
		taxi_lvl.setPreferredSize(new Dimension(__table.getColumnModel().getColumn(7).getPreferredWidth()+1, 25));
		taxi_lvl.setMaximumSize(new Dimension(__table.getColumnModel().getColumn(7).getPreferredWidth()+1, 25));
		taxi.add(taxi_lvl);
		taxi_lvl.setSelectedItem(rb.getString("colClasse"));
		taxi.setBackground(new Color(192, 197, 199));

		JScrollPane __scrollPane = new JScrollPane(__table, 
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, 
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

		table_pane.setBackground(new Color(192, 197, 199));
		table_pane.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("taxonsComptes"), TitledBorder.CENTER, TitledBorder.CENTER));

		table_pane.add(taxi, BorderLayout.NORTH);
		table_pane.add(__scrollPane, BorderLayout.CENTER);

		this.getContentPane().setBackground(new Color(192, 197, 199));
		JPanel test = new JPanel(new BorderLayout());
		test.add(banniere_pane, BorderLayout.NORTH);
		test.add(cartouche_pane, BorderLayout.SOUTH);
		this.getContentPane().add(test, BorderLayout.NORTH);	
		this.getContentPane().add(table_pane, BorderLayout.CENTER);	
	}

	private void draw_frame()
	{
		this.setLocation(50, 50);
		this.pack();
		this.setVisible(true);
		opti_width = this.getWidth();
	}

	/**
	 * Traduction dans la bonne langue des textes de la fentre
	 * @param locale
	 */
	public void translate(Locale locale){
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		// nom de la fentre
		this.setTitle(rb.getString("titreFenConsultCpt"));

		menu_fichier.setText(rb.getString("fichier"));
		open.setText(rb.getString("ouvrir"));
		exportPDF.setText(rb.getString("exportPDF"));
		save_close.setText(rb.getString("fermer"));

		idLabel = rb.getString("infosCptNum");


		labelSite.setText(rb.getString("champSite"));
		labelStation.setText(rb.getString("champStation"));
		labelMilieu.setText(rb.getString("champMilieu"));
		labelDatePrel.setText(rb.getString("champDatePrel"));
		labelRefEch.setText(rb.getString("champRefEch"));
		labelTaxinomiste.setText(rb.getString("champTaxinomiste"));
		labelVolSed.setText(rb.getString("champVolSed"));
		labelFactDilu.setText(rb.getString("champFactDilu"));
		labelChambre.setText(rb.getString("champChambre"));
		labelNbChamps.setText(rb.getString("champNbChamps"));
		labelNbIndTotal.setText(rb.getString("champNbIndivTotal"));
		labelCommentaire.setText(rb.getString("champCommentaire"));

		labelChoixNivTaxinomique.setText(rb.getString("champChoixNiveauTaxinomique"));

		//ragencement de la position des items de la fentre
		this.pack();
	}


}
