package Comptage;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

public class Creer_Taxon extends JDialog {

	private static final long serialVersionUID = 1L;
	private Locale locale;
	@SuppressWarnings("unused")
	private String db_link;
	
	private JPanel code_nom = new JPanel( new FlowLayout() );
	
	private JLabel labelCode = new JLabel();
	private JLabel labelNom = new JLabel();
	private JLabel labelIndivDef = new JLabel();
	
	private JPanel auteur = new JPanel();
	
	private JPanel embranchement = new JPanel();
	private JComboBox<String> jcb_embranchements = new JComboBox<String>();
	
	
	private JPanel autres = new JPanel( new FlowLayout() );
	
	private JLabel labelBioVolCel = new JLabel();
	private JLabel labelBioVolInd = new JLabel();
	private JLabel labelCreateur = new JLabel();

	private JPanel formes = new JPanel( new FlowLayout() );
	
	private JLabel labelFormeCel = new JLabel();
	private JLabel labelFormeInd = new JLabel();
	
	private JCheckBox auteur_ckb = new JCheckBox();
	private JComboBox<String> auteur_cb = new JComboBox<String>();
	private JTextField code_tf = new JTextField();
	private JTextField nom_tf = new JTextField();
	private Comptage_Query cpt_query;
	private JComboBox<String> type_cb = null;
	private JTextField biovolcel_tf = new JTextField();
	private JTextField biovolind_tf = new JTextField();
	private JTextField forme_cel = new JTextField();
	private JTextField forme_ind = new JTextField();
	private JButton modif_forme_cel = new JButton();
	private JButton modif_forme_ind = new JButton();
	private JTextField createur_tf = new JTextField();
	private JButton validate = new JButton();
	private String code = null;
	private Creer_Taxon self = null;
	private String createur;
	
	public Creer_Taxon( JFrame f, String createur, Locale locale, String db_link )
	{
		super(f, "Crer nouveau taxon", true);
		this.setBackground(new Color(192, 197, 199));
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.PAGE_AXIS));
		this.getContentPane().setBackground(new Color(192, 197, 199));
		self = this;
		this.locale = locale;
		this.db_link = db_link;
		
		cpt_query = new Comptage_Query(db_link);
		
		this.createur = createur;
		
		this.translate(locale);
		
		
		this.add_buttons();
		this.add_handlers();
		
		this.pack();
		this.setLocation(100, 100);
		this.setResizable(false);
	}
	
	public Creer_Taxon set_visible()
	{
		this.setVisible(true);
		return this;
	}
	
	/**
	 * Pr-remplit la fentre de cration d'un taxon avec ses informations 
	 * (dans le cas o le taxon existe dj)
	 * @param code
	 * @param nom
	 * @param type
	 * @param auteur
	 * @param biovol
	 * @return
	 */
	public Creer_Taxon pre_remplir(String code, String nom, String type, String auteur, String biovol)
	{
		this.setVisible(false);
		code_tf.setText(code);
		nom_tf.setText(nom);
		nom_tf.setEditable(false);
		type_cb.setSelectedItem(cpt_query.get_indiv_def(code));
		type_cb.setEnabled(false);
		auteur_ckb.setSelected(true);
		((JTextField)auteur_cb.getEditor().getEditorComponent()).setText(auteur);
		auteur_ckb.setEnabled(false);
		auteur_cb.setEnabled(false);
		
		((JTextField)jcb_embranchements.getEditor().getEditorComponent()).setText(cpt_query.get_embranchement(code));
		jcb_embranchements.setEnabled(false);
		
				
		if( type.compareTo("Cel.") == 0 )
		{
			biovolcel_tf.setText(biovol);
			biovolind_tf.setText(cpt_query.get_biovol(code, "Col.", false));
		}
		else
		{
			biovolind_tf.setText(biovol);
			biovolcel_tf.setText(cpt_query.get_biovol(code, "Cel.", false));
		}
		
		this.update(this.getGraphics());
		this.repaint();
		this.pack();
		
		return this;
	}
	
	private void add_handlers() 
	{
		// necessaire pour la traduction des botes de dialogue
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		auteur_ckb.addItemListener(
				new ItemListener() {
					public void itemStateChanged(ItemEvent arg0) {
						if( arg0.getStateChange() == ItemEvent.SELECTED )
							auteur_cb.setEnabled(true);
							
						else
						{
							auteur_cb.removeAllItems();
							auteur_cb.setEnabled(false);
						}
					}});
		
		auteur_cb.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent arg0) {
						String debut = ((JTextField)arg0.getSource()).getText();
						if( debut.length() > 3 
								&& arg0.getKeyCode() != KeyEvent.VK_BACK_SPACE
								&& arg0.getKeyCode() != KeyEvent.VK_DOWN
								&& arg0.getKeyCode() != KeyEvent.VK_UP)
						{
							String[] auteurs = cpt_query.get_auteurs_like(debut.replaceAll("'", "\\\\'"));
							if( auteurs != null )
							{
								auteur_cb.removeAllItems();
								auteur_cb.addItem(debut);
								for( String s : auteurs )
									auteur_cb.addItem(s);
								auteur_cb.hidePopup();
								auteur_cb.showPopup();
							}
						}
					}
					public void keyTyped(KeyEvent arg0) {}
				});
		
		// gestion de l'auto-slection de l'embranchement lorsque l'on commence  taper des
		// lettres dans le champ
		jcb_embranchements.getEditor().getEditorComponent().addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {
					}

					public void keyReleased(KeyEvent arg0) {
						String debut = ((JTextField) arg0.getSource())
								.getText().trim();
						if (arg0.getKeyCode() != KeyEvent.VK_BACK_SPACE
								&& arg0.getKeyCode() != KeyEvent.VK_ENTER
								&& arg0.getKeyCode() != KeyEvent.VK_DOWN
								&& arg0.getKeyCode() != KeyEvent.VK_UP) 
						{
							
							String[] embrs_correspondants = cpt_query.get_embranchement_designes(debut);
							
							if (embrs_correspondants != null) {
								jcb_embranchements.removeAllItems();
								jcb_embranchements.addItem(debut);
								for (String s : embrs_correspondants)
									jcb_embranchements.addItem(s);
								
								jcb_embranchements.hidePopup();
								jcb_embranchements.showPopup();
							}
						}
					}

					public void keyTyped(KeyEvent arg0) {
					}
				});
		
		
		validate.addActionListener(
				new ActionListener() {
					boolean nom_ok = false, auteur_ok = true, biovolcel_ok = true, biovolind_ok = true, 
							createur_ok = false, type_ok = false;
					@SuppressWarnings("static-access")
					public void actionPerformed( ActionEvent e ) {
						if( ! nom_tf.getText().trim().isEmpty() )
							nom_ok = true;
						else
						{
							new JOptionPane().showMessageDialog(self, rb.getString("mssgNomVide"), 
									rb.getString("titreBoxNomVide"),
									JOptionPane.ERROR_MESSAGE);
							nom_ok = false;
						}
						
						if( auteur_ckb.isSelected() )
						{
							if( ! ((JTextField)auteur_cb.getEditor().getEditorComponent()).getText().trim().isEmpty() )
								auteur_ok = true;
							else
							{
								new JOptionPane().showMessageDialog(self, 
										rb.getString("mssgNomAuteurVide"), 
										rb.getString("titreBoxNomAuteurVide"),
										JOptionPane.ERROR_MESSAGE);
								auteur_ok = false;
							}
						}
						else
							auteur_ok = true;
						
						try
						{
							if( ! biovolcel_tf.getText().trim().isEmpty() )
							{
								Float.parseFloat(biovolcel_tf.getText());
								biovolcel_ok = true;
							}
							else
								biovolcel_ok = true;
							if( ! biovolind_tf.getText().trim().isEmpty() )
							{
								Float.parseFloat(biovolind_tf.getText());
								biovolind_ok = true;
							}
							else
								biovolind_ok = true;
						}
						// si les biovolumes ne sont pas au bon format
						catch(NumberFormatException nfe)
						{
							biovolind_ok = false;
							biovolcel_ok = false;
							new JOptionPane().showMessageDialog(self, rb.getString("mssgBioVolFormat"), 
									rb.getString("titreBoxBioVolFormat"),
									JOptionPane.ERROR_MESSAGE);
						}
						
						if( createur_tf.getText().trim().isEmpty() )
						{
							new JOptionPane().showMessageDialog(self, rb.getString("mssgCreateurVide"), 
									rb.getString("titreBoxCreateurVide"),
									JOptionPane.ERROR_MESSAGE);
							createur_ok = false;
						}
						else
							createur_ok = true;
						
						if( type_cb.getSelectedIndex() == 0 )
						{
							new JOptionPane().showMessageDialog(self, rb.getString("mssgTypeVide"), 
									rb.getString("titreBoxTypeVide"),
									JOptionPane.ERROR_MESSAGE);
							type_ok = false;
						}
						else
							type_ok = true;
						
						if( nom_ok && auteur_ok && biovolcel_ok && biovolind_ok && createur_ok && type_ok)
						{
							String nom_auteur = ((JTextField)auteur_cb.getEditor().getEditorComponent()).getText();
							String embr = ((JTextField)jcb_embranchements.getEditor().getEditorComponent()).getText();
							
							Float biocel = ((biovolcel_tf.getText().isEmpty()) ? 0 : Float.parseFloat(biovolcel_tf.getText()));
							Float bioind = ((biovolind_tf.getText().isEmpty()) ? 0 : Float.parseFloat(biovolind_tf.getText()));
							if( nom_auteur.trim().isEmpty() )
								nom_auteur = "A remplir";
							cpt_query.add_taxon_cpt(code_tf.getText(), nom_tf.getText().trim(),
									nom_auteur, (String)type_cb.getSelectedItem(), biocel, bioind, embr,
									createur_tf.getText().trim(), forme_cel.getText(), forme_ind.getText());
							code = code_tf.getText();
							self.dispose();
						}
					}});
		
		modif_forme_cel.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Choisir_Forme(self, null, 0, true, locale);
					}});
		
		modif_forme_ind.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Choisir_Forme(self, null, 1, true, locale);
					}});
	}
	
	public void changerForme(String new_forme, int type){
		if(type == 0)
			forme_cel.setText(new_forme);
		else
			forme_ind.setText(new_forme);
	}

	/**
	 * Retourne le code du taxon cr
	 * @return nouveau code taxon
	 */
	public String get_code()
	{
		return code;
	}
	
	private void add_buttons()
	{		
		JPanel code = new JPanel();
		code.setBackground(new Color(192, 197, 199));
		code.setLayout( new BoxLayout(code, BoxLayout.PAGE_AXIS));
		code.add(Box.createVerticalStrut(5));
		code.add(labelCode);
		code.add(Box.createVerticalStrut(5));
		code_tf.setEditable(false);
		code_tf.setPreferredSize(new Dimension(50,20));
		code.add(code_tf);
		code_tf.setText(cpt_query.get_last_cpt_taxon());
		
		JPanel nom = new JPanel();
		nom.setBackground(new Color(192, 197, 199));
		nom.setLayout( new BoxLayout(nom, BoxLayout.PAGE_AXIS));
		nom.add(Box.createVerticalStrut(5));
		nom.add(labelNom);
		nom.add(Box.createVerticalStrut(5));
		nom_tf.setPreferredSize(new Dimension(200, 20));
		nom.add(nom_tf);
		
		JPanel type = new JPanel();
		type.setBackground(new Color(192, 197, 199));
		type.setLayout( new BoxLayout(type, BoxLayout.PAGE_AXIS));
		type.add(Box.createVerticalStrut(5));
		type.add(labelIndivDef);
		type.add(Box.createVerticalStrut(5));
		type_cb = new JComboBox<String>( new String[] {"", "Cel.", "Fil.", "Col."} );
		type.add(type_cb);
		
		code_nom.setBackground(new Color(192, 197, 199));

		code_nom.add(code);
		code_nom.add(nom);
		code_nom.add(type);
		
		
		auteur.setBackground(new Color(192, 197, 199));
		auteur.setLayout( new BoxLayout(auteur, BoxLayout.PAGE_AXIS));
		
		auteur.add(Box.createVerticalStrut(5));
		auteur_ckb.setBackground(new Color(192, 197, 199));
		auteur_ckb.setAlignmentX(new Float(0.5));
		auteur.add(auteur_ckb);
		auteur_cb.setEnabled(false);
		auteur_cb.setEditable(true);
		auteur_cb.setPreferredSize(new Dimension(150, 20));
		auteur.add(Box.createVerticalStrut(5));
		auteur.add(auteur_cb);
		
		jcb_embranchements.setEnabled(true);
		jcb_embranchements.setEditable(true);
		jcb_embranchements.setPreferredSize(new Dimension(200, 20));
		
		String[] liste_emb = cpt_query.get_embranchements();
		if(liste_emb != null){
			jcb_embranchements.addItem("");
			for(String s: liste_emb)
				jcb_embranchements.addItem(s);
		}
		
		
		
		
		embranchement.setBackground(new Color(192, 197, 199));
		embranchement.add(jcb_embranchements);
		
		
		JPanel biovolcel = new JPanel();
		biovolcel.setBackground(new Color(192, 197, 199));
		biovolcel.setLayout( new BoxLayout(biovolcel, BoxLayout.PAGE_AXIS));
		biovolcel.add(Box.createVerticalStrut(5));
		biovolcel.add(labelBioVolCel);
		biovolcel.add(Box.createVerticalStrut(5));
		biovolcel_tf.setPreferredSize(new Dimension(50,20));
		biovolcel.add(biovolcel_tf);
		
		JPanel biovolind = new JPanel();
		biovolind.setBackground(new Color(192, 197, 199));
		biovolind.setLayout( new BoxLayout(biovolind, BoxLayout.PAGE_AXIS));
		biovolind.add(Box.createVerticalStrut(5));
		biovolind.add(labelBioVolInd);
		biovolind.add(Box.createVerticalStrut(5));
		biovolind_tf.setPreferredSize(new Dimension(50, 20));
		biovolind.add(biovolind_tf);
		
		JPanel createur = new JPanel();
		createur.setBackground(new Color(192, 197, 199));
		createur.setLayout( new BoxLayout(createur, BoxLayout.PAGE_AXIS));
		createur.add(Box.createVerticalStrut(5));
		createur.add(labelCreateur);
		createur.add(Box.createVerticalStrut(5));
		createur_tf.setPreferredSize(new Dimension(200, 20));
		createur_tf.setText(this.createur);
		createur_tf.setEditable(false);
		createur.add(createur_tf);
		
		formes.setBackground(new Color(192, 197, 199));
		
		JPanel cel = new JPanel();
		cel.setBackground(new Color(192, 197, 199));
		cel.setLayout( new BoxLayout(cel, BoxLayout.PAGE_AXIS));
		cel.add(Box.createVerticalStrut(5));
		cel.add(labelFormeCel, BorderLayout.CENTER);
		cel.add(Box.createVerticalStrut(5));
		forme_cel.setPreferredSize(new Dimension(200, 20));
		cel.add(forme_cel);
		cel.add(Box.createVerticalStrut(5));
		cel.add(Box.createHorizontalStrut(77));
		cel.add(modif_forme_cel);
		
		JPanel ind = new JPanel();
		ind.setBackground(new Color(192, 197, 199));
		ind.setLayout( new BoxLayout(ind, BoxLayout.PAGE_AXIS));
		ind.add(Box.createVerticalStrut(5));
		ind.add(labelFormeInd, BorderLayout.CENTER);
		ind.add(Box.createVerticalStrut(5));
		forme_ind.setPreferredSize(new Dimension(200, 20));
		ind.add(forme_ind);
		ind.add(Box.createVerticalStrut(5));
		ind.add(Box.createHorizontalStrut(72));
		ind.add(modif_forme_ind);
		
		formes.add(cel, BorderLayout.NORTH);
		formes.add(ind, BorderLayout.SOUTH);
		
		
		autres.setBackground(new Color(192, 197, 199));
		
		autres.add(biovolcel);
		autres.add(biovolind);
		autres.add(createur);
		
		this.getContentPane().add(code_nom);
		this.getContentPane().add(auteur);
		this.getContentPane().add(embranchement);
		this.getContentPane().add(autres);
		this.getContentPane().add(formes);
		validate.setAlignmentX(new Float(0.5));
		this.getContentPane().add(validate);
	}
	
	public void translate(Locale locale){
		
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		// nom de la fentre
		this.setTitle(rb.getString("titreFenCreerNouveauTaxon"));
		
		code_nom.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("denomination"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		labelCode.setText(rb.getString("champCode"));
		labelNom.setText(rb.getString("champNom"));
		labelIndivDef.setText(rb.getString("champIndivDef"));
		
		auteur.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("auteur"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		auteur_ckb.setText(rb.getString("specifierAuteur"));
		
		embranchement.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("embranchement"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		
		autres.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("autresInfos"), TitledBorder.CENTER, TitledBorder.CENTER));
		
		
		labelBioVolCel.setText(rb.getString("champBiovolCel"));
		labelBioVolInd.setText(rb.getString("champBiovolInd"));
		labelCreateur.setText(rb.getString("champCreateur"));
		
		formes.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, 
						new Color(0xa0, 0xca, 0x56), new Color(0x3d, 0x61, 0x89)),
				rb.getString("formes"), TitledBorder.CENTER, TitledBorder.CENTER));

		labelFormeCel.setText(rb.getString("champFormeCel"));
		labelFormeInd.setText(rb.getString("champFormeIndiv"));
		
		modif_forme_cel.setText(rb.getString("choisir"));
		modif_forme_ind.setText(rb.getString("choisir"));
		validate.setText(rb.getString("ajouter"));
		
		//ragencement de la position des items de la fentre
		this.pack();
	}

}
