package Comptage;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Comparator;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;

public class Ouvrir_Cpt extends JDialog {

	private static final long serialVersionUID = 1L;
	private Locale locale;
	private String db_link;
	private Comptage_Query cpt_query;
	private JTable liste = null;
	private Consultation_Comptage consult;
	
	private JLabel site_lbl = new JLabel();
	
	private JButton open_entry = new JButton();
	private JTextField name_filter = new JTextField();
	private JTextField st_filter = new JTextField();
	private Ouvrir_Cpt self = null;
	private int id_cpt = 0;
	private int[] ids_cpt = null;

	private boolean multi = false;
	private JButton delete = new JButton(new ImageIcon(getClass().getClassLoader().getResource("images/close.png")));
	
	private JLabel labelSelectMult	= new JLabel();
	
	public Ouvrir_Cpt(JFrame f, boolean multi, Locale locale, String db_link)
	{
		super(f, null, true);
		this.locale = locale;
		this.db_link = db_link;
		
		cpt_query = new Comptage_Query(db_link);
		
		// traduction des colonnes de la table
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		String[] columnNames = {rb.getString("colNomSite"), rb.getString("colNomStation"), 
								rb.getString("colDatePrel"), rb.getString("colRefEch"), 
								rb.getString("colDateCpt"), rb.getString("colTaxinomiste"), 
								"#"};
		
		f = consult;

		this.translate(locale);
		
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.LINE_AXIS));
		self = this;
		this.multi = multi;
		add_buttons(columnNames);
		add_handlers(columnNames);
		this.pack();
		this.setLocation(100, 100);
		self.setMinimumSize(new Dimension(740, 200));
		this.setResizable(false);
		this.setVisible(true);
	}

	/**
	 * Retourne l'id du comptage ouvert
	 * @return id du comptage
	 */
	public int get_cpt()
	{
		return id_cpt;
	}	

	public int[] get_cpts()
	{
		return ids_cpt;
	}

	private void add_handlers(final String[] columnNames)
	{
		// pour la traduction des botes de dialogues
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		
		st_filter.addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent arg0) {
						String text = ((JTextField)arg0.getSource()).getText();
						if( ! text.isEmpty() )
							for( int i = liste.getSelectedRow(); i < liste.getRowCount(); i++ )
								if( ((String)liste.getValueAt(i, 1)).toUpperCase().startsWith(text.toUpperCase()))
								{
									self.liste.scrollRectToVisible(self.liste.getCellRect(i+5, 0, true));
									self.liste.getSelectionModel().setSelectionInterval(i, i);
									break;
								}
					}
					public void keyTyped(KeyEvent arg0) {}	
				});

		name_filter.addKeyListener(
				new KeyListener() {
					public void keyPressed(KeyEvent arg0) {}
					public void keyReleased(KeyEvent arg0) {
						String text = ((JTextField)arg0.getSource()).getText();
						System.out.println(text);
						if( ! text.isEmpty() )
						{
							for( int i = 0; i < liste.getRowCount(); i++ )
								if( ((String)liste.getValueAt(i, 0)).toUpperCase().startsWith(text.toUpperCase()))
								{
									self.liste.scrollRectToVisible(self.liste.getCellRect(i+5, 0, true));
									self.liste.getSelectionModel().setSelectionInterval(i, i);
									self.st_filter.setEditable(true);
									break;
								}
						}
						else
							self.st_filter.setEditable(false);
					}
					public void keyTyped(KeyEvent arg0) {}	
				});

		open_entry.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						int nb;
						if( (nb = self.liste.getSelectedRowCount()) != 0 )
						{
							if(! multi )
								self.id_cpt = Integer.parseInt(self.liste.getValueAt(self.liste.getSelectedRow(), 6).toString());
							else
							{
								ids_cpt = new int[nb];
								int index = 0;
								for( int i : self.liste.getSelectedRows() )
								{
									ids_cpt[index] = Integer.parseInt(self.liste.getValueAt(i, 6).toString());
									index++;
								}
							}
							cpt_query.close();
							self.dispose();
						}
					}});

		liste.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				if (e.getClickCount() == 2) {
					int nb;
					if( (nb = self.liste.getSelectedRowCount()) != 0 )
					{
						if(! multi )
							self.id_cpt = Integer.parseInt(self.liste.getValueAt(self.liste.getSelectedRow(), 6).toString());
						else
						{
							ids_cpt = new int[nb];
							int index = 0;
							for( int i : self.liste.getSelectedRows() )
							{
								ids_cpt[index] = Integer.parseInt(self.liste.getValueAt(i, 6).toString());
								index++;
							}
						}

						cpt_query.close();
						self.dispose();
					}
				}
			}
		});

		delete.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) 
					{
						if( self.liste.getSelectedRow() != -1 )
						{
							int reponse = JOptionPane.showConfirmDialog(
									self, rb.getString("mssgConfirmSupprCpt"),
									rb.getString("titreBoxConfirmSupprCpt"), 
									JOptionPane.YES_NO_OPTION);

							if(reponse == 0){
								cpt_query.delCpt(Integer.parseInt(liste.getValueAt(liste.getSelectedRow(), 6).toString()));
								((DefaultTableModel)liste.getModel()).setDataVector(cpt_query.get_data(), columnNames);
								methodeTri();
								setTableFormat();
							}
						}
						else {
							JOptionPane.showMessageDialog(self,
									rb.getString("mssgErrSelectionCpt"),
									rb.getString("titreBoxErrSelectionCpt"),
									JOptionPane.ERROR_MESSAGE);
						}
					}});
	}

	public void openConsult(String[] columnNames){
		consult = new Consultation_Comptage(locale, db_link);
		int nb;
		if( (nb = self.liste.getSelectedRowCount()) != 0 )
		{
			if(! multi )
				self.id_cpt = Integer.parseInt((String)self.liste.getValueAt(self.liste.getSelectedRow(), 6));
			else
			{
				ids_cpt = new int[nb];
				int index = 0;
				for( int i : self.liste.getSelectedRows() )
				{
					ids_cpt[index] = Integer.parseInt((String)self.liste.getValueAt(i, 6));
					index++;
				}
			}
			consult.setId(self.id_cpt);
			cpt_query.close();
			self.dispose();
			consult.toFront();
		}
		consult.dispose();
	}

	private void add_buttons(String[] columnNames)
	{
		
		JPanel all = new JPanel();
		JPanel label = new JPanel();
		label.setLayout(new BoxLayout(label, BoxLayout.LINE_AXIS));
		label.setBackground(new Color(192, 197, 199));
		label.setAlignmentX(Component.LEFT_ALIGNMENT);
		all.setLayout(new BoxLayout(all, BoxLayout.PAGE_AXIS));
		site_lbl.setAlignmentX(Component.LEFT_ALIGNMENT);

		label.add(site_lbl);
		if(multi)
		{
			label.add(Box.createHorizontalGlue());
			label.add(labelSelectMult);
		}

		all.add(Box.createVerticalStrut(5));
		all.add(label);
		name_filter.setMaximumSize(new Dimension(200,20));
		name_filter.setPreferredSize(new Dimension(200,20));
		st_filter.setMaximumSize(new Dimension(145,20));
		st_filter.setPreferredSize(new Dimension(145,20));
		st_filter.setEditable(false);


		JPanel buttons_pane = new JPanel();
		buttons_pane.setLayout(new BoxLayout(buttons_pane, BoxLayout.LINE_AXIS));
		buttons_pane.setAlignmentX(Component.LEFT_ALIGNMENT);
		open_entry.setPreferredSize(new Dimension(80,20));
		buttons_pane.setBackground(new Color(192, 197, 199));
		buttons_pane.add(name_filter);
		buttons_pane.add(Box.createHorizontalStrut(5));
		buttons_pane.add(st_filter);
		buttons_pane.add(Box.createHorizontalStrut(207));
		buttons_pane.add(Box.createHorizontalGlue());
		buttons_pane.add(open_entry);
		buttons_pane.add(Box.createHorizontalStrut(40));
		if(!multi){
			delete.setPreferredSize(new Dimension(20,20));
			buttons_pane.add(delete);
		}

		all.add(Box.createVerticalStrut(5));
		all.add(buttons_pane);


		DefaultTableModel model = new DefaultTableModel(){

			private static final long serialVersionUID = 1L;

			public boolean isCellEditable(int rowIndex, int columnIndex) {
				return false;
			}
		};

		liste = new JTable(model);
		((DefaultTableModel)this.liste.getModel()).setDataVector(cpt_query.get_data(), columnNames);

		liste.getTableHeader().setReorderingAllowed(false);
		if(multi)
			liste.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		else
			liste.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		liste.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		liste.getTableHeader().setResizingAllowed(true);
		
		// appel methode de mise en forme de la table
		setTableFormat();

		JScrollPane liste_scroll = new JScrollPane(liste, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, 
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		
		liste_scroll.setAlignmentX(Component.LEFT_ALIGNMENT);
		liste_scroll.setPreferredSize(new Dimension(700,600));
		all.add(Box.createVerticalStrut(5));
		all.add(liste_scroll);
		all.add(Box.createVerticalStrut(5));
		all.setBackground(new Color(192, 197, 199));	

		this.getContentPane().add(Box.createHorizontalStrut(5));
		this.getContentPane().add(all);
		this.getContentPane().add(Box.createHorizontalStrut(5));
		this.getContentPane().setBackground(new Color(192, 197, 199));

		liste.setAutoCreateRowSorter(true);
		methodeTri();
		
	}

	// Cration de la comparaison des champs de la table qui sont des entiers
	// pour permmettre le tri correct sur ces champs
	public class IntComparator implements Comparator<String> {

		@Override
		public int compare(String arg0, String arg1) {
			if(Integer.parseInt(arg0) < Integer.parseInt(arg1)) return -1;
			if(Integer.parseInt(arg0) > Integer.parseInt(arg1)) return 1;
			return 0;
		}
	}
	// cration de la fonction de tri sur les champs autres que string
	private void methodeTri(){
		TableRowSorter<TableModel> sorter = new TableRowSorter<TableModel>(liste.getModel());   
		liste.setRowSorter(sorter);
		sorter.setComparator(6, new IntComparator());
	}

	// mthode pour dfinir la taille prfre de la Jtable liste de comptages
	private void setTableFormat(){
		liste.getColumnModel().getColumn(0).setPreferredWidth(200);
		liste.getColumnModel().getColumn(1).setPreferredWidth(150);
		liste.getColumnModel().getColumn(liste.getColumnCount()-1).setPreferredWidth(49);
	}
	
	/**
	 * Traduction des textes de la fentre dans la bonne langue
	 * @param locale
	 */
	public void translate(Locale locale){
		
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		// nom de la fentre
		if( multi )
		{
			this.setTitle(rb.getString("comptageAExporter"));
			open_entry.setText(rb.getString("export"));
		}
		else
			this.setTitle(rb.getString("ouvrirComptage"));

		
		
		site_lbl.setText(rb.getString("rechercheParSite"));
		
		open_entry.setText(rb.getString("ouvrir"));
		
		
		labelSelectMult.setText(rb.getString("selectInterMultCptAExport"));
		
		//ragencement de la position des items de la fentre
		this.pack();
	}
	
	
}
