package IPLAC;


import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.JTable;

import Comptage.Ouvrir_Cpt;
import utils.Define;

public class Database {
	private Connection connection;
	private Statement query;
	private ResultSet rs;

	private Locale locale;
	private String db_link;

	public Database(Locale locale, String db_link) {
		this.locale = locale;
		this.db_link = db_link;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			String url = "jdbc:mysql://" + db_link + "/" + new Define().get_db_name();
			connection = DriverManager.getConnection(url,
					new Define().get_user(), new Define().get_pass());
			query = connection.createStatement();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public void export_dce(JTable tableauMCS, int indiceNull) {

		// pour la traduction des botes de dialogue et des colonnes
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);
		int[] ids = new Ouvrir_Cpt(null, true, locale, db_link).get_cpts();
		if (ids != null) {
					@SuppressWarnings("unused")
					String[] headers = { rb.getString("colNomSite"),
							rb.getString("colNomStation"),
							rb.getString("colDatePrel"),
							rb.getString("colTaxinomiste"),
							rb.getString("colCodeSandre"),
							rb.getString("colCodeTaxon"), rb.getString("colCf"),
							rb.getString("colNomTaxon"), rb.getString("colNomAuteur"), 
							rb.getString("colTypeObj"), rb.getString("col1NbMoyCell_ind"), 
							rb.getString("col1NbCel_ml"), rb.getString("col1NbInd_ml"), 
							rb.getString("col1Biovol_mm3_L")};
					try {
						String requete = "SELECT nom_lieu, nom_station, date_prelevement, nom_operateur, liste_taxa.code_sandre, "
								+ "ligne_cpt.code_taxon, cf, tous_codes_taxon.nom_taxon, all_auteurs.nom_auteur, type, ligne_cpt.nb_cell_moy_ind, "
								+ "(nb_cpt * surface_chambre * facteur_dillution) / (nb_champs * vol_sedimente * surface_champ) AS 'abondanceCell', "
								+ "(nb_cpt * surface_chambre * facteur_dillution) / (nb_champs * vol_sedimente * surface_champ) AS 'abondanceInd', "
								+ "ligne_cpt.biovol_calcule FROM (((ligne_cpt LEFT OUTER JOIN liste_taxa "
								+ "ON ligne_cpt.code_taxon = liste_taxa.code_taxon) LEFT OUTER JOIN liste_taxa_cpt "
								+ "ON ligne_cpt.code_taxon = liste_taxa_cpt.code_taxon) LEFT OUTER JOIN tous_codes_taxon "
								+ "ON ligne_cpt.code_taxon = tous_codes_taxon.code_taxon) NATURAL JOIN lieux NATURAL JOIN stations "
								+ "NATURAL JOIN comptage NATURAL JOIN echantillons NATURAL JOIN chambres JOIN (SELECT code_taxon, "
								+ "nom_auteur FROM liste_taxa NATURAL JOIN auteurs UNION SELECT code_taxon, nom_auteur "
								+ "FROM liste_taxa_cpt) AS all_auteurs ON ligne_cpt.code_taxon = all_auteurs.code_taxon "
								+ "JOIN (SELECT code_taxon, biovolcel, biovolind, 0 as vp FROM ligne_cpt NATURAL JOIN liste_taxa "
								+ "WHERE taxon_cpt = 0 UNION SELECT code_taxon, biovolcel, biovolind, "
								+ "IF(code_taxon LIKE 'NEW%', 0, 1) AS vp FROM liste_taxa_cpt) AS biovol "
								+ "ON ligne_cpt.code_taxon = biovol.code_taxon AND ligne_cpt.taxon_cpt = biovol.vp "
								+ "WHERE comptage.id_cpt IN (" + ids[0];

						for (int i = 1; i < ids.length; i++)
							requete += ", " + ids[i];
						requete += ") ORDER BY nom_lieu, nom_station, date_prelevement";

						rs = query.executeQuery(requete);
						
						while (rs.next()) {
							SimpleDateFormat date= new SimpleDateFormat("dd/MM/yyyy");
							SimpleDateFormat date2= new SimpleDateFormat("yyyy-MM-dd");
							
							try {
								Date test = date2.parse(rs.getString("date_prelevement"));
								
							
							tableauMCS.setValueAt(rs.getString("nom_lieu"), indiceNull, 0);
							tableauMCS.setValueAt(date.format(test), indiceNull, 1);
							} catch (ParseException e1) {
								e1.printStackTrace();
							}
							tableauMCS.setValueAt(rs.getString("code_taxon"), indiceNull, 2);
 
							// conversion des 0 et 1 en rien et Cf. pour affichage
							String cfValeur = rs.getString("cf");
							if (cfValeur.compareTo("0") == 0)
								tableauMCS.setValueAt("", indiceNull, 3);
							else if (cfValeur.compareTo("1") == 0)
								tableauMCS.setValueAt("Cf.", indiceNull, 3);
							
							tableauMCS.setValueAt(rs.getString("nom_taxon"), indiceNull, 4);
							tableauMCS.setValueAt(rs.getString("nom_auteur"), indiceNull, 5);
							tableauMCS.setValueAt(rs.getFloat("biovol_calcule"), indiceNull, 6);
							indiceNull+=1;
						}
					} catch (SQLException e) {
						e.printStackTrace();
					}
				}
				close();
			}
	private void close() {
		try {
			query.close();
			connection.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
}
