package IPLAC;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import utils.Define;

public class MCS_Query {
	private Connection connection = null;
	private Statement query = null;
	
	@SuppressWarnings("unused")
	private String db_link;
	
	public MCS_Query(String db_link)
	{
		this.db_link = db_link;
		
		try
		{
			// connexion  la base de donnes
			Class.forName("com.mysql.jdbc.Driver");
			String url = "jdbc:mysql://" + db_link + "/" + new Define().get_db_name();
			connection = DriverManager.getConnection(url, new Define().get_user(), new Define().get_pass());
			query = connection.createStatement();
		}
		catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * Remplit la table avec toutes les donnes des taxons de la base
	 * @param table JTable  remplir
	 */

	public void fill_table( JTable table, JTable table2 )
	{
		Object[] data = new Object[3];
		Object[] data2 = new Object[3];
		
		try 
		{
			ResultSet rs = query.executeQuery("SELECT code_sandre, code_taxon, nom_taxon, nom_auteur, indiv_defaut, "
					+ "biovolcel, biovolind, code_taxon_ref, "
					+ "(SELECT nom_forme FROM formes WHERE id_forme = id_forme_cel) AS cel, "
					+ "(SELECT nom_forme FROM formes WHERE id_forme = id_forme_ind) AS ind , "
					+ "cote_specifique, coef_stenoecie , trophie, slad_s, slad_v, "
					+ "regne, sous_regne, embranchement, classe, ordre, sous_ordre, famille, "
					+ "groupe_algual, code_omnidia, date_maj "
					+ "FROM liste_taxa "
					+ "NATURAL JOIN synonymes "
					+ "NATURAL JOIN auteurs "
					+ "NATURAL JOIN taxinomie "
					+ "WHERE cote_specifique != 'null' OR coef_stenoecie != 'null' "
					+ "ORDER BY nom_taxon");
			while( rs.next() )
			{
				// rcupration des donnes
				
				data[0] = rs.getString("cote_specifique");
				data[1] = rs.getString("coef_stenoecie");
				data[2] = rs.getString("code_taxon_ref");
				
				((DefaultTableModel)table.getModel()).addRow(data);
			}
			ResultSet rs2 = query.executeQuery("SELECT code_sandre, code_taxon, nom_taxon, nom_auteur, indiv_defaut, "
					+ "biovolcel, biovolind, code_taxon_ref, "
					+ "(SELECT nom_forme FROM formes WHERE id_forme = id_forme_cel) AS cel, "
					+ "(SELECT nom_forme FROM formes WHERE id_forme = id_forme_ind) AS ind , "
					+ "cote_specifique, coef_stenoecie , trophie, slad_s, slad_v, "
					+ "regne, sous_regne, embranchement, classe, ordre, sous_ordre, famille, "
					+ "groupe_algual, code_omnidia, date_maj "
					+ "FROM liste_taxa "
					+ "NATURAL JOIN synonymes "
					+ "NATURAL JOIN auteurs "
					+ "NATURAL JOIN taxinomie");
			while( rs2.next() )
			{
				data2[0] = rs2.getString("code_taxon");
				data2[1] = rs2.getString("code_taxon_ref");
				data2[2] = rs2.getString("embranchement");
				
				((DefaultTableModel)table2.getModel()).addRow(data2);
			}
		} 
		catch (SQLException e) { e.printStackTrace(); }
	}
	
	public String auteurTaxon(String codeTaxon)
	{
		try {
			ResultSet rs = query.executeQuery("SELECT nom_auteur FROM auteurs NATURAL JOIN liste_taxa WHERE code_taxon = '"+codeTaxon+"';");
			rs.next();
			return rs.getString("nom_auteur");
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return "";
	}
	
	public String get_last_date()
	{
		String returned = null;
		
		try
		{
			ResultSet rs = query.executeQuery("SELECT date_maj "
					+ "FROM liste_taxa "
					+ "ORDER BY date_maj DESC LIMIT 1");
			rs.next();
			returned = rs.getString(1);
		}
		catch( SQLException e) { e.printStackTrace(); }
		
		return returned;
	}
}