package Import_Export;

import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

@SuppressWarnings("serial")
public class Fields_Frame extends JDialog 
{
	
	@SuppressWarnings("unused")
	private Locale locale;
	
	private JList<String> chosen, all;
	
	private JButton up = new JButton("^"), 
					down = new JButton("v"), 
					left = new JButton("<-"), 
					right = new JButton("->"),
					ok = new JButton();
	
	private ArrayList<Integer> chosen_fields = null;
	private Fields_Frame self = null;
	private ArrayList<Object> arr = null;
	
	@SuppressWarnings("unused")
	private String[] champs = null;
	
	public Fields_Frame(boolean isCalcul, Locale locale)
	{	
		super();
		this.locale = locale;
		this.translate(locale);
		// pour la traductions de tous les champs
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		
		this.setModal(true);
		this.setLayout(new FlowLayout());
		JPanel up_down = new JPanel();
		self = this;
		
		arr = new ArrayList<Object>();
		
		DefaultListModel<String> m = new DefaultListModel<String>();
		
		if(isCalcul){
	
			String[] champs = {
					  rb.getString("colNumCalcul"), rb.getString("colNomSite"),
					  rb.getString("colNomStation"), rb.getString("colMilieu"),
					  rb.getString("colDate"), rb.getString("colRefEch"),
					  rb.getString("colTaxinomiste"),
					  rb.getString("colCommentaire"),
					  rb.getString("colCodeTaxon"),
					  rb.getString("colNomTaxon"),
					  rb.getString("colNomAuteur"),
					  rb.getString("colIndivDefaut"),
					  rb.getString("colCodeOMNIDIA"),
					  rb.getString("colDateMaJ"), rb.getString("colRegne"),
					  rb.getString("colSousRegne"),
					  rb.getString("colEmbranchement"),
					  rb.getString("colClasse"), rb.getString("colOrdre"),
					  rb.getString("colSousOrdre"), rb.getString("colFamille"),
					  rb.getString("colCodeSandre"),
					  rb.getString("colBioVolCel"),
					  rb.getString("colBioVolIn"), rb.getString("colGrpAlgal"),
					  rb.getString("colCoefSteno"),
					  rb.getString("colCoteSpec"), rb.getString("colSladV"),
					  rb.getString("colTrophie"), rb.getString("colSladS"),
					  rb.getString("colIndivChoisi"), rb.getString("colForme"),
					  rb.getString("colBioVolMoy"),
					  rb.getString("colBioVolMax"),
					  rb.getString("colBioVolMin"),
					  rb.getString("colNbCellMoy") };
			
			addChampsInArr(champs);
			
			addChampsInM(champs, m);
			
		}
			
		else {

			String[] champs = { rb.getString("colNomSite"),
					rb.getString("colNomStation"), rb.getString("colMilieu"),
					rb.getString("colDatePrel"), rb.getString("colRefEch"),
					rb.getString("colDateCpt"), rb.getString("colTaxinomiste"),
					rb.getString("colCommentaire"), rb.getString("colNomChambre"),
					rb.getString("colCodeTaxon"), rb.getString("colNomTaxon"),
					rb.getString("colCodeTaxonRef"),
					rb.getString("colNomTaxonRef"),

					rb.getString("colNomAuteur"), rb.getString("colIndivDefaut"),
					rb.getString("colCodeOMNIDIA"), rb.getString("colDateMaJ"),
					rb.getString("colCreateur"), rb.getString("colRegne"),
					rb.getString("colSousRegne"), rb.getString("colEmbranchement"),
					rb.getString("colClasse"), rb.getString("colOrdre"),
					rb.getString("colSousOrdre"), rb.getString("colFamille"),

					rb.getString("colTypeCpt"), rb.getString("colNbChamps"),
					rb.getString("colNbIndivTotal"), rb.getString("colCodeSandre"),
					rb.getString("colBioVolCel"), rb.getString("colBioVolIn"),
					rb.getString("colGrpAlgal"), rb.getString("colCoefSteno"),
					rb.getString("colCoteSpec"), rb.getString("colNumCpt"),
					rb.getString("colSladV"), rb.getString("colCf"),
					rb.getString("colNbCpt"), rb.getString("colValeurPerso"),
					rb.getString("colVolSed"), rb.getString("colFactDilu"),
					rb.getString("colTrophie"), rb.getString("colSladS"),
					rb.getString("col1Biovol_mm3_L"), 
					rb.getString("col1NbMoyCell_ind"), 
					rb.getString("col1NbInd_ml"), rb.getString("col1NbCel_ml")};
			
			addChampsInArr(champs);
			
			addChampsInM(champs, m);

		}
		
		up_down.setLayout(new BoxLayout(up_down, BoxLayout.PAGE_AXIS));
		up_down.add(up);
		up_down.add(down);
		
		chosen = new JList<String>(new DefaultListModel<String>());
		JScrollPane chosen_pane = new JScrollPane(chosen);
		
		JPanel left_right = new JPanel();
		left_right.setLayout(new BoxLayout(left_right, BoxLayout.LINE_AXIS));
		left_right.add(left);
		left_right.add(right);
		left_right.setAlignmentX(Component.LEFT_ALIGNMENT);
		JPanel export = new JPanel();
		export.setLayout(new BoxLayout(export, BoxLayout.PAGE_AXIS));
		export.setAlignmentX(Component.LEFT_ALIGNMENT);
		export.add(left_right);
		export.add(Box.createVerticalStrut(20));
		ok.setAlignmentX(Component.LEFT_ALIGNMENT);
		export.add(ok);
		
		
		all = new JList<String>(m);
		JScrollPane all_pane = new JScrollPane(all);
		
		this.add(all_pane);
		this.add(export);
		this.add(chosen_pane);
		this.add(up_down);
		
		chosen_pane.setPreferredSize(all_pane.getPreferredSize());
		
		add_handlers();
		
		this.pack();
		this.setLocation(100, 100);
		this.setResizable(false);
		this.setVisible(true);
	}

	public ArrayList<Integer> get_fields()
	{
		return chosen_fields;
	}
	
	private void add_handlers() 
	{
		right.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e)
					{
						int[] selected = all.getSelectedIndices();
						int nb_elem = ((DefaultListModel<String>)chosen.getModel()).size();
						
						for(int i = selected.length - 1; i > -1; i--)
						{
							((DefaultListModel<String>)chosen.getModel()).add(nb_elem, 
								((DefaultListModel<String>)all.getModel()).elementAt(selected[i]));
							
							((DefaultListModel<String>)all.getModel()).removeElementAt(selected[i]);
						}
					}});
		
		left.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e)
					{
						int[] selected = chosen.getSelectedIndices();
						
						for(int i = selected.length - 1; i > -1; i--)
						{
							((DefaultListModel<String>)all.getModel()).addElement(((DefaultListModel<String>)chosen.getModel()).elementAt(selected[i]));
							((DefaultListModel<String>)chosen.getModel()).removeElementAt(selected[i]);
						}
					}});
		
		up.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e)
					{
						int selected = chosen.getSelectedIndex();
						if( selected > 0 )
						{
							((DefaultListModel<String>)chosen.getModel()).add(selected -1, 
									((DefaultListModel<String>)chosen.getModel()).elementAt(selected));
							((DefaultListModel<String>)chosen.getModel()).removeElementAt(selected + 1);
							chosen.setSelectedIndex(selected - 1);
						}
					}});
		
		down.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e)
					{
						int selected = chosen.getSelectedIndex();
						if( selected != -1 && selected != ((DefaultListModel<String>)chosen.getModel()).size() - 1)
						{
							((DefaultListModel<String>)chosen.getModel()).add(selected + 2, 
									((DefaultListModel<String>)chosen.getModel()).elementAt(selected));
							((DefaultListModel<String>)chosen.getModel()).removeElementAt(selected);
							chosen.setSelectedIndex(selected + 1);
						}		
					}});
		
		ok.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e)
					{
						Object[] out = ((DefaultListModel<String>)chosen.getModel()).toArray();
						chosen_fields = new ArrayList<Integer>();
						for( int i = 0; i < out.length; i++ )
							chosen_fields.add(arr.indexOf(out[i]));
						self.dispose();
					}});
	}
	
	/**
	 * Traduction dans la bonne langue des textes
	 * @param locale
	 */
	public void translate(Locale locale){
		this.locale = locale;
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
		
		// nom de la fentre
		this.setTitle(rb.getString("titreFenSelectChamps"));
		
		ok.setText(rb.getString("exporter"));
		
		
		//ragencement de la position des items de la fentre
		this.pack();
	}
	
	
	public void addChampsInArr(String[] champs){
		for( String s : champs )
			arr.add(s);
	}
	
	public void addChampsInM(String[] champs,  DefaultListModel<String> m ){
		for( String s : champs )
			m.addElement(s);
	}
	
}
