package Import_Export;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

import utils.Define;
import Comptage.Ouvrir_Cpt;
import Menus.Main_Menu_Frame;

public class Import_Exporter {


	private Connection connection;
	private Statement query;
	private ResultSet rs;

	private Locale locale;
	private String db_link;
	
	//cration du chemin du dossier paramtres
	private String pathParam = new String("Parametres");

	public Import_Exporter(Locale locale, String db_link) {
		this.locale = locale;
		this.db_link = db_link;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			String url = "jdbc:mysql://" + db_link + "/" + new Define().get_db_name();
			connection = DriverManager.getConnection(url,
					new Define().get_user(), new Define().get_pass());
			query = connection.createStatement();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Exporte des calculs donns au format prdfini (DCE)
	 * @param ids
	 */
	@SuppressWarnings("static-access")
	public void export_dce_calcul(int ids[]) {
		// pour la traduction des botes de dialogue et colonnes
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);

		if (ids != null) {

			JFileChooser fc = new JFileChooser();
			fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			fc.setMultiSelectionEnabled(false);

			if (fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {

				String exported_file_name = rb.getString("nomFicExpDCECalcDef") + 
						new SimpleDateFormat("_yy-MM-dd" + "_HH.mm.ss").format(new java.util.Date());

				// affichage d'une bote de dialogue pour la validation/modification du nom du fichier
				JOptionPane jop = new JOptionPane();					 
				exported_file_name = jop.showInputDialog( rb.getString("mssgChoixNomFichierExport"), 
						exported_file_name) + ".csv";

				File f = new File(fc.getSelectedFile().getAbsolutePath() + File.separator + exported_file_name);


				if (f.exists())
					new JOptionPane().showMessageDialog(null,
							rb.getString("mssgFichierDejaExisant"),
							rb.getString("titreBoxFichierDejaExistant"),
							JOptionPane.ERROR_MESSAGE);
				else {

					String[] headers = { rb.getString("colNumLigne"),
							rb.getString("colCodeTaxon"),
							rb.getString("colNomTaxon"),
							rb.getString("colNomAuteur"),
							rb.getString("colTaxinomiste"),
							rb.getString("colObjet"), rb.getString("colForme"),
							rb.getString("colSite"),
							rb.getString("colStation"),
							rb.getString("colDate"), rb.getString("colRefEch"),
							rb.getString("colBioVolMoy"),
							rb.getString("colBioVolMax"),
							rb.getString("colBioVolMin"),
							rb.getString("colNbCellMoy"),
							rb.getString("colBioVol"), "d", "d1", "d2", "d3",
							"d4", "l", "h", "h1", "h2", "h3", "h4", "w",
							rb.getString("colNbCell"),
							rb.getString("colNbBras"), };

					try {
						BufferedWriter writer = new BufferedWriter(
								new FileWriter(f));
						String[] line = new String[30];
						String toWrite = "";

						for (int i = 0; i < headers.length; i++)
							toWrite += headers[i] + ";";
						writer.write(toWrite);
						writer.newLine();

						String requete = "SELECT ligne_calcul.id_ligne, calcul_biovol.code_taxon, "
								+ "(select nom_taxon FROM tous_codes_taxon WHERE calcul_biovol.code_taxon = tous_codes_taxon.code_taxon) as nom_taxon, "
								+ "all_auteurs.nom_auteur, "
								+ "calcul_biovol.nom_operateur, calcul_biovol.type, "
								+ "(SELECT nom_forme FROM formes WHERE formes.id_forme = calcul_biovol.id_forme_choisie) AS name_forme, "
								+ "(SELECT nom_station from stations where stations.id_station = calcul_biovol.id_station) AS nom_station, "
								+ "(SELECT id_lieu from stations where id_station = calcul_biovol.id_station) AS id_lieuu, "
								+ "(SELECT lieux.nom_lieu from lieux where lieux.id_lieu = id_lieuu) AS nom_lieu, calcul_biovol.date, "
								+ "calcul_biovol.ref_etude, biovol_moy, biovol_max, biovol_min, nb_cellule_moy, biovol_objet, d, d1, d2, d3, d4, l, h, h1, h2, h3, h4, w, nb_cellule, nb_epine "
								+ "from calcul_biovol left outer join ligne_calcul on ligne_calcul.id_calcul= calcul_biovol.id_calcul "
								+ "left outer join (SELECT code_taxon, nom_auteur FROM liste_taxa NATURAL JOIN auteurs UNION SELECT code_taxon, nom_auteur "
								+ "FROM liste_taxa_cpt) AS all_auteurs on calcul_biovol.code_taxon= all_auteurs.code_taxon "
								+ "where calcul_biovol.id_calcul in  ("
								+ ids[0];

						for (int i = 1; i < ids.length; i++)
							requete += ", " + ids[i];

						requete += ") ORDER BY calcul_biovol.id_calcul, ligne_calcul.id_ligne";

						rs = query.executeQuery(requete);

						while (rs.next()) {
							toWrite = "";

							line[0] = Integer.toString(rs.getInt("id_ligne"));
							line[1] = rs.getString("code_taxon");
							line[2] = rs.getString("nom_taxon");
							line[3] = rs.getString("nom_auteur");
							line[4] = rs.getString("nom_operateur");
							line[5] = rs.getString("type");
							line[6] = rs.getString("name_forme");
							line[8] = rs.getString("nom_station");
							line[7] = rs.getString("nom_lieu");
							line[9] = rs.getString("date");
							line[10] = rs.getString("ref_etude");
							line[11] = Float
									.toString(rs.getFloat("biovol_moy"));
							line[12] = Float
									.toString(rs.getFloat("biovol_max"));
							line[13] = Float
									.toString(rs.getFloat("biovol_min"));
							line[14] = Float.toString(rs
									.getFloat("nb_cellule_moy"));
							line[15] = Float.toString(rs
									.getFloat("biovol_objet"));
							line[16] = Float.toString(rs.getFloat("d"));
							line[17] = Float.toString(rs.getFloat("d1"));
							line[18] = Float.toString(rs.getFloat("d2"));
							line[19] = Float.toString(rs.getFloat("d3"));
							line[20] = Float.toString(rs.getFloat("d4"));
							line[21] = Float.toString(rs.getFloat("l"));
							line[22] = Float.toString(rs.getFloat("h"));
							line[23] = Float.toString(rs.getFloat("h1"));
							line[24] = Float.toString(rs.getFloat("h2"));
							line[25] = Float.toString(rs.getFloat("h3"));
							line[26] = Float.toString(rs.getFloat("h4"));
							line[27] = Float.toString(rs.getFloat("w"));
							line[28] = Integer
									.toString(rs.getInt("nb_cellule"));
							line[29] = Integer.toString(rs.getInt("nb_epine"));

							for (int i = 16; i <= 29; i++) {
								if (line[i].compareTo("0.0") == 0
										|| line[i].compareTo("0") == 0)
									line[i] = "/";
							}
							if (line[14].compareTo("0.0") == 0)
								line[14] = "";

							for (int i = 0; i < line.length; i++) {
								if (line[i] == null)
									line[i] = "";
								toWrite += line[i] + ";";
							}
							writer.write(toWrite);
							writer.newLine();
						}
						writer.close();
						new JOptionPane().showMessageDialog(
								null,
								rb.getString("mssgExportEffectue")
								+ f.getAbsolutePath(),
								rb.getString("titreBoxExportEffectue"),
								JOptionPane.INFORMATION_MESSAGE);

					} catch (SQLException e) {
						e.printStackTrace();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				close();
			}
		}
	}

	/**
	 * Permet  un utilisateur de choisir les champs qu'il souhaite exporter pour les calculs qu'il a choisi
	 * @param ids
	 */
	@SuppressWarnings("static-access")
	public void export_libre_calcul(int ids[]) {
		// pour la traduction des botes de dialogue et colonnes
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);

		if (ids != null) {
			JFileChooser fc = new JFileChooser();
			fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			fc.setMultiSelectionEnabled(false);

			if (fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {

				String exported_file_name = rb.getString("nomFicExpLibreCalcDef") + 
						new SimpleDateFormat("_yy-MM-dd" + "_HH.mm.ss").format(new java.util.Date());

				// affichage d'une bote de dialogue pour la validation/modification du nom du fichier
				JOptionPane jop = new JOptionPane();					 
				exported_file_name = jop.showInputDialog( rb.getString("mssgChoixNomFichierExport"), 
						exported_file_name) + ".csv";

				File f = new File(fc.getSelectedFile().getAbsolutePath() + File.separator + exported_file_name);


				if (f.exists())
					new JOptionPane().showMessageDialog(null,
							rb.getString("mssgFichierDejaExisant"),
							rb.getString("titreBoxFichierDejaExistant"),
							JOptionPane.ERROR_MESSAGE);
				else {

					Vector<String> champs_all = new Vector<String>(
							Arrays.asList(rb.getString("colNumCalcul"),
									rb.getString("colNomSite"),
									rb.getString("colNomStation"),
									rb.getString("colMilieu"),
									rb.getString("colDate"),
									rb.getString("colRefEch"),
									rb.getString("colTaxinomiste"),
									rb.getString("colCommentaire"),
									rb.getString("colCodeTaxon"),
									rb.getString("colNomTaxon"),
									rb.getString("colNomAuteur"),
									rb.getString("colIndivDefaut"),
									rb.getString("colCodeOMNIDIA"),
									rb.getString("colDateMaJ"),
									rb.getString("colRegne"),
									rb.getString("colSousRegne"),
									rb.getString("colEmbranchement"),
									rb.getString("colClasse"),
									rb.getString("colOrdre"),
									rb.getString("colSousOrdre"),
									rb.getString("colFamille"),
									rb.getString("colCodeSandre"),
									rb.getString("colBioVolCel"),
									rb.getString("colBioVolIn"),
									rb.getString("colGrpAlgal"),
									rb.getString("colCoefSteno"),
									rb.getString("colCoteSpec"),
									rb.getString("colSladV"),
									rb.getString("colTrophie"),
									rb.getString("colSladS"),
									rb.getString("colIndivChoisi"),
									rb.getString("colForme"),
									rb.getString("colBioVolMoy"),
									rb.getString("colBioVolMax"),
									rb.getString("colBioVolMin"),
									rb.getString("colNbCellMoy"),
									rb.getString("colBioVol"), "d", "d1", "d2",
									"d3", "d4", "l", "h", "h1", "h2", "h3",
									"h4", "w", rb.getString("colNbCell"),
									rb.getString("colNbBras")));

					try {
						ArrayList<Integer> fields = new Fields_Frame(true,
								locale).get_fields();

						System.out.println(fields);

						Vector<String> champs_final = new Vector<String>();

						BufferedWriter writer = new BufferedWriter(
								new FileWriter(f));
						String toWrite = "";

						for (int i = 0; i < fields.size(); i++) {
							champs_final.add(champs_all.get(fields.get(i)));
						}

						for (int i = 36; i < champs_all.size(); i++) {
							champs_final.add(champs_all.get(i));
						}

						System.out.println(champs_final);

						for (int i = 0; i < champs_final.size(); i++)
							toWrite += champs_final.get(i) + ";";
						writer.write(toWrite);
						writer.newLine();

						String[] line = new String[51];

						String requete = "SELECT calcul_biovol.id_calcul, ligne_calcul.id_ligne, calcul_biovol.code_taxon, "
								+ "(SELECT nom_taxon FROM tous_codes_taxon WHERE calcul_biovol.code_taxon = tous_codes_taxon.code_taxon) AS nom_taxon,"
								+ "(SELECT indiv_defaut FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS indiv_defaut,"
								+ "(SELECT code_omnidia FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS code_omnidia,"
								+ "(SELECT date_maj FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS date_maj,"

								+ "(SELECT id_taxinomie FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS id_taxi,"
								+ "(SELECT regne FROM taxinomie WHERE taxinomie.id_taxinomie = id_taxi) AS regne,"
								+ "(SELECT sous_regne FROM taxinomie WHERE taxinomie.id_taxinomie = id_taxi) AS sous_regne,"							
								+ "(SELECT embranchement FROM tous_embranchements WHERE calcul_biovol.code_taxon = tous_embranchements.code_taxon) AS embranchement,"
								+ "(SELECT classe FROM taxinomie WHERE taxinomie.id_taxinomie = id_taxi) AS classe,"
								+ "(SELECT ordre FROM taxinomie WHERE taxinomie.id_taxinomie = id_taxi) AS ordre,"
								+ "(SELECT sous_ordre FROM taxinomie WHERE taxinomie.id_taxinomie = id_taxi) AS sous_ordre,"
								+ "(SELECT famille FROM taxinomie WHERE taxinomie.id_taxinomie = id_taxi) AS famille,"

								+ "(SELECT code_sandre FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS code_sandre,"
								+ "(SELECT biovolcel FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS biovolcel,"
								+ "(SELECT biovolind FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS biovolind,"
								+ "(SELECT groupe_algual FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS groupe_algual,"
								+ "(SELECT coef_stenoecie FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS coef_stenoecie,"
								+ "(SELECT cote_specifique FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS cote_specifique,"
								+ "(SELECT slad_v FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS slad_v,"
								+ "(SELECT trophie FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS trophie,"
								+ "(SELECT slad_s FROM liste_taxa WHERE calcul_biovol.code_taxon = liste_taxa.code_taxon) AS slad_s"
								+ ", all_auteurs.nom_auteur, "
								+ "calcul_biovol.nom_operateur, calcul_biovol.commentaire, calcul_biovol.type, (SELECT nom_forme FROM formes "
								+ "WHERE formes.id_forme = calcul_biovol.id_forme_choisie) AS name_forme, "
								+ "(SELECT nom_station from stations where stations.id_station = calcul_biovol.id_station) AS nom_station, "
								+ "(SELECT id_lieu from stations where id_station = calcul_biovol.id_station) AS id_lieuu, "
								+ "(SELECT lieux.nom_lieu from lieux where lieux.id_lieu = id_lieuu) AS nom_lieu,"
								+ "(SELECT milieu from stations where stations.id_station = calcul_biovol.id_station) AS milieu"
								+ ", calcul_biovol.date, calcul_biovol.ref_etude, biovol_moy, biovol_max, biovol_min, nb_cellule_moy, biovol_objet, d, "
								+ "d1, d2, d3, d4, l, h, h1, h2, h3, h4, w, nb_cellule, nb_epine"
								+ " FROM calcul_biovol NATURAL JOIN ligne_calcul "
								+ "left outer join (SELECT code_taxon, nom_auteur FROM liste_taxa NATURAL JOIN auteurs "
								+ "UNION SELECT code_taxon, nom_auteur FROM liste_taxa_cpt) AS all_auteurs on calcul_biovol.code_taxon = all_auteurs.code_taxon "
								+ "WHERE calcul_biovol.id_calcul IN (" + ids[0];

						for (int i = 1; i < ids.length; i++)
							requete += ", " + ids[i];
						requete += ") ORDER BY id_calcul, id_ligne";

						rs = query.executeQuery(requete);

						while (rs.next()) {
							toWrite = "";

							line[0] = Integer.toString(rs.getInt("id_calcul"));
							line[1] = rs.getString("nom_lieu");
							line[2] = rs.getString("nom_station");
							line[3] = rs.getString("milieu");
							line[4] = rs.getString("date");
							line[5] = rs.getString("ref_etude");
							line[6] = rs.getString("nom_operateur");
							line[7] = rs.getString("commentaire");
							line[8] = rs.getString("code_taxon");
							line[9] = rs.getString("nom_taxon");
							line[10] = rs.getString("nom_auteur");
							line[11] = rs.getString("indiv_defaut");
							line[12] = rs.getString("code_omnidia");
							line[13] = rs.getString("date_maj");
							line[14] = rs.getString("regne");
							line[15] = rs.getString("sous_regne");
							line[16] = rs.getString("embranchement");
							line[17] = rs.getString("classe");
							line[18] = rs.getString("ordre");
							line[19] = rs.getString("sous_ordre");
							line[20] = rs.getString("famille");
							line[21] = rs.getString("code_sandre");

							line[22] = Float.toString(rs.getFloat("biovolcel"));
							line[23] = Float.toString(rs.getFloat("biovolind"));
							line[24] = rs.getString("groupe_algual");
							line[25] = Float.toString(rs
									.getFloat("coef_stenoecie"));
							line[26] = Float.toString(rs
									.getFloat("cote_specifique"));
							line[27] = Integer.toString(rs.getInt("slad_v"));
							line[28] = Float.toString(rs.getFloat("trophie"));
							line[29] = Float.toString(rs.getFloat("slad_s"));
							line[30] = rs.getString("type");
							line[31] = rs.getString("name_forme");
							line[32] = Float
									.toString(rs.getFloat("biovol_moy"));
							line[33] = Float
									.toString(rs.getFloat("biovol_max"));
							line[34] = Float
									.toString(rs.getFloat("biovol_min"));
							line[35] = Float.toString(rs
									.getFloat("nb_cellule_moy"));
							line[36] = Float.toString(rs
									.getFloat("biovol_objet"));
							line[37] = Float.toString(rs.getFloat("d"));
							line[38] = Float.toString(rs.getFloat("d1"));
							line[39] = Float.toString(rs.getFloat("d2"));
							line[40] = Float.toString(rs.getFloat("d3"));
							line[41] = Float.toString(rs.getFloat("d4"));

							line[42] = Float.toString(rs.getFloat("l"));
							line[43] = Float.toString(rs.getFloat("h"));
							line[44] = Float.toString(rs.getFloat("h1"));
							line[45] = Float.toString(rs.getFloat("h2"));
							line[46] = Float.toString(rs.getFloat("h3"));
							line[47] = Float.toString(rs.getFloat("h4"));
							line[48] = Float.toString(rs.getFloat("w"));
							line[49] = Integer
									.toString(rs.getInt("nb_cellule"));
							line[50] = Integer.toString(rs.getInt("nb_epine"));

							for (int i = 22; i < 24; i++) {
								if (line[i].compareTo("0.0") == 0
										|| line[i].compareTo("0") == 0)
									line[i] = "";
							}
							for (int i = 25; i < 30; i++) {
								if (line[i].compareTo("0.0") == 0
										|| line[i].compareTo("0") == 0)
									line[i] = "";
							}
							if (line[35].compareTo("0.0") == 0)
								line[35] = "";

							for (int i = 37; i <= 50; i++) {
								if (line[i].compareTo("0.0") == 0
										|| line[i].compareTo("0") == 0)
									line[i] = "/";
							}

							Vector<String> line_final = new Vector<String>();

							for (int i = 0; i < fields.size(); i++) {
								line_final.add(line[fields.get(i)]);
							}

							for (int i = 36; i <= 50; i++) {
								line_final.add(line[i]);
							}

							System.out.println(line_final);

							for (int i = 0; i < line_final.size(); i++) {
								if (line_final.get(i) == null)
									line_final.setElementAt("", i);
								toWrite += line_final.get(i) + ";";
							}
							writer.write(toWrite);
							writer.newLine();
						}
						writer.close();
						new JOptionPane().showMessageDialog(
								null,
								rb.getString("mssgExportEffectue")
								+ f.getAbsolutePath(),
								rb.getString("titreBoxExportEffectue"),
								JOptionPane.INFORMATION_MESSAGE);
					} catch (SQLException e) {
						e.printStackTrace();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				close();
			}
		}
	}

	/**
	 * Fait choisir les comptages  exporter, puis les exporte au format de la DCE
	 */
	@SuppressWarnings("static-access")
	public void export_dce() {

		// pour la traduction des botes de dialogue et des colonnes
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);

		int[] ids = new Ouvrir_Cpt(null, true, locale, db_link).get_cpts();
		if (ids != null) {
			JFileChooser fc = new JFileChooser();
			fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			fc.setMultiSelectionEnabled(false);

			if (fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {

				String exported_file_name = rb.getString("nomFichierExportDCECptDefaut") + 
						new SimpleDateFormat("_yy-MM-dd" + "_HH.mm.ss").format(new java.util.Date());

				// affichage d'une bote de dialogue pour la validation/modification du nom du fichier
				JOptionPane jop = new JOptionPane();					 
				exported_file_name = jop.showInputDialog( rb.getString("mssgChoixNomFichierExport"), 
						exported_file_name) + ".csv";

				File f = new File(fc.getSelectedFile().getAbsolutePath() + File.separator + exported_file_name);


				if (f.exists())
					new JOptionPane().showMessageDialog(null,
							rb.getString("mssgFichierDejaExisant"),
							rb.getString("titreBoxFichierDejaExistant"),
							JOptionPane.ERROR_MESSAGE);
				else {

					String[] headers = { rb.getString("colNomSite"),
							rb.getString("colNomStation"),
							rb.getString("colDatePrel"),
							rb.getString("colTaxinomiste"),
							rb.getString("colCodeSandre"),
							rb.getString("colCodeTaxon"), rb.getString("colCf"),
							rb.getString("colNomTaxon"), rb.getString("colNomAuteur"), 
							rb.getString("colTypeObj"), rb.getString("col1NbMoyCell_ind"), 
							rb.getString("col1NbCel_ml"), rb.getString("col1NbInd_ml"), 
							rb.getString("col1Biovol_mm3_L")};


					try {
						BufferedWriter writer = new BufferedWriter(
								new FileWriter(f));
						String[] line = new String[14];
						String toWrite = "";

						/*
						 //**********************************************************
						 //* Formattage des valeurs dans l'export BDD d'un comptage *
						 //**********************************************************
						 DecimalFormat df2 = (DecimalFormat) DecimalFormat
								.getNumberInstance();
						df2.applyPattern("0.00");

						DecimalFormat df4 = (DecimalFormat) DecimalFormat
								.getNumberInstance();
						df4.applyPattern("0.00000");


						DecimalFormatSymbols symbols = new DecimalFormatSymbols();
						symbols.setDecimalSeparator('.');
						df2.setDecimalFormatSymbols(symbols);
						df4.setDecimalFormatSymbols(symbols);

						// voir jusqu' la ligne 660 pour les appel de ces formatteurs ".format"
						//**********************************************************/

						for (int i = 0; i < headers.length; i++)
							toWrite += headers[i] + ";";
						writer.write(toWrite);
						writer.newLine();

						String requete = "SELECT nom_lieu, nom_station, date_prelevement, nom_operateur, liste_taxa.code_sandre, "
								+ "ligne_cpt.code_taxon, cf, tous_codes_taxon.nom_taxon, all_auteurs.nom_auteur, type, ligne_cpt.nb_cell_moy_ind, "
								+ "(nb_cpt * surface_chambre * facteur_dillution) / (nb_champs * vol_sedimente * surface_champ) AS 'abondanceCell', "
								+ "(nb_cpt * surface_chambre * facteur_dillution) / (nb_champs * vol_sedimente * surface_champ) AS 'abondanceInd', "
								+ "ligne_cpt.biovol_calcule FROM (((ligne_cpt LEFT OUTER JOIN liste_taxa "
								+ "ON ligne_cpt.code_taxon = liste_taxa.code_taxon) LEFT OUTER JOIN liste_taxa_cpt "
								+ "ON ligne_cpt.code_taxon = liste_taxa_cpt.code_taxon) LEFT OUTER JOIN tous_codes_taxon "
								+ "ON ligne_cpt.code_taxon = tous_codes_taxon.code_taxon) NATURAL JOIN lieux NATURAL JOIN stations "
								+ "NATURAL JOIN comptage NATURAL JOIN echantillons NATURAL JOIN chambres JOIN (SELECT code_taxon, "
								+ "nom_auteur FROM liste_taxa NATURAL JOIN auteurs UNION SELECT code_taxon, nom_auteur "
								+ "FROM liste_taxa_cpt) AS all_auteurs ON ligne_cpt.code_taxon = all_auteurs.code_taxon "
								+ "JOIN (SELECT code_taxon, biovolcel, biovolind, 0 as vp FROM ligne_cpt NATURAL JOIN liste_taxa "
								+ "WHERE taxon_cpt = 0 UNION SELECT code_taxon, biovolcel, biovolind, "
								+ "IF(code_taxon LIKE 'NEW%', 0, 1) AS vp FROM liste_taxa_cpt) AS biovol "
								+ "ON ligne_cpt.code_taxon = biovol.code_taxon AND ligne_cpt.taxon_cpt = biovol.vp "
								+ "WHERE comptage.id_cpt IN (" + ids[0];

						for (int i = 1; i < ids.length; i++)
							requete += ", " + ids[i];
						requete += ") ORDER BY nom_lieu, nom_station, date_prelevement";

						rs = query.executeQuery(requete);

						while (rs.next()) {
							toWrite = "";
							line[0] = rs.getString("nom_lieu");
							line[1] = rs.getString("nom_station");
							line[2] = rs.getString("date_prelevement");
							line[3] = rs.getString("nom_operateur");
							Object sandre = rs.getObject("code_sandre");
							if (sandre == null)
								line[4] = "";
							else
								line[4] = Integer.toString((Integer) sandre);

							line[5] = rs.getString("code_taxon");
							line[6] = Integer.toString(rs.getInt("cf"));
							line[7] = rs.getString("nom_taxon");
							line[8] = rs.getString("nom_auteur");

							String typeCpt = rs.getString("type");
							line[9] =typeCpt;

							Integer nbMoyCellInd = rs.getInt("nb_cell_moy_ind");
							line[10] = nbMoyCellInd.toString();

							// calculs des abondances :
							// abondance en cellules						
							Float abondCell = rs.getFloat("abondanceCell");
							// si le taxon a t compt en cellules
							if(typeCpt.equals("Cel.")){
								// alors, l'abondance est la mme
								line[11] = abondCell.toString();//df2.format(abondCell).toString();
							}
							// sinon, on doit multiplier cette abondance par le nb moy cell/ind s'il est connu
							else if (nbMoyCellInd != 0) {
								Float newAbondCell = abondCell * nbMoyCellInd;
								line[11] = newAbondCell.toString();//df2.format(newAbondCell).toString();
							}
							else
								line[11] = "";

							// abondance en individu
							Float abondInd = rs.getFloat("abondanceInd");

							// s'il a t compt en cellules
							if(typeCpt.equals("Cel.")){
								// si on connait le nombre moyen de cell/ind
								if(nbMoyCellInd != 0){
									// alors on doit diviser cette abondance par le nb moy cell/ind
									Float newAbondInd = abondInd/nbMoyCellInd;
									line[12] = newAbondInd.toString();//df2.format(newAbondInd).toString();
								}
								// sinon, on ne peut pas avoir l'abondance individuelle
								else
									line[12] = "";
							}
							// sinon, l'abondance ne change pas
							else
								line[12] = abondInd.toString();//df2.format(abondInd).toString();


							// biovolume total
							Float bv_calc = (rs.getFloat("biovol_calcule"));
							line[13] = bv_calc.toString();//df4.format(rs.getFloat("biovol_calcule")).toString();


							// gestion des valeurs  ne pas afficher :

							if (line[6].compareTo("0") == 0)
								line[6] = "";
							else if (line[6].compareTo("1") == 0)
								line[6] = "Cf.";

							if(line[10].equals("0"))
								line[10] = "";


							if (line[13].compareTo("0.0") == 0 || line[13].compareTo("0.00000") == 0)
								line[13] = "";


							for (int i = 0; i < line.length; i++) {
								if (line[i] == null)
									line[i] = "";
								toWrite += line[i] + ";";
							}

							writer.write(toWrite);
							writer.newLine();
						}
						writer.close();
						new JOptionPane().showMessageDialog(
								null,
								rb.getString("mssgExportEffectue")
								+ f.getAbsolutePath(),
								rb.getString("titreBoxExportEffectue"),
								JOptionPane.INFORMATION_MESSAGE);
					} catch (SQLException e) {
						e.printStackTrace();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				close();
			}
		}
	}

	/**
	 * Remplace la BD existante par une nouvelle
	 */
	@SuppressWarnings("static-access")
	public void import_base() {
		// pour la traduction des botes de dialogue
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);

		close();
		FileFilter ff = new FileFilter() {
			public boolean accept(File pathname) {
				if (pathname.getAbsolutePath().endsWith(".sql")
						|| pathname.isDirectory())
					return true;
				return false;
			}

			public String getDescription() {
				return "Fichiers SQL";
			}
		};

		JFileChooser f = new JFileChooser();
		f.setFileFilter((FileFilter) ff);
		f.setFileSelectionMode(JFileChooser.FILES_ONLY);
		f.setMultiSelectionEnabled(false);
		if (f.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
			if (f.getSelectedFile() != null) {
				String path = f.getSelectedFile().getAbsolutePath();			
				String cmd = "mysql -u" + new Define().get_user() + " -p"
						+ new Define().get_pass() + " -h " + db_link + " phyto_db_cpt" + " < " +'"'+ path + '"';

				System.out.print(path);
				System.out.print(cmd);
				
				// Execution de la commande mysql en fonction de l'OS du PC
				String OS = System.getProperty("os.name");
				System.out.println(OS);
				if (OS.equals("Linux")) {
					try {
						// Commande pour Linux
						String[] array = {"/bin/sh","-c",cmd};
						Runtime.getRuntime().exec( array );

					} catch (IOException e) {
						e.printStackTrace();
					}

				} else {
				try {
					// Commande pour windows
					String[] array = { "cmd.exe", "/C", cmd};
					Runtime.getRuntime().exec( array );

				} catch (IOException e) {
					e.printStackTrace();
				}
				}
				new JOptionPane().showMessageDialog(null,
						rb.getString("mssgImportSucces"),
						rb.getString("titreBoxImportSucces"),
						JOptionPane.INFORMATION_MESSAGE);
			}
		}
	}

	/**
	 * sauvegarde la base de donnes
	 */
	@SuppressWarnings("static-access")
	public void export_base() {
		// pour la traduction des botes de dialogue
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);

		close();
		JFileChooser fc = new JFileChooser();
		fc.setMultiSelectionEnabled(false);
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

		if (fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {

			String exported_base_name = rb.getString("nomFichierSauvegardeBaseDefaut") + 
					new SimpleDateFormat("_yy-MM-dd" + "_HH.mm.ss").format(new java.util.Date());

			// affichage d'une bote de dialogue pour la validation/modification du nom du fichier
			JOptionPane jop = new JOptionPane();
			exported_base_name = jop.showInputDialog( rb.getString("mssgChoixNomFichierExport"), 
					exported_base_name) + ".sql";

			File f = new File(fc.getSelectedFile().getAbsolutePath() + File.separator + exported_base_name);

			if (f.exists())
				new JOptionPane().showMessageDialog(null,
						rb.getString("mssgFichierDejaExisant"),
						rb.getString("titreBoxFichierDejaExistant"),
						JOptionPane.ERROR_MESSAGE);
			else {

				String mysql_cmd = "mysqldump -uphyto_cpt_user -pphyto_pass -h " + db_link + " --opt phyto_db_cpt tous_codes_taxon tous_embranchements chambres comptage echantillons"
						+ " lieux ligne_cpt liste_taxa_cpt stations calcul_biovol ligne_calcul";
				try {
					Process p = Runtime.getRuntime().exec(mysql_cmd);
					BufferedReader r = new BufferedReader(
							new InputStreamReader(p.getInputStream()));
					BufferedWriter w = new BufferedWriter(new FileWriter(f));
					String s;
					while ((s = r.readLine()) != null) {
						w.write(s);
						w.newLine();
					}
					r.close();
					w.close();
					new JOptionPane().showMessageDialog(
							null,
							rb.getString("mssgSauvegardeEffectuee")
							+ f.getAbsolutePath(),
							rb.getString("titreBoxSauvegardeEffectuee"),
							JOptionPane.INFORMATION_MESSAGE);

					// vrif existance du fichier DateSauvegarde.txt si non
					// cration
					File txt = new File(pathParam + File.separator + "DateSauvegarde.txt");

					// dclaration de l'objet Locale ( pour faire le new Main Menu Frame )
					Locale local = null;

					String pathConfig = (pathParam + File.separator + "langage.config");

					try {
						BufferedReader buffer = new BufferedReader(
								new FileReader(pathConfig));

						try {
							String line;
							while ((line = buffer.readLine()) != null) {
								String infosLang[] = line.split("-");
								local = new Locale(infosLang[0], infosLang[1]);
							}
						} finally {
							buffer.close();
						}
					} catch (IOException ioe) {
						File langFile = new File(pathParam + File.separator + "langage.config");
						try {
							BufferedWriter writer = new BufferedWriter(
									new FileWriter(langFile));
							writer.write("fr-FR");
							writer.close();
						} catch (IOException e) {
							e.printStackTrace();
						}

						local = new Locale("fr", "FR");
					}

					Main_Menu_Frame MMF = new Main_Menu_Frame(local, db_link);

					if (!txt.exists()) {
						// cration + criture date
						String chemin = (pathParam + File.separator + "DateSauvegarde.txt");
						txt = new File(chemin);
						MMF.writeDate();
						MMF.dispose();
					} else
						MMF.writeDate();
					MMF.dispose();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	/**
	 * Fait choisir  un utilisateur les comptages qu'il souhaite exporter, puis lui fait choisir
	 * les champs qu'il souhaite avoir
	 */
	@SuppressWarnings("static-access")
	public void export_libre() {

		// pour la traduction des botes de dialogue
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);

		String[] champs = { rb.getString("colNomSite"),
				rb.getString("colNomStation"), rb.getString("colMilieu"),
				rb.getString("colDatePrel"), rb.getString("colRefEch"),
				rb.getString("colDateCpt"), rb.getString("colTaxinomiste"),
				rb.getString("colCommentaire"), rb.getString("colNomChambre"),
				rb.getString("colCodeTaxon"), rb.getString("colNomTaxon"),
				rb.getString("colCodeTaxonRef"),
				rb.getString("colNomTaxonRef"),

				rb.getString("colNomAuteur"), rb.getString("colIndivDefaut"),
				rb.getString("colCodeOMNIDIA"), rb.getString("colDateMaJ"),
				rb.getString("colCreateur"), rb.getString("colRegne"),
				rb.getString("colSousRegne"), rb.getString("colEmbranchement"),
				rb.getString("colClasse"), rb.getString("colOrdre"),
				rb.getString("colSousOrdre"), rb.getString("colFamille"),

				rb.getString("colTypeCpt"), rb.getString("colNbChamps"),
				rb.getString("colNbIndivTotal"), rb.getString("colCodeSandre"),
				rb.getString("colBioVolCel"), rb.getString("colBioVolIn"),
				rb.getString("colGrpAlgal"), rb.getString("colCoefSteno"),
				rb.getString("colCoteSpec"), rb.getString("colNumCpt"),
				rb.getString("colSladV"), rb.getString("colCf"),
				rb.getString("colNbCpt"), rb.getString("colValeurPerso"),
				rb.getString("colVolSed"), rb.getString("colFactDilu"),
				rb.getString("colTrophie"), rb.getString("colSladS"),
				rb.getString("col1Biovol_mm3_L"),
				rb.getString("col1NbMoyCell_ind"),
				rb.getString("col1NbInd_ml"), rb.getString("col1NbCel_ml")};

		String[] st = { "nom_lieu", "nom_station", "milieu",
				"date_prelevement", "ref_etude", "date_cpt", "nom_operateur",
				"commentaire", "nom_chambre", "code_taxon", "nom_taxon",
				"code_taxon_ref", "nom_taxon_ref", "nom_auteur",
				"indiv_defaut", "code_omnidia", "date_maj", "createur",
				"regne", "sous_regne", "embranchement", "classe", "ordre",
				"sous_ordre", "famille", "type" };

		String[] in = { "nb_champs", "nb_indiv_total", "code_sandre",
				"biovolcel", "biovolind", "groupe_algual", "coef_stenoecie",
				"cote_specifique", "id_cpt", "slad_v", "cf", "nb_cpt",
		"taxon_cpt" };

		String[] fl = { "vol_sedimente", "facteur_dillution", "trophie",
				"slad_s", "biovol_calcule", "nb_cell_moy_ind", 
				"abondanceInd", "abondanceCel" };

		JFileChooser fc = new JFileChooser();
		fc.setMultiSelectionEnabled(false);
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		File f = null;

		int[] ids = new Ouvrir_Cpt(null, true, locale, db_link).get_cpts();

		if (ids == null)
			return;
		else {
			@SuppressWarnings("unused")
			int nb_cpts = ids.length;

			if (fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION)

			{
				String exported_file_name = rb.getString("nomFichierExportCptDefaut") + 
						new SimpleDateFormat("_yy-MM-dd" + "_HH.mm.ss").format(new java.util.Date());

				// affichage d'une bote de dialogue pour la slection du nom du fichier
				JOptionPane jop = new JOptionPane();					 
				exported_file_name = jop.showInputDialog(rb.getString("mssgChoixNomFichierExport"), 
						exported_file_name) + ".csv";


				f = new File(fc.getSelectedFile().getAbsolutePath() + File.separator + exported_file_name);

				if (f.exists())
					new JOptionPane().showMessageDialog(null,
							rb.getString("mssgFichierDejaExisant"),
							rb.getString("titreBoxFichierDejaExistant"),
							JOptionPane.ERROR_MESSAGE);
				else {
					ArrayList<Integer> s = new Fields_Frame(false, locale)
					.get_fields();

					if (s == null)
						return;

					BufferedWriter w;
					try {
						w = new BufferedWriter(new FileWriter(f));
						String line = "";
						for (int i : s)
							line += champs[i] + ";";
						w.write(line);
						w.newLine();

						String q = "select nom_lieu, nom_station, milieu, date_prelevement, ref_etude, date_cpt, vol_sedimente, facteur_dillution, "
								+ "nb_champs, nb_indiv_total, nom_operateur, commentaire, nom_chambre, code_sandre, ligne_cpt.code_taxon, "
								+ "tous_codes_taxon.nom_taxon,";
						if (s.contains(11) || s.contains(12))
							q += "valide.code_taxon_ref, valide.nom_taxon_ref,";
						if (s.contains(13))
							q += "all_auteurs.nom_auteur,";
						if (s.contains(14) || s.contains(29)
								|| s.contains(30))
							q += "biovol.indiv_defaut, biovol.biovolcel, biovol.biovolind,";							

						q += "groupe_algual, code_omnidia, date_maj, coef_stenoecie, cote_specifique, id_cpt, trophie, slad_s, slad_v, createur, regne, "
								+ "sous_regne, tous_embranchements.embranchement, classe, ordre, sous_ordre, famille, cf, type, nb_cpt, biovol_calcule, "
								+ "nb_cell_moy_ind, "
								+ "(nb_cpt * surface_chambre * facteur_dillution ) / (nb_champs * surface_champ * vol_sedimente) as abondanceInd, "
								+ "(nb_cpt * surface_chambre * facteur_dillution ) / (nb_champs * surface_champ * vol_sedimente) as abondanceCel, "
								+ "taxon_cpt "
								+ "from ";

						System.out.println("");

						q += "(((lieux natural join stations natural join echantillons natural join comptage natural join chambres "
								+ "natural join ligne_cpt ";

						if (s.contains(13))
							q += "join (select code_taxon, nom_auteur from liste_taxa natural join auteurs union select code_taxon, nom_auteur "
									+ "from liste_taxa_cpt) as all_auteurs on ligne_cpt.code_taxon = all_auteurs.code_taxon ";

						q += "join tous_codes_taxon on ligne_cpt.code_taxon = tous_codes_taxon.code_taxon ";

						if (s.contains(14) || s.contains(29)
								|| s.contains(30))
							q += "join (select code_taxon, indiv_defaut, biovolcel, biovolind, 0 as vp from ligne_cpt natural join liste_taxa "
									+ "where taxon_cpt = 0 union select code_taxon, indiv_defaut, biovolcel, biovolind, "
									+ "if(code_taxon like 'NEW%', 0, 1) as vp from liste_taxa_cpt) as biovol on ligne_cpt.code_taxon = biovol.code_taxon "
									+ "and ligne_cpt.taxon_cpt = biovol.vp ";

						q += "left outer join liste_taxa on ligne_cpt.code_taxon = liste_taxa.code_taxon) "
								+ "left outer join liste_taxa_cpt on ligne_cpt.code_taxon = liste_taxa_cpt.code_taxon) "
								+ "left outer join tous_embranchements on ligne_cpt.code_taxon = tous_embranchements.code_taxon "
								+ "left outer join taxinomie on liste_taxa.id_taxinomie = taxinomie.id_taxinomie) ";

						if (s.contains(11) || s.contains(12))
							q += "left outer join (select synonymes.code_taxon, synonymes.code_taxon_ref, ref.nom_taxon as nom_taxon_ref "
									+ "from synonymes join liste_taxa as ref on ref.code_taxon = synonymes.code_taxon_ref) "
									+ "as valide on valide.code_taxon = ligne_cpt.code_taxon ";
						q += "where ligne_cpt.id_cpt in (";
						String q_base = "";

						// ajout des numros des comptages selectionns dans la requte
						for (int t = 0; t <ids.length ; t++) {

							if (t < ids.length-1)
								q += ids[t] + ", ";
							else
								q += ids[t];

						}

						q_base = q;	
						q_base += ") order by nom_lieu, nom_station, date_prelevement";

						System.out.println(q_base);

						try {
							rs = query.executeQuery(q_base);

							while (rs.next()) {
								line = "";
								for (int i : s) {
									if (i < 26)
										line += rs.getString(st[i])
										+ ";";
									else {
										if (i < 39) {
											if (i == 28) {
												String sandre = rs
														.getString("code_sandre");
												if (sandre == null)
													line += ";";
												else
													line += sandre
													+ ";";

											}
											// colonne du biovolcel
											else if( i == 29) {
												Float bvc = rs.getFloat("biovolcel");
												line += bvc + ";";
											}
											// colonne du biovolind
											else if( i == 30){
												Float bvi = rs.getFloat("biovolind");
												line += bvi + ";";
											}

											else {
												if (i == 32) {
													Float coef = rs
															.getFloat("coef_stenoecie");
													if (coef == null)
														line += ";";
													else
														line += coef
														+ ";";
												} 
												// colonne Cf.
												else if (i== 36){
													int valCf = rs.getInt("cf");
													if(valCf == 1)
														line += "Cf.;";
													else line += ";";
												}
												else {
													if (i == 33) {
														Float cote = rs
																.getFloat("cote_specifique");
														if (cote == null)
															line += ";";
														else
															line += cote
															+ ";";
													}

													else
														line += Integer
														.toString(rs
																.getInt(in[i - 26]))
																+ ";";
												}
											}
										} else {
											if (i == 43) {
												Float bio = rs
														.getFloat("biovol_calcule");
												if (bio == 0.0)
													line += ";";
												else
													line += Float
													.toString(rs
															.getFloat(fl[i - 39]))
															+ ";";
											} 

											// colonnes des abondances
											else if (i == 45 || i == 46) {
												// on va regarder si la valeur nb moy cell/ind est renseigne
												Integer nbMoyCellInd = rs.getInt("nb_cell_moy_ind");
												// rcupration du type d'objet compt
												String typeObjCpt = rs.getString("type");

												// si c'est la colonne de l'abondance d'individu
												if (i == 45){
													Float abondInd = rs.getFloat("abondanceInd");
													// si le taxon a t compt en cellules
													if(typeObjCpt.equals("Cel.")){
														// si on connait le nombre moyen de cellules par individu
														if (nbMoyCellInd != 0){
															// alors on doit diviser cette abondance par le nombre moyen cell/obj
															line += abondInd/nbMoyCellInd + ";";
														}
														// sinon, on ne peut pas avoir l'abondance individuelle
														else
															line += ";";
													}
													// sinon, l'abondance ne change pas
													else
														line += abondInd + ";";		
												}

												// si c'est la colonne de l'abondance cellulaire
												else if(i==46){
													Float abondCel = rs.getFloat("abondanceCel");
													// si le taxon a t compt en cellules
													if(typeObjCpt.equals("Cel.")){
														// alors l'abondance est la mme
														line += abondCel + ";";
													}
													// s'il n'a pas t compt en cellule, on doit multiplier
													// 	cette abondance par le nombre moyen cell/ind s'il est connu
													else if (nbMoyCellInd != 0)
														line += abondCel*nbMoyCellInd + ";";
													// sinon, on ne peut pas avoir l'abondance cellulaire
													else
														line += ";";
												}

											}

											else line += Float
													.toString(rs
															.getFloat(fl[i - 39]))
															+ ";";
										}

									}
								}

								/*
								 * Effacement des null, 0 et 0.0
								 */
								line = line.replaceAll(";null;", ";;");
								line = line.replaceAll(";null;", ";;");
								line = line.replaceAll(";null;", ";;");
								line = line.replaceAll(";null;", ";;");
								line = line.replaceAll(";0;", ";;");
								line = line.replaceAll(";0;", ";;");
								line = line.replaceAll(";0;", ";;");
								line = line.replaceAll(";0;", ";;");
								line = line.replaceAll(";0.0;", ";;");
								line = line.replaceAll(";0.0;", ";;");
								line = line.replaceAll(";0.0;", ";;");
								line = line.replaceAll(";0.0;", ";;");

								w.write(line);
								w.newLine();
							}

						} catch (SQLException e) {
							e.printStackTrace();
						}

						w.close();
						new JOptionPane().showMessageDialog(
								null,
								rb.getString("mssgExportEffectue")
								+ f.getAbsolutePath(),
								rb.getString("titreBoxExportEffectue"),
								JOptionPane.INFORMATION_MESSAGE);
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		}
	}

	/**
	 * export de la synthse des taxons d'une station
	 * 
	 * @return matrice des taxons rencontrs sur un site donn et une station
	 *         donn
	 * @param site
	 * @param station
	 */
	@SuppressWarnings("static-access")
	public void export_synth_station(String site, String station) {

		// pour la traduction des botes de dialogue
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);

		if (station != null) {
			JFileChooser fc = new JFileChooser();
			fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			fc.setMultiSelectionEnabled(false);

			if (fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
				File f = new File(fc.getSelectedFile().getAbsolutePath()
						+ File.separator + "Synth_Station_" + site + ".csv");

				if (f.exists())
					new JOptionPane().showMessageDialog(null,
							rb.getString("mssgFichierDejaExisant"),
							rb.getString("titreBoxFichierDejaExistant"),
							JOptionPane.ERROR_MESSAGE);
				else {

					String[] headers = { rb.getString("colNomSite"),
							rb.getString("colNomStation"),
							rb.getString("colCodeTaxon"),
							rb.getString("colCf"), 
							rb.getString("colNomTaxon"),
							rb.getString("colNomAuteur"), rb.getString("colCodeRef"),
					};


					try {
						BufferedWriter writer = new BufferedWriter(
								new FileWriter(f));
						String[] line = new String[7];
						String toWrite = "";

						for (int i = 0; i < headers.length; i++)
							toWrite += headers[i] + ";";
						writer.write(toWrite);
						writer.newLine();

						String requete = "select nom_lieu, nom_station, code_taxon, cf, nom_taxon, nom_auteur, code_taxon_ref"
								+ " from lieux natural join echantillons natural join stations natural join comptage natural join ligne_cpt natural join liste_taxa natural join auteurs natural join synonymes"
								+ " where nom_lieu like '"
								+ site.replaceAll("\\\\", "\\\\\\\\")
								.replaceAll("'", "\\\\'")
								+ "'"
								+ " and nom_station like '"
								+ station.replaceAll("\\\\", "\\\\\\\\")
								.replaceAll("'", "\\\\'")
								+ "'"
								+ " group by code_taxon"
								+ " order by nom_taxon";

						rs = query.executeQuery(requete);

						while (rs.next()) {
							toWrite = "";

							line[0] = rs.getString("nom_lieu");
							line[1] = rs.getString("nom_station");
							line[2] = rs.getString("code_taxon");

							// gestion de la colonne Cf
							String col_cf = rs.getString("cf");
							if(col_cf.equals("1"))
								line[3] = "Cf.";
							else line[3] = "";

							line[4] = rs.getString("nom_taxon");
							line[5] = rs.getString("nom_auteur");
							line[6] = rs.getString("code_taxon_ref");

							for (int i = 0; i < line.length; i++) {
								if (line[i] == null)
									line[i] = "";
								toWrite += line[i] + ";";
							}
							writer.write(toWrite);
							writer.newLine();
						}
						writer.close();
						new JOptionPane().showMessageDialog(
								null,
								rb.getString("mssgExportEffectue")
								+ f.getAbsolutePath(),
								rb.getString("titreBoxExportEffectue"),
								JOptionPane.INFORMATION_MESSAGE);
					} catch (SQLException e) {
						e.printStackTrace();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				close();
			}
		}
	}

	/**
	 * export des station contenant un taxon donn
	 * 
	 * @return matrice des sites, stations contenant un taxon donn
	 * @param code
	 */
	@SuppressWarnings("static-access")
	public void export_synth_taxon(String code) {
		// pour la traduction des botes de dialogue
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);

		if (code != null) {
			JFileChooser fc = new JFileChooser();
			fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			fc.setMultiSelectionEnabled(false);

			if (fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
				File f = new File(fc.getSelectedFile().getAbsolutePath()
						+ File.separator + "Synth_Taxon_" + code + ".csv");

				if (f.exists())
					new JOptionPane().showMessageDialog(null,
							rb.getString("mssgFichierDejaExisant"),
							rb.getString("titreBoxFichierDejaExistant"),
							JOptionPane.ERROR_MESSAGE);
				else {

					String[] headers = { rb.getString("colCodeTaxon"),
							rb.getString("colNomTaxon"),
							rb.getString("colNomAuteur"), rb.getString("colCodeRef"),
							rb.getString("colNumCpt"), rb.getString("colNomSite"),
							rb.getString("colNomStation"),
							rb.getString("colDatePrel"), rb.getString("colRefEch"),
							rb.getString("colCf"), rb.getString("col1NbMoyCell_ind"),
							rb.getString("colNbCpt"), rb.getString("colType"),
							rb.getString("col1Biovol_mm3_L") };


					try {
						BufferedWriter writer = new BufferedWriter(
								new FileWriter(f));
						String[] line = new String[14];
						String toWrite = "";

						for (int i = 0; i < headers.length; i++)
							toWrite += headers[i] + ";";
						writer.write(toWrite);
						writer.newLine();

						// test si le taxon est personnel : commence par 'NEW'
						//boolean perso = code.startsWith("NEW");
						// car selon que le taxon soit personnel ou pas, 
						// 	la table  interroger n'est pas la mme (soit liste_taxa soit liste_taxa_cpt)

						boolean perso = code.startsWith("NEW");				
						if (perso) {
							rs = query.executeQuery("select l.code_taxon, nom_taxon, nom_auteur, c.id_cpt, nom_lieu, nom_station, date_prelevement, ref_etude,"
									+ " l.cf, l.nb_cell_moy_ind, l.nb_cpt, l.type, l.biovol_calcule"
									+ " from echantillons e, stations s, comptage c, ligne_cpt l, liste_taxa_cpt li, lieux lx"
									+ " where e.id_station=s.id_station and lx.id_lieu=s.id_lieu"
									+ " and e.id_echantillon=c.id_echantillon and c.id_cpt=l.id_cpt"
									+ " and l.code_taxon=li.code_taxon"
									+ " and l.code_taxon like '" + code.replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'")
									+ "'" + " order by nom_lieu, nom_station, date_prelevement");
						}
						else {
							rs = query.executeQuery("select l.code_taxon, nom_taxon, nom_auteur, code_taxon_ref, c.id_cpt, nom_lieu, nom_station, date_prelevement, ref_etude,"
									+ " l.cf, l.nb_cell_moy_ind, l.nb_cpt, l.type, l.biovol_calcule"
									+ " from echantillons e, stations s, comptage c, ligne_cpt l, liste_taxa li, lieux lx, synonymes sy, auteurs a"
									+ " where e.id_station=s.id_station and lx.id_lieu=s.id_lieu"
									+ " and e.id_echantillon=c.id_echantillon and c.id_cpt=l.id_cpt"
									+ " and l.code_taxon=li.code_taxon and l.code_taxon=sy.code_taxon and a.id_auteur=li.id_auteur"
									+ " and l.code_taxon like '" + code.replaceAll("\\\\", "\\\\\\\\").replaceAll("'", "\\\\'")
									+ "'" + " order by nom_lieu, nom_station, date_prelevement");
						}

						while (rs.next()) {
							toWrite = "";

							line[0] = rs.getString("code_taxon");

							line[1] = rs.getString("nom_taxon");
							line[2] = rs.getString("nom_auteur");

							// gestion du code taxon ref inexistant pour les NEW
							if (perso)
								line[3]="";
							else
								line[3] = rs.getString("code_taxon_ref");

							line[4] = rs.getString("id_cpt");
							line[5] = rs.getString("nom_lieu");
							line[6] = rs.getString("nom_station");
							line[7] = rs.getString("date_prelevement");
							line[8] = rs.getString("ref_etude");

							// gestion de la colonne Cf
							String col_cf = rs.getString("cf");
							if(col_cf.equals("1"))
								line[9] = "Cf.";
							else
								line[9] = "";

							line[10] = rs.getString("nb_cell_moy_ind");
							line[11] = rs.getString("nb_cpt");
							line[12] = rs.getString("type");
							line[13] = rs.getString("biovol_calcule");

							for (int i = 0; i < line.length; i++) {
								if (line[i] == null)
									line[i] = "";
								toWrite += line[i] + ";";
							}
							writer.write(toWrite);
							writer.newLine();
						}
						writer.close();
						new JOptionPane().showMessageDialog(
								null,
								rb.getString("mssgExportEffectue")
								+ f.getAbsolutePath(),
								rb.getString("titreBoxExportEffectue"),
								JOptionPane.INFORMATION_MESSAGE);
					} catch (SQLException e) {
						e.printStackTrace();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				close();
			}
		}
	}


	/**
	 * Supprime toutes les donnes personnelles contenues dans la base de donnes.
	 */
	@SuppressWarnings("static-access")
	public void purge_donnees_perso_base() {
		// pour la traduction des botes de dialogue
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue",
				locale);
		try
		{
			query.executeUpdate("TRUNCATE TABLE ligne_calcul;");
			query.executeUpdate("TRUNCATE TABLE calcul_biovol;");
			query.executeUpdate("TRUNCATE TABLE ligne_cpt;");
			query.executeUpdate("DELETE FROM comptage WHERE id_cpt<100000;");
			query.executeUpdate("DELETE FROM echantillons WHERE id_echantillon<100000;");
			query.executeUpdate("DELETE FROM stations WHERE id_station<100000;");
			query.executeUpdate("DELETE FROM lieux WHERE id_lieu<100000;");
			query.executeUpdate("TRUNCATE TABLE liste_taxa_cpt;");
		}
		catch(SQLException e){ e.printStackTrace(); };
		new JOptionPane().showMessageDialog(
				null,
				rb.getString("purgerBaseOk"),
				rb.getString("purgerBase"),
				JOptionPane.INFORMATION_MESSAGE);
	}

	private void close() {
		try {
			query.close();
			connection.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

}
