package Menus;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URI;
import java.net.URISyntaxException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.UIManager;

import C_R_Valides.Consultation_Frame;
import Calcul_Biovolume.Calcul_Biovolume_Frame;
import Calcul_Biovolume.Ouvrir_Calcul;
import Comptage.Comptage_Frame;
import Import_Export.Import_Exporter;
import utils.Define;

public class Main_Menu_Frame extends JFrame {

	private static final long serialVersionUID = 1L;
	private Locale locale;

	public String db_link;
	private Connection connection = null;

	private JPanel buttons_panel = new JPanel(new FlowLayout());

	private Main_Menu_Frame self = this;

	JLabel banniere = new JLabel("", 
			new ImageIcon(getClass().getClassLoader().getResource("images/bannierev2.png")), 
			JLabel.TRAILING);
	
	//cration des chemins des dossiers
	private String pathDocs = new String("Docs");
	private String pathParam = new String("Parametres");
			
	// cration des boutons
	private JButton gestion_taxons = new JButton();
	private JButton menu_comptage = new JButton();
	private JButton menu_IPLAC = new JButton();

	private Comptage_Frame cf = null;
	private Calcul_Biovolume_Frame cbf = null;
	private Gestion_IPLAC_Frame gif = null;
	private Consultation_Frame crf = null;

	JMenuBar menu_bar = new JMenuBar();

	//cration du menu menu
	private JMenu menu = new JMenu();
	private JMenuItem close_menu_item = new JMenuItem();
	private JMenuItem comptage = new JMenuItem();
	private JMenuItem taxons = new JMenuItem();
	private JMenuItem iplac = new JMenuItem();

	//cration du menu import/Export
	private JMenu import_export = new JMenu();
	private JMenu export_cpt = new JMenu();
	private JMenuItem export_libre = new JMenuItem();
	private JMenuItem export_dce = new JMenuItem();
	private JMenu export_calcul = new JMenu();
	private JMenuItem export_libre_calcul = new JMenuItem();
	private JMenu bdd = new JMenu();
	private JMenuItem imp = new JMenuItem();
	private JMenuItem export_base = new JMenuItem();
	private JMenuItem export_dce_calcul = new JMenuItem();
	private JMenu opt_avancees = new JMenu();
	private JMenuItem purger_base = new JMenuItem();


	//cration prfrence
	private JMenu pref = new JMenu();


	// choix du langage dans le menu
	private JMenu language  = new JMenu();
	private JRadioButtonMenuItem french  = new JRadioButtonMenuItem();
	private JRadioButtonMenuItem english = new JRadioButtonMenuItem();
	private JRadioButtonMenuItem spanish = new JRadioButtonMenuItem();

	// choix de la base de donnes dans le menu
	private JMenu choix_BD = new JMenu();
	private JRadioButtonMenuItem bd_locale = new JRadioButtonMenuItem();
	private JRadioButtonMenuItem bd_externe = new JRadioButtonMenuItem();

	//cration du menu ?
	JMenu plus = new JMenu("?");
	private JMenuItem notice = new JMenuItem();
	private JMenuItem licence = new JMenu(); 
	private JMenuItem licenceInfos = new JMenuItem();
	private JMenu apropos = new JMenu();
	private JMenuItem infos = new JMenuItem();


	public Main_Menu_Frame(Locale locale, String db_link)
	{		
		super("PHYTOBS");
		this.getContentPane().setLayout(new BorderLayout());

		this.locale = locale;
		this.db_link = db_link;

		Locale.setDefault(locale);
		UIManager.getDefaults().setDefaultLocale(locale);
		JComponent.setDefaultLocale(locale);

		this.add_handlers();
		this.add_menu();
		this.add_buttons();

		this.translate();

		this.draw_frame();
		this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	}

	// boolen pour ne pas autoriser la fermeture de l'application si l'cran comptage est ouvert
	// avec un comptage 
	public boolean get_closable()
	{
		return ((cf != null && cf.get_id_cpt() != 0) ? false : true);
	}

	private void add_menu()
	{
		if(locale.toString().compareTo("fr_FR") == 0)
			french.setSelected(true);
		else if(locale.toString().compareTo("en_US") == 0)
			english.setSelected(true);
		else
			spanish.setSelected(true);

		apropos.add(infos);
		licence.add(licenceInfos);

		language.add(english);
		language.add(spanish);
		language.add(french);

		pref.add(language);

		if(db_link.toString().compareTo("localhost") == 0)
			bd_locale.setSelected(true);
		else
			bd_externe.setSelected(true);
		choix_BD.add(bd_locale);
		choix_BD.add(bd_externe);

		pref.add(choix_BD);


		plus.add(notice);
		plus.add(licence);
		plus.add(apropos);

		menu.add(comptage);
		menu.add(taxons);
		menu.add(iplac);
		menu.add(close_menu_item);

		import_export.add(export_cpt);
		import_export.add(export_calcul);
		import_export.add(bdd);
		import_export.add(opt_avancees);

		export_cpt.add(export_libre);
		export_cpt.add(export_dce);		

		export_calcul.add(export_libre_calcul);
		export_calcul.add(export_dce_calcul);

		bdd.add(imp);
		bdd.add(export_base);

		opt_avancees.add(purger_base);


		menu_bar.add(menu);
		menu_bar.add(pref);
		menu_bar.add(import_export);		
		menu_bar.add(plus);
		this.setJMenuBar(menu_bar);
	}

	private void add_buttons()
	{	
		buttons_panel.add(gestion_taxons);
		buttons_panel.add(menu_comptage);
		buttons_panel.add(menu_IPLAC);

		JPanel banniere_pane = new JPanel(new FlowLayout());
		((FlowLayout)banniere_pane.getLayout()).setAlignment(FlowLayout.LEFT);
		banniere_pane.setBackground(new Color(192, 197, 199));

		banniere.setFont(new Font(banniere.getFont().getName(), banniere.getFont().getStyle(), 15));
		banniere_pane.add(banniere);

		this.getContentPane().add(banniere_pane, BorderLayout.NORTH);

		buttons_panel.setPreferredSize(new Dimension(200,100));
		((FlowLayout)buttons_panel.getLayout()).setHgap(15);
		((FlowLayout)buttons_panel.getLayout()).setVgap(20);
		buttons_panel.setBackground(new Color(192, 197, 199));
		this.getContentPane().add(buttons_panel, BorderLayout.CENTER);

		ImageIcon logo_icon = new ImageIcon(getClass().getClassLoader().getResource("images/Logo_Irstea_red.png"));
		JLabel logo = new JLabel(logo_icon);
		logo.setHorizontalAlignment(JLabel.RIGHT);
		logo.setVerticalAlignment(JLabel.BOTTOM);

		this.getContentPane().add(logo, BorderLayout.SOUTH);
	}

	private void add_handlers()
	{
		// ncessaire pour la traduction des botes de dialogue
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);


		close_menu_item.addActionListener(
				new ActionListener() {
					boolean gifFermeture = false;
					boolean crfFermeture = false;
					boolean cfFermeture = false;
					boolean ocFermeture = false;
					@SuppressWarnings("static-access")
					public void actionPerformed(ActionEvent arg0) {
						if(gif != null) {
							if( ! gif.get_closable()) {
								new JOptionPane().showMessageDialog(self, 
										rb.getString("mssgCptOuvert"),
										rb.getString("titreBoxCptOuvert"), JOptionPane.WARNING_MESSAGE);
								gifFermeture = false;
							} 
							else {
								gifFermeture = true;
							}
						}
						else {
							gifFermeture = true;
						}

						if(crf != null) {
							if( ! crf.get_closable()){
								new JOptionPane().showMessageDialog(self, 
										rb.getString("mssgCptOuvert"),
										rb.getString("titreBoxCptOuvert"), JOptionPane.WARNING_MESSAGE);
								crfFermeture = false;
							}
							else {
								if( ! crf.get_closableCalc()){
									new JOptionPane().showMessageDialog(self, 
											rb.getString("mssgCalculOuvert"),
											rb.getString("titreBoxCalculOuvert"), JOptionPane.WARNING_MESSAGE);
									crfFermeture = false;
								}
								else {
									crfFermeture = true;
								}
							}
						}
						else {
							crfFermeture = true;
						}

						if(cf != null) {
							if( ! self.get_closable()){ 
								new JOptionPane().showMessageDialog(self, 
										rb.getString("mssgCptOuvert"),
										rb.getString("titreBoxCptOuvert"), JOptionPane.WARNING_MESSAGE);
								cfFermeture = false;
							}
							else 
								if( ! cf.get_closable()){ 
									new JOptionPane().showMessageDialog(self, 
											rb.getString("mssgCptOuvert"),
											rb.getString("titreBoxCptOuvert"), JOptionPane.WARNING_MESSAGE);
									cfFermeture = false;
								}
								else {
									if( ! cf.get_closableCalc()){
										new JOptionPane().showMessageDialog(self, 
												rb.getString("mssgCalculOuvert"),
												rb.getString("titreBoxCalculOuvert"), JOptionPane.WARNING_MESSAGE);
										cfFermeture = false;
									}
									else {
										cfFermeture = true;
									}
								}
						}
						else {
							cfFermeture = true;
						}

						if(cbf != null){
							if( ! cbf.get_closableCalc()){
								new JOptionPane().showMessageDialog(self, 
										rb.getString("mssgCalculOuvert"),
										rb.getString("titreBoxCalculOuvert"), JOptionPane.WARNING_MESSAGE);
								ocFermeture = false;
							}
							else {
								ocFermeture = true;
							}
						}
						else {
							ocFermeture = true;
						}
				 
						if(gifFermeture==true && crfFermeture==true && cfFermeture==true
								&& ocFermeture==true){
							processSauve();
						}	
					}});

		//fermeture de l'application par la croix rouge
		this.addWindowListener(
				new WindowAdapter() {
					public void windowClosing(WindowEvent arg0) {
						close_menu_item.doClick();		
					}});

		gestion_taxons.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						crf = new Consultation_Frame(locale, db_link);
					}});

		menu_comptage.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						cf = new Comptage_Frame(locale, db_link);

					}});

		menu_IPLAC.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						gif = new Gestion_IPLAC_Frame(locale, db_link,"3","01/05/"+Calendar.getInstance().get(Calendar.YEAR),"31/10/"+Calendar.getInstance().get(Calendar.YEAR),true,false);
					}
				});

		export_dce.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Import_Exporter(locale, db_link).export_dce();
					}});

		imp.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Import_Exporter(locale, db_link).import_base();
					}});

		export_libre.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Import_Exporter(locale, db_link).export_libre();
					}});

		export_libre_calcul.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Ouvrir_Calcul(null, true, true, locale, db_link);
					}});

		export_dce_calcul.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Ouvrir_Calcul(null, true, false, locale, db_link);
					}});

		export_base.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						new Import_Exporter(locale, db_link).export_base();
					}});

		purger_base.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						// ncessaire pour la traduction des botes de dialogue
						final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
						// boite de dialogue pour confirmation de suppression
						int reponse = JOptionPane.showConfirmDialog(
								self, rb.getString("mssgConfirmPurgeBase"),
								rb.getString("titreBoxConfirmPurgeBase"), 
								JOptionPane.YES_NO_OPTION);
						if (reponse == 0){
							new Import_Exporter(locale, db_link).purge_donnees_perso_base();

						}
					}}
				);

		notice.addActionListener(
				new ActionListener() {
					@SuppressWarnings("static-access")
					public void actionPerformed(ActionEvent e) {
						// ncessaire pour la traduction des botes de dialogue
						final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);
						
						File pdf = new File(pathDocs + File.separator + "notice.pdf");
						
						if(!pdf.exists())
							pdf = new File(pathDocs + File.separator + "notice.pdf");

						if(Desktop.isDesktopSupported()) 
						{
							if(Desktop.getDesktop().isSupported(java.awt.Desktop.Action.OPEN))
							{
								try { java.awt.Desktop.getDesktop().open(pdf);} 
								catch (IOException ex) { ex.printStackTrace(); }
							} 
							else 
								new JOptionPane().showMessageDialog(self, 
										rb.getString("mssgFonctionNonSupportee"), 
										rb.getString("titreBoxFonctionNonSupp"), JOptionPane.ERROR_MESSAGE);
						}
						else
							new JOptionPane().showMessageDialog(self, 
									rb.getString("mssgFonctionNonSupportee"), 
									rb.getString("titreBoxFonctionNonSupp"), JOptionPane.ERROR_MESSAGE);
					}});

		//ouverture page internet licence GPL
		licenceInfos.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						
						String lienSite = new String("https://www.gnu.org/licenses/");

								try { java.awt.Desktop.getDesktop().browse(new URI(lienSite));} 
								catch (IOException ex) { ex.printStackTrace(); } 
								catch (URISyntaxException e1) {	e1.printStackTrace(); }
							}
				});
		
		//slection du bouton radio Franais
		french.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						french.setSelected(true);
						english.setSelected(false);
						spanish.setSelected(false);
						Locale tmp = new Locale("fr","FR");
						locale = tmp;

						writeLangage("fr-FR");
						Locale.setDefault(tmp);
						UIManager.getDefaults().setDefaultLocale(tmp);
						JComponent.setDefaultLocale(tmp);

						translate();
					}});

		//slection du bouton radio Anglais
		english.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						english.setSelected(true);
						french.setSelected(false);
						spanish.setSelected(false);
						Locale tmp = new Locale("en","US");
						locale = tmp;

						writeLangage("en-US");
						Locale.setDefault(tmp);
						UIManager.getDefaults().setDefaultLocale(tmp);
						JComponent.setDefaultLocale(tmp);

						translate();
					}});

		//slection du bouton radio Espagnol
		spanish.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						spanish.setSelected(true);
						french.setSelected(false);
						english.setSelected(false);
						Locale tmp = new Locale("es","ES");
						locale = tmp;

						writeLangage("es-ES");
						Locale.setDefault(tmp);
						UIManager.getDefaults().setDefaultLocale(tmp);
						JComponent.setDefaultLocale(tmp);

						translate();
					}});

		// slection du bouton radio "Base de donnes locale"
		bd_locale.addActionListener(
				new ActionListener(){
					@SuppressWarnings("static-access")
					public void actionPerformed(ActionEvent e) {
						bd_locale.setSelected(true);
						bd_externe.setSelected(false);

						db_link = new Define().get_local_DB_link();
						writeDbLink(db_link);

						// affichage d'une boite de dialogue d'information
						JOptionPane jop = new JOptionPane();
						jop.showMessageDialog(null, rb.getString("mssgUtilisationBD_loc"), 
								rb.getString("titreBoxUtilBD_loc"), 
								JOptionPane.INFORMATION_MESSAGE);
					}
				});

		// slection du bouton radio "Base de donnes externe"
		bd_externe.addActionListener(
				new ActionListener(){
					@SuppressWarnings("static-access")
					public void actionPerformed(ActionEvent e){
						bd_locale.setSelected(false);
						bd_externe.setSelected(true);
						boolean baseOk = true;

						// affichage d'une bote de dialogue pour saisie du lien de la BD
						JOptionPane jop = new JOptionPane();
						db_link = jop.showInputDialog(null, 
								rb.getString("mssgChoixBD_ext"), 
								rb.getString("titreBoxUtilBD_ext"), 
								JOptionPane.QUESTION_MESSAGE);

						if (db_link == null){
							db_link = new Define().get_local_DB_link();
							bd_locale.setSelected(true);
							bd_externe.setSelected(false);
							writeDbLink(db_link);
						}
						else {
							
							try
							{
								// Test de connexion  la base de donnes ext
								Class.forName("com.mysql.jdbc.Driver");
								String url = "jdbc:mysql://" + db_link + "/" + new Define().get_db_name();
								System.out.println(url);
								connection = DriverManager.getConnection(url, new Define().get_user(), new Define().get_pass());
							}
							catch (ClassNotFoundException ep) {
								ep.printStackTrace();
							} catch (SQLException esql) {
								// affichage d'une boite de dialogue d'information
								JOptionPane jopResult = new JOptionPane();
								jopResult.showMessageDialog(null, rb.getString("mssgPbUtilisationBD_ext"), 
										rb.getString("titreBoxUtilBD_ext"), 
										JOptionPane.INFORMATION_MESSAGE);
								baseOk= false;
								db_link = new Define().get_local_DB_link();
								bd_locale.setSelected(true);
								bd_externe.setSelected(false);
								writeDbLink(db_link);

							}
							if (baseOk == true){
								// affichage d'une boite de dialogue d'information
								JOptionPane jopResult = new JOptionPane();
								jopResult.showMessageDialog(null, rb.getString("mssgUtilisationBD_ext"), 
										rb.getString("titreBoxUtilBD_ext"), 
										JOptionPane.INFORMATION_MESSAGE);
								writeDbLink(db_link);
								try {
									connection.close();
								} catch (SQLException e1) {
									e1.printStackTrace();
								}
							}	
						}
					}
				});

		comptage.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {
						cf = new Comptage_Frame(locale, db_link);
					}});

		taxons.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {
						crf = new Consultation_Frame(locale, db_link);
					}});

		iplac.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {
						gif = new Gestion_IPLAC_Frame(locale, db_link, "3", "01/05", "31/10", true, false);
					}});
	}

	private void draw_frame()
	{
		this.getContentPane().setBackground(new Color(192, 197, 199));//0x4f, 0xec, 0xff
		this.setResizable(false);
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		this.pack();
		this.setLocation(d.width/2 - this.getWidth()/2, d.height/2 - this.getHeight()/2);
		this.setVisible(true);
	}

	@SuppressWarnings("static-access")
	private void sauveBase(){

		// traduction des botes de dialogue
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		JFileChooser fc = new JFileChooser();
		fc.setMultiSelectionEnabled(false);
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		File f = null;

		if( fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION )
		{
			String path = fc.getSelectedFile().getAbsolutePath() + File.separator + "sauvegarde_base" + 
					new SimpleDateFormat("_yyyy-MM-dd" + "_HH.mm.ss").format(new java.util.Date()) + ".sql";
			f = new File(path);

			if(f.exists())
				new JOptionPane().showMessageDialog(null, 
						rb.getString("mssgFichierDejaExisant"), 
						rb.getString("titreBoxFichierDejaExistant"),
						JOptionPane.ERROR_MESSAGE);
			else
			{
				String mysql_cmd = "mysqldump -uphyto_cpt_user -pphyto_pass phyto_db_cpt chambres comptage echantillons" +
						" lieux ligne_cpt liste_taxa_cpt stations calcul_biovol ligne_calcul";
				try 
				{
					Process p = Runtime.getRuntime().exec(mysql_cmd);
					BufferedReader r = new BufferedReader(new InputStreamReader(p.getInputStream()));
					BufferedWriter w = new BufferedWriter(new FileWriter(f));
					String s;
					while( (s = r.readLine()) != null)
					{
						w.write(s);
						w.newLine();
					}
					r.close(); w.close();
					new JOptionPane().showMessageDialog(null, 
							rb.getString("mssgSauvegardeEffectuee") + f.getAbsolutePath(), 
							rb.getString("titreBoxSauvegardeEffectuee"),
							JOptionPane.INFORMATION_MESSAGE);
				} catch (IOException e) {e.printStackTrace();}
			}
		}

	}

	//processus de vrif date dernire suavegarde et sauvegarde si ncessaire
	public void processSauve()
	{

		// traduction des botes de dialogue
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		// vrif existance du fichier DateSauvegarde.txt si non cration
		File txt = new File(pathParam + File.separator + "DateSauvegarde.txt");
		if(!txt.exists()){
			// cration + criture date
			String chemin = (pathParam + File.separator + "DateSauvegarde.txt");
			txt = new File(chemin);
			writeDate();
			self.dispose();
			System.exit(0);
		}
		else {
			Date date_Limite = limiteDate();
			Date date_Sauve = sauveDate();
			DateFormat formatDate = new SimpleDateFormat("dd/MM/yyyy");
			String texteDate = formatDate.format(date_Sauve);

			if (date_Sauve.compareTo(date_Limite)==-1){

				String message= rb.getString("mssgDerniereSauve") + texteDate + 
						" \n" + rb.getString("mssgNouvelleSauve");

				int reponse=javax.swing.JOptionPane.showConfirmDialog(self, message,
						rb.getString("titreBoxSauvegarde"),JOptionPane.YES_NO_OPTION );

				if (reponse ==JOptionPane.CLOSED_OPTION){
					self.pack();
					self.dispose();
					System.exit(0);
				}
				if (reponse==JOptionPane.NO_OPTION){
					self.pack();
					self.dispose();
					System.exit(0);
				}
				else{
					sauveBase();
					writeDate();
					self.dispose();
					System.exit(0);
				}
			}

			else{
				self.dispose();
				System.exit(0);
			}
		}
	}

	//rcupration de la date d'aujourd'hui - 15 jours
	private Date limiteDate(){
		GregorianCalendar aujourdhui = new GregorianCalendar();
		DateFormat formatDate = new SimpleDateFormat("dd/MM/yyyy");
		aujourdhui.add(Calendar.DATE, -15);
		Date dateLimite = aujourdhui.getTime();

		String texteDate = formatDate.format(dateLimite);
		System.out.println("date_limite "+ texteDate);
		return dateLimite;

	}


	//rcupration de la dernire date de sauvegarde dans le fichier DateSauvegarde.txt
	private Date sauveDate(){

		String chaine="";
		String fichier =(pathParam + File.separator + "DateSauvegarde.txt");

		//lecture du fichier texte	
		try{
			InputStream ips=new FileInputStream(fichier); 
			InputStreamReader ipsr=new InputStreamReader(ips);
			BufferedReader br=new BufferedReader(ipsr);
			String ligne="";
			while ((ligne = br.readLine())!=null){
				System.out.println("derniere_sauve " + ligne);
				chaine+=ligne;
			}
			br.close(); 
		}		
		catch (Exception e){
			System.out.println(e.toString());
		}
		String jour = chaine.substring(0,2);
		String mois = chaine.substring(3,5);
		String annee = chaine.substring(6,10);

		GregorianCalendar dateS = new GregorianCalendar(Integer.parseInt(annee), Integer.parseInt(mois)-1, Integer.parseInt(jour));
		Date dateSauve = dateS.getTime();
		System.out.println(jour);
		System.out.println(mois);
		System.out.println(annee);
		System.out.println(dateSauve);
		return dateSauve;

	}
	// Ecriture de la nouvelle date de sauvegarde dans le fichier DateSauvegarde.txt

	public void writeDate(){
		String texteDate="";
		String fichier = (pathParam + File.separator + "DateSauvegarde.txt");

		try {
			GregorianCalendar aujourdhui = new GregorianCalendar();
			DateFormat formatDate = new SimpleDateFormat("dd/MM/yyyy");
			Date dateAujourdhui = aujourdhui.getTime();

			texteDate = formatDate.format(dateAujourdhui);

			FileWriter fw = new FileWriter (fichier);
			BufferedWriter bw = new BufferedWriter (fw);
			PrintWriter fichierSortie = new PrintWriter (bw); 
			fichierSortie.println (texteDate); 
			fichierSortie.close();
			System.out.println("Le fichier " + fichier + " a t modifi"); 
		}
		catch (Exception e){
			System.out.println(e.toString());
		}
	}

	//crit la langue dans le fichier de config langage.config
	private void writeLangage(String local){
		File langFile = new File(pathParam + File.separator + "langage.config");
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(langFile));
			writer.write(local);
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	//crit l'adresse de la base de donnes dans le fichier de config db.config
	private void writeDbLink(String db){
		File dbFile = new File(pathParam + File.separator + "db.config");
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(dbFile));
			writer.write(db);
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Mise en place des textes dans la bonne langue (locale)
	 */
	private void translate() {
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		banniere.setText(rb.getString("titreDetail"));

		menu.setText(rb.getString("menu"));

		gestion_taxons.setText(rb.getString("gestionTaxons"));
		menu_comptage.setText(rb.getString("gestionCpt"));
		menu_IPLAC.setText(rb.getString("menuIPLAC"));

		comptage.setText(rb.getString("fenetreComptage"));
		taxons.setText(rb.getString("taxon"));
		iplac.setText(rb.getString("calculIPLAC"));
		close_menu_item.setText(rb.getString("quitter"));

		import_export.setText(rb.getString("impexp"));
		bdd.setText(rb.getString("baseDonnees"));
		imp.setText(rb.getString("importBase"));
		export_base.setText(rb.getString("sauvegarde"));
		export_cpt.setText(rb.getString("exportComptage"));
		export_libre.setText(rb.getString("exportLibre"));
		export_dce.setText(rb.getString("exportBDD"));
		export_calcul.setText(rb.getString("exportCalcul"));
		export_dce_calcul.setText(rb.getString("exportBDD"));
		export_libre_calcul.setText(rb.getString("exportLibre"));
		opt_avancees.setText(rb.getString("optAvancees"));
		purger_base.setText(rb.getString("purgerBase"));


		pref.setText(rb.getString("preferences"));
		language.setText(rb.getString("langue"));
		french.setText(rb.getString("franais"));
		english.setText(rb.getString("anglais"));
		spanish.setText(rb.getString("espagnol"));

		choix_BD.setText(rb.getString("BD"));
		bd_locale.setText(rb.getString("BD_locale"));
		bd_externe.setText(rb.getString("BD_externe"));

		notice.setText(rb.getString("notice"));
		licence.setText(rb.getString("licence"));
		licenceInfos.setText(rb.getString("licenceInfos"));
		apropos.setText(rb.getString("aPropos"));
		infos.setText(rb.getString("aProposInfos"));

		//ragencement de la position des items de la fentre
		this.pack();
	}	


}
