package Menus;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Locale;

import utils.Define;


public class Menu_Main {

	public static void main(String[] args) {
		Locale local = null;
		String db_link = "";
		
		//cration du chemin du dossier parametres
		String pathParam = new String("Parametres");
		
		// config de la langue  utiliser
		String pathConfig = (pathParam + File.separator + "langage.config");

		try{
			BufferedReader buffer = new BufferedReader(new FileReader(pathConfig));

			try {
				String line;
				while ((line = buffer.readLine()) != null) {
					String infosLang[] = line.split("-");
					local = new Locale(infosLang[0],infosLang[1]);
				}
			}
			finally {
				buffer.close();
			}
		}
		catch (IOException ioe) {
			File langFile = new File(pathParam + File.separator + "langage.config");
			try {
				BufferedWriter writer = new BufferedWriter(new FileWriter(langFile));
				writer.write("fr-FR");
				writer.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			// langue par dfaut pour la premire utilisation : Franais
			local = new Locale("fr","FR");
		}

		// config de la DB  utiliser
		String pathConfigDb = (pathParam + File.separator + "db.config");

		try{
			BufferedReader buffer = new BufferedReader(new FileReader(pathConfigDb));

			try {
				String line;
				while ((line = buffer.readLine()) != null) {
					db_link += line;
				}
			}
			finally {
				buffer.close();
			}
		}
		catch (IOException ioe) {
			File dbFile = new File(pathParam + File.separator + "db.config");
			try {
				BufferedWriter writer = new BufferedWriter(new FileWriter(dbFile));
				writer.write("localhost");
				writer.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			// par dfaut pour la premire utilisation  on prend le lien de la base de donnes locale
			db_link = new Define().get_local_DB_link();
		}

		
		//menu principal
		new Main_Menu_Frame(local, db_link);

	}
}