package Menus;

import java.awt.AWTException;
import java.awt.BasicStroke;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.Ellipse2D;
import java.awt.image.BufferedImage;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.text.Normalizer;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SpringLayout;
import javax.swing.SwingConstants;
import javax.swing.WindowConstants;
import javax.swing.table.DefaultTableModel;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.CategoryAxis;
import org.jfree.chart.axis.CategoryLabelPositions;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.DatasetRenderingOrder;
import org.jfree.chart.plot.IntervalMarker;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.category.BarRenderer;
import org.jfree.chart.renderer.category.CategoryItemRenderer;
import org.jfree.chart.renderer.category.LineAndShapeRenderer;
import org.jfree.chart.renderer.category.StackedBarRenderer;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.chart.title.LegendTitle;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.ui.RectangleEdge;

import com.itextpdf.text.BaseColor;
import com.itextpdf.text.Chunk;
import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.Font;
import com.itextpdf.text.Image;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.Phrase;
import com.itextpdf.text.pdf.BaseFont;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfTemplate;
import com.itextpdf.text.pdf.PdfWriter;

import C_R_Valides.Consultation_Frame;
import Comptage.Comptage_Frame;
import IPLAC.Database;
import IPLAC.ExcelAdapter;
import IPLAC.JTable_IPLAC_Renderer;
import IPLAC.JTable_Italic_Renderer;
import IPLAC.JTable_Renderer;
import IPLAC.LinearRegression;
import IPLAC.MCS_Query;

public class Gestion_IPLAC_Frame extends JFrame {
	private static final long serialVersionUID = 1L;
	private Locale locale;
	@SuppressWarnings("unused")
	private boolean IPLACOuvert=true;

	private MCS_Query c_query;

	public String db_link;
	
	//cration du chemin vers dossier docs
	private String pathDocs = new String("Docs");

	private Gestion_IPLAC_Frame self = this;

	String nomLac, date, code6L, nomTaxon, confer, nomAuteur, Biovol, codeRef, anne, calculNum, calculDeno, mcs, etat, altitude, profondeur, chloa, mba, iplac
	,periode, priseEnCompteTitre, nombreCampagnes, taxTotal, taxContributifs, pourcentContributifs, nbSp, pourcentSp, nbIndic, pourcentIndic, embranchement,
	classeMBA, classeMCS, classeIPLAC, coteSpec, coefSteno, MCSc, limHG, limGM,limMP,limPB, critresBloquants, critresInformatifs,
	mcsBrute, mcsRef, nbCampsHP, nbCampsValides, moyenneChloro, mbaRef, fichier, outilsTexte, copierTexte, collerTexte, 
	fermer, purgerMBA, purgerMCS, calculIPLAC, importPhytobs, analyse, veuillezPatienter, contraintes, minimum, 
	prparationDonnes, prparationDonnesMBA, prparationDonnesMCS, taxonManquant, dateManquanteMCS, planEauManquant, dateManquanteMBA, altProfManquante, 
	altProfDiffrente, chloroManquanteMBA, ligneMBAManquante, calculMBA, non, nbCampValide,
	calculMCS, calculIPLACEnCours, debPer, finPer, nbreCampMin, nbreTaxTot, nbreTaxContrib, analyseResultats, horsPriode, 
	nbTaxonsInd, nbTaxGenres, nbTaxTot, nbTaxContrib, donnesUtilisateurMBA, donnesUtilisateurMCS, donnesListeCote, 
	analyseDonnesFichier, sortieMCSCamp, sortieMCS, sortieMBA, sortieIPLAC, ficheSynthetique, modifierContraintes, pdfContraintes, 
	pdfDebutContrainte, pdfFinContrainte, pdfMinCamp, pdfTaxTot, pdfTaxContrib, pdfDfaut, pdfMoyMCS, pdfAnne, crationFichiers,
	pdfBiovolRelatif, pdfBiovolTotal, pdfProfondeur, pdfClasseMBA, pdfClasseMCS, pdfClasseIPLAC, pdfMoyChloro, pdfRefChloro, 
	pdfNbCamp, pdfNbCampUtil, pdfMCSAnnuelle, pdfRefMCS, pdfRefMBA, pdfMois, pdfChloro, pdfMCSCamp, pdfContrib, pdfNonCotes, 
	pdfgenre, pdfInd, pdfNbTaxons, pdfDate, pdfBiovolRelatifContrib, pdfTaxons, pdfBiovolRelatifPourcent, pdfBiovolTotalUnit, 
	pdfRpartitionEmbranchement, pdfmcsRef, validerTexte, et, pdfGenre, pdfMoyMBA;

	JLabel banniere = new JLabel("", 
			new ImageIcon(getClass().getClassLoader().getResource("images/banniere.jpg")), 
			JLabel.TRAILING);
	
	// Dclaration des tables contenues dans les onglets
	private JTable tableauMBA = new JTable();
	private JTable tableauMCS = new JTable();
	private JTable tableauIPLAC = new JTable();
	private JTable tableauAnalyse = new JTable();

	JTabbedPane onglets = new JTabbedPane(SwingConstants.TOP); // Pannel contenant les onglets

	JMenuBar menu_bar = new JMenuBar();

	JMenu file_menu = new JMenu(fichier);
	JMenu outils = new JMenu();
	JMenu plus = new JMenu("?");
	JMenu apropos = new JMenu();
	JMenu pref = new JMenu();
	JMenu version = new JMenu();
	JMenu menu = new JMenu();

	private JMenuItem copier = new JMenuItem(copierTexte);
	private JMenuItem coller = new JMenuItem(collerTexte);
	private JMenuItem close_menu_item = new JMenuItem(fermer);
	private JMenuItem purge_mba=new JMenuItem();
	private JMenuItem purge_mcs=new JMenuItem();
	private JMenuItem calcul_iplac=new JMenuItem();
	private JMenuItem import_donnes=new JMenuItem();
	JMenuItem infos = new JMenuItem();
	private JMenuItem contraintes_par_dfaut = new JRadioButtonMenuItem();
	private JMenuItem contraintes_modifier = new JRadioButtonMenuItem();
	private JMenuItem derniereDate = new JMenuItem();
	private JMenuItem notice = new JMenuItem();
	private JMenuItem comptage = new JMenuItem();
	private JMenuItem taxons = new JMenuItem();

	private JDialog modifier_les_contraintes = new JDialog();
	private JDialog patienter = new JDialog();

	private JPanel pannel2 = new JPanel();
	private JPanel pannelLogos = new JPanel();

	// Cases  cocher dans la fentre des contraintes
	private JCheckBox contrainte_nb = new JCheckBox();
	private JCheckBox contrainte_dbut = new JCheckBox();
	private JCheckBox contrainte_fin = new JCheckBox();
	private JCheckBox contrainte_contributifs = new JCheckBox();
	private JCheckBox contrainte_total = new JCheckBox();
	private JCheckBox contrainte_pourc_sp = new JCheckBox();
	private JCheckBox contrainte_pourc_ind = new JCheckBox();

	// Champs de texte affichant les contraintes
	private JTextField campMin= new JTextField();
	private JTextField debPeriode = new JTextField();
	private JTextField endPeriode = new JTextField();
	private JTextField camp_Min_= new JTextField();
	private JTextField deb_Periode_ = new JTextField();
	private JTextField end_Periode_ = new JTextField();
	private JTextField taxContrib= new JTextField();
	private JTextField taxTot = new JTextField();
	private JTextField tax_Contrib_ = new JTextField();
	private JTextField tax_Tot_= new JTextField();
	private JTextField pourcSp = new JTextField();
	private JTextField pourcInd = new JTextField();

	//Labels des contraintes
	private JLabel nbCamps = new JLabel();
	private JLabel debut = new JLabel();
	private JLabel finPeriode = new JLabel();
	private JLabel taxonsContributifs = new JLabel();
	private JLabel taxonsTotaux = new JLabel();
	private JLabel pourcentageSp = new JLabel();
	private JLabel pourcentageIndtermins = new JLabel();

	// Bouton de validation des contraintes
	private JButton valider = new JButton();

	private Comptage_Frame cf = null;

	int nbCampagnesMini;

	boolean modifiable = true;

	public Gestion_IPLAC_Frame(Locale locale, String db_link, String camp_mini, String deb_periode, String fin_periode, boolean parDfaut, boolean modifi) 
	{	
		super();

		this.locale = locale;
		this.db_link = db_link;

		// rcupration dimensions de l'cran principal
		GraphicsDevice screenSize = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
		int largeur = screenSize.getDisplayMode().getWidth();
		int hauteur = screenSize.getDisplayMode().getHeight();

		super.setSize(new Dimension(largeur-100, hauteur-100));
		super.setBackground(new Color(192, 197, 199));
		
		super.setTitle(banniere.getText());
		
		translate();
		c_query = new MCS_Query(db_link);
		derniereDate.setText(c_query.get_last_date());

		add_menus(camp_mini, deb_periode, fin_periode, parDfaut, modifi);
		add_tableaux();

		ImageIcon logo_icon_avenir = new ImageIcon(getClass().getClassLoader().getResource("images/Logo-investissement-avenir.png"));
		JLabel logo_avenir = new JLabel(logo_icon_avenir);
		logo_avenir.setHorizontalAlignment(JLabel.LEFT);
		logo_avenir.setVerticalAlignment(JLabel.BOTTOM);

		pannelLogos.add(logo_avenir);

		ImageIcon logo_icon_labex = new ImageIcon(getClass().getClassLoader().getResource("images/PictoCOTE.png"));
		JLabel logo_labex = new JLabel(logo_icon_labex);
		logo_labex.setHorizontalAlignment(JLabel.LEFT);
		logo_labex.setVerticalAlignment(JLabel.BOTTOM);

		pannelLogos.add(logo_labex);

		ImageIcon logo_icon = new ImageIcon(getClass().getClassLoader().getResource("images/Logo_Irstea_red.png"));
		JLabel logo = new JLabel(logo_icon);
		logo.setHorizontalAlignment(JLabel.RIGHT);
		logo.setVerticalAlignment(JLabel.BOTTOM);

		pannelLogos.add(logo, BorderLayout.LINE_END);

		pannelLogos.setBackground(new Color(192, 197, 199));
		super.getContentPane().setBackground(new Color(192, 197, 199));

		super.getContentPane().add(pannelLogos, BorderLayout.SOUTH);

		super.setJMenuBar(menu_bar);
		super.setResizable(true);
		super.setVisible(true);

		add_pannel();
		add_handlers();
	}

	// boolen pour ne pas autoriser la fermeture de l'application si l'cran comptage
	// est ouvert avec un comptage 
	public boolean get_closable()
	{
		return ((cf != null && cf.get_id_cpt() != 0) ? false : true);
	}

	private void add_menus(String camp_mini, String deb_periode, String fin_periode, boolean parDfaut, boolean modifi)
	{
		campMin.setText(camp_mini);
		debPeriode.setText(deb_periode);
		endPeriode.setText(fin_periode);

		version.add(derniereDate);

		apropos.add(infos);
		apropos.add(version);

		menu.add(taxons);
		menu.add(comptage);
		menu.add(close_menu_item);

		file_menu.add(copier);
		file_menu.add(coller);
		file_menu.add(import_donnes);

		contraintes_par_dfaut.setSelected(parDfaut);
		contraintes_modifier.setSelected(modifi);

		outils.add(purge_mba);
		outils.add(purge_mcs);
		outils.add(calcul_iplac);

		pref.add(contraintes_par_dfaut);
		pref.add(contraintes_modifier);

		plus.add(notice);
		plus.add(version);
		plus.add(apropos);

		menu_bar.add(menu);
		menu_bar.add(file_menu);
		menu_bar.add(outils);
		menu_bar.add(pref);
		menu_bar.add(plus);
	}

	private void add_tableaux()
	{
		JPanel pannel = new JPanel();
		JPanel onglet1 = new JPanel();

		onglet1.setPreferredSize(new Dimension((int)super.getWidth()-100, (int)super.getHeight()-175));
		add_table_MBA(onglet1);
		onglet1.setLayout(new GridLayout(1,1));

		onglets.addTab(mba, onglet1);

		JPanel onglet2 = new JPanel();
		onglet2.setPreferredSize(new Dimension((int)super.getWidth()-100, (int)super.getHeight()-175));
		add_table_MCS(onglet2);
		onglet2.setLayout(new GridLayout(1,1));

		onglets.addTab(mcs, onglet2);

		JPanel onglet3 = new JPanel();
		onglet3.setPreferredSize(new Dimension((int)super.getWidth()-100, (int)super.getHeight()-175));
		add_table_Analyse(onglet3);
		onglet3.setLayout(new GridLayout(1,1));

		onglets.addTab(analyse, onglet3);

		JPanel onglet4 = new JPanel();
		onglet4.setPreferredSize(new Dimension((int)super.getWidth()-100, (int)super.getHeight()-175));
		add_table_IPLAC(onglet4);
		onglet4.setLayout(new GridLayout(1,1));

		onglets.addTab(iplac, onglet4);

		onglets.setOpaque(true);
		onglets.setBackground(new Color(192, 197, 199));

		pannel.add(onglets);
		pannel.setBackground(new Color(192, 197, 199));
		super.getContentPane().add(pannel, BorderLayout.CENTER);
	}

	private void add_table_MBA(JPanel onglet)
	{
		//Les donnes du tableauMBA
		String[] columnNames = {nomLac, date, altitude, profondeur, chloa};
		tableauMBA = new JTable(new Object[50000][columnNames.length], columnNames);

		tableauMBA.getColumnModel().getColumn(0).setPreferredWidth(200);
		tableauMBA.getColumnModel().getColumn(1).setPreferredWidth(20);
		tableauMBA.getColumnModel().getColumn(2).setPreferredWidth(20);
		tableauMBA.getColumnModel().getColumn(3).setPreferredWidth(20);
		tableauMBA.getColumnModel().getColumn(4).setPreferredWidth(20);

		// Permettre le copier/coller
		@SuppressWarnings("unused")
		ExcelAdapter myAd = new ExcelAdapter(tableauMBA); 

		onglet.setLayout(new FlowLayout());

		JPanel table2 = new JPanel (new BorderLayout ());

		table2.add (tableauMBA.getTableHeader (), BorderLayout.NORTH);
		table2.add (tableauMBA, BorderLayout.CENTER);
		table2.add(new JScrollPane(tableauMBA));

		onglet.add(table2);
	}

	private void add_table_MCS(JPanel onglet)
	{
		//Les donnes du tableauMCS
		String[] columnNames = {nomLac, date, code6L, confer, nomTaxon, nomAuteur, Biovol};
		tableauMCS = new JTable(new Object[50000][columnNames.length], columnNames);
		tableauMCS.setSize(onglet.getWidth(),onglet.getHeight());

		tableauMCS.setDefaultRenderer(Object.class, new JTable_Italic_Renderer());

		// Permettre le copier/coller
		@SuppressWarnings("unused")
		ExcelAdapter myAd = new ExcelAdapter(tableauMCS); 

		JPanel table2 = new JPanel (new BorderLayout ());

		tableauMCS.getColumnModel().getColumn(0).setPreferredWidth(300);
		tableauMCS.getColumnModel().getColumn(1).setPreferredWidth(20);
		tableauMCS.getColumnModel().getColumn(2).setPreferredWidth(20);
		tableauMCS.getColumnModel().getColumn(3).setMaxWidth(25);
		tableauMCS.getColumnModel().getColumn(4).setPreferredWidth(150);
		tableauMCS.getColumnModel().getColumn(5).setPreferredWidth(100);
		tableauMCS.getColumnModel().getColumn(6).setPreferredWidth(20);

		table2.add (tableauMCS.getTableHeader (), BorderLayout.NORTH);
		table2.add (tableauMCS, BorderLayout.CENTER);
		table2.add(new JScrollPane(tableauMCS, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED));

		onglet.add(table2);
	}

	private void add_table_IPLAC(JPanel onglet)
	{
		//Les donnes du tableauIPLAC
		String[] columnNames = {nomLac, anne, mba, classeMBA, mcs, classeMCS, iplac, classeIPLAC};
		tableauIPLAC = new JTable(new Object[50000][columnNames.length], columnNames);
		tableauIPLAC.setSize(onglet.getWidth(),onglet.getHeight());

		JPanel table2 = new JPanel (new BorderLayout ());

		tableauIPLAC.getColumnModel().getColumn(0).setPreferredWidth(300);
		tableauIPLAC.getColumnModel().getColumn(1).setPreferredWidth(40);
		tableauIPLAC.getColumnModel().getColumn(2).setPreferredWidth(40);
		tableauIPLAC.getColumnModel().getColumn(3).setPreferredWidth(40);
		tableauIPLAC.getColumnModel().getColumn(4).setPreferredWidth(40);
		tableauIPLAC.getColumnModel().getColumn(5).setPreferredWidth(40);
		tableauIPLAC.getColumnModel().getColumn(6).setPreferredWidth(40);
		tableauIPLAC.getColumnModel().getColumn(7).setPreferredWidth(40);

		table2.add (tableauIPLAC.getTableHeader (), BorderLayout.NORTH);
		table2.add (tableauIPLAC, BorderLayout.CENTER);
		table2.add(new JScrollPane(tableauIPLAC, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED));

		onglet.add(table2);
	}

	private void add_table_Analyse(JPanel onglet)
	{
		//Les donnes du tableauAnalyse
		String[] columnNames = {nomLac, periode, priseEnCompteTitre, nombreCampagnes, taxTotal, 
				taxContributifs, pourcentContributifs, nbSp, pourcentSp, nbIndic, pourcentIndic};
		tableauAnalyse = new JTable(new Object[50000][columnNames.length], columnNames);

		tableauAnalyse.getColumnModel().getColumn(0).setPreferredWidth(250);
		tableauAnalyse.getColumnModel().getColumn(1).setPreferredWidth(50);
		tableauAnalyse.getColumnModel().getColumn(2).setPreferredWidth(50);
		tableauAnalyse.getColumnModel().getColumn(3).setPreferredWidth(50);
		tableauAnalyse.getColumnModel().getColumn(4).setPreferredWidth(50);
		tableauAnalyse.getColumnModel().getColumn(5).setPreferredWidth(50);
		tableauAnalyse.getColumnModel().getColumn(6).setPreferredWidth(50);
		tableauAnalyse.getColumnModel().getColumn(7).setPreferredWidth(50);
		tableauAnalyse.getColumnModel().getColumn(8).setPreferredWidth(50);
		tableauAnalyse.getColumnModel().getColumn(9).setPreferredWidth(50);
		tableauAnalyse.getColumnModel().getColumn(10).setPreferredWidth(50);

		JPanel table2 = new JPanel (new BorderLayout ());
		// ajoute les entetes au nord du conteneur

		table2.add (tableauAnalyse.getTableHeader (), BorderLayout.NORTH);
		table2.add (tableauAnalyse, BorderLayout.CENTER);
		table2.add(new JScrollPane(tableauAnalyse, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED));

		onglet.add(table2);
	}

	// mthode pour crire un fichier de sortie ou d'entre
	public void ecrire(String dossier,String nomFic, String entete, JTable tableauMBA) {
		// pour les traductions boites de dialogues entre autres
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		PrintWriter pw;
		if(!new File(dossier).exists())	{
			new File(dossier).mkdirs(); // Crer le dossier avec tous ses parents
		}

		// alerte si fichier(s) entre ou sortie dj ouvert
		boolean accesLibre = false;

		try {
			pw = new PrintWriter(new BufferedWriter(new FileWriter(nomFic, false)));
			accesLibre = true;
			// >>>> on ajoutera aprs suppression de ce qui existait ventuellement
			pw.print("");// ajout de la ligne vierge si print sans ln bien entendu
			pw.close();
		} catch (FileNotFoundException fNot) {
			accesLibre = false;
			new JOptionPane();
			JOptionPane.showMessageDialog(patienter, 
					rb.getString("mssgFichierOuvert"),
					rb.getString("titreBoxFichierOuvert"), JOptionPane.WARNING_MESSAGE);
		} catch (IOException e) {
			e.printStackTrace();
		} 

		if(accesLibre){
			try {
				pw = new PrintWriter(new BufferedWriter(new FileWriter(nomFic, false)));
				// >>>> on ajoutera aprs suppression de ce qui existait ventuellement
				pw.print("");// ajout de la ligne vierge si print sans ln bien entendu
				pw.close();
			} catch (IOException e) {
				e.printStackTrace();
			} 


			String adressedufichier = nomFic; //on va chercher le chemin et le nom du fichier et on met tout ca dans un String
			try
			{
				/**
				 * BufferedWriter a besoin d un FileWriter, les 2 vont ensemble, on donne comme argument le nom du fichier
				 * true signifie qu on ajoute dans le fichier (append), on ne marque pas par dessus
				 */
				FileWriter fw = new FileWriter(adressedufichier, true);
				BufferedWriter output = new BufferedWriter(fw);
				output.write(entete);
				output.newLine();
				for(int i=0;i<tableauMBA.getRowCount();i++)
				{
					for(int j=0;j<tableauMBA.getColumnCount();j++)
					{
						if((String)tableauMBA.getValueAt(i, j)!=null)
						{
							output.write((String)tableauMBA.getValueAt(i, j)+";");
						}
						else
						{
							output.write(";"); // ; est le sparateur de colonnes dans excel
						}
					}
					output.newLine();
				}
				output.flush(); //ensuite flush envoie dans le fichier, ne pas oublier cette methode pour le BufferedWriter	
				output.close(); //et on le ferme		
			}
			catch(IOException ioe){
				System.out.print("Erreur : ");
				ioe.printStackTrace();
			}
		}
	}

	public void add_pannel()
	{		
		taxContrib.setText("5");
		taxTot.setText("10");
		pourcSp.setText("30");
		pourcInd.setText("10");

		Container contentPane = modifier_les_contraintes.getContentPane();
		SpringLayout layout = new SpringLayout();
		contentPane.setLayout(layout);
		contentPane.setBackground(new Color(192, 197, 199));

		pannel2.setLayout(new FlowLayout());

		camp_Min_.setPreferredSize(new Dimension(50, 20)); // taille du champs de camapagnes minimales autoris
		deb_Periode_.setPreferredSize(new Dimension(50, 20)); // taille du champs de priode minimale
		end_Periode_.setPreferredSize(new Dimension(50, 20)); // taille du champs de priode maximale
		tax_Contrib_.setPreferredSize(new Dimension(50, 20));
		tax_Tot_.setPreferredSize(new Dimension(50, 20));
		pourcSp.setPreferredSize(new Dimension(50, 20));
		pourcInd.setPreferredSize(new Dimension(50, 20));

		contentPane.add(contrainte_nb); 
		contentPane.add(nbCamps);
		contentPane.add(camp_Min_);

		contentPane.add(contrainte_dbut);
		contentPane.add(debut);
		contentPane.add(deb_Periode_);

		contentPane.add(contrainte_fin);
		contentPane.add(finPeriode);
		contentPane.add(end_Periode_);

		contentPane.add(contrainte_contributifs);
		contentPane.add(taxonsContributifs);
		contentPane.add(tax_Contrib_);

		contentPane.add(contrainte_total);
		contentPane.add(taxonsTotaux);
		contentPane.add(tax_Tot_);

		contentPane.add(contrainte_pourc_sp);
		contentPane.add(pourcentageSp);
		contentPane.add(pourcSp);

		contentPane.add(contrainte_pourc_ind);
		contentPane.add(pourcentageIndtermins);
		contentPane.add(pourcInd);

		contentPane.add(valider);

		layout.putConstraint(SpringLayout.WEST, contrainte_nb, 5, SpringLayout.WEST, contentPane);
		layout.putConstraint(SpringLayout.NORTH, contrainte_nb, 5, SpringLayout.NORTH, contentPane);

		//Adjust constraints for the text field so it's at
		//(<label's right edge> + 5, 5).
		layout.putConstraint(SpringLayout.WEST, nbCamps, 5, SpringLayout.EAST, contrainte_nb);
		layout.putConstraint(SpringLayout.NORTH, nbCamps, 7, SpringLayout.NORTH, contentPane);

		layout.putConstraint(SpringLayout.EAST, camp_Min_, -5, SpringLayout.EAST, contentPane);
		layout.putConstraint(SpringLayout.NORTH, camp_Min_, 5, SpringLayout.NORTH, contentPane);


		layout.putConstraint(SpringLayout.WEST, contrainte_dbut, 0, SpringLayout.WEST, contrainte_nb);
		layout.putConstraint(SpringLayout.NORTH, contrainte_dbut, 5, SpringLayout.SOUTH, contrainte_nb);

		layout.putConstraint(SpringLayout.WEST, debut, 0, SpringLayout.WEST, nbCamps);
		layout.putConstraint(SpringLayout.NORTH, debut, 2, SpringLayout.NORTH, contrainte_dbut);

		layout.putConstraint(SpringLayout.WEST, deb_Periode_, 0, SpringLayout.WEST, camp_Min_);
		layout.putConstraint(SpringLayout.NORTH, deb_Periode_, 5, SpringLayout.SOUTH, camp_Min_);


		layout.putConstraint(SpringLayout.WEST, contrainte_fin, 0, SpringLayout.WEST, contrainte_dbut);
		layout.putConstraint(SpringLayout.NORTH, contrainte_fin, 5, SpringLayout.SOUTH, contrainte_dbut);

		layout.putConstraint(SpringLayout.WEST, finPeriode, 0, SpringLayout.WEST, debut);
		layout.putConstraint(SpringLayout.NORTH, finPeriode, 2, SpringLayout.NORTH, contrainte_fin);

		layout.putConstraint(SpringLayout.WEST, end_Periode_, 0, SpringLayout.WEST, deb_Periode_);
		layout.putConstraint(SpringLayout.NORTH, end_Periode_, 5, SpringLayout.SOUTH, deb_Periode_);


		layout.putConstraint(SpringLayout.WEST, contrainte_contributifs, 0, SpringLayout.WEST, contrainte_fin);
		layout.putConstraint(SpringLayout.NORTH, contrainte_contributifs, 5, SpringLayout.SOUTH, contrainte_fin);

		layout.putConstraint(SpringLayout.WEST, taxonsContributifs, 0, SpringLayout.WEST, finPeriode);
		layout.putConstraint(SpringLayout.NORTH, taxonsContributifs, 7, SpringLayout.SOUTH, contrainte_fin);

		layout.putConstraint(SpringLayout.WEST, tax_Contrib_, 0, SpringLayout.WEST, end_Periode_);
		layout.putConstraint(SpringLayout.NORTH, tax_Contrib_, 5, SpringLayout.SOUTH, end_Periode_);


		layout.putConstraint(SpringLayout.WEST, contrainte_total, 0, SpringLayout.WEST, contrainte_contributifs);
		layout.putConstraint(SpringLayout.NORTH, contrainte_total, 5, SpringLayout.SOUTH, contrainte_contributifs);

		layout.putConstraint(SpringLayout.WEST, taxonsTotaux, 0, SpringLayout.WEST, taxonsContributifs);
		layout.putConstraint(SpringLayout.NORTH, taxonsTotaux, 7, SpringLayout.SOUTH, contrainte_contributifs);

		layout.putConstraint(SpringLayout.WEST, tax_Tot_, 0, SpringLayout.WEST, tax_Contrib_);
		layout.putConstraint(SpringLayout.NORTH, tax_Tot_, 5, SpringLayout.SOUTH, tax_Contrib_);


		layout.putConstraint(SpringLayout.WEST, contrainte_pourc_sp, 0, SpringLayout.WEST, contrainte_total);
		layout.putConstraint(SpringLayout.NORTH, contrainte_pourc_sp, 5, SpringLayout.SOUTH, contrainte_total);

		layout.putConstraint(SpringLayout.WEST, pourcentageSp, 0, SpringLayout.WEST, taxonsTotaux);
		layout.putConstraint(SpringLayout.NORTH, pourcentageSp, 7, SpringLayout.SOUTH, contrainte_total);

		layout.putConstraint(SpringLayout.WEST, pourcSp, 0, SpringLayout.WEST, tax_Tot_);
		layout.putConstraint(SpringLayout.NORTH, pourcSp, 5, SpringLayout.SOUTH, tax_Tot_);


		layout.putConstraint(SpringLayout.WEST, contrainte_pourc_ind, 0, SpringLayout.WEST, contrainte_pourc_sp);
		layout.putConstraint(SpringLayout.NORTH, contrainte_pourc_ind, 5, SpringLayout.SOUTH, contrainte_pourc_sp);

		layout.putConstraint(SpringLayout.WEST, pourcentageIndtermins, 0, SpringLayout.WEST, pourcentageSp);
		layout.putConstraint(SpringLayout.NORTH, pourcentageIndtermins, 7, SpringLayout.SOUTH, contrainte_pourc_sp);

		layout.putConstraint(SpringLayout.WEST, pourcInd, 0, SpringLayout.WEST, pourcSp);
		layout.putConstraint(SpringLayout.NORTH, pourcInd, 5, SpringLayout.SOUTH, pourcSp);


		layout.putConstraint(SpringLayout.WEST, valider, 165, SpringLayout.WEST, contentPane);
		layout.putConstraint(SpringLayout.SOUTH, valider, -5, SpringLayout.SOUTH, contentPane);

		// Cases non coches
		contrainte_nb.setSelected(false);
		contrainte_dbut.setSelected(false);
		contrainte_fin.setSelected(false);
		contrainte_contributifs.setSelected(false);
		contrainte_total.setSelected(false);
		contrainte_pourc_sp.setSelected(false);
		contrainte_pourc_ind.setSelected(false);

		camp_Min_.setText(campMin.getText().substring(0, 1));
		deb_Periode_.setText(debPeriode.getText().substring(0, 5));
		end_Periode_.setText(endPeriode.getText().substring(0, 5));
		tax_Contrib_.setText(taxContrib.getText());
		tax_Tot_.setText(taxTot.getText());

		// Champs non ditables
		camp_Min_.setEditable(false);
		deb_Periode_.setEditable(false);
		end_Periode_.setEditable(false);
		tax_Contrib_.setEditable(false);
		tax_Tot_.setEditable(false);
		pourcSp.setEditable(false);
		pourcInd.setEditable(false);

		// Mise en place de la couleur de fond
		contrainte_nb.setBackground(new Color(192, 197, 199));
		contrainte_dbut.setBackground(new Color(192, 197, 199));
		contrainte_fin.setBackground(new Color(192, 197, 199));
		contrainte_contributifs.setBackground(new Color(192, 197, 199));
		contrainte_total.setBackground(new Color(192, 197, 199));
		contrainte_pourc_sp.setBackground(new Color(192, 197, 199));
		contrainte_pourc_ind.setBackground(new Color(192, 197, 199));

		// Mise en page du pannel principal
		pannel2.setBackground(new Color(192, 197, 199));
	}

	private void add_handlers()
	{

		this.addWindowListener(
				new WindowAdapter() {
					public void windowClosing(WindowEvent arg0) {
						close_menu_item.doClick();
						IPLACOuvert=false;
						self.dispose();
					}});

		purge_mba.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						for(int i=0;i<tableauMBA.getRowCount();i++)
						{
							if(tableauMBA.getValueAt(i, 0)!=null || tableauMBA.getValueAt(i, 1)!=null
									|| tableauMBA.getValueAt(i, 2)!=null)
							{
								for(int j=0;j<tableauMBA.getColumnCount();j++)
								{
									tableauMBA.setValueAt(null, i, j);
								}
							}
						}
						// retour en permire ligne, premire cel
						tableauMBA.changeSelection(0,0, false, false);
					}
				});

		purge_mcs.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						for(int i=0;i<tableauMCS.getRowCount();i++)
						{
							if(tableauMCS.getValueAt(i, 0)!=null)
							{
								for(int j=0;j<tableauMCS.getColumnCount();j++)
								{
									tableauMCS.setValueAt(null, i, j);
								}
							}
						}
						// retour en permire ligne, premire cel
						tableauMCS.changeSelection(0,0, false, false);
					}
				});

		// TODO CALCUL D'IPLAC
		calcul_iplac.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						patienter.setTitle(veuillezPatienter);

						miseEnPlaceAttente();

						tableauAnalyse.setEnabled(true);

						empty_table(tableauAnalyse);
						empty_table(tableauIPLAC);

						String[] columnNames = {nomLac, date, altitude, profondeur, chloa,"nom auteur"};	
						String[] nomColonnes = {nomLac,date,"Moy Chloro","Ref","H/G seuil","G/M seuil","M/P seuil","P/B seuil","H/G EQR","G/M EQR","M/P EQR","P/B EQR","MBA EQR","MBA normalise","ClasseMBA", etat};
						String[] nomColonnesTMCS = {nomLac, date, code6L, confer, nomTaxon,nomAuteur, Biovol, codeRef, coteSpec, coefSteno, embranchement};
						String[] nomColonnesCampagne = {"colCoteSpec", "colCoefSteno", "colCodeRef"};
						String[] nomColonnesRsultats = {nomLac,date,"MCS_brute","MCS_Ref","H/G","G/M","M/P","P/B","MCS EQR","MCSnEQR","ClasseMCS","Nb_camp_HP","Nb_camp_valide","Valide"};
						String[] nomColonnesIntermdiaire = {nomLac, date, "MCSc", "Etat", "Bloquant", "Informatif" };
						String[] colonnesRfrence = {"code6L","codeRef","embranchement"};
						String[] IPLACFichier = {nomLac, anne, mba, classeMBA, mcs, classeMCS, iplac, classeIPLAC, "Critres bloquants","Critres informatifs","Contraintes"}; 

						JTable tableMCS = new JTable(new Object[50000][nomColonnesTMCS.length],nomColonnesTMCS);
						JTable listeCote = new JTable(new Object[50000][nomColonnesCampagne.length], nomColonnesCampagne);
						JTable miseAJourCodes = new JTable(new Object[50000][colonnesRfrence.length],colonnesRfrence);
						JTable resultatsMCS = new JTable(new Object[50000][nomColonnesRsultats.length], nomColonnesRsultats);
						JTable MCS_campagne = new JTable(new Object[50000][nomColonnesIntermdiaire.length], nomColonnesIntermdiaire);
						JTable tableIPLAC = new JTable(new Object[50000][IPLACFichier.length], IPLACFichier);

						DefaultTableModel model = new DefaultTableModel();
						listeCote.setModel(model);
						((DefaultTableModel)listeCote.getModel()).setColumnIdentifiers(nomColonnesCampagne);

						DefaultTableModel modle = new DefaultTableModel();
						miseAJourCodes.setModel(modle);
						((DefaultTableModel)miseAJourCodes.getModel()).setColumnIdentifiers(colonnesRfrence);

						c_query.fill_table(listeCote,miseAJourCodes);

						double numerateur=0;
						double denominateur=0;
						double sommeCampagnes=0;

						int nbTaxonsTotaux=0;
						int nbTaxonsInd=0;
						int nbTaxonsContrib=0;
						int nbTaxonsSp=0;
						int nbCampagnes=0;
						int nbCampagnesHorsPriode=0;
						int indiceMCSCampagne=1;
						int fin=0;
						int i;
						int placeFinal=0;
						int indiceMBA=0;
						int indiceMCS=0;
						int ligneIPLAC=0;

						DecimalFormat f2 = new DecimalFormat();
						f2.setMaximumFractionDigits(3);

						DecimalFormat f = new DecimalFormat();
						f.setMaximumFractionDigits(1);

						float moyChloro;
						float refChloro=0;
						JTable tableMBA = new JTable(new Object[50000][nomColonnes.length],nomColonnes);

						int nbChloro=0;
						int place=0;

						nbCampagnesMini=Integer.parseInt(campMin.getText());

						moyChloro=0;
						patienter.setTitle(prparationDonnes);
						try {
							SimpleDateFormat da = new SimpleDateFormat("dd/MM/yyyy");
							Date priodeDbut = da.parse(debPeriode.getText());
							Calendar contrainteDbut= Calendar.getInstance();
							Calendar contrainteFin= Calendar.getInstance();
							Date priodeFin = da.parse(endPeriode.getText());
							contrainteDbut.setTime(priodeDbut);
							contrainteFin.setTime(priodeFin);
							Date d;
							Calendar cal= Calendar.getInstance();
							@SuppressWarnings("unused")
							Calendar calPrec = Calendar.getInstance();
							Calendar calDeb = Calendar.getInstance();
							Calendar calFin = Calendar.getInstance();
							Date debutPeriode =da.parse(debPeriode.getText());
							calDeb.setTime(debutPeriode);
							Date finPeriode = da.parse(endPeriode.getText());
							calFin.setTime(finPeriode);
							patienter.setTitle(prparationDonnesMBA);
							trierMBA(tableauMBA, columnNames);
							patienter.setTitle(prparationDonnesMCS);
							trierMCS(tableauMCS, nomColonnesTMCS);

							// vrification donnes manquantes table MCS
							for(i=0;i<tableauMCS.getRowCount();i++)
							{
								if(tableauMCS.getValueAt(i, 0)!=null)
								{
									for(int j=0;j<tableauMCS.getColumnCount();j++)
									{
										if(String.valueOf(tableauMCS.getValueAt(i, 2)).isEmpty())
										{
											patienter.setTitle(taxonManquant);
											return;
										}
										if(String.valueOf(tableauMCS.getValueAt(i, 1)).isEmpty())
										{
											patienter.setTitle(dateManquanteMCS);
											return;
										}
										tableMCS.setValueAt(tableauMCS.getValueAt(i, j), i, j);	
									}
								}
								if(tableauMCS.getValueAt(i, 1)!=null || tableauMCS.getValueAt(i, 2)!=null)
								{
									if(String.valueOf(tableauMCS.getValueAt(i, 0)).isEmpty())
									{
										patienter.setTitle(planEauManquant);
										return;
									}
								}
							}

							// vrification donnes manquantes table MBA
							for(i=0;i<tableauMBA.getRowCount();i++)
							{
								if(tableauMBA.getValueAt(i, 0)!=null)
								{
									for(int j=0;j<tableauMBA.getColumnCount();j++)
									{
										if(String.valueOf(tableauMBA.getValueAt(i, 1)).isEmpty())
										{
											patienter.setTitle(dateManquanteMBA);
											return;
										}
										if(String.valueOf(tableauMBA.getValueAt(i, 2)).isEmpty() || String.valueOf(tableauMBA.getValueAt(i, 3)).isEmpty())
										{
											patienter.setTitle(altProfManquante);
											return;
										}
										if(i>0 && String.valueOf(tableauMBA.getValueAt(i,0)).toUpperCase().compareTo(String.valueOf(tableauMBA.getValueAt(i-1, 0)).toUpperCase())==0 
												&& (String.valueOf(tableauMBA.getValueAt(i, 2)).compareTo(String.valueOf(tableauMBA.getValueAt(i-1, 2)))!=0 
												|| String.valueOf(tableauMBA.getValueAt(i, 3)).compareTo(String.valueOf(tableauMBA.getValueAt(i-1, 3)))!=0))
										{
											patienter.setTitle(altProfDiffrente);
											return;
										}
										if(String.valueOf(tableauMBA.getValueAt(i, 4)).isEmpty())
										{
											patienter.setTitle(chloroManquanteMBA);
											return;
										}

									}
								}
								if(tableauMBA.getValueAt(i, 1)!=null || tableauMBA.getValueAt(i, 2)!=null)
								{
									if(String.valueOf(tableauMBA.getValueAt(i, 0)).isEmpty())
									{
										patienter.setTitle(planEauManquant);
										return;
									}
								}
							}

							// vrification des donnes de MCS sans ligne de MBA en face
							for(i=0;i<tableauMCS.getRowCount();i++)
							{	
								boolean testPE=false;

								if(tableauMCS.getValueAt(i, 0)!=null)
								{
									for(int j=0;j<tableauMBA.getRowCount();j++)
									{
										if(String.valueOf(tableauMCS.getValueAt(i, 0)).compareTo(String.valueOf(tableauMBA.getValueAt(j, 0)))==0)
										{

											testPE=true;
										}
									}
									if(!testPE)
									{
										patienter.setTitle(ligneMBAManquante);
										return;
									}
								}
							}

							for(i=0;i<tableMCS.getRowCount();i++)
							{
								if(tableMCS.getValueAt(i, 0)!=null)
								{
									for(int j=0;j<miseAJourCodes.getRowCount();j++)
									{
										if(String.valueOf(tableMCS.getValueAt(i, 2)).compareTo(String.valueOf(miseAJourCodes.getValueAt(j, 0)))==0)
										{
											tableMCS.setValueAt(miseAJourCodes.getValueAt(j, 1),i,2);
											if(tableauMCS.getValueAt(i, 6)==null && tableauMCS.getValueAt(i, 2)!=null)
											{
												tableMCS.setValueAt(c_query.auteurTaxon(String.valueOf(tableMCS.getValueAt(i, 2))), i, 5);
												tableauMCS.setValueAt(c_query.auteurTaxon(String.valueOf(tableauMCS.getValueAt(i, 2))), i, 5);
											}
											tableMCS.setValueAt(miseAJourCodes.getValueAt(j, 2),i,10);
										}
									}
								}
							}

							patienter.setTitle(calculMBA);
							d=da.parse(String.valueOf(tableauMBA.getValueAt(0, 1)));
							cal.setTime(d);
							if(cal.get(Calendar.DAY_OF_YEAR)>=calDeb.get(Calendar.DAY_OF_YEAR) && cal.get(Calendar.DAY_OF_YEAR)<=calFin.get(Calendar.DAY_OF_YEAR))
							{
								moyChloro=Float.parseFloat(String.valueOf(tableauMBA.getValueAt(0, 4)));
								nbChloro=1;
							}

							calculerMBA(refChloro, moyChloro, nbChloro, tableMBA, place);

							patienter.setTitle(calculMCS);
							i=0;

							calculerMCS(fin, i, nbTaxonsTotaux, nbTaxonsContrib, nbTaxonsInd, nbTaxonsSp,numerateur, denominateur, sommeCampagnes, 
									nbCampagnes, nbCampagnesHorsPriode, indiceMCSCampagne, tableMCS, listeCote, MCS_campagne, resultatsMCS, placeFinal);
							patienter.setTitle(calculIPLACEnCours);
							calculerIPLAC(indiceMBA, indiceMCS, ligneIPLAC, tableMBA, resultatsMCS, tableIPLAC);

							indiceMBA=0;
							indiceMCS=0;
							int indiceAnalyse=1;
							int priseEnCompte=0;
							int placeSomme=1;
							nbTaxonsTotaux=0;
							nbTaxonsInd=0;
							nbTaxonsContrib=0;
							nbTaxonsSp=0;
							indiceMCSCampagne=0;
							ligneIPLAC=0;
							patienter.setTitle(analyseResultats);

							analyserDonnes(indiceMBA, indiceMCS, indiceAnalyse, placeSomme, priseEnCompte, ligneIPLAC,
									nbTaxonsTotaux, nbTaxonsContrib, nbTaxonsSp, nbTaxonsInd, indiceMCSCampagne, tableIPLAC,
									tableMCS, listeCote, MCS_campagne);

							for(i=0;i<tableauMCS.getRowCount();i++)
							{
								if(tableauMCS.getValueAt(i, 2)!=null)
								{
									tableMCS.setValueAt(String.valueOf(tableauMCS.getValueAt(i, 2)), i, 2);
								}
							}
							indiceMCSCampagne=0;
							ligneIPLAC=0;
							while(MCS_campagne.getValueAt(indiceMCSCampagne, 0)!=null)
							{
								if(indiceMCSCampagne>0)
								{
									if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 0)).compareTo(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne-1, 0)))!=0 
											|| String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 1)).substring(6, 10).compareTo(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne-1, 1)).substring(6, 10))!=0)
									{
										while(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 0)).compareTo(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 0)))!=0 
												&& String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 1)).compareTo(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 1)).substring(6, 9))!=0)
										{
											ligneIPLAC+=1;
										}
									}
								}

								if(MCS_campagne.getValueAt(indiceMCSCampagne, 4)!=null)
								{
									if(tableIPLAC.getValueAt(ligneIPLAC, 8)==null)
									{
										tableIPLAC.setValueAt(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)), ligneIPLAC, 8);
									}
									else if(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 8)).compareTo(horsPriode)==0)
									{
										if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxContrib) && String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxTot)==false)
										{
											tableIPLAC.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), ligneIPLAC, 8);
										}
										else if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxContrib)==false && String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxTot))
										{
											tableIPLAC.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
										else if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxContrib) && String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxTot))
										{
											tableIPLAC.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
									}
									else if(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 8)).compareTo(nbTaxContrib+taxContrib.getText())==0)
									{
										if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(horsPriode) && String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxTot)==false)
										{
											tableIPLAC.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), ligneIPLAC, 8);
										}
										else if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(horsPriode)==false && String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxTot))
										{
											tableIPLAC.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
										else if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(horsPriode) && String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxTot))
										{
											tableIPLAC.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
									}
									else if(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 8)).compareTo(nbTaxTot+taxTot.getText())==0)
									{
										if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(horsPriode) && String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxContrib)==false)
										{
											tableIPLAC.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
										else if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(horsPriode)==false && String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxContrib))
										{
											tableIPLAC.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
										else if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(horsPriode) && String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxContrib))
										{
											tableIPLAC.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
									}
									else if(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 8)).contains(horsPriode) && String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 8)).contains(nbTaxContrib))
									{
										if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxTot))
										{
											tableIPLAC.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
									}
									else if(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 8)).contains(horsPriode) && String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 8)).contains(nbTaxTot))
									{
										if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(nbTaxContrib))
										{
											tableIPLAC.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
									}
									else if(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 8)).contains(nbTaxContrib) && String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 8)).contains(nbTaxTot))
									{
										if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 4)).contains(horsPriode))
										{
											tableIPLAC.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), ligneIPLAC, 8);
										}
									}
								}
								if(MCS_campagne.getValueAt(indiceMCSCampagne, 5)!=null)
								{
									if(tableIPLAC.getValueAt(ligneIPLAC, 9)==null)
									{
										tableIPLAC.setValueAt(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 5)), ligneIPLAC, 9);
									}
									if(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 9)).contains(nbTaxGenres))
									{
										if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 5)).contains(nbTaxonsInd))
										{
											tableIPLAC.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", ligneIPLAC, 9);
										}
									}
									else if(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 9)).contains(nbTaxonsInd))
									{
										if(String.valueOf(MCS_campagne.getValueAt(indiceMCSCampagne, 5)).contains(nbTaxGenres))
										{
											tableIPLAC.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", ligneIPLAC, 9);
										}
									}
								}
								indiceMCSCampagne+=1;
							}
						} catch (ParseException e1) {
							patienter.setVisible(false);
							e1.printStackTrace();
						}
						patienter.setTitle(crationFichiers);

						ecrire("Entree", "Entree" + File.separator + donnesUtilisateurMBA+".csv",nomLac+";"+date+";"+altitude+";"+profondeur+";"+chloa, tableauMBA);
						ecrire("Entree", "Entree" + File.separator + donnesUtilisateurMCS+".csv",nomLac+";"+date+";"+code6L+";"+confer+";"+nomTaxon+";"+nomAuteur+";"+Biovol+";"+codeRef+";"+coteSpec+";"+coefSteno+";"+embranchement, tableMCS);
						ecrire("Entree", "Entree" + File.separator + donnesListeCote+".csv",coteSpec+";"+coefSteno+";"+codeRef, listeCote);
						ecrire("Entree", "Entree" + File.separator + analyseDonnesFichier+".csv",nomLac+";"+periode+";"+priseEnCompteTitre+";"+nombreCampagnes+";"+taxTotal+";"+ 
								taxContributifs+";"+pourcentContributifs+";"+nbSp+";"+pourcentSp+";"+nbIndic+";"+pourcentIndic,tableauAnalyse);
						ecrire("Sortie", "Sortie" + File.separator + sortieMCSCamp+".csv",nomLac+";"+date+";"+MCSc+";"+etat+";"+critresBloquants+";"+critresInformatifs, MCS_campagne);
						ecrire("Sortie", "Sortie" + File.separator + sortieMCS+".csv",nomLac+";"+anne+";"+mcsBrute+";"+mcsRef+";"+limHG+";"+limGM+";"+limMP+";"+limPB+";MCS_EQR;MCSnEQR;"+classeMCS+";"+nbCampsHP+";"+nbCampsValides+";"+etat, resultatsMCS);
						ecrire("Sortie", "Sortie" + File.separator + sortieMBA+".csv",nomLac+";"+anne+";"+moyenneChloro+";"+mbaRef+";"+limHG+";"+limGM+";"+limMP+";"+limPB+";H/G_EQR;G/M_EQR;M/P_EQR;P/B_EQR;MBA_EQR;MBA_nEQR;"+classeMBA+";"+etat, tableMBA);
						ecrire("Sortie", "Sortie" + File.separator + sortieIPLAC+".csv",nomLac+";"+anne+";"+mba+";"+classeMBA+";"+mcs+";"+classeMCS+";"+iplac+";"+classeIPLAC+";"+critresBloquants+";"+critresInformatifs+";"+contraintes,tableIPLAC);
						try {
							createPdf("Sortie" + File.separator + ficheSynthetique+".pdf", tableauIPLAC, tableauMBA, tableauMCS, tableMBA, resultatsMCS, MCS_campagne, tableMCS);
						} catch (IOException | DocumentException e1) {
							e1.printStackTrace();
						}
						tableauAnalyse.setDefaultRenderer(Object.class, new JTable_Renderer());
						tableauIPLAC.setDefaultRenderer(Object.class, new JTable_IPLAC_Renderer());

						patienter.setVisible(false);
						onglets.setSelectedIndex(2);
					}
				});

		close_menu_item.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(ActionEvent e) {
						IPLACOuvert=false;
						self.dispose();
					}
				});

		// mise en place des contraintes par dfaut
		contraintes_par_dfaut.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(ActionEvent e) {
						campMin.setText("3");
						debPeriode.setText("01/05/"+Calendar.getInstance().get(Calendar.YEAR));
						endPeriode.setText("31/10/"+Calendar.getInstance().get(Calendar.YEAR));
						taxContrib.setText("5");
						taxTot.setText("10");
						pourcSp.setText("30");
						pourcInd.setText("10");

						contrainte_nb.setSelected(false);
						contrainte_dbut.setSelected(false);
						contrainte_fin.setSelected(false);
						contrainte_contributifs.setSelected(false);
						contrainte_total.setSelected(false);
						contrainte_pourc_sp.setSelected(false);
						contrainte_pourc_ind.setSelected(false);

						camp_Min_.setEditable(false);
						deb_Periode_.setEditable(false);
						end_Periode_.setEditable(false);
						tax_Contrib_.setEditable(false);
						tax_Tot_.setEditable(false);
						pourcSp.setEditable(false);
						pourcInd.setEditable(false);

						contraintes_par_dfaut.setSelected(true);
						contraintes_modifier.setSelected(false);
					}
				});

		// modification des contraintes
		contraintes_modifier.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(ActionEvent e) {
						camp_Min_.setText(campMin.getText().substring(0, 1));
						deb_Periode_.setText(debPeriode.getText().substring(0, 5));
						end_Periode_.setText(endPeriode.getText().substring(0, 5));
						tax_Contrib_.setText(taxContrib.getText());
						tax_Tot_.setText(taxTot.getText());

						modifier_les_contraintes.setTitle(modifierContraintes);

						Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
						modifier_les_contraintes.setSize(400, 250);
						modifier_les_contraintes.setFocusableWindowState(true);
						modifier_les_contraintes.setLocation(d.width/2 - modifier_les_contraintes.getWidth()/2, d.height/2 - modifier_les_contraintes.getHeight()/2);

						modifier_les_contraintes.getContentPane().add(pannel2);

						modifier_les_contraintes.setBackground(new Color(192, 197, 199));

						modifier_les_contraintes.setResizable(false);
						modifier_les_contraintes.setModal(true);
						modifier_les_contraintes.setVisible(true);

						contraintes_par_dfaut.setSelected(false);
						contraintes_modifier.setSelected(true);

						modifier_les_contraintes.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);	
					}
				});

		// choix du nombre de campagnes min
		contrainte_nb.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(ActionEvent arg0) {
						if(contrainte_nb.isSelected())
						{
							camp_Min_.setEditable(true);
						}
						else
						{
							camp_Min_.setEditable(false);
							camp_Min_.setText("3");
							campMin.setText("3");
						}
					}
				});

		// choix de la date de dbut
		contrainte_dbut.addActionListener(
				new ActionListener() {

					@Override
					public void actionPerformed(ActionEvent e) {
						if(contrainte_dbut.isSelected())
						{
							deb_Periode_.setEditable(true);
						}
						else
						{
							deb_Periode_.setEditable(false);
							deb_Periode_.setText("01/05");
							debPeriode.setText("01/05/"+Calendar.getInstance().get(Calendar.YEAR));
						}
					}
				});

		// choix de la date de fin
		contrainte_fin.addActionListener(
				new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						if(contrainte_fin.isSelected())
						{
							end_Periode_.setEditable(true);
						}
						else
						{
							end_Periode_.setEditable(false);
							end_Periode_.setText("31/10");
							endPeriode.setText("31/10/"+Calendar.getInstance().get(Calendar.YEAR));
						}
					}
				});

		// choix du nombre de taxons contributifs min
		contrainte_contributifs.addActionListener(
				new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						if(contrainte_contributifs.isSelected())
						{
							tax_Contrib_.setEditable(true);
						}
						else
						{
							tax_Contrib_.setEditable(false);
							tax_Contrib_.setText("5");
							taxContrib.setText("5");
						}
					}
				});

		// choix du nombre de taxons total min
		contrainte_total.addActionListener(
				new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						if(contrainte_total.isSelected())
						{
							tax_Tot_.setEditable(true);
						}
						else
						{
							tax_Tot_.setEditable(false);
							tax_Tot_.setText("10");
							taxTot.setText("10");
						}
					}
				});

		// choix du % de taxons sp max
		contrainte_pourc_sp.addActionListener(
				new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						if(contrainte_pourc_sp.isSelected())
						{
							pourcSp.setEditable(true);
						}
						else
						{
							pourcSp.setText("30");
							pourcSp.setEditable(false);
						}
					}
				});

		// choix du % de taxon ind max 
		contrainte_pourc_ind.addActionListener(
				new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						if(contrainte_pourc_ind.isSelected())
						{
							pourcInd.setEditable(true);
						}
						else
						{
							pourcInd.setText("10");
							pourcInd.setEditable(false);
						}
					}
				});

		// validation de l'cran des contraintes
		valider.addActionListener(
				new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						campMin.setText(camp_Min_.getText());
						debPeriode.setText(deb_Periode_.getText()+"/"+Calendar.getInstance().get(Calendar.YEAR));
						endPeriode.setText(end_Periode_.getText()+"/"+Calendar.getInstance().get(Calendar.YEAR));
						taxContrib.setText(tax_Contrib_.getText());
						taxTot.setText(tax_Tot_.getText());

						modifier_les_contraintes.dispose();

						contraintes_par_dfaut.setSelected(false);
						contraintes_modifier.setSelected(true);
					}	
				});

		coller.addActionListener( 
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						try {
							Robot robot = new Robot();
							robot.keyPress(KeyEvent.VK_CONTROL);
							robot.keyPress(KeyEvent.VK_V);

							robot.keyRelease(KeyEvent.VK_CONTROL);
							robot.keyRelease(KeyEvent.VK_V);
						} catch (AWTException e1) {
							e1.printStackTrace();
						}
					}
				});

		copier.addActionListener( 
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						try {
							Robot robot = new Robot();
							robot.keyPress(KeyEvent.VK_CONTROL);
							robot.keyPress(KeyEvent.VK_C);

							robot.keyRelease(KeyEvent.VK_CONTROL);
							robot.keyRelease(KeyEvent.VK_C);
						} catch (AWTException e1) {
							e1.printStackTrace();
						}
					}
				});

		import_donnes.addActionListener( 
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						int indiceNull=0;
						while(tableauMCS.getValueAt(indiceNull, 0)!=null)
						{
							indiceNull+=1;
						}
						new Database(locale, db_link).export_dce(tableauMCS, indiceNull);
					}
				});

		notice.addActionListener(
				new ActionListener() {
					@SuppressWarnings("static-access")
					public void actionPerformed(ActionEvent e) {
						ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

						File pdf = new File(pathDocs + File.separator + "notice.pdf");
						if(!pdf.exists())
							pdf = new File(pathDocs + File.separator + "notice.pdf");

						if(Desktop.isDesktopSupported()) 
						{
							if(Desktop.getDesktop().isSupported(java.awt.Desktop.Action.OPEN))
							{
								try { java.awt.Desktop.getDesktop().open(pdf);} 
								catch (IOException ex) { ex.printStackTrace(); }
							} 
							else 
								new JOptionPane().showMessageDialog(self, 
										rb.getString("mssgFonctionNonSupportee"), 
										rb.getString("titreBoxFonctionNonSupp"), JOptionPane.ERROR_MESSAGE);
						}
						else
							new JOptionPane().showMessageDialog(self, 
									rb.getString("mssgFonctionNonSupportee"), 
									rb.getString("titreBoxFonctionNonSupp"), JOptionPane.ERROR_MESSAGE);
					}});

		comptage.addActionListener(
				new ActionListener()  {
					public void actionPerformed(ActionEvent e) {
						cf= new Comptage_Frame(locale, db_link);
					}});

		taxons.addActionListener(
				new ActionListener()  {

					public void actionPerformed(ActionEvent e) {
						new Consultation_Frame(locale, db_link);
					}});

	}


	// TODO CREATION DU PDF DE SORTIE
	public void createPdf(String filename, JTable IPLACTable, JTable MBATable, JTable MCSTable, JTable resultatsMBA, JTable resultatsMCS, JTable MCSCamp, JTable tableMCS)
			throws IOException, DocumentException {

		// pour les traductions boites de dialogues entre autres
		final ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		// step 1
		Document document = new Document(PageSize.A4,0,0,0,0);

		Paragraph test = new Paragraph();
		Paragraph test2 = new Paragraph();
		Paragraph test3 = new Paragraph();

		BaseFont bf = BaseFont.createFont(
				BaseFont.TIMES_ROMAN,
				BaseFont.CP1252,
				BaseFont.EMBEDDED);
		Font fontH1 = new Font(bf, 10);

		BaseFont bf2 = BaseFont.createFont(
				BaseFont.TIMES_BOLD,
				BaseFont.CP1252,
				BaseFont.EMBEDDED);
		Font fontH2 = new Font(bf2, 11);

		// alerte si fichier pdf dj ouvert
		boolean accesLibre = false;					
		try {
			FileOutputStream testFlux = new FileOutputStream(filename);
			accesLibre = true;
			testFlux.close();
		} catch (FileNotFoundException notF) {
			accesLibre = false;
			new JOptionPane();
			JOptionPane.showMessageDialog(patienter, 
					rb.getString("mssgPdfOuvert"),
					rb.getString("titreBoxPdfOuvert"), JOptionPane.WARNING_MESSAGE);
		}

		if(accesLibre) {

			try {


				// step 2
				PdfWriter writer = PdfWriter.getInstance(document, new FileOutputStream(filename));

				// step 3
				document.open();	        
				PdfContentByte cb = writer.getDirectContent();
				// step 4
				SimpleDateFormat da = new SimpleDateFormat("dd/MM/yyyy");
				Date mois;
				Date moisMin;
				Date moisMax;
				Calendar moisActuel= Calendar.getInstance();
				DecimalFormat f2 = new DecimalFormat();
				f2.setMaximumFractionDigits(3);

				int indiceMBA=0;
				int indiceMCS=0;

				float baci=0;
				float charo=0;
				float chlor=0;
				float craspe=0;
				float crypto=0;
				float cyano=0;
				float dino=0;
				float eugleno=0;
				float hapto=0;
				float hetero=0;
				float rhodo=0;
				float nonEmbr=0;
				float taxonsTotaux=0;

				float biovolTot=0;
				float biovolCon=0;

				int indiceResMCS=0;
				int indiceResMBA=0;
				int indiceAnalyse=1;
				int nbCampagnesMBA=0;
				int indiceMCSCampagne=0;

				double valeurMax=0;
				int row=1;
				int rowMCS=0;

				String contraintes=pdfContraintes;

				if(String.valueOf(tableauAnalyse.getValueAt(0,1)).substring(0, 5).compareTo("01/05")!=0)
				{
					contraintes+=pdfDebutContrainte+String.valueOf(tableauAnalyse.getValueAt(0,1)).substring(0, 5)+")";
					if(String.valueOf(tableauAnalyse.getValueAt(0,1)).substring(6, 11).compareTo("31/10")!=0)
					{
						contraintes+=", "+pdfFinContrainte+String.valueOf(tableauAnalyse.getValueAt(0,1)).substring(6, 11)+")";
					}
					if(String.valueOf(tableauAnalyse.getValueAt(0,3)).substring(0, 1).compareTo("3")!=0)
					{
						contraintes+=", \n "+pdfMinCamp+String.valueOf(tableauAnalyse.getValueAt(0,3)).substring(0, 1)+")";
					}
					if(String.valueOf(tableauAnalyse.getValueAt(0,4)).compareTo("10")!=0)
					{
						contraintes+=", "+pdfTaxTot+String.valueOf(tableauAnalyse.getValueAt(0,4))+")";
					}
					if(String.valueOf(tableauAnalyse.getValueAt(0,5)).compareTo("5")!=0)
					{
						contraintes+=", \n "+pdfTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0,5))+")";
					}
				}
				else if(String.valueOf(tableauAnalyse.getValueAt(0,1)).substring(6, 11).compareTo("31/10")!=0)
				{
					contraintes+=pdfFinContrainte+String.valueOf(tableauAnalyse.getValueAt(0,1)).substring(6, 11)+")";
					if(String.valueOf(tableauAnalyse.getValueAt(0,3)).substring(0, 1).compareTo("3")!=0)
					{
						contraintes+=", "+pdfMinCamp+String.valueOf(tableauAnalyse.getValueAt(0,3)).substring(0, 1)+")";
					}
					if(String.valueOf(tableauAnalyse.getValueAt(0,4)).compareTo("10")!=0)
					{
						contraintes+=", \n "+pdfTaxTot+String.valueOf(tableauAnalyse.getValueAt(0,4))+")";
					}
					if(String.valueOf(tableauAnalyse.getValueAt(0,5)).compareTo("5")!=0)
					{
						contraintes+=", "+pdfTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0,5))+")";
					}
				}
				else if(String.valueOf(tableauAnalyse.getValueAt(0,3)).substring(0, 1).compareTo("3")!=0)
				{
					contraintes+=pdfMinCamp+String.valueOf(tableauAnalyse.getValueAt(0,3)).substring(0, 1)+")";
					if(String.valueOf(tableauAnalyse.getValueAt(0,4)).compareTo("10")!=0)
					{
						contraintes+=", "+pdfTaxTot+String.valueOf(tableauAnalyse.getValueAt(0,4))+")";
					}
					if(String.valueOf(tableauAnalyse.getValueAt(0,5)).compareTo("5")!=0)
					{
						contraintes+=", \n "+pdfTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0,5))+")";
					}
				}
				else if(String.valueOf(tableauAnalyse.getValueAt(0,4)).compareTo("10")!=0)
				{
					contraintes+=pdfTaxTot+String.valueOf(tableauAnalyse.getValueAt(0,4))+")";
					if(String.valueOf(tableauAnalyse.getValueAt(0,5)).compareTo("5")!=0)
					{
						contraintes+=", "+pdfTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0,5))+")";
					}
				}
				else if(String.valueOf(tableauAnalyse.getValueAt(0,5)).compareTo("5")!=0)
				{
					contraintes+=pdfTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0,5))+")";
				}
				else
				{
					contraintes=pdfDfaut;
				}
				test3.add(new Phrase(contraintes, fontH1));

				// boucle pour chaque anne-lac
				for(int i=0;i<IPLACTable.getRowCount();i++) {
					if(IPLACTable.getValueAt(i, 0)!=null)
					{
						XYSeriesCollection dq = new XYSeriesCollection();
						XYSeries tada = new XYSeries("Valeurs Chlorophylle");
						XYSeries pointDpart= new XYSeries("Dbut axe x");
						XYSeries pointFin= new XYSeries("Fin axe x");
						pointDpart.add(0,0);
						pointFin.add(12,0);

						XYSeriesCollection dq2 = new XYSeriesCollection();
						XYSeries tadb = new XYSeries("MCS_Campagne");
						XYSeries H_G_MCS = new XYSeries("H/G");
						XYSeries G_M_MCS = new XYSeries("G/M");
						XYSeries M_P_MCS = new XYSeries("M/P");
						XYSeries P_B_MCS = new XYSeries("P/B");
						XYSeries refMCS = new XYSeries(pdfmcsRef);
						XYSeries MCSAnnuelle = new XYSeries(pdfMoyMCS);
						test.add(new Chunk(String.valueOf(tableauIPLAC.getValueAt(i, 0))+" - "+pdfAnne+" "
								+String.valueOf(tableauIPLAC.getValueAt(i, 1))).setTextRenderMode(PdfContentByte.TEXT_RENDER_MODE_FILL_STROKE, 0.5f, null));
						final DefaultCategoryDataset resultEmbranchement = 
								new DefaultCategoryDataset( );
						DefaultCategoryDataset dataset2 = new DefaultCategoryDataset();
						DefaultCategoryDataset dataset3 = new DefaultCategoryDataset();
						while(String.valueOf(tableMCS.getValueAt(indiceMCS, 0)).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 0)))==0
								&& String.valueOf(tableMCS.getValueAt(indiceMCS, 1)).substring(6, 10).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 1)))==0)
						{

							if(tableMCS.getValueAt(indiceMCS, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0) {

								if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("BACILLARIOPHYTA")==0)
								{
									baci+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("CHAROPHYTA")==0)
								{
									charo+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("CHLOROPHYTA")==0)
								{
									chlor+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("CRASPEDOPHYTA")==0)
								{
									craspe+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("CRYPTOPHYTA")==0)
								{
									crypto+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("CYANOBACTERIA")==0)
								{
									cyano+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("DINOPHYTA")==0)
								{
									dino+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("EUGLENOPHYTA")==0)
								{
									eugleno+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("HAPTOPHYTA")==0)
								{
									hapto+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("HETEROKONTOPHYTA")==0)
								{
									hetero+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else if(String.valueOf(tableMCS.getValueAt(indiceMCS, 10)).compareTo("RHODOPHYTA")==0)
								{
									rhodo+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
								else
								{
									nonEmbr+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
									taxonsTotaux+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								}
							}

							if(tableMCS.getValueAt(indiceMCS, 8)!=null && tableMCS.getValueAt(indiceMCS, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0) {

								biovolCon+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
								biovolTot+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
							}
							else if(tableMCS.getValueAt(indiceMCS, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0) {

								biovolTot+=Float.parseFloat(String.valueOf(tableMCS.getValueAt(indiceMCS, 6)));
							}
							indiceMCS+=1;
							if(String.valueOf(tableMCS.getValueAt(indiceMCS, 1)).compareTo(String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)))!=0)
							{
								resultEmbranchement.addValue((baci/taxonsTotaux)*100, "Bacilla"/*riophyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((charo/taxonsTotaux)*100, "Charo"/*phyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((chlor/taxonsTotaux)*100, "Chloro"/*phyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((craspe/taxonsTotaux)*100, "Craspe"/*dophyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((crypto/taxonsTotaux)*100, "Crypto"/*phyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((cyano/taxonsTotaux)*100, "Cyano"/*bacteria"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((dino/taxonsTotaux)*100, "Dino"/*phyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((eugleno/taxonsTotaux)*100, "Eugleno"/*phyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((hapto/taxonsTotaux)*100, "Hapto"/*phyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((hetero/taxonsTotaux)*100, "Hetero"/*kontophyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((rhodo/taxonsTotaux)*100, "Rhodo"/*phyta"*/, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								resultEmbranchement.addValue((nonEmbr/taxonsTotaux)*100, "Ind", String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));

								dataset2.addValue((biovolCon/biovolTot)*100, pdfBiovolRelatif, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));
								dataset3.addValue(biovolTot, pdfBiovolTotal, String.valueOf(tableMCS.getValueAt(indiceMCS-1, 1)).substring(0, 5));

								baci=0;
								charo=0;
								chlor=0;
								craspe=0;
								crypto=0;
								cyano=0;
								dino=0;
								eugleno=0;
								hapto=0;
								hetero=0;
								rhodo=0;
								nonEmbr=0;
								taxonsTotaux=0;
								biovolCon=0;
								biovolTot=0;
							}
						}
						while(String.valueOf(MBATable.getValueAt(indiceMBA+1, 0)).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 0)))==0
								&& String.valueOf(MBATable.getValueAt(indiceMBA+1, 1)).substring(6, 10).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 1)))==0)
						{
							try {
								mois = da.parse(String.valueOf(MBATable.getValueAt(indiceMBA, 1)));
								moisActuel.setTime(mois);
								double moisActuelEntier=((double) moisActuel.get(Calendar.MONTH)+1.0);
								tada.add(moisActuelEntier+(double)moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH),Double.parseDouble(String.valueOf(MBATable.getValueAt(indiceMBA, 4))));
								if(Double.parseDouble(String.valueOf(MBATable.getValueAt(indiceMBA, 4)))>valeurMax)
								{
									valeurMax=Double.parseDouble(String.valueOf(MBATable.getValueAt(indiceMBA, 4)));
								}
							} catch (ParseException e) {
								e.printStackTrace();
							}
							nbCampagnesMBA+=1;
							indiceMBA+=1;
						}
						while(String.valueOf(MCSCamp.getValueAt(indiceMCSCampagne, 0)).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 0)))==0
								&& String.valueOf(MCSCamp.getValueAt(indiceMCSCampagne, 1)).substring(6, 10).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 1)))==0)
						{
							try {
								mois = da.parse(String.valueOf(MCSCamp.getValueAt(indiceMCSCampagne, 1)));
								moisActuel.setTime(mois);
								double moisActuelEntier=((double) moisActuel.get(Calendar.MONTH)+1.0);
								tadb.add(moisActuelEntier+(double)moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH),Double.parseDouble(String.valueOf(MCSCamp.getValueAt(indiceMCSCampagne, 2))));
							} catch (ParseException e) {
								e.printStackTrace();
							}
							indiceMCSCampagne+=1;
						}
						nbCampagnesMBA+=1;
						while(tableauAnalyse.getValueAt(indiceAnalyse, 3)==null && tableauAnalyse.getValueAt(indiceAnalyse, 0)!=null)
						{
							indiceAnalyse+=1;
						}
						test2.add(new Phrase(altitude+" : "+MBATable.getValueAt(indiceMBA, 2)+" m - "+pdfProfondeur+MBATable.getValueAt(indiceMBA, 3)+" m", fontH1));
						test.setAlignment(Element.ALIGN_CENTER);
						test2.setAlignment(Element.ALIGN_CENTER);
						test3.setAlignment(Element.ALIGN_CENTER);

						document.add(test);
						document.add(test2);
						document.add(test3);
						// a table with three columns
						PdfPTable table = new PdfPTable(6);
						PdfPTable table2 = new PdfPTable(2);
						PdfPTable table3 = new PdfPTable(2);

						table.setWidths(new int[]{1, 2, 1, 2, 1, 2});
						// we add the four remaining cells with addCell()
						PdfPCell cell = null;
						PdfPCell cell2;
						PdfPCell cell3;

						cell = new PdfPCell(new Phrase(iplac, fontH2));
						cell.setColspan(6);
						cell.setHorizontalAlignment(Element.ALIGN_CENTER);

						table.addCell(cell);

						cell3 = new PdfPCell(new Phrase(mba,fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(pdfClasseMBA,fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(mcs,fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(pdfClasseMCS,fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(iplac,fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(pdfClasseIPLAC,fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(String.valueOf(tableauIPLAC.getValueAt(i, 2)),fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(String.valueOf(tableauIPLAC.getValueAt(i, 3)),fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(String.valueOf(tableauIPLAC.getValueAt(i, 4)),fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(String.valueOf(tableauIPLAC.getValueAt(i, 5)),fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						cell3 = new PdfPCell(new Phrase(String.valueOf(tableauIPLAC.getValueAt(i, 6)),fontH2));
						cell3.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell3);

						if(String.valueOf(tableauIPLAC.getValueAt(i, 7)).compareTo("B")==0)
						{
							cell2 = new PdfPCell(new Phrase("B", fontH2));
							cell2.setBackgroundColor(BaseColor.RED);
							cell2.setHorizontalAlignment(Element.ALIGN_CENTER);
							table.addCell(cell2);
						}
						else if(String.valueOf(tableauIPLAC.getValueAt(i, 7)).compareTo("P")==0)
						{
							cell2 = new PdfPCell(new Phrase("P", fontH2));
							cell2.setBackgroundColor(BaseColor.ORANGE);
							cell2.setHorizontalAlignment(Element.ALIGN_CENTER);
							table.addCell(cell2);
						}
						else if(String.valueOf(tableauIPLAC.getValueAt(i, 7)).compareTo("M")==0)
						{
							cell2 = new PdfPCell(new Phrase("M", fontH2));
							cell2.setBackgroundColor(BaseColor.YELLOW);
							cell2.setHorizontalAlignment(Element.ALIGN_CENTER);
							table.addCell(cell2);
						}
						else if(String.valueOf(tableauIPLAC.getValueAt(i, 7)).compareTo("G")==0)
						{
							cell2 = new PdfPCell(new Phrase("G", fontH2));
							cell2.setBackgroundColor(BaseColor.GREEN);
							cell2.setHorizontalAlignment(Element.ALIGN_CENTER);
							table.addCell(cell2);
						}
						else if(String.valueOf(tableauIPLAC.getValueAt(i, 7)).compareTo("H")==0)
						{
							cell2 = new PdfPCell(new Phrase("H", fontH2));
							cell2.setBackgroundColor(new BaseColor(0,180,238));
							cell2.setHorizontalAlignment(Element.ALIGN_CENTER);
							table.addCell(cell2);
						}
						else if(String.valueOf(tableauIPLAC.getValueAt(i, 7)).compareTo("NA")==0)
						{
							cell2 = new PdfPCell(new Phrase("NA", fontH2));
							cell2.setHorizontalAlignment(Element.ALIGN_CENTER);
							table.addCell(cell2);
						}

						cell = new PdfPCell(new Phrase(rb.getString("phytobsVer") + " - " + derniereDate.getText().substring(8, 10)
								+ "/" + derniereDate.getText().substring(5, 7) + "/" + derniereDate.getText().substring(0, 4), fontH1));

						cell.setColspan(6);
						cell.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell(cell);

						// Tableau de la MBA
						table2.setWidths(new int[]{2,1});

						table2.addCell(new Phrase(mba, new Font(bf,10,Font.BOLD)));
						table2.addCell(new Phrase(String.valueOf(tableauIPLAC.getValueAt(i, 2)), fontH1));
						table2.addCell(new Phrase(pdfClasseMBA, fontH1));
						table2.addCell(new Phrase(String.valueOf(tableauIPLAC.getValueAt(i, 3)), fontH1));
						table2.addCell(new Phrase(pdfMoyChloro, fontH1));
						table2.addCell(new Phrase(f2.format(Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(i, 2)))), fontH1));
						table2.addCell(new Phrase(pdfRefChloro, fontH1));
						table2.addCell(new Phrase(f2.format(Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(i, 3)))), fontH1));
						table2.addCell(new Phrase(pdfNbCamp, fontH1));
						table2.addCell(new Phrase(String.valueOf(nbCampagnesMBA), fontH1));
						table2.addCell(new Phrase(pdfNbCampUtil, fontH1));
						table2.addCell(new Phrase(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 3)), fontH1));

						// Tableau de la MCS
						table3.setWidths(new int[]{2,1});

						table3.addCell(new Phrase(mcs, new Font(bf,10,Font.BOLD)));
						table3.addCell(new Phrase(String.valueOf(tableauIPLAC.getValueAt(i, 4)), fontH1));
						table3.addCell(new Phrase(pdfClasseMCS, fontH1));
						table3.addCell(new Phrase(String.valueOf(tableauIPLAC.getValueAt(i, 5)), fontH1));
						table3.addCell(new Phrase(pdfMCSAnnuelle, fontH1));
						if(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 0)).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 0)))==0
								&& String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 1)).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 1)))==0)
						{
							table3.addCell(new Phrase(f2.format(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 2)))), fontH1));
							table3.addCell(new Phrase(pdfRefMCS, fontH1));
							table3.addCell(new Phrase(f2.format(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 3)))), fontH1));
							table3.addCell(new Phrase(pdfNbCamp, fontH1));
							table3.addCell(new Phrase(String.valueOf(tadb.getItemCount()), fontH1));
							table3.addCell(new Phrase(pdfNbCampUtil, fontH1));
							table3.addCell(new Phrase(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 12)), fontH1));


							H_G_MCS.add(0,Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 4))));
							H_G_MCS.add(12,Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 4))));

							G_M_MCS.add(0,Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 5))));
							G_M_MCS.add(12,Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 5))));

							M_P_MCS.add(0,Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 6))));
							M_P_MCS.add(12,Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 6))));

							P_B_MCS.add(0,Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 7))));
							P_B_MCS.add(12,Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 7))));

							refMCS.add(0, Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 3))));
							refMCS.add(12, Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 3))));

							MCSAnnuelle.add(0, Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 2))));
							MCSAnnuelle.add(12, Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceResMCS, 2))));

							indiceResMCS+=1;
						}
						else
						{
							table3.addCell(new Phrase("NA", fontH1));
							table3.addCell(new Phrase(pdfRefMCS, fontH1));
							table3.addCell(new Phrase("NA", fontH1));
							table3.addCell(new Phrase(pdfNbCamp, fontH1));
							table3.addCell(new Phrase("NA", fontH1));
							table3.addCell(new Phrase(pdfNbCampUtil, fontH1));
							table3.addCell(new Phrase("NA", fontH1));
						}
						try {
							mois = da.parse(String.valueOf(MBATable.getValueAt(indiceMBA, 1)));
							moisActuel.setTime(mois);
							double moisActuelEntier=((double) moisActuel.get(Calendar.MONTH)+1.0);
							tada.add(moisActuelEntier+(double)moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH),Double.parseDouble(String.valueOf(MBATable.getValueAt(indiceMBA, 4))));
							if(Double.parseDouble(String.valueOf(MBATable.getValueAt(indiceMBA, 4)))>valeurMax)
							{
								valeurMax=Double.parseDouble(String.valueOf(MBATable.getValueAt(indiceMBA, 4)));
							}
							if(String.valueOf(MCSCamp.getValueAt(indiceMCSCampagne, 0)).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 0)))==0
									&& String.valueOf(MCSCamp.getValueAt(indiceMCSCampagne, 1)).substring(6, 10).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 1)))==0)
							{
								mois = da.parse(String.valueOf(MCSCamp.getValueAt(indiceMCSCampagne, 1)));
								moisActuel.setTime(mois);
								moisActuelEntier=((double) moisActuel.get(Calendar.MONTH)+1.0);
								tadb.add(moisActuelEntier+(double)moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH),Double.parseDouble(String.valueOf(MCSCamp.getValueAt(indiceMCSCampagne, 2))));
								indiceMCSCampagne+=1;
							}

						} catch (ParseException e) {
							new JOptionPane();
							JOptionPane.showMessageDialog(patienter, 
									rb.getString("mssgNbCampInsuff"), 
									rb.getString("titreBoxNbCampInsuff"), JOptionPane.WARNING_MESSAGE);

							break;
						}

						indiceMBA+=1;
						dq.addSeries(tada);
						dq.addSeries(pointDpart);
						dq.addSeries(pointFin);

						dq2.addSeries(tadb);
						dq2.addSeries(pointDpart);
						dq2.addSeries(pointFin);

						XYSeries moy = new XYSeries(pdfMoyMBA);
						XYSeries H_G = new XYSeries("H/G");
						XYSeries G_M = new XYSeries("G/M");
						XYSeries M_P = new XYSeries("M/P");
						XYSeries P_B = new XYSeries("P/B");
						XYSeries dateMin = new XYSeries("Contrainte dbut");
						XYSeries dateMax = new XYSeries("Contrainte fin");
						XYSeries refMBA = new XYSeries(pdfRefMBA);

						moy.add(0,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 2))));
						moy.add(12,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 2))));

						H_G.add(0,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 4))));
						H_G.add(12,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 4))));

						G_M.add(0,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 5))));
						G_M.add(12,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 5))));

						M_P.add(0,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 6))));
						M_P.add(12,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 6))));

						P_B.add(0,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 7))));
						P_B.add(12,Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 7))));

						refMBA.add(0, Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 3))));
						refMBA.add(12, Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 3))));

						if(Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 7)))>valeurMax)
						{
							valeurMax=Double.parseDouble(String.valueOf(resultatsMBA.getValueAt(indiceResMBA, 7)));
						}
						XYSeries dateMinMBA = new XYSeries("");
						XYSeries dateMaxMBA = new XYSeries("");

						dq.addSeries(moy);
						dq.addSeries(H_G);
						dq.addSeries(G_M);
						dq.addSeries(M_P);
						dq.addSeries(P_B);

						try {
							moisMin=da.parse(debPeriode.getText());
							moisMax=da.parse(endPeriode.getText());
							moisActuel.setTime(moisMin);
							dateMinMBA.add(moisActuel.get(Calendar.MONTH)+1+(moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH)), 0);
							dateMinMBA.add(moisActuel.get(Calendar.MONTH)+1+(moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH)), valeurMax);
							dq.addSeries(dateMinMBA);
							dateMin.add(moisActuel.get(Calendar.MONTH)+1+(moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH)), 0);
							dateMin.add(moisActuel.get(Calendar.MONTH)+1+(moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH)), 20);
							moisActuel.setTime(moisMax);
							dateMaxMBA.add(moisActuel.get(Calendar.MONTH)+1+(moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH)), 0);
							dateMaxMBA.add(moisActuel.get(Calendar.MONTH)+1+(moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH)), valeurMax);
							dq.addSeries(dateMaxMBA);
							dateMax.add(moisActuel.get(Calendar.MONTH)+1+(moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH)), 0);
							dateMax.add(moisActuel.get(Calendar.MONTH)+1+(moisActuel.get(Calendar.DAY_OF_MONTH)/moisActuel.getActualMaximum(Calendar.DAY_OF_MONTH)), 20);
							dq.addSeries(refMBA);
						} catch (ParseException e) {
							e.printStackTrace();
						}

						dq2.addSeries(dateMin);
						dq2.addSeries(dateMax);
						dq2.addSeries(H_G_MCS);
						dq2.addSeries(G_M_MCS);
						dq2.addSeries(M_P_MCS);
						dq2.addSeries(P_B_MCS);
						dq2.addSeries(MCSAnnuelle);
						dq2.addSeries(refMCS);


						JFreeChart grapheMBA = ChartFactory.createXYLineChart(
								mba ,
								pdfMois ,
								pdfChloro ,
								dq ,
								PlotOrientation.VERTICAL ,
								true , false , false);
						grapheMBA.setTitle(new org.jfree.chart.title.TextTitle(mba,
								new java.awt.Font("SansSerif", java.awt.Font.BOLD, 11)));
						grapheMBA.getLegend().setItemFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 9));
						final XYPlot plot = grapheMBA.getXYPlot();
						plot.setDomainGridlinePaint(Color.white);
						plot.setRangeGridlinePaint(Color.white);

						final XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();

						renderer.setSeriesShape(0, new Ellipse2D.Double(-2,-2,4,4));
						renderer.setSeriesLinesVisible(0, false);
						renderer.setSeriesShapesVisible(1, false);
						renderer.setSeriesShapesVisible(2, false);
						renderer.setSeriesShapesVisible(3, false);
						renderer.setSeriesShapesVisible(4, false);
						renderer.setSeriesShapesVisible(5, false);
						renderer.setSeriesShapesVisible(6, false);
						renderer.setSeriesShapesVisible(7, false);
						renderer.setSeriesShapesVisible(8, false);
						renderer.setSeriesShapesVisible(9, false);
						renderer.setSeriesShapesVisible(10, false);
						renderer.setSeriesVisibleInLegend(0, false);
						renderer.setSeriesVisibleInLegend(1, false);
						renderer.setSeriesVisibleInLegend(2, false);
						renderer.setSeriesVisibleInLegend(4, false);
						renderer.setSeriesVisibleInLegend(5, false);
						renderer.setSeriesVisibleInLegend(6, false);
						renderer.setSeriesVisibleInLegend(7, false);
						renderer.setSeriesVisibleInLegend(8, false);
						renderer.setSeriesVisibleInLegend(9, false);
						renderer.setSeriesStroke(4, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {6.0f, 4.0f}, 0.0f
								));
						renderer.setSeriesStroke(5, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {6.0f, 4.0f}, 0.0f
								));
						renderer.setSeriesStroke(6, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {6.0f, 4.0f}, 0.0f
								));
						renderer.setSeriesStroke(7, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {6.0f, 4.0f}, 0.0f
								));
						renderer.setSeriesStroke(8, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {2.0f, 8.0f}, 0.0f
								));
						renderer.setSeriesStroke(9, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {2.0f, 8.0f}, 0.0f
								));
						renderer.setSeriesStroke(10, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {10.0f, 8.0f}, 0.0f
								));
						plot.setRenderer(renderer);
						plot.getDomainAxis().setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));
						plot.getRangeAxis().setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));
						plot.getRenderer().setSeriesPaint(0, Color.BLACK);
						plot.getRenderer().setSeriesPaint(3, new Color(143,89,34));
						plot.getRenderer().setSeriesPaint(4, Color.BLUE);
						plot.getRenderer().setSeriesPaint(5, Color.GREEN);
						plot.getRenderer().setSeriesPaint(6, Color.YELLOW);
						plot.getRenderer().setSeriesPaint(7, new Color(238,118,33));
						plot.getRenderer().setSeriesPaint(8, Color.BLACK);
						plot.getRenderer().setSeriesPaint(9, Color.BLACK);
						plot.getRenderer().setSeriesPaint(10, Color.BLACK);
						LegendTitle legend=grapheMBA.getLegend();
						legend.setPosition(RectangleEdge.RIGHT);
						grapheMBA.setBackgroundPaint(Color.WHITE);

						PdfTemplate tp = cb.createTemplate( 390, 170 ); 
						BufferedImage img = null;
						img=grapheMBA.createBufferedImage(415, 140);
						Image itextImage = 
								Image.getInstance(Toolkit.getDefaultToolkit().createImage(img.getSource() 
										), null); 

						JFreeChart grapheMCS = ChartFactory.createXYLineChart(
								mcs,
								pdfMois ,
								pdfMCSCamp ,
								dq2 ,
								PlotOrientation.VERTICAL ,
								true , false , false);
						grapheMCS.setTitle(new org.jfree.chart.title.TextTitle(mcs,
								new java.awt.Font("SansSerif", java.awt.Font.BOLD, 11)));
						grapheMCS.getLegend().setItemFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 9));
						final XYPlot plotMCS = grapheMCS.getXYPlot();
						final XYLineAndShapeRenderer rendererMCS = new XYLineAndShapeRenderer();
						rendererMCS.setSeriesShape(0, new Ellipse2D.Double(0,0,4,4));
						rendererMCS.setSeriesLinesVisible(0, false);
						rendererMCS.setSeriesShapesVisible(1, false);
						rendererMCS.setSeriesShapesVisible(2, false);
						rendererMCS.setSeriesShapesVisible(3, false);
						rendererMCS.setSeriesShapesVisible(4, false);
						rendererMCS.setSeriesShapesVisible(5, false);
						rendererMCS.setSeriesShapesVisible(6, false);
						rendererMCS.setSeriesShapesVisible(7, false);
						rendererMCS.setSeriesShapesVisible(8, false);
						rendererMCS.setSeriesShapesVisible(9, false);
						rendererMCS.setSeriesShapesVisible(10, false);
						rendererMCS.setSeriesVisibleInLegend(0, false);
						rendererMCS.setSeriesVisibleInLegend(1, false);
						rendererMCS.setSeriesVisibleInLegend(2, false);
						rendererMCS.setSeriesVisibleInLegend(3, false);
						rendererMCS.setSeriesVisibleInLegend(4, false);
						rendererMCS.setSeriesVisibleInLegend(5, false);
						rendererMCS.setSeriesVisibleInLegend(6, false);
						rendererMCS.setSeriesVisibleInLegend(7, false);
						rendererMCS.setSeriesVisibleInLegend(8, false);
						rendererMCS.setSeriesStroke(3, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {2.0f, 8.0f}, 0.0f
								));
						rendererMCS.setSeriesStroke(4, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {2.0f, 8.0f}, 0.0f
								));
						rendererMCS.setSeriesStroke(5, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {6.0f, 4.0f}, 0.0f
								));
						rendererMCS.setSeriesStroke(6, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {6.0f, 4.0f}, 0.0f
								));
						rendererMCS.setSeriesStroke(7, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {6.0f, 4.0f}, 0.0f
								));
						rendererMCS.setSeriesStroke(8, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {6.0f, 4.0f}, 0.0f
								));
						rendererMCS.setSeriesStroke(10, new BasicStroke(
								1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
								1.0f, new float[] {10.0f, 6.0f}, 0.0f
								));
						plotMCS.setRenderer(rendererMCS);
						plotMCS.getDomainAxis().setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));
						plotMCS.getRangeAxis().setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));
						plotMCS.getRenderer().setSeriesPaint(0, Color.BLACK);
						plotMCS.getRenderer().setSeriesPaint(3, Color.BLACK);
						plotMCS.getRenderer().setSeriesPaint(4, Color.BLACK);
						plotMCS.getRenderer().setSeriesPaint(5, Color.BLUE);
						plotMCS.getRenderer().setSeriesPaint(6, Color.GREEN);
						plotMCS.getRenderer().setSeriesPaint(7, Color.YELLOW);
						plotMCS.getRenderer().setSeriesPaint(8, new Color(238,118,33));
						plotMCS.getRenderer().setSeriesPaint(9, new Color(143,89,34));
						plotMCS.getRenderer().setSeriesPaint(10, Color.BLACK);

						LegendTitle legendMCS=grapheMCS.getLegend();
						legendMCS.setPosition(RectangleEdge.RIGHT);
						grapheMCS.setBackgroundPaint(Color.WHITE);

						BufferedImage img2 = null;
						img2=grapheMCS.createBufferedImage(415, 140);
						Image itextImage2 = 
								Image.getInstance(Toolkit.getDefaultToolkit().createImage(img2.getSource() 
										), null); 

						nbCampagnesMBA=0;
						indiceAnalyse+=1;

						table2.setWidthPercentage(25);
						table3.setWidthPercentage(25);
						table.setWidthPercentage(60);

						table2.setTotalWidth(150);
						table2.writeSelectedRows(0, 6, 10, 740, cb);

						table.setTotalWidth(450);

						table.writeSelectedRows(0, 4, document.getPageSize().getWidth()/8, 80, cb);

						table3.setTotalWidth(150);
						table3.writeSelectedRows(0, 6, 10, 590, cb);
						itextImage.setAbsolutePosition(165, 615);
						itextImage2.setAbsolutePosition(165, 470);

						final DefaultCategoryDataset result = 
								new DefaultCategoryDataset( );
						if(String.valueOf(tableauAnalyse.getValueAt(row, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(rowMCS, 0)))==0
								&& String.valueOf(tableauAnalyse.getValueAt(row, 1)).substring(6, 10).compareTo(String.valueOf(resultatsMCS.getValueAt(rowMCS, 1)))==0)
						{
							while(String.valueOf(tableauAnalyse.getValueAt(row, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(rowMCS, 0)))==0
									&& String.valueOf(tableauAnalyse.getValueAt(row, 1)).substring(6, 10).compareTo(String.valueOf(resultatsMCS.getValueAt(rowMCS, 1)))==0)
							{
								if(tableauAnalyse.getValueAt(row, 5)!=null)
								{
									result.addValue(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(row, 5))), pdfContrib, String.valueOf(tableauAnalyse.getValueAt(row, 1)).substring(0, 5));
									result.addValue(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(row, 4)))-Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(row, 5)))
											-Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(row, 7)))-Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(row, 9))), 
											pdfNonCotes, String.valueOf(tableauAnalyse.getValueAt(row, 1)).substring(0, 5));
									result.addValue(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(row, 7))), pdfGenre, String.valueOf(tableauAnalyse.getValueAt(row, 1)).substring(0, 5));
									result.addValue(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(row, 9))), pdfInd, String.valueOf(tableauAnalyse.getValueAt(row, 1)).substring(0, 5));
									row+=1;
								}
								else
								{
									row+=1;
								}
							}
							rowMCS+=1;
						}
						else
						{
							while(String.valueOf(tableauAnalyse.getValueAt(row, 0)).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 0)))==0
									&& String.valueOf(tableauAnalyse.getValueAt(row, 1)).substring(6, 10).compareTo(String.valueOf(tableauIPLAC.getValueAt(i, 1)))==0)
							{
								row+=1;
							}
						}
						if(String.valueOf(tableauAnalyse.getValueAt(row, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(rowMCS, 0)))>0)
						{
							rowMCS+=1;
						}
						final CategoryItemRenderer rendererTest = new StackedBarRenderer();
						final CategoryPlot plotTest = new CategoryPlot();
						plotTest.setDataset(result);
						plotTest.setRenderer(rendererTest);

						plotTest.setDomainAxis(new CategoryAxis(pdfDate));
						plotTest.setRangeAxis(new NumberAxis(pdfNbTaxons));

						plotTest.setOrientation(PlotOrientation.VERTICAL);
						plotTest.setRangeGridlinesVisible(true);
						plotTest.setDomainGridlinesVisible(true);

						final CategoryItemRenderer renderer2 = new LineAndShapeRenderer();
						plotTest.setDataset(1, dataset2);
						plotTest.setRenderer(1, renderer2);
						plotTest.mapDatasetToRangeAxis(1, 1);

						final CategoryAxis domainAxis = plotTest.getDomainAxis();
						domainAxis.setCategoryLabelPositions(CategoryLabelPositions.DOWN_45);
						final ValueAxis axis2 = new NumberAxis(pdfBiovolRelatifContrib);
						plotTest.setRangeAxis(1, axis2);
						plotTest.getDomainAxis().setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));
						plotTest.getRangeAxis(0).setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));
						plotTest.getRangeAxis(1).setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));

						plotTest.setDatasetRenderingOrder(DatasetRenderingOrder.FORWARD);

						final JFreeChart chart = new JFreeChart(plotTest);
						chart.setBorderVisible(false);

						BarRenderer r = (BarRenderer)chart.getCategoryPlot().getRenderer(0);
						r.setSeriesPaint(0,new Color(24,116,205));
						r.setSeriesPaint(1, new Color(34,139,34));
						r.setSeriesPaint(2, new Color(238,118,33));
						r.setSeriesPaint(3, new Color(178,34,34));

						chart.getLegend().setItemFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 9));
						LegendTitle legendChart=chart.getLegend();
						legendChart.setPosition(RectangleEdge.RIGHT);
						chart.setBackgroundPaint(Color.WHITE);
						chart.setTitle(new org.jfree.chart.title.TextTitle(pdfTaxons,
								new java.awt.Font("SansSerif", java.awt.Font.BOLD, 10)));
						BufferedImage img3 = null;
						img3=chart.createBufferedImage(570, 200);
						Image itextImage3 = 
								Image.getInstance(Toolkit.getDefaultToolkit().createImage(img3.getSource() 
										), null);
						itextImage3.setAbsolutePosition(10, 280);

						final CategoryPlot plotChart = new CategoryPlot();
						plotChart.setDataset(resultEmbranchement);
						plotChart.setRenderer(rendererTest);

						plotChart.setDomainAxis(new CategoryAxis(pdfDate));
						plotChart.setRangeAxis(new NumberAxis(pdfBiovolRelatifPourcent));

						plotChart.setOrientation(PlotOrientation.VERTICAL);
						plotChart.setRangeGridlinesVisible(true);
						plotChart.setDomainGridlinesVisible(true);

						final CategoryItemRenderer renderer3 = new LineAndShapeRenderer();
						plotChart.setDataset(1, dataset3);
						plotChart.setRenderer(1, renderer3);
						plotChart.mapDatasetToRangeAxis(1, 1);

						final CategoryAxis domainAxis2 = plotChart.getDomainAxis();
						domainAxis2.setCategoryLabelPositions(CategoryLabelPositions.DOWN_45);
						final ValueAxis axis3 = new NumberAxis(pdfBiovolTotalUnit);
						plotChart.setRangeAxis(1, axis3);
						plotChart.getDomainAxis().setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));
						plotChart.getRangeAxis(0).setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));
						plotChart.getRangeAxis(1).setLabelFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 11));

						plotChart.setDatasetRenderingOrder(DatasetRenderingOrder.FORWARD);

						final JFreeChart chartTaxons = new JFreeChart(plotChart);
						chartTaxons.setBorderVisible(false);

						CategoryPlot plotAa = (CategoryPlot) chartTaxons.getPlot();
						final IntervalMarker target = new IntervalMarker(50.0, 1.0);
						target.setPaint(new Color(222, 222, 255, 128));
						plotAa.addRangeMarker(target);

						BarRenderer r2 = (BarRenderer)chartTaxons.getCategoryPlot().getRenderer();
						r2.setSeriesPaint(0,new Color(205,133,63));
						r2.setSeriesPaint(1, new Color(0,255,0));
						r2.setSeriesPaint(2, new Color(34,139,34));
						r2.setSeriesPaint(3,new Color(205,102,29)); 
						r2.setSeriesPaint(4, new Color(139,69,19));
						r2.setSeriesPaint(5, new Color(0,238,238));
						r2.setSeriesPaint(6, new Color(24,116,205));
						r2.setSeriesPaint(7, new Color(238,118,33));
						r2.setSeriesPaint(8,new Color(255,48,48)); 
						r2.setSeriesPaint(9, Color.ORANGE);
						r2.setSeriesPaint(10, new Color(255,0,0));
						r2.setSeriesPaint(11, Color.WHITE);

						chartTaxons.getLegend().setItemFont(new java.awt.Font("SansSerif", java.awt.Font.LAYOUT_LEFT_TO_RIGHT, 9));
						LegendTitle legendEmbr=chartTaxons.getLegend();
						legendEmbr.setHeight(90);
						legendEmbr.setPosition(RectangleEdge.RIGHT);
						chartTaxons.setBackgroundPaint(Color.WHITE);

						chartTaxons.setTitle(new org.jfree.chart.title.TextTitle(pdfRpartitionEmbranchement,
								new java.awt.Font("SansSerif", java.awt.Font.BOLD, 10)));
						BufferedImage img4 = null;
						img4=chartTaxons.createBufferedImage(570, 205);
						Image itextImage4 = 
								Image.getInstance(Toolkit.getDefaultToolkit().createImage(img4.getSource() 
										), null);
						itextImage4.setAbsolutePosition(10, 85);
						itextImage4.setBackgroundColor(new BaseColor(0,0,0));
						Image itextImage5 = 
								Image.getInstance(getClass().getClassLoader().getResource("images/logo_irstea.jpg"));
						itextImage5.scaleAbsolute(80, 80);
						itextImage5.setAbsolutePosition(document.getPageSize().getWidth()-80, document.getPageSize().getHeight()-80);

						document.add(itextImage5);
						document.add(itextImage);
						cb.addTemplate(tp, 0, 0);
						document.add(itextImage2);
						document.add(itextImage3);
						document.add(itextImage4);
						document.newPage();

						test.clear();
						test2.clear();
						valeurMax=0;
						indiceResMBA+=1;
						baci=0;
						charo=0;
						chlor=0;
						craspe=0;
						crypto=0;
						cyano=0;
						dino=0;
						eugleno=0;
						hapto=0;
						hetero=0;
						rhodo=0;
						nonEmbr=0;
					}
				} 
				document.close();
			} catch (DocumentException de) {
				de.printStackTrace();
			}catch (IOException ioe){
				ioe.printStackTrace();
			}

		}
	}

	// TODO TRIE DE LA TABLE MBA
	private void trierMBA(JTable tableauMBA, String [] columnNames)
	{
		JTable trier= new JTable(new Object[50000][columnNames.length], columnNames);
		Date tab1;
		Date tab2;
		Calendar cal1 = Calendar.getInstance();
		Calendar cal2 = Calendar.getInstance();
		SimpleDateFormat da = new SimpleDateFormat("dd/MM/yyyy");
		int tri=0;
		try
		{
			for(int i=0;i<tableauMBA.getRowCount();i++)
			{
				if(tableauMBA.getValueAt(i, 0)!=null)
				{
					tab1=da.parse(String.valueOf(tableauMBA.getValueAt(i, 1)));
					cal1.setTime(tab1);
					tri=i;
					for(int j=i;j<tableauMBA.getRowCount();j++)
					{
						if(tableauMBA.getValueAt(j,0)!=null)
						{
							if(String.valueOf(tableauMBA.getValueAt(j,1)).isEmpty()==false)
							{
								tab2=da.parse(String.valueOf(tableauMBA.getValueAt(j, 1)));
								cal2.setTime(tab2);
								if(String.valueOf(tableauMBA.getValueAt(tri,0)).toUpperCase().compareTo(String.valueOf(tableauMBA.getValueAt(j, 0)).toUpperCase())==0 && cal2.before(cal1) && j>i)
								{
									tri=j;
									cal1.setTime(tab2);
								}
								else if(String.valueOf(tableauMBA.getValueAt(tri,0)).toUpperCase().compareTo(String.valueOf(tableauMBA.getValueAt(j, 0)).toUpperCase())>0)
								{
									tri=j;
									cal1.setTime(tab2);
								}
							}
						}
					}
					trier.setValueAt(String.valueOf(Normalizer.normalize(String.valueOf(tableauMBA.getValueAt(tri, 0)), 
							Normalizer.Form.NFD).replaceAll("[^\\p{ASCII}]", "").toUpperCase()), 0, 0);
					trier.setValueAt(String.valueOf(tableauMBA.getValueAt(tri, 1)), 0, 1);
					trier.setValueAt(String.valueOf(tableauMBA.getValueAt(tri, 2)), 0, 2);
					trier.setValueAt(String.valueOf(tableauMBA.getValueAt(tri, 3)), 0, 3);
					trier.setValueAt(String.valueOf(tableauMBA.getValueAt(tri, 4)), 0, 4);

					tableauMBA.setValueAt(String.valueOf(tableauMBA.getValueAt(i, 0)), tri, 0);
					tableauMBA.setValueAt(String.valueOf(tableauMBA.getValueAt(i, 1)), tri, 1);
					tableauMBA.setValueAt(String.valueOf(tableauMBA.getValueAt(i, 2)), tri, 2);
					tableauMBA.setValueAt(String.valueOf(tableauMBA.getValueAt(i, 3)), tri, 3);
					tableauMBA.setValueAt(String.valueOf(tableauMBA.getValueAt(i, 4)), tri, 4);

					tableauMBA.setValueAt(String.valueOf(trier.getValueAt(0, 0)), i, 0);
					tableauMBA.setValueAt(String.valueOf(trier.getValueAt(0, 1)), i, 1);
					tableauMBA.setValueAt(String.valueOf(trier.getValueAt(0, 2)), i, 2);
					tableauMBA.setValueAt(String.valueOf(trier.getValueAt(0, 3)), i, 3);
					tableauMBA.setValueAt(String.valueOf(trier.getValueAt(0, 4)), i, 4);
				}
			}
		}catch(ParseException e)
		{

		}
	}

	// TODO TRIE DE LA TABLE MCS
	private void trierMCS(JTable tableauMCS, String [] columnNames)
	{
		JTable trier= new JTable(new Object[50000][columnNames.length], columnNames);
		Date tab1;
		Date tab2;
		Calendar cal1 = Calendar.getInstance();
		Calendar cal2 = Calendar.getInstance();
		SimpleDateFormat da = new SimpleDateFormat("dd/MM/yyyy");
		int tri=0;
		try
		{
			for(int i=0;i<tableauMCS.getRowCount();i++)
			{
				if(tableauMCS.getValueAt(i, 0)!=null)
				{
					tab1=da.parse(String.valueOf(tableauMCS.getValueAt(i, 1)));
					cal1.setTime(tab1);
					tri=i;
					for(int j=i;j<tableauMCS.getRowCount();j++)
					{
						if(tableauMCS.getValueAt(j,1)!=null)
						{
							tab2=da.parse(String.valueOf(tableauMCS.getValueAt(j, 1)));
							cal2.setTime(tab2);
							if(String.valueOf(tableauMCS.getValueAt(tri,0)).toUpperCase().compareTo(String.valueOf(tableauMCS.getValueAt(j, 0)).toUpperCase())==0 && cal2.before(cal1) && j>i)
							{
								tri=j;
								cal1.setTime(tab2);
							}
							else if(String.valueOf(tableauMCS.getValueAt(tri,0)).toUpperCase().compareTo(String.valueOf(tableauMCS.getValueAt(j, 0)).toUpperCase())>0)
							{
								tri=j;
								cal1.setTime(tab2);
							}
						}
					}
					trier.setValueAt(String.valueOf(Normalizer.normalize(String.valueOf(tableauMCS.getValueAt(tri, 0)), 
							Normalizer.Form.NFD).replaceAll("[^\\p{ASCII}]", "").toUpperCase()), 0, 0);
					trier.setValueAt(String.valueOf(tableauMCS.getValueAt(tri, 1)), 0, 1);
					trier.setValueAt(String.valueOf(tableauMCS.getValueAt(tri, 2)).toUpperCase(), 0, 2);
					trier.setValueAt(String.valueOf(tableauMCS.getValueAt(tri, 3)), 0, 3);
					trier.setValueAt(String.valueOf(tableauMCS.getValueAt(tri, 4)), 0, 4);
					trier.setValueAt(String.valueOf(tableauMCS.getValueAt(tri, 5)), 0, 5);
					trier.setValueAt(String.valueOf(tableauMCS.getValueAt(tri, 6)), 0, 6);
					
					tableauMCS.setValueAt(String.valueOf(tableauMCS.getValueAt(i, 0)), tri, 0);
					tableauMCS.setValueAt(String.valueOf(tableauMCS.getValueAt(i, 1)), tri, 1);
					tableauMCS.setValueAt(String.valueOf(tableauMCS.getValueAt(i, 2)), tri, 2);
					tableauMCS.setValueAt(String.valueOf(tableauMCS.getValueAt(i, 3)), tri, 3);
					tableauMCS.setValueAt(String.valueOf(tableauMCS.getValueAt(i, 4)), tri, 4);
					tableauMCS.setValueAt(String.valueOf(tableauMCS.getValueAt(i, 5)), tri, 5);
					tableauMCS.setValueAt(String.valueOf(tableauMCS.getValueAt(i, 6)), tri, 6);
					
					tableauMCS.setValueAt(String.valueOf(trier.getValueAt(0, 0)), i, 0);
					tableauMCS.setValueAt(String.valueOf(trier.getValueAt(0, 1)), i, 1);
					tableauMCS.setValueAt(String.valueOf(trier.getValueAt(0, 2)), i, 2);
					tableauMCS.setValueAt(String.valueOf(trier.getValueAt(0, 3)), i, 3);
					tableauMCS.setValueAt(String.valueOf(trier.getValueAt(0, 4)), i, 4);
					if(String.valueOf(trier.getValueAt(0, 5)).compareTo("null")==0
							|| String.valueOf(trier.getValueAt(0, 5)).compareTo("#N/A")==0)
					{
						tableauMCS.setValueAt(null, i, 5);
					}
					else
					{
						tableauMCS.setValueAt(String.valueOf(trier.getValueAt(0, 5)), i, 5);
					}
					if(String.valueOf(trier.getValueAt(0, 6)).compareTo("null")==0
							|| String.valueOf(trier.getValueAt(0, 6)).compareTo("0.0")==0)
					{
						tableauMCS.setValueAt(null, i, 6);
					}
					else
					{
						tableauMCS.setValueAt(String.valueOf(trier.getValueAt(0, 6)), i, 6);
					}
				}
			}
		}catch(ParseException e)
		{

		}
	}

	// vidage de la table
	private void empty_table(JTable table)
	{
		for(int i=0;i<table.getRowCount();i++)
		{
			if(table.getValueAt(i, 0)!=null)
			{
				for(int j=0;j<table.getColumnCount();j++)
				{
					table.setValueAt(null, i, j);
				}
			}
		}
		tableauAnalyse.setValueAt(contraintes, 0, 0);
		tableauAnalyse.setValueAt(debPeriode.getText().substring(0, 5)+"-"+endPeriode.getText().substring(0, 5), 0, 1);
		tableauAnalyse.setValueAt(campMin.getText()+" "+minimum, 0,3);
		tableauAnalyse.setValueAt(taxTot.getText(), 0, 4);
		tableauAnalyse.setValueAt(taxContrib.getText(),0,5);
		tableauAnalyse.setValueAt(pourcSp.getText(), 0, 8);
		tableauAnalyse.setValueAt(pourcInd.getText(), 0, 10);
	}

	// cration petit ecran d'attente
	private void miseEnPlaceAttente()
	{
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		patienter.setSize(600, 0);
		patienter.setLocation(dim.width/2 - patienter.getWidth()/2, dim.height/2 - patienter.getHeight()/2);
		patienter.setAlwaysOnTop(true);
		patienter.setResizable(false);
		patienter.setVisible(true);
	}

	// TODO METHODE DE CALCUL DE LA MBA
	private void calculerMBA(float refChloro, float moyChloro, int nbChloro, JTable tableMBA, int place)
	{
		try
		{
			SimpleDateFormat da = new SimpleDateFormat("dd/MM/yyyy");
			Date priodeDbut = da.parse(debPeriode.getText());
			Calendar contrainteDbut= Calendar.getInstance();
			Calendar contrainteFin= Calendar.getInstance();
			Date priodeFin = da.parse(endPeriode.getText());
			contrainteDbut.setTime(priodeDbut);
			contrainteFin.setTime(priodeFin);
			Date d;
			Calendar cal= Calendar.getInstance();
			Calendar calPrec = Calendar.getInstance();
			Calendar calDeb = Calendar.getInstance();
			Calendar calFin = Calendar.getInstance();
			Date debutPeriode =da.parse(debPeriode.getText());
			calDeb.setTime(debutPeriode);
			Date finPeriode = da.parse(endPeriode.getText());
			calFin.setTime(finPeriode);
			
			for(int i=1;i<tableauMBA.getRowCount();i++)
			{
				if(String.valueOf(tableauMBA.getValueAt(i, 2)).compareTo("null")!=0 && String.valueOf(tableauMBA.getValueAt(i, 3)).compareTo("null")!=0)
				{	
					d=da.parse(String.valueOf(tableauMBA.getValueAt(i, 1)));
					cal.setTime(d);

					Date datePrec = da.parse(String.valueOf(tableauMBA.getValueAt(i-1, 1)));
					calPrec.setTime(datePrec);
					if(String.valueOf(tableauMBA.getValueAt(i, 0)).compareTo(String.valueOf(tableauMBA.getValueAt(i-1, 0)))==0 && cal.get(Calendar.YEAR)==calPrec.get(Calendar.YEAR))
					{
						d=da.parse(String.valueOf(tableauMBA.getValueAt(i, 1)));
						cal.setTime(d);

						if(cal.get(Calendar.DAY_OF_YEAR)>=calDeb.get(Calendar.DAY_OF_YEAR) && cal.get(Calendar.DAY_OF_YEAR)<=calFin.get(Calendar.DAY_OF_YEAR))
						{
							moyChloro+=Float.parseFloat((String) tableauMBA.getValueAt(i, 4));
							nbChloro+=1;
						}
					}
					else if(String.valueOf(tableauMBA.getValueAt(i, 0)).compareTo(String.valueOf(tableauMBA.getValueAt(i-1, 0)))!=0 || cal.get(Calendar.YEAR)!=calPrec.get(Calendar.YEAR))
					{
						moyChloro=moyChloro/(float)nbChloro;
						refChloro=(float) Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))));

						tableMBA.setValueAt(String.valueOf(tableauMBA.getValueAt(i-1, 0)), place, 0);
						tableMBA.setValueAt(String.valueOf(calPrec.get(Calendar.YEAR)), place, 1);
						tableMBA.setValueAt(String.valueOf(moyChloro), place, 2);
						tableMBA.setValueAt(String.valueOf(refChloro), place, 3);
						tableMBA.setValueAt(String.valueOf(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773)))), place, 4);
						tableMBA.setValueAt(String.valueOf(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+2*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773))))), place, 5);
						tableMBA.setValueAt(String.valueOf(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+3*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773))))), place, 6);
						tableMBA.setValueAt(String.valueOf(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+4*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773))))), place, 7);
						tableMBA.setValueAt(String.valueOf(refChloro/(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773))))), place, 8);
						tableMBA.setValueAt(String.valueOf(refChloro/(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+2*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773)))))), place, 9);
						tableMBA.setValueAt(String.valueOf(refChloro/(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+3*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773)))))), place, 10);
						tableMBA.setValueAt(String.valueOf(refChloro/(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+4*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773)))))), place, 11);
						tableMBA.setValueAt(String.valueOf(refChloro/moyChloro), place, 12);
						tableMBA.setValueAt(String.valueOf(LinearRegression.variable(Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 4))),
								Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 5))),Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 6))),
								Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 7))),Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 8))),
								Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 9))),Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 10))),
								Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 11))))*Math.log(refChloro/moyChloro)+1), place, 13);
						if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))<Float.parseFloat((String) tableMBA.getValueAt(place, 11)))
						{
							tableMBA.setValueAt("B",place,14);
						}
						else if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))>=Float.parseFloat((String) tableMBA.getValueAt(place, 11)) && Float.parseFloat((String) tableMBA.getValueAt(place, 12))<Float.parseFloat((String) tableMBA.getValueAt(place, 10)))
						{
							tableMBA.setValueAt("P", place, 14);
						}
						else if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))>=Float.parseFloat((String) tableMBA.getValueAt(place, 10)) && Float.parseFloat((String) tableMBA.getValueAt(place, 12))<Float.parseFloat((String) tableMBA.getValueAt(place, 9)))
						{
							tableMBA.setValueAt("M", place, 14);
						}
						else if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))>=Float.parseFloat((String) tableMBA.getValueAt(place, 9)) && Float.parseFloat((String) tableMBA.getValueAt(place, 12))<Float.parseFloat((String) tableMBA.getValueAt(place, 8)))
						{
							tableMBA.setValueAt("G", place, 14);
						}
						if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))>=Float.parseFloat((String) tableMBA.getValueAt(place, 8)))
						{
							tableMBA.setValueAt("H",place,14);
						}
						if(nbChloro<nbCampagnesMini)
						{
							tableMBA.setValueAt(non + nbCampValide + nbCampagnesMini, place, 15);
						}
						else if(nbChloro>=nbCampagnesMini)
						{
							tableMBA.setValueAt("Ok", place, 15);
						}
						d=da.parse(String.valueOf(tableauMBA.getValueAt(i, 1)));
						cal.setTime(d);
						calDeb.setTime(debutPeriode);
						calFin.setTime(finPeriode);
						if(cal.get(Calendar.DAY_OF_YEAR)>=calDeb.get(Calendar.DAY_OF_YEAR) && cal.get(Calendar.DAY_OF_YEAR)<=calFin.get(Calendar.DAY_OF_YEAR))
						{
							nbChloro=1;
							moyChloro=Float.parseFloat((String) tableauMBA.getValueAt(i, 4));
						}	
						else
						{
							moyChloro=0;
							nbChloro=0;
						}
						place+=1;
					}
				}
				// calcul de la MBA pour la dernire ligne du tableau de donnes
				else if(tableauMBA.getValueAt(i, 0)==null && tableauMBA.getValueAt(i-1, 0)!=null)
				{
					moyChloro=moyChloro/(float)nbChloro;
					refChloro=(float) Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))));

					tableMBA.setValueAt(String.valueOf(tableauMBA.getValueAt(i-2, 0)), place, 0);
					tableMBA.setValueAt(String.valueOf(calPrec.get(Calendar.YEAR)), place, 1);
					tableMBA.setValueAt(String.valueOf(moyChloro), place, 2);
					tableMBA.setValueAt(String.valueOf(refChloro), place, 3);
					tableMBA.setValueAt(String.valueOf(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773)))), place, 4);
					tableMBA.setValueAt(String.valueOf(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+2*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773))))), place, 5);
					tableMBA.setValueAt(String.valueOf(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+3*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773))))), place, 6);
					tableMBA.setValueAt(String.valueOf(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+4*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773))))), place, 7);
					tableMBA.setValueAt(String.valueOf(refChloro/(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773))))), place, 8);
					tableMBA.setValueAt(String.valueOf(refChloro/(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+2*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773)))))), place, 9);
					tableMBA.setValueAt(String.valueOf(refChloro/(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+3*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773)))))), place, 10);
					tableMBA.setValueAt(String.valueOf(refChloro/(Math.pow(10, 0.754-(0.489*Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3))))+4*(1.7109*(0.1424*Math.sqrt(1.0385+Math.pow((Math.log10(Float.parseFloat((String) tableauMBA.getValueAt(i-1, 3)))-0.9425),2)/4.0773)))))), place, 11);
					tableMBA.setValueAt(String.valueOf(refChloro/moyChloro), place, 12);
					tableMBA.setValueAt(String.valueOf(LinearRegression.variable(Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 4))),
							Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 5))),Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 6))),
							Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 7))),Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 8))),
							Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 9))),Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 10))),
							Float.parseFloat(String.valueOf(tableMBA.getValueAt(place, 11))))*Math.log(refChloro/moyChloro)+1), place, 13);

					if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))<Float.parseFloat((String) tableMBA.getValueAt(place, 11)))
					{
						tableMBA.setValueAt("B",place,14);
					}
					else if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))>=Float.parseFloat((String) tableMBA.getValueAt(place, 11)) && Float.parseFloat((String) tableMBA.getValueAt(place, 12))<Float.parseFloat((String) tableMBA.getValueAt(place, 10)))
					{
						tableMBA.setValueAt("P", place, 14);
					}
					else if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))>=Float.parseFloat((String) tableMBA.getValueAt(place, 10)) && Float.parseFloat((String) tableMBA.getValueAt(place, 12))<Float.parseFloat((String) tableMBA.getValueAt(place, 9)))
					{
						tableMBA.setValueAt("M", place, 14);
					}
					else if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))>=Float.parseFloat((String) tableMBA.getValueAt(place, 9)) && Float.parseFloat((String) tableMBA.getValueAt(place, 12))<Float.parseFloat((String) tableMBA.getValueAt(place, 8)))
					{
						tableMBA.setValueAt("G", place, 14);
					}
					if(Float.parseFloat((String) tableMBA.getValueAt(place, 12))>=Float.parseFloat((String) tableMBA.getValueAt(place, 8)))
					{
						tableMBA.setValueAt("H",place,14);
					}					
					if(nbChloro<nbCampagnesMini)
					{
						tableMBA.setValueAt(non + nbCampValide + nbCampagnesMini, place, 15);
					}
					else if(nbChloro>=nbCampagnesMini)
					{
						tableMBA.setValueAt("Ok", place, 15);
					}
				}
			}
		}catch(ParseException e)
		{

		}
	}

	// TODO METHODE DE CALCUL DE LA MCS
	private void calculerMCS(int fin, int i, int nbTaxonsTotaux, int nbTaxonsContrib, int nbTaxonsInd, int nbTaxonsSp, 
			double numerateur, double denominateur, double sommeCampagnes, int nbCampagnes, int nbCampagnesHorsPriode,
			int indiceMCSCampagne, JTable tableMCS, JTable listeCote, JTable MCS_campagne, JTable resultatsMCS, int placeFinal)
	{
		try
		{
			SimpleDateFormat da = new SimpleDateFormat("dd/MM/yyyy");
			Date priodeDbut = da.parse(debPeriode.getText());
			Calendar contrainteDbut= Calendar.getInstance();
			Calendar contrainteFin= Calendar.getInstance();
			Date priodeFin = da.parse(endPeriode.getText());
			contrainteDbut.setTime(priodeDbut);
			contrainteFin.setTime(priodeFin);
			Date d;
			Calendar cal= Calendar.getInstance();
			Calendar calPrec = Calendar.getInstance();
			Calendar calDeb = Calendar.getInstance();
			Calendar calFin = Calendar.getInstance();
			Date debutPeriode =da.parse(debPeriode.getText());
			calDeb.setTime(debutPeriode);
			Date finPeriode = da.parse(endPeriode.getText());
			calFin.setTime(finPeriode);
			
			placeFinal=0;		//ajout pour tester
			
			while(tableauMCS.getValueAt(fin, 0)!=null)
			{
				d=da.parse(String.valueOf(tableauMCS.getValueAt(i, 1)));
				contrainteDbut.setTime(priodeDbut);
				contrainteFin.setTime(priodeFin);
				cal.setTime(d);
				if(i==0)
				{
					nbTaxonsTotaux=1;
					for(int j=0;j<listeCote.getRowCount();j++)
					{
						// exclusion des taxons qui sont cts mais sans biovol
						// sinon calcul
						if(String.valueOf(tableMCS.getValueAt(i, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0
								&& (tableMCS.getValueAt(i, 6)!=null)
								&& String.valueOf(tableMCS.getValueAt(i, 6)).compareTo("")!=0
								&& String.valueOf(tableMCS.getValueAt(i, 6)).compareTo("0")!=0) {

							numerateur+=Double.parseDouble(String.valueOf(tableMCS.getValueAt(i, 6)))
									*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 0)))
									*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 1)));
							denominateur+=Double.parseDouble(String.valueOf(tableMCS.getValueAt(i, 6)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 1)));
							tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j, 2)), i, 7);
							tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j,0)),i,8);
							tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j,1)),i,9);
							nbTaxonsContrib+=1;
							System.out.println("1erligneMCS= "+nbTaxonsContrib);
						}
					}
					if(String.valueOf(tableauMCS.getValueAt(i, 2)).startsWith("IND"))
					{
						nbTaxonsInd+=1;
					}
					if(String.valueOf(tableauMCS.getValueAt(i, 2)).endsWith("SPX"))
					{
						nbTaxonsSp+=1;
					}
					i++;
					fin=i;
				}
				if(i>0)
				{
					Date datePrec;
					datePrec = da.parse(String.valueOf(tableauMCS.getValueAt(i-1, 1)));
					calPrec.setTime(datePrec);
					// si toujour sur mme PE et mme anne
					if(String.valueOf(tableauMCS.getValueAt(i, 0)).compareTo(String.valueOf(tableauMCS.getValueAt(i-1, 0)))==0 
							&& cal.get(Calendar.YEAR)==calPrec.get(Calendar.YEAR))
					{
						// alors si la date est la mme que la ligne prcdente
						if(cal.get(Calendar.DAY_OF_YEAR)==calPrec.get(Calendar.DAY_OF_YEAR))
						{
							nbTaxonsTotaux+=1;
							for(int j=0;j<listeCote.getRowCount();j++)
							{
								// exclusion des taxons qui sont cts mais sans biovol
								// sinon calcul
								if(String.valueOf(tableMCS.getValueAt(i, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
										&& tableMCS.getValueAt(i, 6)!=null
										&& String.valueOf(tableMCS.getValueAt(i, 6)).compareTo("")!=0
										&& String.valueOf(tableMCS.getValueAt(i, 6)).compareTo("0")!=0)
								{

									numerateur+=Double.parseDouble(String.valueOf(tableMCS.getValueAt(i, 6)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 0)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 1)));
									denominateur+=Double.parseDouble(String.valueOf(tableMCS.getValueAt(i, 6)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 1)));
									tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j, 2)), i, 7);
									tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j,0)),i,8);
									tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j,1)),i,9);
									nbTaxonsContrib+=1;
									System.out.println("1TaxContrib= "+nbTaxonsContrib);
								}
							}
							// ajout  partir de l
							if(String.valueOf(tableauMCS.getValueAt(i, 2)).startsWith("IND"))
							{
								nbTaxonsInd+=1;
							}
							if(String.valueOf(tableauMCS.getValueAt(i, 2)).endsWith("SPX"))
							{
								nbTaxonsSp+=1;
							}	// jusque l
						} 
						else // sinon nouvelle date du mme PE et mme anne
						{
							if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
									&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
									&& nbTaxonsContrib>=Integer.parseInt(taxContrib.getText()) && nbTaxonsTotaux>=Integer.parseInt(taxTot.getText()))
							{
								sommeCampagnes+=numerateur/denominateur;
								nbCampagnes+=1;
								System.out.println("1erCamp= "+nbCampagnes);
								System.out.println("NbTaxContrib-1erCamp= "+nbTaxonsContrib);
							} else
							{
							// ajout camp hors priode
							if(calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
									|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR))
							{
								System.out.println("CampHorsPer= "+calPrec.get(Calendar.MONTH)); // TODO lignes print  suppr  la fin
								System.out.println("CampHorsPer= "+calPrec.get(Calendar.DAY_OF_YEAR));
								System.out.println("CampHorsPer= "+contrainteDbut.get(Calendar.DAY_OF_YEAR));
								nbCampagnesHorsPriode+=1;
								System.out.println("CampHorsPer= "+nbCampagnesHorsPriode);
							}
							}
							MCS_campagne.setValueAt(tableauMCS.getValueAt(i-1, 0),indiceMCSCampagne-1,0);
							MCS_campagne.setValueAt(tableauMCS.getValueAt(i-1, 1), indiceMCSCampagne-1, 1);
							MCS_campagne.setValueAt(String.valueOf(numerateur/denominateur), indiceMCSCampagne-1, 2);
							nbTaxonsTotaux=1;
							nbTaxonsContrib=0;
							numerateur=0;
							denominateur=0;
							
							// recherche des taxons cots nouvelle campagne
							for(int j=0;j<listeCote.getRowCount();j++)
							{
								if(String.valueOf(tableMCS.getValueAt(i, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
										&& tableMCS.getValueAt(i, 5)!=null
										&& String.valueOf(tableMCS.getValueAt(i, 6)).compareTo("")!=0
										&& String.valueOf(tableMCS.getValueAt(i, 6)).compareTo("0")!=0)
								{
									numerateur=Double.parseDouble(String.valueOf(tableMCS.getValueAt(i, 6)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 0)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 1)));
									denominateur=Double.parseDouble(String.valueOf(tableMCS.getValueAt(i, 6)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 1)));
									tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j, 2)), i, 7);
									tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j,0)),i,8);
									tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j,1)),i,9);
									nbTaxonsContrib=1;
									System.out.println("1bisTaxContrib= "+nbTaxonsContrib);
								}
							}
							nbTaxonsInd=0;
							nbTaxonsSp=0;
							indiceMCSCampagne+=1;
						}		
						if(String.valueOf(tableauMCS.getValueAt(i, 2)).startsWith("IND"))
						{
							nbTaxonsInd+=1;
						}
						if(String.valueOf(tableauMCS.getValueAt(i, 2)).endsWith("SPX"))
						{
							nbTaxonsSp+=1;
						}
						i++;
						fin=i;
					} else		// sinon changement de PE ou d'anne
					{
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR)
								&& nbTaxonsContrib>=Integer.parseInt(taxContrib.getText()) && nbTaxonsTotaux>=Integer.parseInt(taxTot.getText()))
						{
							sommeCampagnes+=numerateur/denominateur;
							nbCampagnes+=1;
							System.out.println("derniereCamp= "+nbCampagnes);
							System.out.println("NbTaxContribDernierCamp= "+nbTaxonsContrib);
						} else

						// si campagne hors priode						
						if(calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR))
						{
							nbCampagnesHorsPriode+=1;
						}

						MCS_campagne.setValueAt(tableauMCS.getValueAt(i-1, 0),indiceMCSCampagne-1,0);
						MCS_campagne.setValueAt(tableauMCS.getValueAt(i-1, 1), indiceMCSCampagne-1, 1);
						MCS_campagne.setValueAt(String.valueOf(numerateur/denominateur), indiceMCSCampagne-1, 2);
						resultatsMCS.setValueAt(String.valueOf(tableauMCS.getValueAt(i-1, 0)), placeFinal, 0);
						resultatsMCS.setValueAt(String.valueOf(calPrec.get(Calendar.YEAR)), placeFinal, 1);

						for(int j=0;j<tableauMBA.getRowCount();j++)
						{
							// si nom PE de MCS correspond nom PE de MBA
							if(String.valueOf(tableauMCS.getValueAt(i-1, 0)).compareTo(String.valueOf(tableauMBA.getValueAt(j, 0)))==0
									&& String.valueOf(tableauMBA.getValueAt(j, 2)).compareTo("null")!=0 
									&& String.valueOf(tableauMBA.getValueAt(j, 3)).compareTo("null")!=0)
							{
								if(placeFinal>0)
								{
									if(calPrec.get(Calendar.YEAR)!=Integer.parseInt(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 1)))
											|| String.valueOf(tableauMCS.getValueAt(i-1, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 0)))!=0)  // test sans i-1
									{
										resultatsMCS.setValueAt(tableauMCS.getValueAt(i-1, 0), placeFinal, 0);
										resultatsMCS.setValueAt(String.valueOf(calPrec.get(Calendar.YEAR)), placeFinal, 1);
										resultatsMCS.setValueAt(String.valueOf(sommeCampagnes/nbCampagnes), placeFinal, 2);
										resultatsMCS.setValueAt(String.valueOf(10.134+(2.603*Math.log10(Double.parseDouble(String.valueOf(tableauMBA.getValueAt(j, 3)))+1))+(0.3148*Math.log10(Double.parseDouble(String.valueOf(tableauMBA.getValueAt(j, 2)))+1))), placeFinal, 3);
										resultatsMCS.setValueAt(String.valueOf((sommeCampagnes/nbCampagnes)/Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))), placeFinal, 8);
										resultatsMCS.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 8)))*1.2048561-0.3318232), placeFinal, 9);
										if(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)).compareTo("NaN")==0)
										{
											resultatsMCS.setValueAt(null, placeFinal, 9);
										}
										else
										{
											if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.8)
											{
												resultatsMCS.setValueAt("H", placeFinal, 10);
											}
											else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.8 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.6)
											{
												resultatsMCS.setValueAt("G", placeFinal, 10);
											}
											else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.6 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.4)
											{
												resultatsMCS.setValueAt("M", placeFinal, 10);
											}
											else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.4 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.2)
											{
												resultatsMCS.setValueAt("P", placeFinal, 10);
											}
											else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.2)
											{
												resultatsMCS.setValueAt("B", placeFinal, 10);
											}
										}
										resultatsMCS.setValueAt(String.valueOf((0.8+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 4);
										resultatsMCS.setValueAt(String.valueOf((0.6+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 5);
										resultatsMCS.setValueAt(String.valueOf((0.4+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 6);
										resultatsMCS.setValueAt(String.valueOf((0.2+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 7);
										resultatsMCS.setValueAt(String.valueOf(nbCampagnesHorsPriode), placeFinal, 11);
										resultatsMCS.setValueAt(String.valueOf(nbCampagnes), placeFinal, 12);

										System.out.println("SortieNbCampValid1= "+nbCampagnes); //  suppr

										if(nbCampagnes>=Integer.parseInt(campMin.getText()))
										{
											resultatsMCS.setValueAt("Ok", placeFinal, 13);
										}
										else
										{
											resultatsMCS.setValueAt(non, placeFinal, 13);
										}
									}
								}
								else if(placeFinal==0)
								{
									resultatsMCS.setValueAt(String.valueOf(sommeCampagnes/nbCampagnes), placeFinal, 2);
									resultatsMCS.setValueAt(String.valueOf(10.134+(2.603*Math.log10(Double.parseDouble(String.valueOf(tableauMBA.getValueAt(j, 3)))+1))+(0.3148*Math.log10(Double.parseDouble(String.valueOf(tableauMBA.getValueAt(j, 2)))+1))), placeFinal, 3);
									resultatsMCS.setValueAt(String.valueOf((sommeCampagnes/nbCampagnes)/Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))), placeFinal, 8);
									resultatsMCS.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 8)))*1.2048561-0.3318232), placeFinal, 9);
									if(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)).compareTo("NaN")==0)
									{
										resultatsMCS.setValueAt(null, placeFinal, 9);
									}
									else
									{
										if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.8)
										{
											resultatsMCS.setValueAt("H", placeFinal, 10);
										}
										else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.8 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.6)
										{
											resultatsMCS.setValueAt("G", placeFinal, 10);
										}
										else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.6 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.4)
										{
											resultatsMCS.setValueAt("M", placeFinal, 10);
										}
										else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.4 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.2)
										{
											resultatsMCS.setValueAt("P", placeFinal, 10);
										}
										else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.2)
										{
											resultatsMCS.setValueAt("B", placeFinal, 10);
										}
									}
									resultatsMCS.setValueAt(String.valueOf((0.8+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 4);
									resultatsMCS.setValueAt(String.valueOf((0.6+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 5);
									resultatsMCS.setValueAt(String.valueOf((0.4+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 6);
									resultatsMCS.setValueAt(String.valueOf((0.2+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 7);
									resultatsMCS.setValueAt(String.valueOf(nbCampagnesHorsPriode), placeFinal, 11);
									resultatsMCS.setValueAt(String.valueOf(nbCampagnes), placeFinal, 12);

									System.out.println("SortieNbCampValid0= "+nbCampagnes); //  suppr
									System.out.println("SortieNbCampHorsPer0= "+nbCampagnesHorsPriode); //  suppr
									
									if(nbCampagnes>=Integer.parseInt(campMin.getText()))
									{
										resultatsMCS.setValueAt("Ok", placeFinal, 13);
									}
									else
									{
										resultatsMCS.setValueAt(non, placeFinal, 13);
									}
								}
							} 
						}
						placeFinal+=1;
						nbTaxonsTotaux=1;
						nbTaxonsContrib=0;
						nbCampagnes=0;
						nbCampagnesHorsPriode=0;
						sommeCampagnes=0;
						numerateur=0;
						denominateur=0;
						//recherche des taxons cots de la nouvelle ligne/campagne
						for(int j=0;j<listeCote.getRowCount();j++)
						{
							if(String.valueOf(tableMCS.getValueAt(i, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
									&& tableMCS.getValueAt(i, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(i, 6)).compareTo("")!=0
									&& String.valueOf(tableMCS.getValueAt(i, 6)).compareTo("0")!=0)
							{
								numerateur=Double.parseDouble(String.valueOf(tableMCS.getValueAt(i, 6)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 0)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 1)));
								denominateur=Double.parseDouble(String.valueOf(tableMCS.getValueAt(i, 6)))*Double.parseDouble(String.valueOf(listeCote.getValueAt(j, 1)));
								tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j, 2)), i, 7);
								tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j,0)),i,8);
								tableMCS.setValueAt(String.valueOf(listeCote.getValueAt(j,1)),i,9);
								nbTaxonsContrib=1;
							}
						}
						nbTaxonsInd=0;
						nbTaxonsSp=0;
						if(String.valueOf(tableauMCS.getValueAt(i, 2)).startsWith("IND"))
						{
							nbTaxonsInd+=1;
						}
						if(String.valueOf(tableauMCS.getValueAt(i, 2)).endsWith("SPX"))
						{
							nbTaxonsSp+=1;
						}
						indiceMCSCampagne+=1;
						i++;
						fin=i;
					}
				}
			}
			// si premire ligne de sortie MCS
			if(placeFinal==0)
			{
				if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
						&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR)
						&& nbTaxonsContrib>=Integer.parseInt(taxContrib.getText()) && nbTaxonsTotaux>=Integer.parseInt(taxTot.getText()))
				{
					sommeCampagnes+=numerateur/denominateur;
					nbCampagnes+=1;
					System.out.println("3erOcc= "+nbCampagnes);
				}
				
				// ajout  partir de l
		/*		else
					if(calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
							|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR))
					{
						nbCampagnesHorsPriode+=1;
					}
				//jusque l
		*/		
				resultatsMCS.setValueAt(tableauMCS.getValueAt(i-1, 0), placeFinal, 0);
				resultatsMCS.setValueAt(String.valueOf(calPrec.get(Calendar.YEAR)), placeFinal, 1);
				resultatsMCS.setValueAt(String.valueOf(sommeCampagnes/nbCampagnes), placeFinal, 2);
				resultatsMCS.setValueAt(String.valueOf(10.134+(2.603*Math.log10(Double.parseDouble(String.valueOf(tableauMBA.getValueAt(0, 3)))+1))+(0.3148*Math.log10(Double.parseDouble(String.valueOf(tableauMBA.getValueAt(0, 2)))+1))), placeFinal, 3);
				resultatsMCS.setValueAt(String.valueOf((sommeCampagnes/nbCampagnes)/Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))), placeFinal, 8);
				resultatsMCS.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 8)))*1.2048561-0.3318232), placeFinal, 9);
				if(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)).compareTo("NaN")==0)
				{
					resultatsMCS.setValueAt(null, placeFinal, 9);
				}
				else
				{
					if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.8)
					{
						resultatsMCS.setValueAt("H", placeFinal, 10);
					}
					else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.8 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.6)
					{
						resultatsMCS.setValueAt("G", placeFinal, 10);
					}
					else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.6 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.4)
					{
						resultatsMCS.setValueAt("M", placeFinal, 10);
					}
					else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.4 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.2)
					{
						resultatsMCS.setValueAt("P", placeFinal, 10);
					}
					else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.2)
					{
						resultatsMCS.setValueAt("B", placeFinal, 10);
					}
				}
				resultatsMCS.setValueAt(String.valueOf((0.8+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 4);
				resultatsMCS.setValueAt(String.valueOf((0.6+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 5);
				resultatsMCS.setValueAt(String.valueOf((0.4+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 6);
				resultatsMCS.setValueAt(String.valueOf((0.2+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 7);
				resultatsMCS.setValueAt(String.valueOf(nbCampagnesHorsPriode), placeFinal, 11);
				resultatsMCS.setValueAt(String.valueOf(nbCampagnes), placeFinal, 12);

				System.out.println("2-SortieNbCampValid0= "+nbCampagnes); //  suppr
				System.out.println("2-SortieNbCampHorsPer0= "+nbCampagnesHorsPriode); //  suppr
				
				if(nbCampagnes>=Integer.parseInt(campMin.getText()))
				{
					resultatsMCS.setValueAt("Ok", placeFinal, 13);
				}
				else
				{
					resultatsMCS.setValueAt(non, placeFinal, 13);
				}
				placeFinal+=1;

			} else

				if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
						&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR)
				&& nbTaxonsContrib>=Integer.parseInt(taxContrib.getText()) && nbTaxonsTotaux>=Integer.parseInt(taxTot.getText()))
				{
					sommeCampagnes+=numerateur/denominateur;
					nbCampagnes+=1;
					System.out.println("4-NbCampValid= "+nbCampagnes);
				}
				else
					if(calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
							|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR))
					{
						nbCampagnesHorsPriode+=1;
					}

			MCS_campagne.setValueAt(tableauMCS.getValueAt(i-1, 0),indiceMCSCampagne-1,0);
			MCS_campagne.setValueAt(tableauMCS.getValueAt(i-1, 1), indiceMCSCampagne-1, 1);
			MCS_campagne.setValueAt(String.valueOf(numerateur/denominateur), indiceMCSCampagne-1, 2);

			if(resultatsMCS.getValueAt(placeFinal-1, 9)!=null)
			{
				if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))>=0.8)
				{
					resultatsMCS.setValueAt("H", placeFinal-1, 10);
				}
				else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))<0.8 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))>=0.6)
				{
					resultatsMCS.setValueAt("G", placeFinal-1, 10);
				}
				else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))<0.6 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))>=0.4)
				{
					resultatsMCS.setValueAt("M", placeFinal-1, 10);
				}
				else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))<0.4 && Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))>=0.2)
				{
					resultatsMCS.setValueAt("P", placeFinal-1, 10);
				}
				else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))<0.2)
				{
					resultatsMCS.setValueAt("B", placeFinal-1, 10);
				}

		/*
				// ajout  partir de l
				resultatsMCS.setValueAt(String.valueOf((0.8+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 3)))/1.2048561) , placeFinal-1, 4);
				resultatsMCS.setValueAt(String.valueOf((0.6+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 3)))/1.2048561) , placeFinal-1, 5);
				resultatsMCS.setValueAt(String.valueOf((0.4+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 3)))/1.2048561) , placeFinal-1, 6);
				resultatsMCS.setValueAt(String.valueOf((0.2+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 3)))/1.2048561) , placeFinal-1, 7);
				resultatsMCS.setValueAt(String.valueOf(nbCampagnesHorsPriode), placeFinal-1, 11);
				resultatsMCS.setValueAt(String.valueOf(nbCampagnes), placeFinal-1, 12);
				
				System.out.println("4-SortieNbCampValid= "+nbCampagnes); //  suppr
				System.out.println("4-SortieNbCampHorsPer= "+nbCampagnesHorsPriode); //  suppr
				
				//jusque l
		*/
			}
			// comparaison des noms de PE entre Tableau MBA et tableau MCS
			for(int j=0;j<tableauMBA.getRowCount();j++)
			{
				if(String.valueOf(tableauMCS.getValueAt(i-1, 0)).compareTo(String.valueOf(tableauMBA.getValueAt(j, 0)))==0 
						&& String.valueOf(tableauMBA.getValueAt(j, 2)).compareTo("null")!=0 
						&& String.valueOf(tableauMBA.getValueAt(j, 3)).compareTo("null")!=0)
				{
					if(calPrec.get(Calendar.YEAR)!=Integer.parseInt(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 1))) 
							|| String.valueOf(tableauMCS.getValueAt(i-1, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 0)))!=0)
					{
						resultatsMCS.setValueAt(tableauMCS.getValueAt(i-1, 0), placeFinal, 0);
						resultatsMCS.setValueAt(String.valueOf(calPrec.get(Calendar.YEAR)), placeFinal, 1);
						resultatsMCS.setValueAt(String.valueOf(sommeCampagnes/nbCampagnes), placeFinal, 2);
						resultatsMCS.setValueAt(String.valueOf(10.134+(2.603*Math.log10(Double.parseDouble(String.valueOf(tableauMBA.getValueAt(j, 3)))+1))+(0.3148*Math.log10(Double.parseDouble(String.valueOf(tableauMBA.getValueAt(j, 2)))+1))), placeFinal, 3);
						resultatsMCS.setValueAt(String.valueOf((sommeCampagnes/nbCampagnes)/Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))), placeFinal, 8);
						resultatsMCS.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 8)))*1.2048561-0.3318232), placeFinal, 9);
						if(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)).compareTo("NaN")==0)
						{
							resultatsMCS.setValueAt(null, placeFinal, 9);
						}
						else
						{
							if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.8)
							{
								resultatsMCS.setValueAt("H", placeFinal, 10);
							}
							else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.8 
									&& Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.6)
							{
								resultatsMCS.setValueAt("G", placeFinal, 10);
							}
							else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.6 
									&& Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.4)
							{
								resultatsMCS.setValueAt("M", placeFinal, 10);
							}
							else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.4 
									&& Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))>=0.2)
							{
								resultatsMCS.setValueAt("P", placeFinal, 10);
							}
							else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal, 9)))<0.2)
							{
								resultatsMCS.setValueAt("B", placeFinal, 10);
							}
						}
						resultatsMCS.setValueAt(String.valueOf((0.8+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 4);
						resultatsMCS.setValueAt(String.valueOf((0.6+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 5);
						resultatsMCS.setValueAt(String.valueOf((0.4+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 6);
						resultatsMCS.setValueAt(String.valueOf((0.2+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal, 3)))/1.2048561) , placeFinal, 7);
						resultatsMCS.setValueAt(String.valueOf(nbCampagnesHorsPriode), placeFinal, 11);
						resultatsMCS.setValueAt(String.valueOf(nbCampagnes), placeFinal, 12);

						System.out.println("5-SortieNbCampValid= "+nbCampagnes); //  suppr
						System.out.println("5-SortieNbCampHorsPer= "+nbCampagnesHorsPriode); //  suppr

						if(nbCampagnes>=Integer.parseInt(campMin.getText()))
						{
							resultatsMCS.setValueAt("Ok", placeFinal, 13);
						}
						else
						{
							resultatsMCS.setValueAt(non, placeFinal, 13);
						}
						placeFinal+=1;
					}
				}
			}

			if(resultatsMCS.getValueAt(placeFinal-1, 9)!=null)
			{
				if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))>=0.8)
				{
					resultatsMCS.setValueAt("H", placeFinal-1, 10);
				}
				else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))<0.8 
						&& Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))>=0.6)
				{
					resultatsMCS.setValueAt("G", placeFinal-1, 10);
				}
				else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))<0.6 
						&& Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))>=0.4)
				{
					resultatsMCS.setValueAt("M", placeFinal-1, 10);
				}
				else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))<0.4 
						&& Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))>=0.2)
				{
					resultatsMCS.setValueAt("P", placeFinal-1, 10);
				}
				else if(Float.parseFloat(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 9)))<0.2)
				{
					resultatsMCS.setValueAt("B", placeFinal-1, 10);
				}

/*
				// ajout  partir de l
				resultatsMCS.setValueAt(String.valueOf((0.8+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 3)))/1.2048561) , placeFinal-1, 4);
				resultatsMCS.setValueAt(String.valueOf((0.6+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 3)))/1.2048561) , placeFinal-1, 5);
				resultatsMCS.setValueAt(String.valueOf((0.4+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 3)))/1.2048561) , placeFinal-1, 6);
				resultatsMCS.setValueAt(String.valueOf((0.2+0.3318232)*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(placeFinal-1, 3)))/1.2048561) , placeFinal-1, 7);
				resultatsMCS.setValueAt(String.valueOf(nbCampagnesHorsPriode), placeFinal-1, 11);
				resultatsMCS.setValueAt(String.valueOf(nbCampagnes), placeFinal-1, 12);
				
				System.out.println("6-SortieNbCampValid= "+nbCampagnes); //  suppr
				System.out.println("6-SortieNbCampHorsPer= "+nbCampagnesHorsPriode); //  suppr
				
				//jusque l
*/
			}
		} catch(ParseException e)
		{

		}
		
	}

	// TODO METHODE DE CALCUL DE L'IPLAC
	private void calculerIPLAC(int indiceMBA, int indiceMCS, int ligneIPLAC, JTable tableMBA, JTable resultatsMCS, JTable tableIPLAC)
	{
		DecimalFormat f2 = new DecimalFormat();
		f2.setMaximumFractionDigits(3);
		while(indiceMBA<tableMBA.getRowCount()+1 && indiceMCS<resultatsMCS.getRowCount()+1)
		{
			if(tableMBA.getValueAt(indiceMBA, 0)!=null && resultatsMCS.getValueAt(indiceMCS, 0)!=null)
			{
				tableIPLAC.setValueAt(debPer+String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(0, 5)+finPer+
						String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(6, 11)+nbreCampMin+String.valueOf(tableauAnalyse.getValueAt(0, 3)).substring(0, 1)+
						nbreTaxTot+String.valueOf(tableauAnalyse.getValueAt(0, 4))+nbreTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0, 5)), ligneIPLAC, 10);
				if(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)))==0 && Integer.parseInt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)))==Integer.parseInt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1))))
				{
					tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
					tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
					tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
					tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
					if(String.valueOf(tableMBA.getValueAt(indiceMBA, 15)).compareTo("Ok")==0)
					{
						if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>=0 && Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<=1)
						{
							tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13))))).replace(",", "."), ligneIPLAC, 2);
							tableIPLAC.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))).replace(",", "."), ligneIPLAC, 2);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<0)
						{
							tableauIPLAC.setValueAt(0, ligneIPLAC, 2);
							tableIPLAC.setValueAt("0", ligneIPLAC, 2);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>1)
						{
							tableauIPLAC.setValueAt(1, ligneIPLAC, 2);
							tableIPLAC.setValueAt("1", ligneIPLAC, 2);
						}
						tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
						tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
					}
					else
					{
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 2);
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 3);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 2);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 3);
					}
					if(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 13)).compareTo("Ok")==0)
					{
						if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))>=0 && Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))<=1)
						{
							tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9))))).replace(",", "."), ligneIPLAC, 4);
							tableIPLAC.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))).replace(",", "."), ligneIPLAC, 4);
						}
						else if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))<0)
						{
							tableauIPLAC.setValueAt(0, ligneIPLAC, 4);
							tableIPLAC.setValueAt("0", ligneIPLAC, 4);
						}
						else if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))>1)
						{
							tableauIPLAC.setValueAt(1, ligneIPLAC, 4);
							tableIPLAC.setValueAt("1", ligneIPLAC, 4);
						}
						tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
						tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
					}
					else
					{
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 4);
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 5);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 4);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 5);
					}

					if(String.valueOf(tableauIPLAC.getValueAt(ligneIPLAC, 2))=="NA" || String.valueOf(tableauIPLAC.getValueAt(ligneIPLAC, 4))=="NA")
					{
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 6);
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 7);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 6);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 7);
					}
					else
					{
						if(0.70*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 9)))+0.30*Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>=0 
								&& 0.70*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 9)))+0.30*Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<=1)
						{
							tableauIPLAC.setValueAt(String.valueOf(f2.format(0.70*Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 4)))+0.30*Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 2))))).replace(",", "."), ligneIPLAC, 6);
							tableIPLAC.setValueAt(String.valueOf(0.70*Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 4)))+0.30*Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 2)))).replace(",", "."), ligneIPLAC, 6);
						}
						else if(0.70*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 9)))+0.30*Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<0)
						{
							tableauIPLAC.setValueAt(0, ligneIPLAC, 6);
							tableIPLAC.setValueAt("0", ligneIPLAC, 6);
						}
						else if(0.70*Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 9)))+0.30*Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>1)
						{
							tableauIPLAC.setValueAt(1, ligneIPLAC, 6);
							tableIPLAC.setValueAt("1", ligneIPLAC, 6);
						}

						if(Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 6)))<0.2)
						{
							tableauIPLAC.setValueAt("B", ligneIPLAC, 7);
							tableIPLAC.setValueAt("B", ligneIPLAC, 7);
						}
						else if(Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 6)))>=0.2 && Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 6)))<0.4)
						{
							tableauIPLAC.setValueAt("P", ligneIPLAC, 7);
							tableIPLAC.setValueAt("P", ligneIPLAC, 7);
						}
						else if(Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 6)))>=0.4 && Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 6)))<0.6)
						{
							tableauIPLAC.setValueAt("M", ligneIPLAC, 7);
							tableIPLAC.setValueAt("M", ligneIPLAC, 7);
						}
						else if(Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 6)))>=0.6 && Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 6)))<0.8)
						{
							tableauIPLAC.setValueAt("G", ligneIPLAC, 7);
							tableIPLAC.setValueAt("G", ligneIPLAC, 7);
						}
						else if(Double.parseDouble(String.valueOf(tableIPLAC.getValueAt(ligneIPLAC, 6)))>=0.8)
						{
							tableauIPLAC.setValueAt("H", ligneIPLAC, 7);
							tableIPLAC.setValueAt("H", ligneIPLAC, 7);
						}
					}
					indiceMBA++;
					indiceMCS++;
					ligneIPLAC++;
				}
				else if(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)))==0 && Integer.parseInt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)))<Integer.parseInt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1))))
				{
					tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
					tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
					tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
					tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
					if(String.valueOf(tableMBA.getValueAt(indiceMBA, 15)).compareTo("Ok")==0)
					{
						if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>=0 && Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<=1)
						{
							tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13))))).replace(",", "."), ligneIPLAC, 2);
							tableIPLAC.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))).replace(",", "."), ligneIPLAC, 2);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<0)
						{
							tableauIPLAC.setValueAt(0, ligneIPLAC, 2);
							tableIPLAC.setValueAt("0", ligneIPLAC, 2);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>1)
						{
							tableauIPLAC.setValueAt(1, ligneIPLAC, 2);
							tableIPLAC.setValueAt("1", ligneIPLAC, 2);
						}
						tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
						tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
					}
					else
					{
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 2);
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 3);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 2);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 3);
					}
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 4);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 5);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 6);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 7);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 4);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 5);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 6);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 7);
					indiceMBA++;
					ligneIPLAC++;
				}
				else if(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)))==0 && Integer.parseInt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)))>Integer.parseInt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1))))
				{
					tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
					tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1)), ligneIPLAC, 1);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 2);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 3);
					tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
					tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1)), ligneIPLAC, 1);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 2);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 3);
					if(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 13)).compareTo("Ok")==0)
					{
						if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))>=0 && Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))<=1)
						{
							tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9))))).replace(",", "."), ligneIPLAC, 4);
							tableIPLAC.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))).replace(",", "."), ligneIPLAC, 4);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<0)
						{
							tableauIPLAC.setValueAt(0, ligneIPLAC, 4);
							tableIPLAC.setValueAt("0", ligneIPLAC, 4);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>1)
						{
							tableauIPLAC.setValueAt(1, ligneIPLAC, 4);
							tableIPLAC.setValueAt("1", ligneIPLAC, 4);
						}
						tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
						tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
					}
					else
					{
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 4);
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 5);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 4);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 5);
					}
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 6);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 7);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 6);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 7);
					indiceMCS++;
					ligneIPLAC++;
				}
				else if(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)))<0)
				{
					tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
					tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
					tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
					tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
					if(String.valueOf(tableMBA.getValueAt(indiceMBA, 15)).compareTo("Ok")==0)
					{
						if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>=0 && Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<=1)
						{
							tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13))))).replace(",", "."), ligneIPLAC, 2);
							tableIPLAC.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))).replace(",", "."), ligneIPLAC, 2);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<0)
						{
							tableauIPLAC.setValueAt(0, ligneIPLAC, 2);
							tableIPLAC.setValueAt("0", ligneIPLAC, 2);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>1)
						{
							tableauIPLAC.setValueAt(1, ligneIPLAC, 2);
							tableIPLAC.setValueAt("1", ligneIPLAC, 2);
						}
						tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
						tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
					}
					else
					{
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 2);
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 3);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 2);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 3);
					}
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 4);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 5);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 6);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 7);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 4);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 5);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 6);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 7);
					indiceMBA++;
					ligneIPLAC++;
				}
				else if(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)))>0)
				{
					tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)), ligneIPLAC, 0);
					tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1)), ligneIPLAC, 1);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 2);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 3);
					tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)), ligneIPLAC, 0);
					tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1)), ligneIPLAC, 1);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 2);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 3);
					if(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 13)).compareTo("Ok")==0)
					{
						if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))>=0 && Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))<=1)
						{
							tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9))))).replace(",", "."), ligneIPLAC, 4);
							tableIPLAC.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))).replace(",", "."), ligneIPLAC, 4);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<0)
						{
							tableauIPLAC.setValueAt(0, ligneIPLAC, 4);
							tableIPLAC.setValueAt("0", ligneIPLAC, 4);
						}
						else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>1)
						{
							tableauIPLAC.setValueAt(1, ligneIPLAC, 4);
							tableIPLAC.setValueAt("1", ligneIPLAC, 4);
						}
						tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
						tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
					}
					else
					{
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 4);
						tableauIPLAC.setValueAt("NA", ligneIPLAC, 5);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 4);
						tableIPLAC.setValueAt("NA", ligneIPLAC, 5);
					}
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 6);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 7);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 6);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 7);
					indiceMCS++;
					ligneIPLAC++;
				}
			}
			else if(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)))!=0 
					&& String.valueOf(tableMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauIPLAC.getValueAt(ligneIPLAC-1, 0)))==0)
			{
				tableIPLAC.setValueAt(debPer+String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(0, 5)+finPer+
						String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(6, 11)+nbreCampMin+String.valueOf(tableauAnalyse.getValueAt(0, 3)).substring(0, 1)+
						nbreTaxTot+String.valueOf(tableauAnalyse.getValueAt(0, 4))+nbreTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0, 5)), ligneIPLAC, 10);
				tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
				tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
				tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
				tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
				if(String.valueOf(tableMBA.getValueAt(indiceMBA, 15)).compareTo("Ok")==0)
				{
					if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>=0 && Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<=1)
					{
						tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13))))).replace(",", "."), ligneIPLAC, 2);
						tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)).replace(",", "."), ligneIPLAC, 2);
					}
					else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<0)
					{
						tableauIPLAC.setValueAt(0, ligneIPLAC, 2);
						tableIPLAC.setValueAt("0", ligneIPLAC, 2);
					}
					else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>1)
					{
						tableauIPLAC.setValueAt(1, ligneIPLAC, 2);
						tableIPLAC.setValueAt("1", ligneIPLAC, 2);
					}
					tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
					tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
				}
				else
				{
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 2);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 3);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 2);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 3);
				}
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 4);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 5);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 6);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 7);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 4);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 5);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 6);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 7);
				indiceMBA++;
				ligneIPLAC++;
			}
			else if(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)))!=0 
					&& String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)).compareTo(String.valueOf(tableauIPLAC.getValueAt(ligneIPLAC-1, 0)))==0)
			{
				tableIPLAC.setValueAt(debPer+String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(0, 5)+finPer+
						String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(6, 11)+nbreCampMin+String.valueOf(tableauAnalyse.getValueAt(0, 3)).substring(0, 1)+
						nbreTaxTot+String.valueOf(tableauAnalyse.getValueAt(0, 4))+nbreTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0, 5)), ligneIPLAC, 10);
				tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)), ligneIPLAC, 0);
				tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1)), ligneIPLAC, 1);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 2);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 3);
				tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)), ligneIPLAC, 0);
				tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1)), ligneIPLAC, 1);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 2);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 3);
				if(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 13)).compareTo("Ok")==0)
				{
					if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))>=0 && Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))<=1)
					{
						tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9))))).replace(",", "."), ligneIPLAC, 4);
						tableIPLAC.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))).replace(",", "."), ligneIPLAC, 4);
					}
					else if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))<0)
					{
						tableauIPLAC.setValueAt(0, ligneIPLAC, 4);
						tableIPLAC.setValueAt("0", ligneIPLAC, 4);
					}
					else if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))>1)
					{
						tableauIPLAC.setValueAt(1, ligneIPLAC, 4);
						tableIPLAC.setValueAt("1", ligneIPLAC, 4);
					}
					tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
					tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
				}
				else
				{
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 4);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 5);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 4);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 5);
				}
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 6);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 7);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 6);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 7);
				indiceMCS++;
				ligneIPLAC++;
			}
			else if(tableMBA.getValueAt(indiceMBA, 0)==null && resultatsMCS.getValueAt(indiceMCS, 0)!=null)
			{
				tableIPLAC.setValueAt(debPer+String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(0, 5)+finPer+
						String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(6, 11)+nbreCampMin+String.valueOf(tableauAnalyse.getValueAt(0, 3)).substring(0, 1)+
						nbreTaxTot+String.valueOf(tableauAnalyse.getValueAt(0, 4))+nbreTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0, 5)), ligneIPLAC, 10);
				tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)), ligneIPLAC, 0);
				tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1)), ligneIPLAC, 1);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 2);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 3);
				tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 0)), ligneIPLAC, 0);
				tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 1)), ligneIPLAC, 1);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 2);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 3);
				if(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 13)).compareTo("Ok")==0)
				{
					if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))>=0 && Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9)))<=1)
					{
						tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9))))).replace(",", "."), ligneIPLAC, 4);
						tableIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS,9))))).replace(",", "."), ligneIPLAC, 4);
					}
					else if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 9)))<0)
					{
						tableauIPLAC.setValueAt(0, ligneIPLAC, 4);
						tableIPLAC.setValueAt("0", ligneIPLAC, 4);
					}
					else if(Double.parseDouble(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 9)))>1)
					{
						tableauIPLAC.setValueAt(1, ligneIPLAC, 4);
						tableIPLAC.setValueAt("1", ligneIPLAC, 4);
					}
					tableauIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
					tableIPLAC.setValueAt(String.valueOf(resultatsMCS.getValueAt(indiceMCS, 10)), ligneIPLAC, 5);
				}
				else
				{
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 4);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 5);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 4);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 5);
				}
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 6);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 7);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 6);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 7);
				indiceMCS++;
				ligneIPLAC++;
			}
			else if(resultatsMCS.getValueAt(indiceMCS, 0)==null && tableMBA.getValueAt(indiceMBA, 0)!=null)
			{
				tableIPLAC.setValueAt(debPer+String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(0, 5)+finPer+
						String.valueOf(tableauAnalyse.getValueAt(0, 1)).substring(6, 11)+nbreCampMin+String.valueOf(tableauAnalyse.getValueAt(0, 3)).substring(0, 1)+
						nbreTaxTot+String.valueOf(tableauAnalyse.getValueAt(0, 4))+nbreTaxContrib+String.valueOf(tableauAnalyse.getValueAt(0, 5)), ligneIPLAC, 10);
				tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
				tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
				tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 0)), ligneIPLAC, 0);
				tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 1)), ligneIPLAC, 1);
				if(String.valueOf(tableMBA.getValueAt(indiceMBA, 15)).compareTo("Ok")==0)
				{
					if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>=0 && Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<=1)
					{
						tableauIPLAC.setValueAt(String.valueOf(f2.format(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13))))).replace(",", "."), ligneIPLAC, 2);
						tableIPLAC.setValueAt(String.valueOf(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))).replace(",", "."), ligneIPLAC, 2);
					}
					else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))<0)
					{
						tableauIPLAC.setValueAt(0, ligneIPLAC, 2);
						tableIPLAC.setValueAt("0", ligneIPLAC, 2);
					}
					else if(Double.parseDouble(String.valueOf(tableMBA.getValueAt(indiceMBA, 13)))>1)
					{
						tableauIPLAC.setValueAt(1, ligneIPLAC, 2);
						tableIPLAC.setValueAt("1", ligneIPLAC, 2);
					}
					tableauIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
					tableIPLAC.setValueAt(String.valueOf(tableMBA.getValueAt(indiceMBA, 14)), ligneIPLAC, 3);
				}
				else
				{
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 2);
					tableauIPLAC.setValueAt("NA", ligneIPLAC, 3);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 2);
					tableIPLAC.setValueAt("NA", ligneIPLAC, 3);
				}
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 4);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 5);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 6);
				tableauIPLAC.setValueAt("NA", ligneIPLAC, 7);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 4);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 5);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 6);
				tableIPLAC.setValueAt("NA", ligneIPLAC, 7);
				indiceMBA++;
				ligneIPLAC++;
			}
			else if(tableMBA.getValueAt(indiceMBA, 0)==null && resultatsMCS.getValueAt(indiceMCS, 0)==null)
			{
				indiceMBA=tableMBA.getRowCount()+1;
				indiceMCS=resultatsMCS.getRowCount()+1;
			}
		}
	}

	// TODO METHODE POUR L'ANALYSE DES DONNEES
	private void analyserDonnes(int indiceMBA, int indiceMCS, int indiceAnalyse, int placeSomme, int priseEnCompte, int ligneIPLAC,
			int nbTaxonsTotaux, int nbTaxonsContrib, int nbTaxonsSp, int nbTaxonsInd, int indiceMCSCampagne, JTable tableIPLAC,
			JTable tableMCS, JTable listeCote, JTable MCS_campagne)
	{
		DecimalFormat f = new DecimalFormat();
		f.setMaximumFractionDigits(1);
		try
		{
			while(indiceMBA<tableauMBA.getRowCount() && indiceMCS<tableauMCS.getRowCount())
			{

				SimpleDateFormat da = new SimpleDateFormat("dd/MM/yyyy");
				Date priodeDbut = da.parse(debPeriode.getText());
				Calendar contrainteDbut= Calendar.getInstance();
				Calendar contrainteFin= Calendar.getInstance();
				Date priodeFin = da.parse(endPeriode.getText());
				contrainteDbut.setTime(priodeDbut);
				contrainteFin.setTime(priodeFin);
				Date d;
				//Calendar cal= Calendar.getInstance();
				Calendar calPrec = Calendar.getInstance();
				Calendar calDeb = Calendar.getInstance();
				Calendar calFin = Calendar.getInstance();
				Date debutPeriode =da.parse(debPeriode.getText());
				calDeb.setTime(debutPeriode);
				Date finPeriode = da.parse(endPeriode.getText());
				calFin.setTime(finPeriode);
				Calendar cala= Calendar.getInstance();
				Calendar calb= Calendar.getInstance();
				Calendar analyse= Calendar.getInstance();
				Calendar analysePrec= Calendar.getInstance();

				if(tableauMBA.getValueAt(indiceMBA, 0)!=null && tableauMCS.getValueAt(indiceMCS, 0)!=null)
				{
					Date datePrec = new Date();
					datePrec = da.parse(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)));
					calPrec.setTime(datePrec);
					Date mba=da.parse(String.valueOf(tableauMBA.getValueAt(indiceMBA, 1)));
					cala.setTime(mba);
					d=da.parse(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)));
					calb.setTime(d);
					if(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)))<0)
					{
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 1)), indiceAnalyse, 1);
						if(indiceAnalyse>1)
						{
							Date analyseActuelle= da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 1)));
							Date analysePrcdente=da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 1)));
							analyse.setTime(analyseActuelle);
							analysePrec.setTime(analysePrcdente);

							if(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)!=null && analyse.get(Calendar.YEAR)!=analysePrec.get(Calendar.YEAR))
							{
								for(int k=placeSomme;k<indiceAnalyse;k++)
								{
									if(String.valueOf(tableauAnalyse.getValueAt(k, 2))=="1")
									{
										priseEnCompte+=1;
									}
								}
								tableauAnalyse.setValueAt(String.valueOf(priseEnCompte), placeSomme, 3);
								priseEnCompte=0;
								ligneIPLAC+=1;
								placeSomme=indiceAnalyse;
							}
						}
						if(cala.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR) 
								&& cala.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR))
						{
									tableauAnalyse.setValueAt("1", indiceAnalyse, 2);
						}
						else
						{
							tableauAnalyse.setValueAt("0", indiceAnalyse, 2);
							tableIPLAC.setValueAt(horsPriode, ligneIPLAC, 8);
						}
						priseEnCompte=0;
						indiceAnalyse+=1;
						indiceMBA+=1;
					}
					else if(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)))>0)
					{
						tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)), indiceAnalyse, 1);
						while(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS+1, 1)))==0)
						{
							nbTaxonsTotaux+=1;
							for(int j=0;j<listeCote.getRowCount();j++)
							{
								if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
										&& tableMCS.getValueAt(indiceMCS, 6)!=null
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
								{
									nbTaxonsContrib+=1;
								}
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
							{
								nbTaxonsInd+=1;
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
							{
								nbTaxonsSp+=1;
							}
							indiceMCS+=1;
						}
						for(int j=0;j<listeCote.getRowCount();j++)
						{
							if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
									&& tableMCS.getValueAt(indiceMCS, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
							{
								nbTaxonsContrib+=1;
							}
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
						{
							nbTaxonsInd+=1;
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
						{
							nbTaxonsSp+=1;
						}
						nbTaxonsTotaux+=1;
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsTotaux), indiceAnalyse, 4);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsContrib), indiceAnalyse, 5);
						System.out.println("1erVal"+nbTaxonsContrib);  //  suppr
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,5)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100)).replace(",", "."), indiceAnalyse, 6);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsSp), indiceAnalyse, 7);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,7)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",",".")), indiceAnalyse, 8);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsInd), indiceAnalyse, 9);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,9)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 10);
						
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR) 
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR)
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))>=Integer.parseInt(taxTot.getText()))
						{
							
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							
							if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
							{
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
						}
						else
						{
							if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR) 
									&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR) 
									|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+Double.parseDouble(taxTot.getText()), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
										&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
								}
							}
						}
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						priseEnCompte=0;
						indiceAnalyse+=1;
						indiceMCS+=1;
						nbTaxonsTotaux=0;
						nbTaxonsInd=0;
						nbTaxonsSp=0;
						nbTaxonsContrib=0;
						indiceMCSCampagne+=1;
					}
					else if(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)))==0 && cala.equals(calb))
					{
						while(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS+1, 1)))==0)
						{
							nbTaxonsTotaux+=1;
							for(int j=0;j<listeCote.getRowCount();j++)
							{
								if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
										&& tableMCS.getValueAt(indiceMCS, 6)!=null
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
								{
									nbTaxonsContrib+=1;
								}
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
							{
								nbTaxonsInd+=1;
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
							{
								nbTaxonsSp+=1;
							}
							indiceMCS+=1;
						}
						for(int j=0;j<listeCote.getRowCount();j++)
						{
							if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
									&& tableMCS.getValueAt(indiceMCS, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
							{
								nbTaxonsContrib+=1;
							}
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
						{
							nbTaxonsInd+=1;
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
						{
							nbTaxonsSp+=1;
						}
						nbTaxonsTotaux+=1;
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 1)), indiceAnalyse, 1);
						if(indiceAnalyse>1)
						{
							Date analyseActuelle= da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 1)));
							Date analysePrcdente=da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 1)));
							analyse.setTime(analyseActuelle);
							analysePrec.setTime(analysePrcdente);

							if(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)!=null && analyse.get(Calendar.YEAR)!=analysePrec.get(Calendar.YEAR))
							{
								for(int k=placeSomme;k<indiceAnalyse;k++)
								{
									if(String.valueOf(tableauAnalyse.getValueAt(k, 2))=="1")
									{
										priseEnCompte+=1;
									}
								}
								tableauAnalyse.setValueAt(String.valueOf(priseEnCompte), placeSomme, 3);
								priseEnCompte=0;
								ligneIPLAC+=1;
								placeSomme=indiceAnalyse;
							}
						}
						if(cala.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& cala.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR))
						{
							tableauAnalyse.setValueAt("1", indiceAnalyse, 2);
							
						}
						else
						{
							tableauAnalyse.setValueAt("0", indiceAnalyse, 2);
							tableIPLAC.setValueAt(horsPriode, ligneIPLAC, 8);
						}

						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsTotaux), indiceAnalyse, 4);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsContrib), indiceAnalyse, 5);
						System.out.println("2erVal"+nbTaxonsContrib);  //  suppr
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,5)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100)).replace(",", "."), indiceAnalyse, 6);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsSp), indiceAnalyse, 7);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,7)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",",".")), indiceAnalyse, 8);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsInd), indiceAnalyse, 9);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,9)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 10);
						
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR)
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))>=Integer.parseInt(taxTot.getText()))
						{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							
							if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
						}
						else
						{
							if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
									&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
									|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+Double.parseDouble(taxTot.getText()), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
										&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
								}
							}
						}
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						priseEnCompte=0;
						indiceAnalyse+=1;
						indiceMBA+=1;
						indiceMCS+=1;
						nbTaxonsTotaux=0;
						nbTaxonsInd=0;
						nbTaxonsSp=0;
						nbTaxonsContrib=0;
						indiceMCSCampagne+=1;
					}
					else if(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)))==0 && cala.before(calb))
					{
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 1)), indiceAnalyse, 1);
						if(indiceAnalyse>1)
						{
							Date analyseActuelle= da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 1)));
							Date analysePrcdente=da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 1)));
							analyse.setTime(analyseActuelle);
							analysePrec.setTime(analysePrcdente);
							if(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)!=null && analyse.get(Calendar.YEAR)!=analysePrec.get(Calendar.YEAR))
							{
								for(int k=placeSomme;k<indiceAnalyse;k++)
								{
									if(String.valueOf(tableauAnalyse.getValueAt(k, 2))=="1")
									{
										priseEnCompte+=1;
									}
								}
								tableauAnalyse.setValueAt(String.valueOf(priseEnCompte), placeSomme, 3);
								priseEnCompte=0;
								ligneIPLAC+=1;
								placeSomme=indiceAnalyse;
							}
						}
						if(cala.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& cala.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR))
						{
							tableauAnalyse.setValueAt("1", indiceAnalyse, 2);
						}
						else
						{
							tableauAnalyse.setValueAt("0", indiceAnalyse, 2);
							tableIPLAC.setValueAt(horsPriode, ligneIPLAC, 8);
						}
						indiceAnalyse+=1;
						indiceMBA+=1;
					}
					else if(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)))==0 && cala.after(calb))
					{
						while(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS+1, 1)))==0)
						{
							nbTaxonsTotaux+=1;
							for(int j=0;j<listeCote.getRowCount();j++)
							{
								if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
										&& tableMCS.getValueAt(indiceMCS, 6)!=null
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
								{
									nbTaxonsContrib+=1;
								}
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
							{
								nbTaxonsInd+=1;
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
							{
								nbTaxonsSp+=1;
							}
							indiceMCS+=1;
						}
						for(int j=0;j<listeCote.getRowCount();j++)
						{
							if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
									&& tableMCS.getValueAt(indiceMCS, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
							{
								nbTaxonsContrib+=1;
							}
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
						{
							nbTaxonsInd+=1;
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
						{
							nbTaxonsSp+=1;
						}
						nbTaxonsTotaux+=1;
						tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)),indiceAnalyse,1);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsTotaux), indiceAnalyse, 4);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsContrib), indiceAnalyse, 5);
						System.out.println("3erVal"+nbTaxonsContrib);  //  suppr
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,5)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100)).replace(",", "."), indiceAnalyse, 6);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsSp), indiceAnalyse, 7);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,7)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 8);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsInd), indiceAnalyse, 9);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,9)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 10);
						
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR)
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))>=Integer.parseInt(taxTot.getText()))
						{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							
							if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
						}
						else
						{
							if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
									&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
									|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
										&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
								}
							}
						}
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						indiceAnalyse+=1;
						indiceMCS+=1;
						nbTaxonsTotaux=0;
						nbTaxonsInd=0;
						nbTaxonsSp=0;
						nbTaxonsContrib=0;
						indiceMCSCampagne+=1;
					}
					else if(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)))!=0 && String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))==0 && String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))!=0)
					{
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 1)), indiceAnalyse, 1);
						if(indiceAnalyse>1)
						{
							Date analyseActuelle= da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 1)));
							Date analysePrcdente=da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 1)));
							analyse.setTime(analyseActuelle);
							analysePrec.setTime(analysePrcdente);

							if(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)!=null && analyse.get(Calendar.YEAR)!=analysePrec.get(Calendar.YEAR))
							{
								for(int k=placeSomme;k<indiceAnalyse;k++)
								{
									if(String.valueOf(tableauAnalyse.getValueAt(k, 2))=="1")
									{
										priseEnCompte+=1;
									}
								}
								tableauAnalyse.setValueAt(String.valueOf(priseEnCompte), placeSomme, 3);
								priseEnCompte=0;
								ligneIPLAC+=1;
								placeSomme=indiceAnalyse;
							}
						}
						if(cala.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& cala.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR))
						{
							
							tableauAnalyse.setValueAt("1", indiceAnalyse, 2);
						}
						else
						{
							tableauAnalyse.setValueAt("0", indiceAnalyse, 2);
							tableIPLAC.setValueAt(horsPriode, ligneIPLAC, 8);
						}

						indiceAnalyse+=1;
						indiceMBA+=1;
					}
					else if(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)))!=0 && String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))==0 && String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))!=0)
					{
						while(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS+1, 1)))==0)
						{
							nbTaxonsTotaux+=1;
							for(int j=0;j<listeCote.getRowCount();j++)
							{
								if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
										&& tableMCS.getValueAt(indiceMCS, 6)!=null
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
								{
									nbTaxonsContrib+=1;
								}
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
							{
								nbTaxonsInd+=1;
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
							{
								nbTaxonsSp+=1;
							}
							indiceMCS+=1;
						}
						for(int j=0;j<listeCote.getRowCount();j++)
						{
							if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
									&& tableMCS.getValueAt(indiceMCS, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
							{
								nbTaxonsContrib+=1;
							}
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
						{
							nbTaxonsInd+=1;
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
						{
							nbTaxonsSp+=1;
						}
						nbTaxonsTotaux+=1;
						tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS,1)),indiceAnalyse,1);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsTotaux), indiceAnalyse, 4);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsContrib), indiceAnalyse, 5);
						System.out.println("4erVal"+nbTaxonsContrib);  //  suppr
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,5)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100)).replace(",", "."), indiceAnalyse, 6);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsSp), indiceAnalyse, 7);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,7)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 8);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsInd), indiceAnalyse, 9);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,9)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 10);
						
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR)
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))>=Integer.parseInt(taxTot.getText()))
						{
							
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							
							if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
						}
						else
						{
							if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
									&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
									|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
										&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
								}
							}
						}
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						indiceAnalyse+=1;
						indiceMCS+=1;
						nbTaxonsTotaux=0;
						nbTaxonsInd=0;
						nbTaxonsSp=0;
						nbTaxonsContrib=0;
						indiceMCSCampagne+=1;
					}
					else if(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))==0 && String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))!=0)
					{
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 1)), indiceAnalyse, 1);
						if(indiceAnalyse>1)
						{
							Date analyseActuelle= da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 1)));
							Date analysePrcdente=da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 1)));
							analyse.setTime(analyseActuelle);
							analysePrec.setTime(analysePrcdente);

							if(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)!=null && analyse.get(Calendar.YEAR)!=analysePrec.get(Calendar.YEAR))
							{
								for(int k=placeSomme;k<indiceAnalyse;k++)
								{
									if(String.valueOf(tableauAnalyse.getValueAt(k, 2))=="1")
									{
										priseEnCompte+=1;
									}
								}
								tableauAnalyse.setValueAt(String.valueOf(priseEnCompte), placeSomme, 3);
								priseEnCompte=0;
								ligneIPLAC+=1;
								placeSomme=indiceAnalyse;
							}
						}
						if(cala.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& cala.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR))
						{
							tableauAnalyse.setValueAt("1", indiceAnalyse, 2);
						}
						else
						{
							tableauAnalyse.setValueAt("0", indiceAnalyse, 2);
							tableIPLAC.setValueAt(horsPriode, ligneIPLAC, 8);
						}
						indiceAnalyse+=1;
						indiceMBA+=1;
					}
					else if(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))!=0 && String.valueOf(tableauMCS.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))==0)
					{
						while(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS+1, 1)))==0)
						{
							nbTaxonsTotaux+=1;
							for(int j=0;j<listeCote.getRowCount();j++)
							{
								if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
										&& tableMCS.getValueAt(indiceMCS, 6)!=null
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
										&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
								{
									nbTaxonsContrib+=1;
								}
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
							{
								nbTaxonsInd+=1;
							}
							if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
							{
								nbTaxonsSp+=1;
							}
							indiceMCS+=1;
						}
						for(int j=0;j<listeCote.getRowCount();j++)
						{
							if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
									&& tableMCS.getValueAt(indiceMCS, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
							{
								nbTaxonsContrib+=1;
							}
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
						{
							nbTaxonsInd+=1;
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
						{
							nbTaxonsSp+=1;
						}
						nbTaxonsTotaux+=1;
						tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS,1)),indiceAnalyse,1);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsTotaux), indiceAnalyse, 4);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsContrib), indiceAnalyse, 5);
						System.out.println("5erVal"+nbTaxonsContrib);  //  suppr
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,5)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100)).replace(",", "."), indiceAnalyse, 6);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsSp), indiceAnalyse, 7);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,7)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 8);
						tableauAnalyse.setValueAt(String.valueOf(nbTaxonsInd), indiceAnalyse, 9);
						tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,9)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 10);
						
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR)
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))>=Integer.parseInt(taxTot.getText()))
						{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							
							if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							}
							else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							}
						}
						else
						{
							if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
									&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
									|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
									&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
								}
								if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
										&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
								{
									MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
								}
							}
						}
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<=Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
								MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
							}
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						indiceAnalyse+=1;
						indiceMCS+=1;
						nbTaxonsTotaux=0;
						nbTaxonsInd=0;
						nbTaxonsSp=0;
						nbTaxonsContrib=0;
						indiceMCSCampagne+=1;
					}
					else if(String.valueOf(tableauMBA.getValueAt(indiceMBA,0)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)))!=0 && String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))!=0 && String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)))!=0)
					{
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)), indiceAnalyse, 0);
						tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 1)), indiceAnalyse, 1);
						if(indiceAnalyse>1)
						{
							Date analyseActuelle= da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 1)));
							Date analysePrcdente=da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 1)));
							analyse.setTime(analyseActuelle);
							analysePrec.setTime(analysePrcdente);

							if(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)!=null && analyse.get(Calendar.YEAR)!=analysePrec.get(Calendar.YEAR))
							{
								for(int k=placeSomme;k<indiceAnalyse;k++)
								{
									if(String.valueOf(tableauAnalyse.getValueAt(k, 2))=="1")
									{
										priseEnCompte+=1;
									}
								}
								tableauAnalyse.setValueAt(String.valueOf(priseEnCompte), placeSomme, 3);
								priseEnCompte=0;
								ligneIPLAC+=1;
								placeSomme=indiceAnalyse;
							}
						}
						if(cala.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& cala.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR))
						{
							tableauAnalyse.setValueAt("1", indiceAnalyse, 2);
						}
						else
						{
							tableauAnalyse.setValueAt("0", indiceAnalyse, 2);
							tableIPLAC.setValueAt(horsPriode, ligneIPLAC, 8);
						}
						indiceAnalyse+=1;
						indiceMBA+=1;
					}
				}
				else if(tableauMCS.getValueAt(indiceMCS, 0)!=null)
				{
					Date datePrec = new Date();
					datePrec = da.parse(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)));
					calPrec.setTime(datePrec);
					while(String.valueOf(tableauMCS.getValueAt(indiceMCS, 1)).compareTo(String.valueOf(tableauMCS.getValueAt(indiceMCS+1, 1)))==0)
					{
						nbTaxonsTotaux+=1;
						for(int j=0;j<listeCote.getRowCount();j++)
						{
							if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
									&& tableMCS.getValueAt(indiceMCS, 6)!=null
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
									&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
							{
								nbTaxonsContrib+=1;
							}
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
						{
							nbTaxonsInd+=1;
						}
						if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
						{
							nbTaxonsSp+=1;
						}
						indiceMCS+=1;
					}
					for(int j=0;j<listeCote.getRowCount();j++)
					{
						if(String.valueOf(tableMCS.getValueAt(indiceMCS, 2)).compareTo(String.valueOf(listeCote.getValueAt(j,2)))==0 
								&& tableMCS.getValueAt(indiceMCS, 6)!=null
								&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("")!=0
								&& String.valueOf(tableMCS.getValueAt(indiceMCS, 6)).compareTo("0")!=0)
						{
							nbTaxonsContrib+=1;
						}
					}
					if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).startsWith("IND"))
					{
						nbTaxonsInd+=1;
					}
					if(String.valueOf(tableauMCS.getValueAt(indiceMCS, 2)).endsWith("SPX"))
					{
						nbTaxonsSp+=1;
					}
					nbTaxonsTotaux+=1;
					tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS, 0)), indiceAnalyse, 0);
					tableauAnalyse.setValueAt(String.valueOf(tableauMCS.getValueAt(indiceMCS,1)),indiceAnalyse,1);
					tableauAnalyse.setValueAt(String.valueOf(nbTaxonsTotaux), indiceAnalyse, 4);
					tableauAnalyse.setValueAt(String.valueOf(nbTaxonsContrib), indiceAnalyse, 5);
					System.out.println("6erVal"+nbTaxonsContrib);  //  suppr
					tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,5)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100)).replace(",", "."), indiceAnalyse, 6);
					tableauAnalyse.setValueAt(String.valueOf(nbTaxonsSp), indiceAnalyse, 7);
					tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,7)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 8);
					tableauAnalyse.setValueAt(String.valueOf(nbTaxonsInd), indiceAnalyse, 9);
					tableauAnalyse.setValueAt(String.valueOf(f.format(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,9)))/Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse,4)))*100).replace(",", ".")), indiceAnalyse, 10);
					
					if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
							&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR)
							&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText())
							&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))>=Integer.parseInt(taxTot.getText()))
					{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
						
						if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
						else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
						}
						else if(Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						}
					}
					else
					{
						if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
								&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
						if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
								|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<Double.parseDouble(pourcInd.getText()) 
								&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<Double.parseDouble(pourcSp.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
							}
							if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
									&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
							{
								MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+Integer.parseInt(taxTot.getText()), indiceMCSCampagne, 4);
							}
						}
					}
					if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
							&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
					{
						MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
						MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
					}
					else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
							&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()))
					{
						MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
						MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
					}
					else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
							&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText())
							&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
					{
						MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
						MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
					}
					else if(calPrec.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
							&& calPrec.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()))
					{
						MCS_campagne.setValueAt("Ok", indiceMCSCampagne, 3);
						MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<=Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()) 
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
							MCS_campagne.setValueAt(nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
					}
					else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
							|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))<=Double.parseDouble(pourcSp.getText()))
					{
						MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
						MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
						MCS_campagne.setValueAt(nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
					}
					else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
							|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))<=Double.parseDouble(pourcInd.getText()) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()))
					{
						MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
						MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
						MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"%", indiceMCSCampagne, 5);
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
						{
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText())
								&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
					}
					else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
							|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
							&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))>=Integer.parseInt(taxContrib.getText()))
					{
						MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
						MCS_campagne.setValueAt(horsPriode, indiceMCSCampagne, 4);
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
						MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
					}
					else if((calPrec.get(Calendar.DAY_OF_YEAR)<contrainteDbut.get(Calendar.DAY_OF_YEAR)
							|| calPrec.get(Calendar.DAY_OF_YEAR)>contrainteFin.get(Calendar.DAY_OF_YEAR)) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 10)))>Double.parseDouble(pourcInd.getText()) 
							&& Double.parseDouble(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 8)))>Double.parseDouble(pourcSp.getText()) 
							&& Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 5)))<Integer.parseInt(taxContrib.getText()))
					{
						MCS_campagne.setValueAt(non, indiceMCSCampagne, 3);
						MCS_campagne.setValueAt(horsPriode+et+" "+nbTaxContrib+taxContrib.getText(), indiceMCSCampagne, 4);
						if(Integer.parseInt(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 4)))<Integer.parseInt(taxTot.getText()))
						{
							MCS_campagne.setValueAt(horsPriode+", "+nbTaxContrib+taxContrib.getText()+" "+et+" "+nbTaxTot+taxTot.getText(), indiceMCSCampagne, 4);
						}
						MCS_campagne.setValueAt(nbTaxGenres+Double.parseDouble(pourcSp.getText())+"% "+et+" "+nbTaxonsInd+Double.parseDouble(pourcInd.getText())+"%", indiceMCSCampagne, 5);
					}
					indiceAnalyse+=1;
					indiceMCS+=1;
					nbTaxonsTotaux=0;
					nbTaxonsInd=0;
					nbTaxonsSp=0;
					nbTaxonsContrib=0;
					indiceMCSCampagne+=1;
				}
				else if(tableauMBA.getValueAt(indiceMBA, 0)!=null)
				{
					tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 0)), indiceAnalyse, 0);
					tableauAnalyse.setValueAt(String.valueOf(tableauMBA.getValueAt(indiceMBA, 1)), indiceAnalyse, 1);
					Date mba=da.parse(String.valueOf(tableauMBA.getValueAt(indiceMBA, 1)));
					cala.setTime(mba);
					if(indiceAnalyse>1)
					{
						Date analyseActuelle= da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse, 1)));
						Date analysePrcdente=da.parse(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 1)));
						analyse.setTime(analyseActuelle);
						analysePrec.setTime(analysePrcdente);

						if(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)!=null && analyse.get(Calendar.YEAR)!=analysePrec.get(Calendar.YEAR))
						{
							for(int k=placeSomme;k<indiceAnalyse;k++)
							{
								if(String.valueOf(tableauAnalyse.getValueAt(k, 2))=="1")
								{
									priseEnCompte+=1;
								}
							}
							tableauAnalyse.setValueAt(String.valueOf(priseEnCompte), placeSomme, 3);
							priseEnCompte=0;
							ligneIPLAC+=1;
							placeSomme=indiceAnalyse;
						}
					}
					if(cala.get(Calendar.DAY_OF_YEAR)>=contrainteDbut.get(Calendar.DAY_OF_YEAR)
							&& cala.get(Calendar.DAY_OF_YEAR)<=contrainteFin.get(Calendar.DAY_OF_YEAR))
					{
						tableauAnalyse.setValueAt("1", indiceAnalyse, 2);
					}
					else
					{
						tableIPLAC.setValueAt(horsPriode, ligneIPLAC, 8);
						tableauAnalyse.setValueAt("0", indiceAnalyse, 2);
					}
					indiceAnalyse+=1;
					indiceMBA+=1;
				}
				else
				{
					if(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)!=null)
					{
						for(int k=placeSomme;k<indiceAnalyse;k++)
						{
							if(String.valueOf(tableauAnalyse.getValueAt(k, 2))=="1")
							{
								priseEnCompte+=1;
							}
						}
						tableauAnalyse.setValueAt(String.valueOf(priseEnCompte), placeSomme, 3);
						priseEnCompte=0;
						indiceAnalyse=tableauAnalyse.getRowCount();
						placeSomme=indiceAnalyse-1;
					}

					indiceMBA+=1;
					indiceMCS+=1;
				}
				if(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-1, 0)).compareTo(String.valueOf(tableauAnalyse.getValueAt(indiceAnalyse-2, 0)))!=0 && indiceAnalyse!=1)
				{
					for(int k=placeSomme;k<indiceAnalyse-1;k++)
					{
						if(String.valueOf(tableauAnalyse.getValueAt(k, 2))=="1")
						{
							priseEnCompte+=1;
						}
					}
					tableauAnalyse.setValueAt(String.valueOf(priseEnCompte), placeSomme, 3);
					placeSomme=indiceAnalyse-1;
					priseEnCompte=0;
				}
			}
		}catch(ParseException e)
		{

		}
	}

	/**
	 * Mise en place des textes dans la bonne langue (locale)
	 */
	private void translate() {
		ResourceBundle rb = ResourceBundle.getBundle("ressources.Langue", locale);

		banniere.setText(rb.getString("calculIPLAC"));

		altitude = rb.getString("altitude");
		profondeur = rb.getString("profondeur");
		chloa = rb.getString("chloa");

		mba = rb.getString("mba");
		iplac = rb.getString("iplac");

		critresBloquants = rb.getString("criteresBloquants");
		critresInformatifs = rb.getString("criteresInformatifs");
		nomLac = rb.getString("nomLac");
		date = rb.getString("date"); 
		code6L = rb.getString("code6L");
		confer = rb.getString("confer");	
		nomTaxon = rb.getString("nomTaxon");
		nomAuteur = rb.getString("nomAuteur");
		Biovol = rb.getString("biovol");
		codeRef = rb.getString("codeRef");
		embranchement = rb.getString("embranchement");
		anne = rb.getString("anne");
		coteSpec = rb.getString("coteSpec");
		coefSteno = rb.getString("coefSteno");
		calculNum = rb.getString("calculNum");
		calculDeno = rb.getString("calculDeno");
		mcs = rb.getString("mcs");
		etat = rb.getString("etat");
		periode = rb.getString("periode");
		priseEnCompteTitre = rb.getString("priseEnCompte");
		nombreCampagnes = rb.getString("nombreCampagnes");
		taxTotal = rb.getString("taxTotal");
		taxContributifs = rb.getString("taxContributifs");
		pourcentContributifs = rb.getString("pourcentContributifs");
		nbSp = rb.getString("nbSp");
		pourcentSp = rb.getString("pourcentSp");
		nbIndic = rb.getString("nbIndic");
		pourcentIndic = rb.getString("pourcentIndic");
		classeMBA = rb.getString("classeMBA");
		classeMCS = rb.getString("classeMCS");
		classeIPLAC = rb.getString("classeIPLAC");
		MCSc = rb.getString("MCSc");
		mcsBrute = rb.getString("mcsBrute");
		mcsRef = rb.getString("mcsRef");
		nbCampsHP = rb.getString("nbCampsHP");
		nbCampsValides = rb.getString("nbCampsValides");
		nbCampValide = rb.getString("nbCampValide");
		moyenneChloro = rb.getString("moyenneChloro");
		mbaRef = rb.getString("mbaRef");

		limHG = rb.getString("limHG");
		limGM = rb.getString("limGM");
		limMP = rb.getString("limMP");
		limPB = rb.getString("limPB");

		nbCamps.setText(rb.getString("nbCampMinAcceptes"));
		debut.setText(rb.getString("debPriodeAccepte"));
		finPeriode.setText(rb.getString("finPriodeAccepte"));
		taxonsContributifs.setText(rb.getString("minTaxonsContributifs"));
		taxonsTotaux.setText(rb.getString("minTaxonsTotaux"));
		pourcentageSp.setText(rb.getString("pourcentageSp"));
		pourcentageIndtermins.setText(rb.getString("pourcentageIndtermins"));

		contraintes_par_dfaut.setText(rb.getString("contraintesDfaut"));
		contraintes_modifier.setText(rb.getString("modifierContraintes"));

		menu.setText(rb.getString("menu"));
		file_menu.setText(rb.getString("fichier"));
		close_menu_item.setText(rb.getString("fermer"));
		comptage.setText(rb.getString("fenetreComptage"));
		taxons.setText(rb.getString("taxon"));

		pref.setText(rb.getString("preferences"));
		apropos.setText(rb.getString("aProposFenetreIPLAC"));
		infos.setText(rb.getString("aProposIPLAC"));
		version.setText(rb.getString("versionDu"));
		notice.setText(rb.getString("notice"));

		crationFichiers=rb.getString("crationFichiers");
		outils.setText(rb.getString("outils"));
		copier.setText(rb.getString("copier")); 						
		coller.setText(rb.getString("coller"));		
		fermer=rb.getString("fermer");			
		purge_mba.setText(rb.getString("purgerMBA"));			
		purge_mcs.setText(rb.getString("purgerMCS"));		
		calcul_iplac.setText(rb.getString("calculerIPLAC"));			
		import_donnes.setText(rb.getString("importPhytobs"));			
		valider.setText(rb.getString("validerTexte"));	
		analyse=rb.getString("analyse");			
		veuillezPatienter=rb.getString("veuillezPatienter");
		contraintes=rb.getString("contraintes");	
		minimum=rb.getString("minimum");		
		prparationDonnes=rb.getString("prparationDonnes");
		prparationDonnesMBA=rb.getString("prparationDonnesMBA");
		prparationDonnesMCS=rb.getString("prparationDonnesMCS");
		taxonManquant=rb.getString("taxonManquant");
		dateManquanteMCS=rb.getString("dateManquanteMCS");
		planEauManquant=rb.getString("planEauManquant");
		dateManquanteMBA=rb.getString("dateManquanteMBA");
		altProfManquante=rb.getString("altProfManquante");
		altProfDiffrente=rb.getString("altProfDiffrente");
		chloroManquanteMBA=rb.getString("chloroManquanteMBA");
		ligneMBAManquante=rb.getString("ligneMBAManquante");
		calculMBA=rb.getString("calculMBA");
		calculMCS=rb.getString("calculMCS");
		calculIPLACEnCours=rb.getString("calculIPLACEnCours");
		non=rb.getString("non");
		debPer=rb.getString("debPer");
		finPer=rb.getString("finPer");
		nbreCampMin=rb.getString("nbreCampMin");
		nbreTaxTot=rb.getString("nbreTaxTot");
		nbreTaxContrib=rb.getString("nbreTaxContrib");
		analyseResultats=rb.getString("analyseResultats");
		horsPriode=rb.getString("horsPriode");
		nbTaxonsInd=rb.getString("nbTaxonsInd");
		nbTaxGenres=rb.getString("nbTaxGenres");
		nbTaxTot=rb.getString("nbTaxTot");
		nbTaxContrib=rb.getString("nbTaxContrib");
		donnesUtilisateurMBA=rb.getString("donnesUtilisateurMBA");
		donnesUtilisateurMCS=rb.getString("donnesUtilisateurMCS");	
		donnesListeCote=rb.getString("donnesListeCote");		
		analyseDonnesFichier=rb.getString("analyseDonnesFichier");
		sortieMCSCamp=rb.getString("sortieMCSCamp");
		sortieMCS=rb.getString("sortieMCS");
		sortieMBA=rb.getString("sortieMBA");
		sortieIPLAC=rb.getString("sortieIPLAC");
		ficheSynthetique=rb.getString("ficheSynthetique");
		modifierContraintes=rb.getString("modifierContraintes");
		pdfContraintes=rb.getString("pdfContraintes");
		pdfDebutContrainte=rb.getString("pdfDebutContrainte");
		pdfFinContrainte=rb.getString("pdfFinContrainte");
		pdfMinCamp=rb.getString("pdfMinCamp");
		pdfTaxTot=rb.getString("pdfTaxTot");
		pdfTaxContrib=rb.getString("pdfTaxContrib");
		pdfDfaut=rb.getString("pdfDfaut");
		pdfmcsRef=rb.getString("pdfmcsRef");
		pdfMoyMCS=rb.getString("pdfMoyMCS");
		pdfAnne=rb.getString("pdfAnne");
		pdfBiovolRelatif=rb.getString("pdfBiovolRelatif");
		pdfBiovolTotal=rb.getString("pdfBiovolTotal");		
		pdfProfondeur=rb.getString("pdfProfondeur");
		pdfClasseMBA=rb.getString("pdfClasseMBA");
		pdfClasseMCS=rb.getString("pdfClasseMCS");
		pdfClasseIPLAC=rb.getString("pdfClasseIPLAC");
		pdfMoyChloro=rb.getString("pdfMoyChloro");
		pdfRefChloro=rb.getString("pdfRefChloro");
		pdfNbCamp=rb.getString("pdfNbCamp");
		pdfNbCampUtil=rb.getString("pdfNbCampUtil");
		pdfMCSAnnuelle=rb.getString("pdfMCSAnnuelle");
		pdfMoyMBA=rb.getString("pdfMoyMBA");
		pdfMois=rb.getString("pdfMois");
		pdfChloro=rb.getString("pdfChloro");
		pdfMCSCamp=rb.getString("pdfMCSCamp");
		pdfRefMBA=rb.getString("pdfRefMBA");
		pdfContrib=rb.getString("pdfContrib");
		pdfNonCotes=rb.getString("pdfNonCotes");
		pdfGenre=rb.getString("pdfGenre");
		pdfInd=rb.getString("pdfInd");
		pdfDate=rb.getString("pdfDate");
		pdfNbTaxons=rb.getString("pdfNbTaxons");
		pdfBiovolRelatifContrib=rb.getString("pdfBiovolRelatifContrib");
		pdfTaxons=rb.getString("pdfTaxons");
		pdfBiovolRelatifPourcent=rb.getString("pdfBiovolRelatifPourcent");
		pdfBiovolTotalUnit=rb.getString("pdfBiovolTotalUnit");
		pdfRpartitionEmbranchement=rb.getString("pdfRpartitionEmbranchement");
		pdfRefMCS=rb.getString("pdfmcsRef");
		et=rb.getString("et");

	}	
}